#pragma once

#ifndef KCH_EXP
#ifdef BUILD_THEPARSER
#define KCH_EXP __declspec(dllexport)
#else
#define KCH_EXP __declspec(dllimport)
#endif
#endif


#ifndef WINVER
#define WINVER 0x501
#endif

#include <afxwin.h>
#include <kch_tokenmap.h>

#define STR_EQL_ASCII(astr, bstr) !::strcmp(astr, bstr)

typedef __int64 integer;
typedef double realnum;

typedef std::vector<std::wstring> StrArray;
typedef StrArray::iterator StrArrayItr;
typedef StrArray::const_iterator StrArrayCItr;

void KCH_EXP PutChar(wchar_t wch);
void KCH_EXP PutString(const std::wstring& text);
integer KCH_EXP ToIntLiteral(const char* text, int len, char thousand=',');
realnum KCH_EXP ToRealLiteral(const char* text, int len, char thousand=',', char decimalpoint='.');
std::wstring KCH_EXP CharToWString(char* const buffer, int len);
std::wstring KCH_EXP CharToWideString(char* const src, int len);
void KCH_EXP CharToWString(std::wstring& result, char* const buffer, int len);
void KCH_EXP puterrormsg(const char* const msg[], int count);
void KCH_EXP PlantTokenMap();
KCH_EXP bool LoadFileContents(const CString& filepath, CString& contents);
KCH_EXP bool LoadFileContents(const std::wstring& filepath, std::wstring& contents);
KCH_EXP std::wstring CharToWideStringTrim(char* const buffer, int len);
KCH_EXP std::wstring TrimString(const std::wstring& str);

extern "C" void SetOutputEditorCEdit(CEdit* pEditor=NULL);

extern UnicodeToken gTokenMap;

extern TransKeywords gTransKeyword, gTransOprType;
extern TransKeywords gTransKeywordTemplate, gTransOprTypeTemplate;

extern "C" const TransKeywords::KeywordMap& GetKeywordMap();
extern "C" const TransKeywords::KeywordMap& GetMemberMap();

KCH_EXP StrArray GetFileList(const CString& thePath, const CString& theFilter);
extern "C" void InitializeKeywords(CEdit* pEditor, const CString& thePath);

extern "C" void SetPathSettings(const CString& AppPath, const CString& LibPath, 
							 const CString &LangPath, const CString& WorkPath);
