%option noyywrap

%{
	#pragma warning(disable: 4060 4267 4102 4244 4273 4996 4065 4102)
	
	#include "lexer_util.h"
	
	void DeleteCurrentBuffer() 
		{ yy_delete_buffer(YY_CURRENT_BUFFER); }	
		
	YY_BUFFER_STATE GetCurrentBuffer() 
			{ return yy_current_buffer; }
			
	char* GetTokenText() { return yytext; }
		
	void ResetLexer() { yy_start = 0; yy_init = 1; }
%}

ZERO			[0][\x00]		
DIGIT			[1-9][\x00]
DIGITZ			{ZERO}|{DIGIT}
DIGITS			{DIGITZ}+

ATSYMBOL								[@][\x00]
EQUAL									[=][\x00]
NEWLINE									[\n][\x00]

SINGLEQ									([\x27][\x00])|([\xB9\xBC\xC8][\x02])|([\x18\x19\x32][\x20])|([\x8C][\xA7])|([\x01][\x03])
BASIC_LATIN								[A-Za-z_][\x00]
LATIN_1									[\xC0-\xD6\xD8-\xF6\xF8-\xFF\xB4\xB8][\x00]
LATIN_EXTENDED_A						[\x00-\x7F][\x01]
LATIN_EXTENDED_B						([\x80-\xFF][\x01])|([\x00-\x4F][\x02])
GREEK									[\x70-\xFF][\x03]
CYRILLIC								[\x00-\xFF][\x04]
CYRILLIC_SUPPLEMENT						[\x00-\x2F][\x05]
ARMENIAN								[\x30-\x8F][\x05]
HEBREW									[\x90-\xFF][\x05]
ARABIC									[\x00-\xFF][\x06]
SYRIAC									[\x00-\x4F][\x07]
ARABIC_SUPPLEMENT						[\x50-\x7F][\x07]
THAANA									[\x80-\xBF][\x07]
NKO										[\xC0-\xFF][\x07]
DEVANAGARI								[\x00-\x7F][\x09]
BENGALI									[\x80-\xFF][\x09]
GURMUKHI								[\x00-\x7F][\x0A]
GUJARATI								[\x80-\xFF][\x0A]
ORIYA									[\x00-\x7F][\x0B]
TAMIL									[\x80-\xFF][\x0B]
TELUGU									[\x00-\x7F][\x0C]
KANNADA									[\x80-\xFF][\x0C]
MALAYALAM								[\x00-\x7F][\x0D]
SINHALA									[\x80-\xFF][\x0D]
TIBETAN									[\x00-\xFF][\x0F]
GEORGIAN								[\xA0-\xFF][\x10]
HANGUL_JAMO								[\x00-\xFF][\x11]
ETHIOPIC								([\x00-\xFF][\x12])|([\x00-\x7F][\x13])
ETHIOPIC_SUPPLEMENT						[\x80-\x9F][\x13]
CHEROKEE								[\xA0-\xFF][\x13]
CANADIAN_SYLLABICS						([\x00-\xFF][\x14\x15])|([\x00-\x7F][\x16])
OGHAM									[\x80-\x9F][\x16]
RUNIC									[\xA0-\xFF][\x16]
TAGALOG									[\x00-\x1F][\x17]
HANUNOO									[\x20-\x3F][\x17]
BUHID									[\x40-\x5F][\x17]
TAGBANWA								[\x60-\x7F][\x17]
KHMER									[\x80-\xFF][\x17]
MONGOLIAN								[\x00-\xAF][\x18]
LIMBU									[\x00-\x4F][\x19]
BUGINESE								[\x00-\x1F][\x1A]
BALINESE								[\x00-\x7F][\x1B]
LATIN_EXTENDED_ADDITIONAL				[\x00-\xFF][\x1E]
GREEK_EXTENDED							[\x00-\xFF][\x1F]
GLAGOLITIC								[\x00-\x5F][\x2C]
LATIN_EXTENDED_C						[\x60-\x7F][\x2C]
COPTIC									[\x80-\xFF][\X2C]
GEORGIAN_SUPPLEMENT						[\x00-\x2F][\x2D]
TIFINAGH								[\x30-\x7F][\x2D]
ETHIOPIC_EXTENDED						[\x80-\xDF][\x2D]
CJK_RADICALS							[\x80-\xFF][\x2E]
KANGXI_RADICALS							[\x00-\xDF][\x2F]
HIRAGANA								[\x40-\x9F][\x30]
KATAKANA								[\xA0-\xFF][\x30]
BOPOMOFO								[\x00-\x2F][\x31]
HANGUL_COMPATIBILITY_JAMO				[\x30-\x8F][\x31]
KANBUN									[\x90-\x9F][\x31]
BOPOMOFO_EXTENDED						[\xA0-\xBF][\x31]
CJK_STROKES								[\xC0-\xEF][\x31]
KATAKANA_PHONETIC_EXTENSIONS			[\xF0-\xFF][\x31]
CJK_UNIFIED_IDEOGRAPHS_EXTENSTION_A		([\x00-\xFF][\x34-\x4C])|([\x00-\xBF][\x4D])
CJK_UNIFIED_IDEOGRAPHS					([\x00-\xFF][\x4E-\x9E])|([\x00-\xBF][\x9F])
YI_SYLLABLES							([\x00-\xFF][\xA0-\xA3])|([\x00-\x8F][\xA4])
YI_RADICALS								[\x90-\xCF][\xA4]
LATIN_EXTENDED_D						[\x20-\xFF][\xA7]
SYLOTI_NAGRI							[\x00-\x2F][\xA8]
PHAGS_PA								[\x40-\x7F][\xA8]
HANGUL_SYLLABLES						([\x00-\xFF][\xAC-\xD6])|([\x00-\xAF][\xD7])
CJK_COMPATIBILITY_IDEOGRAPHS			[\x00-\xFF][\xF9\xFA]
ARMENIAN_LIGATURES						[\x00-\x4F][\xFB]
ARABIC_PRESENTATION_FORM_A				([\x50-\xFF][\xFB])|([\x00-\xFF][\xFC\xFD])
ARABIC_PRESENTATION_FORM_B				[\x70-\xFF][\xFE]

LETTER									{SINGLEQ}|{BASIC_LATIN}|{LATIN_1}|{LATIN_EXTENDED_A}|{LATIN_EXTENDED_B}|{GREEK}|{CYRILLIC}|{CYRILLIC_SUPPLEMENT}|{ARMENIAN}|{HEBREW}|{ARABIC}|{SYRIAC}|{ARABIC_SUPPLEMENT}|{THAANA}|{NKO}|{DEVANAGARI}|{BENGALI}|{GURMUKHI}|{GUJARATI}|{ORIYA}|{TAMIL}|{TELUGU}|{KANNADA}|{MALAYALAM}|{SINHALA}|{TIBETAN}|{GEORGIAN}|{HANGUL_JAMO}|{ETHIOPIC}|{ETHIOPIC_SUPPLEMENT}|{CHEROKEE}|{CANADIAN_SYLLABICS}|{OGHAM}|{RUNIC}|{TAGALOG}|{HANUNOO}|{BUHID}|{TAGBANWA}|{KHMER}|{MONGOLIAN}|{LIMBU}|{BUGINESE}|{BALINESE}|{LATIN_EXTENDED_ADDITIONAL}|{GREEK_EXTENDED}|{GLAGOLITIC}|{LATIN_EXTENDED_C}|{COPTIC}|{GEORGIAN_SUPPLEMENT}|{TIFINAGH}|{ETHIOPIC_EXTENDED}|{CJK_RADICALS}|{KANGXI_RADICALS}|{HIRAGANA}|{KATAKANA}|{BOPOMOFO}|{HANGUL_COMPATIBILITY_JAMO}|{KANBUN}|{BOPOMOFO_EXTENDED}|{CJK_STROKES}|{KATAKANA_PHONETIC_EXTENSIONS}|{CJK_UNIFIED_IDEOGRAPHS_EXTENSTION_A}|{CJK_UNIFIED_IDEOGRAPHS}|{YI_SYLLABLES}|{YI_RADICALS}|{LATIN_EXTENDED_D}|{SYLOTI_NAGRI}|{PHAGS_PA}|{HANGUL_SYLLABLES}|{CJK_COMPATIBILITY_IDEOGRAPHS}|{ARMENIAN_LIGATURES}|{ARABIC_PRESENTATION_FORM_A}|{ARABIC_PRESENTATION_FORM_B}
LETTERS									{LETTER}+({DIGITS}|{LETTER})*

POWER			[eE][\x00]  
PLUSMINUS		[+-][\x00]

PERIOD			[.][\x00]
COMMA			[,][\x00]

ANYCHAR			(.){2}

BUTDBLQ			([^"][^\x00])|([^"][\x00])|(["][^\x00])
ANYBLNKD		([^\n"][^\x00])|([^\n"][\x00])|([\n"][^\x00])
BLANK			([^\n"\\][^\x00])|([^\n"\\][\x00])|([\n"\\][^\x00])
ANYBLNK			([^\n'"][^\x00])|([^\n'"][\x00])|([\n'"][^\x00])
PATHNAME		([^\\/:*?"<>|\n][^\x00])|([\\/:*?"<>|\n][^\x00])|([^\\/:*?"<>|\n][\x00])

STRINGD			["][\x00]{ANYBLNKD}+["][\x00]
STRINGQ			["][\x00]{BUTDBLQ}+["][\x00]

INCPATH			[<][\x00]{ANYBLNK}+[>][\x00]

FLTINTG			{ZERO}|{DIGITZ}*
HEADINTG		{DIGIT}{DIGITZ}{0,2}
FMTTAIL			{COMMA}{DIGITZ}{3}
FMTINTG			{HEADINTG}{FMTTAIL}*

FLATFLOAT		{FLTINTG}({PERIOD}{DIGITS})?
FLTREAL			({FLATFLOAT})({POWER}{PLUSMINUS}{DIGITS})?

FMTFLOAT		({FMTINTG}|{ZERO})({PERIOD}{DIGITS})?
FMTREAL			({FMTFLOAT})({POWER}{PLUSMINUS}{DIGITS})?

INTEGER			{FLTINTG}|{FMTINTG}
REAL			{FLTREAL}|{FMTREAL}

COMMENT1		(([^*\n][^\x00])|([^*\n][\x00])|([*\n][^\x00]))*
COMMENT2		([*][\x00])+(([^*/\n][^\x00])|([^*/\n][\x00])|([*/\n][^\x00]))*
COMMENT3		([*][\x00])+([/][\x00])

BUTNL			([^\x0A][^\x00])|([^\x0A][\x00])|([\x0A][^\x00])

%x SC_COMPUTE SC_COMMENT SC_INCLUDE  SC_SINGCOM SC_STRING

%%
	SET_USER_ABORT;
	
	static std::wstring strbuffer;
			
	if(send_token != -1) 
	{ int token = send_token; send_token = -1; return token; }
	
	if(eof_seen==4) eof_seen = 0; 
	else if(eof_seen>0) { eof_seen++; return TKN_EOF; }
									
<INITIAL>
{
	[<][\x00][%][\x00]	{	gScanFileStack.top().charcount += yyleng/2;  
						
							if(initial_set==0)
							{
								if(gStmtListGlobal) 
									gStmtListStack.push(gStmtListGlobal->Clone(gGC.GetStmtList())); 
								else
									gStmtListStack.push(gGC.GetStmtList()); 
								++initial_set; gBlockTypeStack.push(false);
							}
							BEGIN(SC_COMPUTE);
						}
						
	{ANYCHAR}			{	gScanFileStack.top().charcount += yyleng/2;}
}

<SC_COMMENT>
{
	{COMMENT1}		{	gScanFileStack.top().charcount += yyleng/2; 
	                    /* eat anything that's not a '*' */ }
	{COMMENT2}		{	gScanFileStack.top().charcount += yyleng/2; 
	                    /* eat up '*'s not followed by '/'s */ }
	([\n][\x00])+	{	gScanFileStack.top().charcount += yyleng/2; 
						gScanFileStack.top().lineno += yyleng/2; }
	{COMMENT3}		{	gScanFileStack.top().charcount += yyleng/2; BEGIN(SC_COMPUTE); }
}

<SC_SINGCOM>
{	
	[\n][\x00]			{	gScanFileStack.top().charcount += yyleng/2; 
							++gScanFileStack.top().lineno; BEGIN(SC_COMPUTE); }
							
	{BUTNL}+			{	gScanFileStack.top().charcount += yyleng/2; }
}

<SC_INCLUDE>
{
	([ \t][\x00])+			{   gScanFileStack.top().charcount += yyleng/2; 
								/* each up white space */ }
	{STRINGD}				{   gScanFileStack.top().charcount += yyleng/2; 
	 							
	 							if(include_stack_ptr >= MAX_INCLUDE_DEPTH)
									HandleSyntaxError(_T("Includes nested too deeply.\r\n"));
										
								std::wstring fname = CharToWideStringTrim(&yytext[2], yyleng-4); 
								CString flatname(fname.c_str()), filename;
								
								int index = InvalidFileName(flatname);
								if(index != -1)
								{
									std::wostringstream os;
									os<<_T("Invalid file name[")<<flatname.GetString()<<_T("].\r\n");
									os<<_T("Character \'")<<flatname[index]<<_T("\' is not allowed in the file name.\r\n");
									HandleSyntaxError(os.str());
								}
										
								filename.Format(_T("%s%s"), GetPath(gScanFileStack.top().filename).c_str(), flatname);
													
								// already included										
								if(gIncludeSet.insert(filename).second==false)
									BEGIN(SC_COMPUTE);
								else // new file to include
									{																				
										if(PrepareNewFileScan(filename))
											BEGIN(SC_COMPUTE);
										else
										{
											std::wostringstream os;
											os<<_T("Can not open file ["<<fname<<_T("].\r\n"));
											os<<_T("Current path is ["<<GetCurrentPath().GetString()<<_T("].\r\n"));
											HandleSyntaxError(os.str());
										}
									}
							}
																
	{INCPATH}				{	gScanFileStack.top().charcount += yyleng/2; 
		 
								if(include_stack_ptr >= MAX_INCLUDE_DEPTH)
									HandleSyntaxError(_T("Includes nested too deeply.\r\n"));
										
								std::wstring fname = CharToWideStringTrim(&yytext[2], yyleng-4); 
								CString flatname(fname.c_str()), filename;
								int index = InvalidFileName(flatname);
								if(index != -1)
								{
									std::wostringstream os;
									os<<_T("Invalid file name[")<<flatname.GetString()<<_T("].\r\n");
									os<<_T("Character \'")<<flatname[index]<<_T("\' is not allowed in the file name.\r\n");
									HandleSyntaxError(os.str());
								}
										
								filename.Format(_T("%s\\%s"), gLibPath, flatname);
																																					
								if(gIncludeSet.insert(CString(filename)).second==false)
								{
									BEGIN(SC_COMPUTE);
								}
								else
								{																				
									if(PrepareNewFileScan(filename))
										BEGIN(SC_COMPUTE);
									else
									{
										std::wostringstream os;
										os<<_T("Can not open file [")<<fname<<_T("].\r\n");
										HandleSyntaxError(os.str());
									}
								}
							}
}

<SC_COMPUTE>
{
	[<][\x00][%][\x00]			{	gScanFileStack.top().charcount += yyleng/2; }
	[+][\x00][+][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_INC; }
	[-][\x00][-][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_DEC; }
	[+][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_PLS; }
	[-][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_MNS; }
	[*][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_MUL; }
	[/][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_DIV; }
	[%][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_CRS; }
	[?][\x00][?][\x00]			{	gScanFileStack.top().charcount += yyleng/2; 
									sol_set=true; return OPR_SOL; }
	[-+*/%!|&?^:#@~<>][\x00]	{	gScanFileStack.top().charcount += yyleng/2; return yytext[0]; }
	[,][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									if(gArrayInit.pStmtInit==NULL && vartype==TypeNull) assign_set=false;
									point_set=false; return ','; }
	[\[][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									if(vartype!=TypeNull) assign_set = true;
									return '['; 
								}
	[\]][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									if(vartype!=TypeNull) assign_set = false;
									return ']'; 
								}
	[(][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									gPuncParan.push(gScanFileStack.top()); return '('; 
								}	
	[)][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									
									try { gPuncParan.pop(); }
									catch(UnicodeException&)
									{
										HandleSyntaxError(_T("Unexpecting: \')\' symbol.\r\n"));
									}
									return ')'; 
								}
	[=][\x00]  					{	gScanFileStack.top().charcount += yyleng/2; 
									if(vartype!=TypeNull) assign_set = true; 
									
									if(!gUdtFactoryStack.empty() && vartype==TypeUser) 
									{
										gLastUdt = gUdtFactoryStack.top(); 
										vartype = TypeNull; gUdtFactoryStack.clear();
									}
									gOpr = '='; return '='; 
								}
								
	[;][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									vartype=TypeNull; assign_set=point_set=false; return ';'; }
	[{][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									gPuncCurly.push(gScanFileStack.top());
									
									vartype=TypeNull;
									if(class_set) 
									{
										class_set = false; 
										gBlockTypeStack.push(true); return '{'; 
									 }
									else
									{
										gBlockTypeStack.push(false); 
										gStmtListStack.push(gGC.GetStmtList()); 
										return '{'; 
									}
								}
							
	[}][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									try { gPuncCurly.pop(); }
									catch(UnicodeException&)
									{
										HandleSyntaxError(_T("Unexpecting: \'}\' symbol.\r\n"));
									}
									vartype=TypeNull;
									if(gBlockTypeStack.top()==true)
									{
										gBlockTypeStack.pop(); return '}'; 
									}
									else
									{
										gBlockTypeStack.pop(); 
										gStmtListStack.pop(); return '}'; 
									}
								}						
	[<][\x00][-][\x00]			{	gScanFileStack.top().charcount += yyleng/2; 
									assign_set = true; gOpr = '&'; return OPR_XPR; }
	[{][\x00][:][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return ARY_OPEN; }
	[:][\x00][}][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return ARY_CLOSE; }
	[<][\x00][=][\x00][>][\x00]	{	gScanFileStack.top().charcount += yyleng/2; return OPR_SWAP; }
	[<][\x00][*][\x00][>][\x00]	{	gScanFileStack.top().charcount += yyleng/2; return OPR_PRO; }
	[>][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return GE; }
	[<][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return LE; }
	[=][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return EQ; }
	[!][\x00][=][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return NE; }
	[|][\x00][|][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OR; }
	[&][\x00][&][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return AND; }
	[<][\x00][<][\x00]			{	gScanFileStack.top().charcount += yyleng/2; return OPR_OUTPUT; }
	[>][\x00][>][\x00]			{   gScanFileStack.top().charcount += yyleng/2; return OPR_INPUT; }
	[.][\x00]					{   gScanFileStack.top().charcount += yyleng/2; 
									point_set = true; return '.'; }
	[%][\x00][>][\x00]			{	gScanFileStack.top().charcount += yyleng/2; 
									BEGIN(INITIAL); eof_seen = 1; return TKN_EOF; }
	[/][\x00][/][\x00]			{	gScanFileStack.top().charcount += yyleng/2; BEGIN(SC_SINGCOM); }
	[/][\x00][*][\x00]			{	gScanFileStack.top().charcount += yyleng/2; BEGIN(SC_COMMENT); } 
	{INTEGER}					{	gScanFileStack.top().charcount += yyleng/2; 
									lvalp->intg = ToIntLiteral((const char*)yytext, yyleng); return INTG; }
	
	{REAL}						{	gScanFileStack.top().charcount += yyleng/2;
									lvalp->scalar = ToRealLiteral((const char*)yytext, yyleng); return REAL; }
	["][\x00]					{	gScanFileStack.top().charcount += yyleng/2; 
									strbuffer =_T(""); BEGIN(SC_STRING);
								}
								
	[:][\x00][:][\x00]{LETTERS}	{   gScanFileStack.top().charcount += yyleng/2;
	 
									StrCopy(lvalp->fname.fn, CharToWString(&yytext[4], yyleng-4));
								
									int rtn = GetFunType(lvalp->fname, lvalp);
									if(rtn == TYPE_UNDF)
									{
										std::wostringstream os;
										os<<_T("\'")<<lvalp->fname.fn<<_T("\' is not a global function.\r\n");
										HandleSyntaxError(os.str());
									}
									else return rtn;
								}
								
	{LETTERS}					{   gScanFileStack.top().charcount += yyleng/2; 
									std::wstring text; CharToWString(text, yytext, yyleng);
									int rlt = HandleScanID(text, lvalp); 
									
									if(rlt) return rlt;
								}
							
}
<SC_STRING>
{
	[\\][\x00]["][\x00]	{	gScanFileStack.top().charcount += yyleng/2;
							 CharToWString(strbuffer, &yytext[2], yyleng-2);
						}
	([\\][\x00]){2}		{	gScanFileStack.top().charcount += yyleng/2;
							 CharToWString(strbuffer, &yytext[2], yyleng-2);
						}
	[\\][\x00]			{	gScanFileStack.top().charcount += yyleng/2;
							 //CharToWString(strbuffer, &yytext[2], yyleng-2);
						}
	[\\][\x00][t][\x00] {	gScanFileStack.top().charcount += yyleng/2;
							 yytext[2]='\t'; CharToWString(strbuffer, &yytext[2], yyleng-2);
						}
	[\\][\x00][n][\x00] {	gScanFileStack.top().charcount += yyleng/2;
							char txtbuf[4] = { 13, 0, 10, 0 };
							CharToWString(strbuffer, txtbuf, 4);
						}
	["][\x00]			{	gScanFileStack.top().charcount += yyleng/2;
							lvalp->pstr = strbuffer.c_str(); BEGIN(SC_COMPUTE);
							return TKN_STRING;
						}
	{BLANK}+			{	gScanFileStack.top().charcount += yyleng/2;
							CharToWString(strbuffer, yytext, yyleng);
						}
	[\n][\x00]			{	gScanFileStack.top().charcount += yyleng/2; 
							gScanFileStack.top().lineno += yyleng/2; 
							char txtbuf[4] = { 13, 0, 10, 0 };
							CharToWString(strbuffer, txtbuf, 4);
						}						
}

<*>
{
	([\n][\x00])+		{	gScanFileStack.top().charcount += yyleng/2; 
							gScanFileStack.top().lineno+=yyleng/2; 
							if(YY_START==SC_SINGCOM) BEGIN(SC_COMPUTE);
						}
						
	([ \t][\x00])+ 	{	gScanFileStack.top().charcount += yyleng/2; }
}

<<EOF>>					{
							extern ProgStatus gProgStatus;
							
							if(gProgStatus == PS_InputTime)
								return 0;
	
							extern bool HandleEOF();
												
							if(gScanFileStack.size()==1 && YY_START != INITIAL)
							{
								std::wostringstream os;
								
								switch(YY_START)
								{
								case SC_COMMENT:
									os<<_T("Expecting: \'*/\' symbol. Multiline comment is not closed.\r\n");
									HandleSyntaxError(os.str()); 
								case SC_COMPUTE:
									if(!gPuncCurly.empty())
									{
										gLastLine = gPuncCurly.top().lineno;  
										gLastCharCount = gPuncCurly.top().charcount;
										gPuncCurly.clear();
										HandleSyntaxError(_T("Unexpecting: end of file. Symbol \'{\' is not closed by symbol \'}\'.\r\n"));
									}
									else if(!gPuncParan.empty())
									{
										gLastLine = gPuncParan.top().lineno;  
										gLastCharCount = gPuncParan.top().charcount;
										gPuncParan.clear();
										HandleSyntaxError(_T("Unexpecting: end of file. Symbol \'(\' is not closed by symbol \'}\'.\r\n"));
									}
									
									os<<_T("Unexpecting: end of file, Expecting: \'%>\' symbol.\r\n");
									HandleSyntaxError(os.str());
								}
							}
						
							if(!gPuncCurly.empty())
							{
								gLastLine = gPuncCurly.top().lineno;  gLastCharCount = gPuncCurly.top().charcount;
								gPuncCurly.clear();
								HandleSyntaxError(_T("\'{\' symbol is not closed by \'}\' symbol.\r\n"));
							}
							else if(!gPuncParan.empty())
							{
								gLastLine = gPuncParan.top().lineno;  
								gLastCharCount = gPuncParan.top().charcount;
								gPuncCurly.clear();
								HandleSyntaxError(_T("Unexpecting: end of file. Symbol \'(\' is not closed by symbol \')\'.\r\n"));
							}
							else if(HandleEOF()) return 0;
						}
%%

void ModeToInclude() { BEGIN(SC_INCLUDE); }
bool HandleEOF() 
{
	gStmtListStack.top()->CheckImplemented();
	
	--include_stack_ptr;
					
	if(include_stack_ptr<0)
	{	
		if(initial_set !=0)
		{
			gStmtListStack.pop(); 
			gBlockTypeStack.pop();
		}
		if(!gScanFileStack.empty()) gScanFileStack.pop(); 
		yycleanup();  return true;
	}
	else
	{
		if(!gScanFileStack.empty()) gScanFileStack.pop();
				
		yy_delete_buffer(YY_CURRENT_BUFFER);
		delete [] gScanBuffer.top(); gScanBuffer.pop();
		
		yy_switch_to_buffer(include_stack[include_stack_ptr]);
		BEGIN(SC_COMPUTE); return false;
	}
}

void CleanScanBuffer()
{
	if(HandleEOF()) return;
	else CleanScanBuffer();
}