#include <kch_complex.h>
#include "nr.h"
using namespace std;

void NR::hypser(const Complex &a, const Complex &b,
	const Complex &c, const Complex &z,
	Complex &series, Complex &deriv)
{
	int n;
	Complex aa,bb,cc,fac,temp;

	deriv=0.0;
	fac=1.0;
	temp=fac;
	aa=a;
	bb=b;
	cc=c;
	for (n=1;n<=1000;n++) {
		fac *= ((aa*bb)/cc);
		deriv += fac;
		fac *= ((1.0/n)*z);
		series=temp+fac;
		if (series == temp) return;
		temp=series;
		aa += 1.0;
		bb += 1.0;
		cc += 1.0;
	}
	nrerror(L"convergence failure in hypser");
}
