#include "stdafx.h"

#include "parser_util.h"
#include <kch_error_status.h>

int gArgCount, initial_set, gOpr = '=';
int gLastLine, gLastCharCount;
bool point_set, assign_set, arg_set, static_set, literal_set, sol_set;
bool unitvctr_set, unitcplx_set, goto_set, class_set;

FunctionState gFuncState;

DataType vartype; 
GarbageCollector gGC;
MemoryManager gMM;
FuncList gflist; 
wchar_t ArrayName[BUF_LENGTH];
			
std::wstring strmsg, strtype;
StatementList* gCurrentStmtList;
StmtInitArray *gStmtInitArray = NULL;
ScanFile gScanFile;

UserDefinedType *gUdtPtr;

#ifdef _DEBUG

Stack<UserDefinedType*> gUdtFactoryStack(_T("gUdtFactoryStack"));
Stack<UserDefinedType*> gFactoryStack(_T("gFactoryStack"));
Stack<char*> gScanBuffer(_T("gScanBuffer"));
Stack<ScanFile> gScanFileStack(_T("gScanFileStack"));	
Stack<StatementList*> gStmtListStack(_T("gStmtListStack"));
Stack<Statement*> gSelectStack(_T("gSelectStack"));
Stack<BaseType*> gArgStack(_T("gArgStack"));
Stack<ReturnSig> gReturnStack(_T("gReturnStack"));
Stack<BaseCUF*>  gFuncCallStack(_T("gFuncCallStack"));
Stack<StmtType>	gLoopStack(_T("gLoopStack"));
Stack<bool> gBlockTypeStack(_T("gBlockTypeStack"));
Stack<bool> gCatchBlockStack(_T("gCatchBlockStack"));

#else

Stack<UserDefinedType*> gUdtFactoryStack;
Stack<UserDefinedType*> gFactoryStack;
Stack<char*> gScanBuffer;
Stack<ScanFile> gScanFileStack;	
Stack<StatementList*> gStmtListStack;
Stack<Statement*> gSelectStack;
Stack<BaseType*> gArgStack;
Stack<ReturnSig> gReturnStack;
Stack<BaseCUF*>  gFuncCallStack;
Stack<StmtType>	gLoopStack;
Stack<bool> gBlockTypeStack;
Stack<bool> gCatchBlockStack;

#endif

ArrayInit gArrayInit;
	
Declare<integer> *pDecIntg; Declare<realnum> *pDecReal;
Declare<Complex> *pDecCplx; Declare<Vector>  *pDecVctr;

UserDefinedType* gLastUdt = NULL;

Function* BeforeDeclareFunction(DataType rtn, const wchar_t* name, UserDefinedType *udtptr)
{
	vartype=TypeNull; Function* fPtr=NULL; gArgCount=0;
	extern bool static_set;

	if(!gBlockTypeStack.top())
	{
		// Already declared and/or implemented
		fPtr=gStmtListStack.top()->FindFunction(name);

		if(fPtr) 
		{
			if(fPtr->rtntype != rtn)
			{
				std::wostringstream os;
				os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

				HandleSyntaxError(os.str());
			}
			else if(fPtr->pUDTFactory != udtptr)
			{
				std::wostringstream os;
				os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

				HandleSyntaxError(os.str());			
			}
			else if(fPtr->NotUseMember != static_set)
			{
				std::wostringstream os;
				os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

				HandleSyntaxError(os.str());			
			}
			
			gFuncState = FS_Declared;
		}
		else // Neither declared nor implemented
		{	
			gFuncState = FS_NewFunction;
			
			// it can not fail to add
			fPtr = gGC.GetFunction(rtn, std::wstring(name));
			gStmtListStack.top()->AddUDFunction(name, fPtr);		
			fPtr->pStmtList = gGC.GetStmtList();
			fPtr->pStmtList->funcstmt = true;
			fPtr->pUDTFactory = udtptr;
			fPtr->NotUseMember = static_set;
		}
	}
	else
	{
		// Already declared and/or implemented
		if(fPtr = gFactoryStack.top()->FindFunction(name)) 
		{
			if(fPtr->rtntype != rtn)
			{
				std::wostringstream os;
				os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

				HandleSyntaxError(os.str());
			}
			else if(fPtr->pUDTFactory != udtptr)
			{
				std::wostringstream os;
				os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

				HandleSyntaxError(os.str());			
			}
			else if(fPtr->NotUseMember != static_set)
			{
				std::wostringstream os;
				os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

				HandleSyntaxError(os.str());			
			}
			
			gFuncState = FS_Declared;
		}
		else // Neither declared nor implemented
		{	
			gFuncState = FS_NewFunction;

			// it can not fail to add
			fPtr = gGC.GetFunction(rtn, std::wstring(name));
			gFactoryStack.top()->AddUDFunction(name, fPtr);
			fPtr->pStmtList = gGC.GetStmtList();
			fPtr->pStmtList->funcstmt = true;
			fPtr->pUDTFactory = udtptr;
			fPtr->NotUseMember = static_set;
		}	
	}

	// At this point fPtr points to a Function
	// with pStmtList != NULL
	gStmtListStack.push(fPtr->pStmtList);
	gBlockTypeStack.push(false);
	gReturnStack.push(MakeReturn(rtn, name, fPtr));
	
	static_set = false;
	
	return fPtr;
}

void AfterDeclareFunction(Function *fPtr)
{	
	gReturnStack.pop();  gStmtListStack.pop();
	gBlockTypeStack.pop();

	fPtr->pParen = gReturnStack.empty() ? NULL: gReturnStack.top().fptr;
}

void CreateUDFunction(DataType rtn, const wchar_t* name, UserDefinedType *udtptr)
{
	vartype=TypeNull; Function* fPtr=NULL; gArgCount=0;

	if(!gBlockTypeStack.top())
	{
		fPtr = gStmtListStack.top()->FindFunction(name);
			
		if(fPtr)
		{
			if(fPtr->pStmtList->IsLastStmtList())
			{
				std::wostringstream os;  
				os<<_T("Function \'")<<fPtr->GetName()
					<<_T("\' is already defined.\r\n");
				HandleSyntaxError(os.str());
			}
			else
			{
				if(fPtr->rtntype != rtn)
				{	
					std::wostringstream os;
					os<<_T("The return data type of the function \'")<<name
					<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

					HandleSyntaxError(os.str());
				}
				else if(fPtr->pUDTFactory != udtptr)
				{
					std::wostringstream os;
					os<<_T("The return data type of the function \'")<<name
						<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

					HandleSyntaxError(os.str());			
				}
				else if(fPtr->NotUseMember != static_set)
				{
					std::wostringstream os;
					os<<_T("The return data type of the function \'")<<name
						<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

					HandleSyntaxError(os.str());			
				}

				gFuncState = FS_Declared;
			}
		}
		else
		{	
			// it can not fail to add
			gFuncState = FS_NewFunction;
			fPtr = gGC.GetFunction(rtn, std::wstring(name));
			gStmtListStack.top()->AddUDFunction(name, fPtr);
			fPtr->pStmtList = gGC.GetStmtList();
			fPtr->pStmtList->funcstmt = true;
			fPtr->pUDTFactory = udtptr;
			fPtr->NotUseMember = static_set;
		}
	}
	else
	{
		fPtr = gFactoryStack.top()->FindFunction(name);
			
		if(fPtr)
		{
			if(fPtr->pStmtList->IsLastStmtList())
			{
				std::wostringstream os;  
				os<<_T("Function \'")<<fPtr->GetName()
					<<_T("\' is already defined.\r\n");
				HandleSyntaxError(os.str());
			}
			else 
			{
				if(fPtr->rtntype != rtn)
				{
					std::wostringstream os;
						os<<_T("The return data type of the function \'")<<name
							<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");
					HandleSyntaxError(os.str());
				}
				else if(fPtr->pUDTFactory != udtptr)
				{
					std::wostringstream os;
					os<<_T("The return data type of the function \'")<<name
						<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

					HandleSyntaxError(os.str());			
				}
				else if(fPtr->NotUseMember != static_set)
				{
					std::wostringstream os;
					os<<_T("The return data type of the function \'")<<name
						<<_T("\' does not\r\nmatch with its previous declaration or definition.\r\n");

					HandleSyntaxError(os.str());			
				}

				gFuncState = FS_Declared;
			}
		}
		else
		{	
			// it can not fail to add
			gFuncState = FS_NewFunction;
			fPtr = gGC.GetFunction(rtn, std::wstring(name));
			gFactoryStack.top()->AddUDFunction(name, fPtr);
			fPtr->pStmtList = gGC.GetStmtList();
			fPtr->pStmtList->funcstmt = true;
			fPtr->pUDTFactory = udtptr;
			fPtr->NotUseMember = static_set;
		}
	}
	
	// At this point fPtr points
	// to a Function with pStmtList != NULL
	gStmtListStack.push(fPtr->pStmtList);
	gBlockTypeStack.push(false);
	gReturnStack.push(MakeReturn(rtn, name, fPtr));
	
	static_set = false;
}

void AfterFunctionDefinition(Statement* stmt)
{	
	ReturnSig rs = gReturnStack.pop();
	rs.fptr->pStmtList->Add(stmt); 

	gStmtListStack.pop(); gBlockTypeStack.pop(); 

	rs.fptr->pParen = gReturnStack.empty() ? NULL: gReturnStack.top().fptr;

	if((rs.type!=TypeVoid) && stmt && !stmt->IsReturn())
	{
		std::wostringstream os;
		os<<_T("In function \'")<<rs.fname
			<<_T("\', not all control paths return a value.\r\n");
		HandleSyntaxError(os.str());
	}
}

void PreArrayInit(LHSArrayBase *pLHS, bool PutToStmtInit)
{
	gArrayInit = MakeAI();

	gArrayInit.arraydim = pLHS->GetDimension(gArrayInit.type);
	gArrayInit.pStmtInit = gGC.GetStmtInitArray();

	Statement *pLastStmt = gStmtListStack.top()->GetLastStmt();
	DeclareBaseArray *pStmt = NULL;

	if(pLastStmt) 
		pStmt = dynamic_cast<DeclareBaseArray*>(pLastStmt);
		
	if(PutToStmtInit && pStmt)
		pStmt->SetInitExpr(gArrayInit.pStmtInit);
	else
	{	
		if(gOpr=='&')
		{
			gArrayInit.pStmtInit->stmttype=StmtExpr;
			gArrayInit.pStmtInit->pArrayBase = pLHS;
		}
		gStmtListStack.top()->Add(gArrayInit.pStmtInit);
	}
	
	switch(gArrayInit.type)
	{
	case TypeAi1D: gArrayInit.lhsPtr.pIntgVec1D 
			= dynamic_cast<LeftHandSideArray<IntgVec1D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<IntgVec1D>(gArrayInit.lhsPtr.pIntgVec1D); break;
	case TypeAr1D: gArrayInit.lhsPtr.pRealVec1D 
			= dynamic_cast<LeftHandSideArray<RealVec1D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<RealVec1D>(gArrayInit.lhsPtr.pRealVec1D); break;
	case TypeAc1D: gArrayInit.lhsPtr.pCplxVec1D 
			= dynamic_cast<LeftHandSideArray<CplxVec1D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<CplxVec1D>(gArrayInit.lhsPtr.pCplxVec1D); break;
	case TypeAv1D: gArrayInit.lhsPtr.pVctrVec1D 
			= dynamic_cast<LeftHandSideArray<VctrVec1D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<VctrVec1D>(gArrayInit.lhsPtr.pVctrVec1D); break;

	
	case TypeAi2D: gArrayInit.lhsPtr.pIntgVec2D 
			= dynamic_cast<LeftHandSideArray<IntgVec2D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<IntgVec2D>(gArrayInit.lhsPtr.pIntgVec2D); break;
	case TypeAr2D: gArrayInit.lhsPtr.pRealVec2D 
			= dynamic_cast<LeftHandSideArray<RealVec2D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<RealVec2D>(gArrayInit.lhsPtr.pRealVec2D); break;
	case TypeAc2D: gArrayInit.lhsPtr.pCplxVec2D 
			= dynamic_cast<LeftHandSideArray<CplxVec2D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<CplxVec2D>(gArrayInit.lhsPtr.pCplxVec2D); break;
	case TypeAv2D: gArrayInit.lhsPtr.pVctrVec2D 
			= dynamic_cast<LeftHandSideArray<VctrVec2D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<VctrVec2D>(gArrayInit.lhsPtr.pVctrVec2D); break;
	
	case TypeAi3D: gArrayInit.lhsPtr.pIntgVec3D 
			= dynamic_cast<LeftHandSideArray<IntgVec3D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<IntgVec3D>(gArrayInit.lhsPtr.pIntgVec3D); break;
	case TypeAr3D: gArrayInit.lhsPtr.pRealVec3D 
			= dynamic_cast<LeftHandSideArray<RealVec3D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<RealVec3D>(gArrayInit.lhsPtr.pRealVec3D); break;break;
	case TypeAc3D: gArrayInit.lhsPtr.pCplxVec3D 
			= dynamic_cast<LeftHandSideArray<CplxVec3D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<CplxVec3D>(gArrayInit.lhsPtr.pCplxVec3D); break;
	case TypeAv3D: gArrayInit.lhsPtr.pVctrVec3D 
			= dynamic_cast<LeftHandSideArray<VctrVec3D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<VctrVec3D>(gArrayInit.lhsPtr.pVctrVec3D); break;


	case TypeAi4D: gArrayInit.lhsPtr.pIntgVec4D 
			= dynamic_cast<LeftHandSideArray<IntgVec4D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<IntgVec4D>(gArrayInit.lhsPtr.pIntgVec4D); break;
	case TypeAr4D: gArrayInit.lhsPtr.pRealVec4D 
			= dynamic_cast<LeftHandSideArray<RealVec4D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<RealVec4D>(gArrayInit.lhsPtr.pRealVec4D); break;
	case TypeAc4D: gArrayInit.lhsPtr.pCplxVec4D 
			= dynamic_cast<LeftHandSideArray<CplxVec4D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<CplxVec4D>(gArrayInit.lhsPtr.pCplxVec4D); break;
	case TypeAv4D: gArrayInit.lhsPtr.pVctrVec4D 
			= dynamic_cast<LeftHandSideArray<VctrVec4D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<VctrVec4D>(gArrayInit.lhsPtr.pVctrVec4D); break;


	case TypeAi5D: gArrayInit.lhsPtr.pIntgVec5D 
			= dynamic_cast<LeftHandSideArray<IntgVec5D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<IntgVec5D>(gArrayInit.lhsPtr.pIntgVec5D); break;
	case TypeAr5D: gArrayInit.lhsPtr.pRealVec5D 
			= dynamic_cast<LeftHandSideArray<RealVec5D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<RealVec5D>(gArrayInit.lhsPtr.pRealVec5D); break;
	case TypeAc5D: gArrayInit.lhsPtr.pCplxVec5D 
			= dynamic_cast<LeftHandSideArray<CplxVec5D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<CplxVec5D>(gArrayInit.lhsPtr.pCplxVec5D); break;
	case TypeAv5D: gArrayInit.lhsPtr.pVctrVec5D 
			= dynamic_cast<LeftHandSideArray<VctrVec5D>*>(pLHS); 
		gArrayInit.pArrayResizePtr = gGC.GetArrayResize<VctrVec5D>(gArrayInit.lhsPtr.pVctrVec5D); break;

	default:
		HandleSyntaxError(L"Unsupported array type.\r\n");
	}

	gArrayInit.pStmtInit->Add(dynamic_cast<Statement*>(gArrayInit.pArrayResizePtr));
}

void AfterArrayInit()
{
	for(int i=0; i<=gArrayInit.maxdim; ++i)
	{
		gArrayInit.pArrayResizePtr->InsertSize(i, gGC.GetLiteral(integer(gArrayInit.maxidx[i]+1)));
	}
	
	gArrayInit=MakeAI(); assign_set=false; 
}

void AfterArrayClose()
{
	for(int i=0; i<MAX_DIMENSION; ++i)
	{
		if((i+1)==gArrayInit.dim) ++gArrayInit.index[i] ;
		else if((i+1)>gArrayInit.dim) gArrayInit.index[i] = 0;
	}
	--gArrayInit.dim; 
}

// it never returns
int HandleSyntaxError(std::wstring msg, ExceptionType etype)
{
	extern ErrorStatusInfo *gpErrorStatusInfo;
	extern void SetErrorFile(CString& filename,
		CString& token, int errorline, int errorchar);
	
	CString fmt_startup, msg_startup;
	fmt_startup.LoadString(IDS_ERROR_MSG_STARTUP);

	CString fmt_compile, msg_compile;
	fmt_compile.LoadString(IDS_ERROR_MSG_COMPILE);

	switch(gProgStatus)
	{
	case PS_StartUpTime:
		{
			extern std::wstring gLastToken, gPrevToken;
			std::wostringstream os;  os<<gPrevToken<<L" and "<<gLastToken;

			msg_startup.FormatMessage(fmt_startup, 
				gScanFileStack.top().filename, os.str().c_str(),
				gLastLine, gLastCharCount,
				msg.c_str()); ::AfxMessageBox(msg_startup); 
			
			throw CompileTimeException();
		}
	case PS_CompileTime:
		{
			extern std::wstring gLastToken, gPrevToken;
			msg_compile.FormatMessage(fmt_compile, msg.c_str(), gScanFileStack.top().filename, gLastLine, 
				gLastCharCount, gPrevToken.c_str(), gLastToken.c_str()); PutString(msg_compile);

			SetErrorFile(gScanFileStack.top().filename, 
			CString(gLastToken.c_str()), gLastLine, gLastCharCount);
			
			throw CompileTimeException(_T(""));
		}

	case PS_RunTime:
		throw RunTimeException(msg);

	case PS_InputTime:
		throw UnicodeException(msg); 

	case PS_IdleTime:
		throw UnicodeException(msg); 
	}

	return 0; // to suppress warning
}

// it never returns
int HandleSyntaxError(UINT rcid, ExceptionType etype)
{
	CString msg; msg.LoadString(rcid);
	return HandleSyntaxError(msg.GetString());
}
