// crt_rand_s.c
// This program illustrates how to generate random
// integer or floating point numbers in a specified range.

// Remembing to define _CRT_RAND_S prior
// to inclusion statement
#define _CRT_RAND_S

#include <cstdlib>
#include <cstdio>
#include <climits>
#include <kch_exceptions.h>

typedef __int64 integer;

integer irandom(integer start, integer end)
{
	integer big = (start>end ? start:end);
	integer small = (start>end ? end:start);
	integer range = big-small;

	unsigned int number;
    errno_t err = rand_s(&number);
    if(err != 0)
		throw RunTimeException(L"irandom() function failed.\r\n");
	
	return integer((double(number)/double(UINT_MAX)*double(range))+double(small));
}

double drandom(double start, double end)
{
	double big = (start>end ? start:end);
	double small = (start>end ? end:start);
	double range = big-small;

	unsigned int number;
    errno_t err = rand_s( &number );
    if(err != 0)
		throw RunTimeException(L"drandom() function failed.\r\n");
    
	return double(number)/double(UINT_MAX)*range+small;
}