#include "stdafx.h"

#include <kch_array.h>
#include <kch_theparser.h>
#include <kch_userdefinedtype.h>
#include <kch_theparser_type.h>
#include <kch_theparser_type2.h>

#include "garbagecollector.h"

void usertype::clear()
{
	if(elemap.empty()) return;

	DataTemp<usertype> *ptr;

	for(UsrtMapItr itr = elemap.begin(); itr != elemap.end(); ++itr)
	{
		switch(itr->second.first)
		{
		case TypeBool: delete (bool*)   itr->second.second; break;
		case TypeIntg: delete (integer*)itr->second.second; break;
		case TypeReal: delete (realnum*)itr->second.second; break;
		case TypeCplx: delete (Complex*)itr->second.second; break;
		case TypeVctr: delete (Vector*) itr->second.second; break;
		case TypeStrn: delete (string*) itr->second.second; break;
		
		case TypeAi1D: delete (IntgAry1D*)itr->second.second; break;
		case TypeAr1D: delete (RealAry1D*)itr->second.second; break;
		case TypeAc1D: delete (CplxAry1D*)itr->second.second; break;
		case TypeAv1D: delete (VctrAry1D*)itr->second.second; break;

		case TypeAi2D: delete (IntgAry2D*)itr->second.second; break;
		case TypeAr2D: delete (RealAry2D*)itr->second.second; break;
		case TypeAc2D: delete (CplxAry2D*)itr->second.second; break;
		case TypeAv2D: delete (VctrAry2D*)itr->second.second; break;

		case TypeAi3D: delete (IntgAry3D*)itr->second.second; break;
		case TypeAr3D: delete (RealAry3D*)itr->second.second; break;
		case TypeAc3D: delete (CplxAry3D*)itr->second.second; break;
		case TypeAv3D: delete (VctrAry3D*)itr->second.second; break;

		case TypeAi4D: delete (IntgAry4D*)itr->second.second; break;
		case TypeAr4D: delete (RealAry4D*)itr->second.second; break;
		case TypeAc4D: delete (CplxAry4D*)itr->second.second; break;
		case TypeAv4D: delete (VctrAry4D*)itr->second.second; break;

		case TypeAi5D: delete (IntgAry5D*)itr->second.second; break;
		case TypeAr5D: delete (RealAry5D*)itr->second.second; break;
		case TypeAc5D: delete (CplxAry5D*)itr->second.second; break;
		case TypeAv5D: delete (VctrAry5D*)itr->second.second; break;

		case TypeUPtr: delete (UPtrData*) itr->second.second; break;

		case TypeUser: 
			ptr = udtvec.front(); ptr->GetPtr()->clear();
			delete ptr;  udtvec.pop_front(); break;

		default:
			throw RunTimeException(L"usertype::clear(), Unsupported member type.\r\n");
		}
	}

	elemap.clear(); 
}

void usertype::FastCopy(const usertype* const utptr) 
{ 	this->Copy(*utptr); }

void usertype::Copy(const usertype& ut)
{

	if(!CheckAllocated(ut)) ut.udtPtr->AllocateMemory(this);
	
#ifdef _DEBUG
	std::wostringstream os1, os2;

	os1<<L"Source: "<<ut.typetag<<L"  EleCount: "<<ut.elemap.size()<<L"  ";

	for(UsrtMapCItr itr=ut.elemap.begin(); itr != ut.elemap.end(); ++itr)
	{
		os1<<itr->first<<"  ";
	}

	os1<<L"\r\n"; PutString(os1.str());

	os2<<L"Target: "<<typetag<<L"  EleCount: "<<elemap.size()<<L"  ";

	for(UsrtMapCItr itr=elemap.begin(); itr != elemap.end(); ++itr)
	{
		os2<<itr->first<<"  ";
	}

	os2<<L"\r\n"; PutString(os2.str());

#endif

	UsrtMapCItr src = ut.elemap.begin();
	for(UsrtMapItr itr = elemap.begin(); itr != elemap.end(); ++itr, ++src)
	{
		switch(itr->second.first)
		{
		case TypeBool:
			*static_cast<bool*>(itr->second.second) =		*static_cast<bool*>(src->second.second);		continue;
		case TypeStrn:
			*static_cast<string*>(itr->second.second) =		*static_cast<string*>(src->second.second);		continue;
		case TypeIntg:
			*static_cast<integer*>(itr->second.second) =	*static_cast<integer*>(src->second.second);		continue;
		case TypeReal:
			*static_cast<realnum*>(itr->second.second) =	*static_cast<realnum*>(src->second.second);		continue;
		case TypeCplx:
			*static_cast<Complex*>(itr->second.second) =	*static_cast<Complex*>(src->second.second);		continue;
		case TypeVctr:
			*static_cast<Vector*>(itr->second.second) =		*static_cast<Vector*>(src->second.second);		continue;

		case TypeAi1D:
			*static_cast<IntgAry1D*>(itr->second.second) =	*static_cast<IntgAry1D*>(src->second.second);	continue;
		case TypeAr1D:
			*static_cast<RealAry1D*>(itr->second.second) =	*static_cast<RealAry1D*>(src->second.second);	continue;
		case TypeAc1D:
			*static_cast<CplxAry1D*>(itr->second.second) =	*static_cast<CplxAry1D*>(src->second.second);	continue;
		case TypeAv1D:
			*static_cast<VctrAry1D*>(itr->second.second) =	*static_cast<VctrAry1D*>(src->second.second);	continue;

		case TypeAi2D:
			*static_cast<IntgAry2D*>(itr->second.second) =	*static_cast<IntgAry2D*>(src->second.second);	continue;
		case TypeAr2D:
			*static_cast<RealAry2D*>(itr->second.second) =	*static_cast<RealAry2D*>(src->second.second);	continue;
		case TypeAc2D:
			*static_cast<CplxAry2D*>(itr->second.second) = 	*static_cast<CplxAry2D*>(src->second.second);	continue;
		case TypeAv2D:
			*static_cast<VctrAry2D*>(itr->second.second) =	*static_cast<VctrAry2D*>(src->second.second);	continue;

		case TypeAi3D:
			*static_cast<IntgAry3D*>(itr->second.second) =	*static_cast<IntgAry3D*>(src->second.second);	continue;
		case TypeAr3D:
			*static_cast<RealAry3D*>(itr->second.second) =	*static_cast<RealAry3D*>(src->second.second);	continue;
		case TypeAc3D:
			*static_cast<CplxAry3D*>(itr->second.second) =	*static_cast<CplxAry3D*>(src->second.second);	continue;
		case TypeAv3D:
			*static_cast<VctrAry3D*>(itr->second.second) =	*static_cast<VctrAry3D*>(src->second.second);	continue;

		case TypeAi4D:
			*static_cast<IntgAry4D*>(itr->second.second) =	*static_cast<IntgAry4D*>(src->second.second);	continue;
		case TypeAr4D:
			*static_cast<RealAry4D*>(itr->second.second) =	*static_cast<RealAry4D*>(src->second.second);	continue;
		case TypeAc4D:
			*static_cast<CplxAry4D*>(itr->second.second) =	*static_cast<CplxAry4D*>(src->second.second);	continue;
		case TypeAv4D:
			*static_cast<VctrAry4D*>(itr->second.second) =	*static_cast<VctrAry4D*>(src->second.second);	continue;

		case TypeAi5D:
			*static_cast<IntgAry5D*>(itr->second.second) =	*static_cast<IntgAry5D*>(src->second.second);	continue;
		case TypeAr5D:
			*static_cast<RealAry5D*>(itr->second.second) =	*static_cast<RealAry5D*>(src->second.second);	continue;
		case TypeAc5D:
			*static_cast<CplxAry5D*>(itr->second.second) =	*static_cast<CplxAry5D*>(src->second.second);	continue;
		case TypeAv5D:
			*static_cast<VctrAry5D*>(itr->second.second) =	*static_cast<VctrAry5D*>(src->second.second);	continue;

		case TypeUPtr:
			*static_cast<UPtrData*>(itr->second.second) =	*static_cast<UPtrData*>(src->second.second);	continue;

		case TypeUser:
			static_cast<usertype*>(itr->second.second)->FastCopy(static_cast<usertype*>(src->second.second));	continue;
		
		}
	}
}

usertype* usertype::AllocateCopy() const
{

	if(this->udtPtr==NULL)
		HandleSyntaxError(L"usertype::AllocateCopy(), source UserDefinedData ptr is null.\r\n");

	usertype *pTarget = new usertype(this->typetag);
	UserDefinedType *pUdtPtr = pTarget->udtPtr = this->udtPtr;

	for(UsrtMapCItr srcItr = this->elemap.begin();
		srcItr != this->elemap.end(); ++srcItr)
	{
		switch(srcItr->second.first)
		{
		case TypeBool:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new bool(*static_cast<bool*>(srcItr->second.second))))); continue;
		case TypeIntg:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new integer(*static_cast<integer*>(srcItr->second.second))))); continue;
		case TypeReal:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new realnum(*static_cast<realnum*>(srcItr->second.second))))); continue;
		case TypeCplx:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new Complex(*static_cast<Complex*>(srcItr->second.second))))); continue;
		case TypeVctr:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new Vector(*static_cast<Vector*>(srcItr->second.second))))); continue;
		case TypeStrn:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new string(*static_cast<string*>(srcItr->second.second))))); continue;

		case TypeAi1D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new IntgAry1D(*static_cast<IntgAry1D*>(srcItr->second.second))))); continue;
		case TypeAr1D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new RealAry1D(*static_cast<RealAry1D*>(srcItr->second.second))))); continue;
		case TypeAc1D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new CplxAry1D(*static_cast<CplxAry1D*>(srcItr->second.second))))); continue;
		case TypeAv1D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new VctrAry1D(*static_cast<VctrAry1D*>(srcItr->second.second))))); continue;

		case TypeAi2D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new IntgAry2D(*static_cast<IntgAry2D*>(srcItr->second.second))))); continue;
		case TypeAr2D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new RealAry2D(*static_cast<RealAry2D*>(srcItr->second.second))))); continue;
		case TypeAc2D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new CplxAry2D(*static_cast<CplxAry2D*>(srcItr->second.second))))); continue;
		case TypeAv2D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new VctrAry2D(*static_cast<VctrAry2D*>(srcItr->second.second))))); continue;

		case TypeAi3D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new IntgAry3D(*static_cast<IntgAry3D*>(srcItr->second.second))))); continue;
		case TypeAr3D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new RealAry3D(*static_cast<RealAry3D*>(srcItr->second.second))))); continue;
		case TypeAc3D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new CplxAry3D(*static_cast<CplxAry3D*>(srcItr->second.second))))); continue;
		case TypeAv3D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new VctrAry3D(*static_cast<VctrAry3D*>(srcItr->second.second))))); continue;

		case TypeAi4D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new IntgAry4D(*static_cast<IntgAry4D*>(srcItr->second.second))))); continue;
		case TypeAr4D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new RealAry4D(*static_cast<RealAry4D*>(srcItr->second.second))))); continue;
		case TypeAc4D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new CplxAry4D(*static_cast<CplxAry4D*>(srcItr->second.second))))); continue;
		case TypeAv4D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new VctrAry4D(*static_cast<VctrAry4D*>(srcItr->second.second))))); continue;

		case TypeAi5D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new IntgAry5D(*static_cast<IntgAry5D*>(srcItr->second.second))))); continue;
		case TypeAr5D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new RealAry5D(*static_cast<RealAry5D*>(srcItr->second.second))))); continue;
		case TypeAc5D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new CplxAry5D(*static_cast<CplxAry5D*>(srcItr->second.second))))); continue;
		case TypeAv5D:	pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, 
				new VctrAry5D(*static_cast<VctrAry5D*>(srcItr->second.second))))); continue;
	
		case TypeUser:
			{
				usertype *utPtr = static_cast<usertype*>(srcItr->second.second)->AllocateCopy();
				UserData *udPtr = new UserData(srcItr->first, utPtr->udtPtr); udPtr->Push(utPtr); 
				pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, utPtr)));
				pTarget->udtvec.push_back(udPtr); continue;
			}
		case TypeUPtr:
			{
				UPtrData *uptrData = new UPtrData; *uptrData = *static_cast<UPtrData*>(srcItr->second.second);
				pTarget->InsertElement(UsrtPair(srcItr->first, UdtPair(srcItr->second.first, uptrData))); continue;
			}
		}
	}

	return pTarget;
}

void usertype::InsertElement(UsrtPair ele) { elemap.insert(ele); }

void usertype::ClearEleMap() { clear(); }

usertype::usertype(std::wstring tag): 
	udtPtr(NULL), typetag(tag) { }

usertype::usertype(const usertype& ut) 
{ 
	udtPtr = NULL; typetag = std::wstring(L"Temporary: usertype");
	Copy(ut); 
}
usertype::~usertype() { clear(); }
usertype& usertype::operator=(const usertype& ut) 
	{ if(this != &ut) Copy(ut); return *this; }
	
UdtPair* usertype::GetElement(const std::wstring& id)
{
	UsrtMapItr itr = elemap.find(id);
	if(itr!= elemap.end()) return &(itr->second);
	else
	{
		std::wostringstream os;
		os<<id<<L" is not found.\r\n";

		HandleSyntaxError(os.str());

		return NULL;
	}
}

void usertype::Swap(usertype *ptr)
{
	if(udtPtr != ptr->udtPtr) 
		throw UnicodeException(_T("Can not swap. Type mismatch.\r\n"));
	this->elemap.swap(ptr->elemap);
}


///////////////////////

UserDefinedType::UserDefinedType(const std::wstring& tag): 
	typetag(tag), pEnclosingUDT(NULL) { }
	
const std::wstring& UserDefinedType::GetTypeTag() const { return typetag; }

void UserDefinedType::InsertElement(TypePair tpr)
{
	if(!typemap.insert(tpr).second)
	{
		std::wostringstream os; 
		os<<_T("\'")<<tpr.first<<_T("\' ")<<LoadUnicodeMsg(IDS_ALREADY_DECLARED);

		HandleSyntaxError(os.str());
	}
}

bool UserDefinedType::CheckRecursive(UserDefinedType *const ptr) const
{
	if(ptr == this) 
		return true;
	else if(this->pEnclosingUDT)
	{
		return pEnclosingUDT->CheckRecursive(ptr);
	}
	else return false;
}
void UserDefinedType::CheckImplemented() const
{
	funclist.CheckImplemented();
}
void UserDefinedType::AddFactory(UserDefinedType *udt)
{
	if(!udtmap.insert(NameUdtPair(udt->typetag, udt)).second)
	{
		std::wostringstream os; 
		os<<_T("\'")<<udt->typetag<<_T("\' ")<<LoadUnicodeMsg(IDS_ALREADY_DECLARED);

		HandleSyntaxError(os.str());
	}
}

void UserDefinedType::InsertElement(UserDefinedType *udt)
{
	if(!(typemap.insert(TypePair(udt->typetag, TypeUser)).second && 
		elemap.insert(NameUdtPair(udt->typetag, udt)).second))
	{
		std::wostringstream os; 
		os<<_T("\'")<<udt->typetag<<_T("\' ")<<LoadUnicodeMsg(IDS_ALREADY_DECLARED);

		HandleSyntaxError(os.str());
	}
}

void UserDefinedType::InsertElement(UserDefinedType *udt, std::wstring name)
{
	if(!(typemap.insert(TypePair(name, TypeUser)).second && 
		elemap.insert(NameUdtPair(name, udt)).second))
	{
		std::wostringstream os; 
		os<<_T("\'")<<name<<_T("\' ")<<LoadUnicodeMsg(IDS_ALREADY_DECLARED);

		HandleSyntaxError(os.str());
	}
}

void UserDefinedType::InsertElementUPtr(UserDefinedType *udt, std::wstring name)
{
	if(!(typemap.insert(TypePair(name, TypeUPtr)).second && 
		elemap.insert(NameUdtPair(name, udt)).second))
	{
		std::wostringstream os; 
		os<<_T("\'")<<name<<_T("\' ")<<LoadUnicodeMsg(IDS_ALREADY_DECLARED);

		HandleSyntaxError(os.str());
	}
}

void UserDefinedType::AddUDFunction(const wchar_t* id, Function* fptr)
{
	this->funclist.InsertFunction(id, fptr);
}

Function* UserDefinedType::FindFunction(const std::wstring& id)
{
	return this->funclist.FindFunction(id);
}

void UserDefinedType::InsertElement(Data* ptr, DataType type, std::wstring name)
{
	if(!(typemap.insert(TypePair(name, type)).second && 
		datamap.insert(NameDataPair(name, ptr)).second))
	{
		std::wostringstream os; 
		os<<_T("\'")<<name<<_T("\' ")<<LoadUnicodeMsg(IDS_ALREADY_DECLARED);

		HandleSyntaxError(os.str());
	}
}

UserDefinedType* UserDefinedType::GetUdt(const std::wstring& name)
{
	NameUdtMapItr itr = udtmap.find(name);
	
	if(itr == udtmap.end())
	{
		if(this->typetag==name) 
			return (UserDefinedType*)this;
		else return NULL;
	}
	else return itr->second;
}

UserDefinedType* UserDefinedType::GetEleUdt(const std::wstring& name)
{
	NameUdtMapItr itr = elemap.find(name);
	if(itr == elemap.end()) return NULL;
	else return itr->second;
}

Data* UserDefinedType::GetData(const std::wstring& name)
{
	NameDataMapItr itr = datamap.find(name);
	if(itr == datamap.end()) return NULL;
	else return itr->second;
}


DataType UserDefinedType::GetElementType(const std::wstring& id)
{
	TypeMapItr itr = typemap.find(id);
	if(itr == typemap.end()) return TypeNull;
	else return itr->second;
}

bool UserDefinedType::IsLiteral() 
{
	for(TypeMapItr itr = typemap.begin(); itr != typemap.end(); ++itr)
	{
		switch(itr->second)
		{
		case TypeBool: return false; case TypeIntg: return false;
		case TypeReal: return false; case TypeCplx: return false;
		case TypeVctr: return false; case TypeStrn: return false;

		case TypeAi1D: return false; case TypeAr1D: return false;
		case TypeAc1D: return false; case TypeAv1D: return false;

		case TypeAi2D: return false; case TypeAr2D: return false;
		case TypeAc2D: return false; case TypeAv2D: return false;

		case TypeAi3D: return false; case TypeAr3D: return false;
		case TypeAc3D: return false; case TypeAv3D: return false;

		case TypeAi4D: return false; case TypeAr4D: return false;
		case TypeAc4D: return false; case TypeAv4D: return false;

		case TypeAi5D: return false; case TypeAr5D: return false;
		case TypeAc5D: return false; case TypeAv5D: return false;

		case TypeUPtr: return false; 

		case TypeUser:
			{
				NameUdtMapItr udtItr = this->elemap.find(itr->first);
				return udtItr->second->IsLiteral();
			}
		}
	}

	return true;
}

usertype* UserDefinedType::AllocateMemory()
{
	usertype *uptr = new usertype(typetag); 
	uptr->udtPtr = this;  

	for(TypeMapItr itr=typemap.begin(); itr != typemap.end(); ++itr)
	{
		switch(itr->second)
		{
		case TypeBool: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeBool, new bool())));			continue;
		case TypeStrn: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeStrn, new string())));		continue;
		case TypeIntg: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeIntg, new integer())));		continue;
		case TypeReal: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeReal, new realnum())));		continue;
		case TypeCplx: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeCplx, new Complex())));		continue;
		case TypeVctr: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeVctr, new Vector())));		continue;
		
		case TypeAi1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi1D, new IntgAry1D())));	continue;
		case TypeAr1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr1D, new RealAry1D())));	continue;
		case TypeAc1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc1D, new CplxAry1D())));	continue;
		case TypeAv1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv1D, new VctrAry1D())));	continue;

		case TypeAi2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi2D, new IntgAry2D())));	continue;
		case TypeAr2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr2D, new RealAry2D())));	continue;
		case TypeAc2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc2D, new CplxAry2D())));	continue;
		case TypeAv2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv2D, new VctrAry2D())));	continue;

		case TypeAi3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi3D, new IntgAry3D())));	continue;
		case TypeAr3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr3D, new RealAry3D())));	continue;
		case TypeAc3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc3D, new CplxAry3D())));	continue;
		case TypeAv3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv3D, new VctrAry3D())));	continue;

		case TypeAi4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi4D, new IntgAry4D())));	continue;
		case TypeAr4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr4D, new RealAry4D())));	continue;
		case TypeAc4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc4D, new CplxAry4D())));	continue;
		case TypeAv4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv4D, new VctrAry4D())));	continue;

		case TypeAi5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi5D, new IntgAry5D())));	continue;
		case TypeAr5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr5D, new RealAry5D())));	continue;
		case TypeAc5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc5D, new CplxAry5D())));	continue;
		case TypeAv5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv5D, new VctrAry5D())));	continue;
		case TypeUser:
			{
				NameUdtMapItr udtItr = this->elemap.find(itr->first);

				if(udtItr != elemap.end())
				{
					UserData *udptr = new UserData(itr->first, udtItr->second, true);
					
					uptr->InsertElement(UsrtPair(itr->first, UdtPair(itr->second, udptr->GetPtr())));
					uptr->udtvec.push_back(udptr); continue;
				}
				else
					HandleSyntaxError(L"Can NOT find UserDefinedType.\r\n");
			}

		case TypeUPtr:
			{
				NameUdtMapItr udtItr = this->elemap.find(itr->first);

				if(udtItr != elemap.end())
				{
					UPtrData *udptr = new UPtrData(itr->first, udtItr->second, true);
					uptr->InsertElement(UsrtPair(itr->first, UdtPair(itr->second, udptr)));
					continue;
				}
					HandleSyntaxError(L"Can NOT find UserDefinedType.\r\n");
			}
		}
	}

	return uptr;
}

void UserDefinedType::AllocateMemory(usertype* const uptr)
{
#ifdef _DEBUG

	if(uptr->GetTypeTag()==std::wstring(L""))
		uptr->SetID(this->typetag);
#endif
	
	uptr->ClearEleMap(); uptr->udtPtr = this; 

	for(TypeMapItr itr=typemap.begin();itr != typemap.end(); ++itr)
	{
		switch(itr->second)
		{
		case TypeBool: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeBool, new bool())));		continue;
		case TypeStrn: uptr->InsertElement(UsrtPair(itr->first,	UdtPair(TypeStrn, new string())));		continue;
		case TypeIntg: uptr->InsertElement(UsrtPair(itr->first,	UdtPair(TypeIntg, new integer())));		continue;
		case TypeReal: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeReal, new realnum())));		continue;
		case TypeCplx: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeCplx, new Complex())));		continue;
		case TypeVctr: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeVctr, new Vector())));		continue;
		
		case TypeAi1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi1D, new IntgAry1D())));	continue;
		case TypeAr1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr1D, new RealAry1D())));	continue;
		case TypeAc1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc1D, new CplxAry1D())));	continue;
		case TypeAv1D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv1D, new VctrAry1D())));	continue;

		case TypeAi2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi2D, new IntgAry2D())));	continue;
		case TypeAr2D: uptr->InsertElement(UsrtPair(itr->first,	UdtPair(TypeAr2D, new RealAry2D())));	continue;
		case TypeAc2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc2D, new CplxAry2D())));	continue;
		case TypeAv2D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv2D, new VctrAry2D())));	continue;

		case TypeAi3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi3D, new IntgAry3D())));	continue;
		case TypeAr3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr3D, new RealAry3D())));	continue;
		case TypeAc3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc3D, new CplxAry3D())));	continue;
		case TypeAv3D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv3D, new VctrAry3D())));	continue;

		case TypeAi4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi4D, new IntgAry4D())));	continue;
		case TypeAr4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr4D, new RealAry4D())));	continue;
		case TypeAc4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc4D, new CplxAry4D())));	continue;
		case TypeAv4D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv4D, new VctrAry4D())));	continue;

		case TypeAi5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAi5D, new IntgAry5D())));	continue;
		case TypeAr5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAr5D, new RealAry5D())));	continue;
		case TypeAc5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAc5D, new CplxAry5D())));	continue;
		case TypeAv5D: uptr->InsertElement(UsrtPair(itr->first, UdtPair(TypeAv5D, new VctrAry5D())));	continue;

		case TypeUser:
			{
				NameUdtMapItr udtItr = this->elemap.find(itr->first);

				if(udtItr != elemap.end())
				{
					UserData *udptr = new UserData(itr->first, udtItr->second, true);
					uptr->InsertElement(UsrtPair(itr->first, UdtPair(itr->second, udptr->GetPtr())));
					uptr->udtvec.push_back(udptr); continue;
				}
				else
					HandleSyntaxError(L"Can NOT find UserDefinedType.\r\n");
			}
		
		case TypeUPtr:
			{
				NameUdtMapItr udtItr = this->elemap.find(itr->first);

				if(udtItr != elemap.end())
				{
					UPtrData *udptr = new UPtrData(itr->first, udtItr->second, true);
					uptr->InsertElement(UsrtPair(itr->first, UdtPair(itr->second, udptr))); continue;
				}
				else
					HandleSyntaxError(L"Can NOT find UserDefinedType.\r\n");
			}
		}
	}
}

UserDefinedType::~UserDefinedType() { }

MemoryManager::MemoryManager() { }

void* MemoryManager::CreateMemory(DataType type)
{
	void *ptr = NULL;

	switch(type)
	{
	case TypeBool: ptr = new bool();		break;
	case TypeStrn: ptr = new string();		break;
	case TypeIntg: ptr = new integer();		break;
	case TypeReal: ptr = new realnum();		break;
	case TypeCplx: ptr = new Complex();		break;
	case TypeVctr: ptr = new Vector();		break;

	case TypeAi1D: ptr = new IntgVec1D();	break;
	case TypeAr1D: ptr = new RealVec1D();	break;
	case TypeAc1D: ptr = new CplxVec1D();	break;
	case TypeAv1D: ptr = new VctrVec1D();	break;

	case TypeAi2D: ptr = new IntgVec2D();	break;
	case TypeAr2D: ptr = new RealVec2D();	break;
	case TypeAc2D: ptr = new CplxVec2D();	break;
	case TypeAv2D: ptr = new VctrVec2D();	break;

	case TypeAi3D: ptr = new IntgVec3D();	break;
	case TypeAr3D: ptr = new RealVec3D();	break;
	case TypeAc3D: ptr = new CplxVec3D();	break;
	case TypeAv3D: ptr = new VctrVec3D();	break;

	case TypeAi4D: ptr = new IntgVec4D();	break;
	case TypeAr4D: ptr = new RealVec4D();	break;
	case TypeAc4D: ptr = new CplxVec4D();	break;
	case TypeAv4D: ptr = new VctrVec4D();	break;

	case TypeAi5D: ptr = new IntgVec5D();	break;
	case TypeAr5D: ptr = new RealVec5D();	break;
	case TypeAc5D: ptr = new CplxVec5D();	break;
	case TypeAv5D: ptr = new VctrVec5D();	break;
	
	default:
		HandleSyntaxError(L"MemoryManager::CreateMemroy(), unsupported allocation type.\r\n");
	}
	
	memmap.insert(MemPair(ptr, type)); return ptr; 
}

void MemoryManager::Clear()
{
	int count = int(memmap.size());
	if(count>0)
	{
		std::wostringstream os;
		os<<L"Warning:  "<<count<<L" dynamically allocated objects were not properly deleted.\r\n";
		PutString(os.str());
	}

	for(MemMapItr itr = memmap.begin(); 
		itr != memmap.end(); ++itr)
	{
		switch(itr->second)
		{
		case TypeBool: delete (bool*) itr->first;		continue;
		case TypeStrn: delete (string*) itr->first;		continue;
		case TypeIntg: delete (integer*) itr->first;	continue;
		case TypeReal: delete (realnum*) itr->first;	continue;
		case TypeCplx: delete (Complex*) itr->first;	continue;
		case TypeVctr: delete (Vector*) itr->first;		continue;

		case TypeUser: delete (UserData*) itr->first;	continue;

		case TypeAi1D: delete (IntgVec1D*) itr->first;	continue;
		case TypeAr1D: delete (RealVec1D*) itr->first;	continue;
		case TypeAc1D: delete (CplxVec1D*) itr->first;	continue;
		case TypeAv1D: delete (VctrVec1D*) itr->first;	continue;

		case TypeAi2D: delete (IntgVec2D*) itr->first;	continue;
		case TypeAr2D: delete (RealVec2D*) itr->first;	continue;
		case TypeAc2D: delete (CplxVec2D*) itr->first;	continue;
		case TypeAv2D: delete (VctrVec2D*) itr->first;	continue;

		case TypeAi3D: delete (IntgVec3D*) itr->first;	continue;
		case TypeAr3D: delete (RealVec3D*) itr->first;	continue;
		case TypeAc3D: delete (CplxVec3D*) itr->first;	continue;
		case TypeAv3D: delete (VctrVec3D*) itr->first;	continue;

		case TypeAi4D: delete (IntgVec4D*) itr->first;	continue;
		case TypeAr4D: delete (RealVec4D*) itr->first;	continue;
		case TypeAc4D: delete (CplxVec4D*) itr->first;	continue;
		case TypeAv4D: delete (VctrVec4D*) itr->first;	continue;

		case TypeAi5D: delete (IntgVec5D*) itr->first;	continue;
		case TypeAr5D: delete (RealVec5D*) itr->first;	continue;
		case TypeAc5D: delete (CplxVec5D*) itr->first;	continue;
		case TypeAv5D: delete (VctrVec5D*) itr->first;	continue;
			
		default:
			HandleSyntaxError(L"MemoryManager::clear(), unsupported data type.\r\n");
		}
	}
	
	memmap.clear();
}

void MemoryManager::Release(void *ptr)
{
	MemMapItr itr = memmap.find(ptr);
	if(itr == memmap.end())
	{

#ifdef _DEBUG
		PutString(L"Memory to delete not found.\r\n");
#endif
		return;
	}
	else
	{
#ifdef _DEBUG
		
		PutString(L"Memory deleted.\r\n");
#endif
		switch(itr->second)
		{
		case TypeBool: delete (bool*) itr->first;		break;
		case TypeStrn: delete (string*) itr->first;		break;
		case TypeIntg: delete (integer*) itr->first;	break;
		case TypeReal: delete (realnum*) itr->first;	break;
		case TypeCplx: delete (Complex*) itr->first;	break;
		case TypeVctr: delete (Vector*) itr->first;		break;

		case TypeUser: delete (UserData*) itr->first;	break;

		case TypeAi1D: delete (IntgVec1D*) itr->first;	break;
		case TypeAr1D: delete (RealVec1D*) itr->first;	break;
		case TypeAc1D: delete (CplxVec1D*) itr->first;	break;
		case TypeAv1D: delete (VctrVec1D*) itr->first;	break;

		case TypeAi2D: delete (IntgVec2D*) itr->first;	break;
		case TypeAr2D: delete (RealVec2D*) itr->first;	break;
		case TypeAc2D: delete (CplxVec2D*) itr->first;	break;
		case TypeAv2D: delete (VctrVec2D*) itr->first;	break;

		case TypeAi3D: delete (IntgVec3D*) itr->first;	break;
		case TypeAr3D: delete (RealVec3D*) itr->first;	break;
		case TypeAc3D: delete (CplxVec3D*) itr->first;	break;
		case TypeAv3D: delete (VctrVec3D*) itr->first;	break;

		case TypeAi4D: delete (IntgVec4D*) itr->first;	break;
		case TypeAr4D: delete (RealVec4D*) itr->first;	break;
		case TypeAc4D: delete (CplxVec4D*) itr->first;	break;
		case TypeAv4D: delete (VctrVec4D*) itr->first;	break;

		case TypeAi5D: delete (IntgVec5D*) itr->first;	break;
		case TypeAr5D: delete (RealVec5D*) itr->first;	break;
		case TypeAc5D: delete (CplxVec5D*) itr->first;	break;
		case TypeAv5D: delete (VctrVec5D*) itr->first;	break;
				
		default:
			HandleSyntaxError(L"MemoryManager::Release(), unsupported data type.\r\n");
		}

		memmap.erase(ptr); ptr = NULL;
	}
}

UserData* MemoryManager::AllocateUserData(UserDefinedType *udtPtr)
{
	UserData *ptr = new UserData(L"Dynamic UserData", udtPtr, true);
	memmap.insert(MemPair(ptr, TypeUser)); return ptr;
}

MemoryManager::~MemoryManager() { Clear(); }

UserData* AllocateUserData(UserDefinedType *udtPtr)
{
	return gMM.AllocateUserData(udtPtr);
}

DataTemp<usertype>* usertype::FindUserData(const std::wstring& id)
{
	UsrtMapItr itr = elemap.find(id);

	if(itr != elemap.end()) 
	{
		if(itr->second.first == TypeUser)
		{
			int count = int(this->udtvec.size());
			for(int i=0; i< count; ++i)
			{
				if(udtvec[i]->GetId() == id) 
					return udtvec[i];
			}

			return NULL;
		}
		else if(itr->second.first == TypeUPtr)
		{
			return ((UPtrData*)itr->second.second)->GetData();
		}
		else return NULL;
	}
	else return NULL;
}