// ExplorerBar.cpp : implementation file
//

#include "stdafx.h"
#include "Yal.h"
#include "ExplorerBar.h"
#include "WebDoc.h"
#include "WebView.h"
#include "MainFrame.h"
#include "WebFrame.h"

#include "resource.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int idTree = 1;

/////////////////////////////////////////////////////////////////////////////
// CExplorerBar

CExplorerBar::CExplorerBar()
{
}

CExplorerBar::~CExplorerBar()
{
}

BEGIN_MESSAGE_MAP(CExplorerBar, CBCGPTasksPane)
	//{{AFX_MSG_MAP(CExplorerBar)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_NOTIFY(TVN_SELCHANGED, idTree, OnSelectTree)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExplorerBar message handlers

int CExplorerBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	SetWindowText (_T("My Links"));
	if (CBCGPTasksPane::OnCreate(lpCreateStruct) == -1)
		return -1;

	EnableOffsetCustomControls (FALSE);

	// ----------------------
	// Create favorites list:
	// ----------------------
	CRect rectDummy (0, 0, 0, 0);
	const DWORD dwTreeStyle =	WS_CHILD | WS_VISIBLE | TVS_SINGLEEXPAND | TVS_TRACKSELECT;

	if(!m_wndFavorites.Create (dwTreeStyle, rectDummy,
		this, idTree))
	{
		TRACE0("Failed to create the Favorites window\n");
		return FALSE;      // fail to create
	}

	theApp.m_Favorites.FillTree (m_wndFavorites);

	// -----------
	// Add groups:
	// -----------
	int nGroup1 = AddGroup (_T("Favorites"), FALSE, TRUE);
	AddWindow (nGroup1, m_wndFavorites.GetSafeHwnd (), 200);

	int nGroup2 = AddGroup (_T("Links"));

	AddTask (nGroup2, _T("Yet Another Language Tutorial"), -1,        ID_TUTORIAL);
	AddTask (nGroup2, _T("Online Encyclopedia"), -1, ID_BEST_INFO_PDR);
	AddTask (nGroup2, _T("Science World"), -1,		 ID_LINK_SCIWOLRD); 
	AddTask (nGroup2, _T("Scientific American"), -1, ID_LINK_SCIAM);  
	AddTask (nGroup2, _T("Institute of Physics"), -1, ID_LINK_IOP); 
	AddTask (nGroup2, _T("Medical Information"),  -1, ID_LINK_DOCDOC); 

	return 0;
}
//************************************************************************************
void CExplorerBar::OnSelectTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	HTREEITEM hTreeItem = m_wndFavorites.GetSelectedItem ();
	if (hTreeItem != NULL)
	{
		CFavorit* pFavorit = (CFavorit*) m_wndFavorites.GetItemData (hTreeItem);
		ASSERT_VALID (pFavorit);

		if (!pFavorit->GetURL ().IsEmpty ())
		{
			CMainFrame *pMainFrame = (CMainFrame*)::AfxGetMainWnd();
			CWebView *pView=NULL;
			if(pView=DYNAMIC_DOWNCAST(CWebView, pMainFrame->GetActiveFrame()->GetActiveView()))
			{
				pView->SetFocus();
				pView->Navigate2(pFavorit->GetURL());
			}
			else
			{				
				pMainFrame->pNewAddress->SetEditText(pFavorit->GetURL());
				theApp.OnNewPane = true; theApp.OnNewWeb();
			}
		}
	}
	
	*pResult = 0;
}
