// MainFrame.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Yal.h"

#include "YalView.h"
#include "MainFrame.h"

#include "WebView.h"
#include "WebDoc.h"
#include "WebFrame.h"

#include "StartupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	WM_ICON_NOTIFY		WM_USER+10

const int IdStartProgressTimer = 1;
const int IdShowProgressTimer = 2;

// Update image count here
const int RunnerCount = 4;

const DWORD idTabDeveloper = 101;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CBCGPMDIFrameWnd)


BEGIN_MESSAGE_MAP(CMainFrame, CBCGPMDIFrameWnd)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_COMMAND(ID_ADDRESSBOX, OnNewAddress)
	ON_COMMAND(ID_HELP_FINDER, CBCGPMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CBCGPMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CBCGPMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CBCGPMDIFrameWnd::OnHelpFinder)
	ON_REGISTERED_MESSAGE(BCGM_CUSTOMIZEHELP, OnHelpCustomizeToolbars)

	ON_COMMAND(ID_WINDOW_MANAGER, OnWindowManager)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_MANAGER, OnUpdateWindowManager)

	ON_COMMAND_RANGE(ID_VIEW_APPLOOK_2000, ID_VIEW_APPLOOK_VS2008, OnAppLook)
	ON_UPDATE_COMMAND_UI_RANGE(ID_VIEW_APPLOOK_2000, ID_VIEW_APPLOOK_VS2008, OnUpdateAppLook)

	ON_COMMAND(ID_MDI_MOVE_TO_NEXT_GROUP, OnMdiMoveToNextGroup)
	ON_COMMAND(ID_MDI_MOVE_TO_PREV_GROUP, OnMdiMoveToPrevGroup)
	ON_COMMAND(ID_MDI_NEW_HORZ_TAB_GROUP, OnMdiNewHorzTabGroup)
	ON_COMMAND(ID_MDI_NEW_VERT_TAB_GROUP, OnMdiNewVertGroup)
	ON_COMMAND(ID_MDI_CANCEL, OnMdiCancel)
	//ON_COMMAND(ID_VIEW_WORKSPACE, OnViewWorkspace)
	//ON_UPDATE_COMMAND_UI(ID_VIEW_WORKSPACE, OnUpdateViewWorkspace)
	//ON_COMMAND(ID_VIEW_WORKSPACE2, OnViewWorkspace2)
	//ON_UPDATE_COMMAND_UI(ID_VIEW_WORKSPACE2, OnUpdateViewWorkspace2)
	ON_COMMAND(ID_VIEW_OUTPUT, OnViewOutput)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OUTPUT, OnUpdateViewOutput)
	
	ON_COMMAND(ID_EDIT_CLEAROUTPUT, &CMainFrame::OnEditClearoutput)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAROUTPUT, &CMainFrame::OnUpdateEditClearoutput)

	ON_COMMAND(ID_VIEW_EXPLORERBAR, OnViewExplorerbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_EXPLORERBAR, OnUpdateViewExplorerbar)

	ON_COMMAND_RANGE(FIRST_FAVORITE_COMMAND, LAST_FAVORITE_COMMAND, OnFavorite)
	ON_COMMAND_RANGE(FIRST_HISTORY_COMMAND, FIRST_HISTORY_COMMAND + HISTORY_LEN - 1, OnHistory)

	ON_COMMAND(ID_VIEW_LINKS, &CMainFrame::OnViewLinks)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LINKS, &CMainFrame::OnUpdateViewLinks)
	ON_WM_CLOSE()
	
	ON_COMMAND(ID_POPUP_OPTION1, OnPopupOption1)
	ON_UPDATE_COMMAND_UI(ID_POPUP_OPTION1, OnUpdatePopupOption1)
	ON_COMMAND(ID_POPUP_OPTION2, OnPopupOption2)
	
	ON_COMMAND(ID_TOOLS_OPTIONS, OnToolsOptions)

	ON_COMMAND(ID_NEW_TAB, &CMainFrame::OnViewNewWindow)
	ON_COMMAND(ID_TUTORIAL, &CMainFrame::OnTutorial)
	ON_COMMAND(ID_YAL_HELP, &CMainFrame::OnYalHelp)
	ON_COMMAND(ID_YALHOME, &CMainFrame::OnYalhome)
	ON_COMMAND(ID_FILE_SAVE_ALL, &CMainFrame::OnFileSaveAll)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_ALL, &CMainFrame::OnUpdateFileSaveAll)
	ON_COMMAND(ID_COMMAND_RELOAD, &CMainFrame::OnCommandReload)
	ON_COMMAND(ID_BEST_INFO_PDR, &CMainFrame::OnBestInfoPdr)
	ON_COMMAND(ID_LINK_DOCDOC, &CMainFrame::OnLinkDocdoc)
	ON_COMMAND(ID_LINK_IOP, &CMainFrame::OnLinkIop)
	ON_COMMAND(ID_LINK_SCIAM, &CMainFrame::OnLinkSciam)
	ON_COMMAND(ID_LINK_SCIWOLRD, &CMainFrame::OnLinkSciwolrd)
END_MESSAGE_MAP()

/*
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
*/

static UINT indicators[] =
{
	ID_INDICATOR_ICON,		// status icon
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_PROGRESS,	// progress bar
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

const int nStatusIcon = 0;
const int nStatusInfo = 1;
const int nStatusProgress = 2;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_nAppLook = theApp.GetInt (_T("ApplicationLook"), ID_VIEW_APPLOOK_2007);
	// TODO: add member initialization code here

	m_nProgressValue = -1;
	m_bInfiniteProgressMode = TRUE;
	mFontSize = ID_VIEW_FONTS_MEDIUM;
	m_Option1Enabled = TRUE;
	CallCount=0;
}

CMainFrame::~CMainFrame()
{
}

void CMainFrame::OnAppLook(UINT id)
{
	CBCGPDockManager::SetDockMode (DT_SMART);

	m_nAppLook = id;

	CBCGPTabbedControlBar::m_StyleTabWnd = CBCGPTabWnd::STYLE_3D;

	CBCGPMDITabParams mdiTabParams;
	mdiTabParams.m_bTabIcons = TRUE;

	switch (m_nAppLook)
	{
	case ID_VIEW_APPLOOK_2000:
		// enable Office 2000 look:
		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManager));
		break;

	case ID_VIEW_APPLOOK_XP:
		// enable Office XP look:
		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManagerXP));
		break;

	case ID_VIEW_APPLOOK_WIN_XP:
		// enable Windows XP look (in other OS Office XP look will be used):
		CBCGPWinXPVisualManager::m_b3DTabsXPTheme = TRUE;
		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPWinXPVisualManager));
		break;

	case ID_VIEW_APPLOOK_2003:
		// enable Office 2003 look:
		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManager2003));

		mdiTabParams.m_style = CBCGPTabWnd::STYLE_3D_VS2005;
		mdiTabParams.m_bAutoColor = TRUE;
		CBCGPDockManager::SetDockMode (DT_SMART);
		break;

	case ID_VIEW_APPLOOK_2007:
	case ID_VIEW_APPLOOK_2007_1:
	case ID_VIEW_APPLOOK_2007_2:
	case ID_VIEW_APPLOOK_2007_3:
		// enable Office 2007 look:
		switch (m_nAppLook)
		{
		case ID_VIEW_APPLOOK_2007:
			CBCGPVisualManager2007::SetStyle (CBCGPVisualManager2007::VS2007_LunaBlue);
			break;

		case ID_VIEW_APPLOOK_2007_1:
			CBCGPVisualManager2007::SetStyle (CBCGPVisualManager2007::VS2007_ObsidianBlack);
			break;

		case ID_VIEW_APPLOOK_2007_2:
			CBCGPVisualManager2007::SetStyle (CBCGPVisualManager2007::VS2007_Silver);
			break;

		case ID_VIEW_APPLOOK_2007_3:
			CBCGPVisualManager2007::SetStyle (CBCGPVisualManager2007::VS2007_Aqua);
			break;
		}

		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManager2007));

		mdiTabParams.m_style = CBCGPTabWnd::STYLE_3D_VS2005;
		mdiTabParams.m_bAutoColor = TRUE;
		CBCGPDockManager::SetDockMode (DT_SMART);
		break;

	case ID_VIEW_APPLOOK_VS2005:
		// enable VS 2005 look:
		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManagerVS2005));

		mdiTabParams.m_style = CBCGPTabWnd::STYLE_3D_VS2005;
		mdiTabParams.m_bDocumentMenu = TRUE;
		CBCGPDockManager::SetDockMode (DT_SMART);
		break;

	case ID_VIEW_APPLOOK_VS2008:
		// enable VS 2008 look:
		CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManagerVS2008));

		mdiTabParams.m_style = CBCGPTabWnd::STYLE_3D_VS2005;
		mdiTabParams.m_bDocumentMenu = TRUE;
		CBCGPDockManager::SetDockMode (DT_SMART);
		break;
	}

	EnableMDITabbedGroups (TRUE, mdiTabParams);

	CBCGPDockManager* pDockManager = GetDockManager ();
	if (pDockManager != NULL)
	{
		ASSERT_VALID (pDockManager);
		pDockManager->AdjustBarFrames ();
	}

	CBCGPTabbedControlBar::ResetTabs ();

	RecalcLayout ();
	RedrawWindow (NULL, NULL, RDW_ALLCHILDREN | RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);

	theApp.WriteInt (_T("ApplicationLook"), m_nAppLook);
}

void CMainFrame::OnUpdateAppLook(CCmdUI* pCmdUI)
{
	pCmdUI->SetRadio (m_nAppLook == pCmdUI->m_nID);
}

void CMainFrame::OnPopupOption1() 
{
	//MessageBox(_T("You chose Option 1"));	
	m_TrayIcon.RemoveIcon();
	m_TrayIcon.DestroyWindow();
	this->ShowWindow(SW_SHOWNORMAL);

}

void CMainFrame::OnUpdatePopupOption1(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Option1Enabled);
}

void CMainFrame::OnPopupOption2() 
{
	m_Option1Enabled = !m_Option1Enabled;

	CString str;
	str.Format(_T("You chose option 2. Option 1 is now %s"), 
		m_Option1Enabled? _T("Enabled") : _T("Disabled"));

	MessageBox(str);
}

void CMainFrame::OnNewAddress()
{
	// gets called when an item in the Address combo box is selected
	// just navigate to the newly selected location.
	this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	theApp.OnNewPane = true; theApp.OnNewWeb();
}

void CMainFrame::OnViewNewWindow()
{
	// TODO: Add your command handler code here
	//this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	//::AfxMessageBox(_T("Called CMainFrame::OnViewNewWindow()"));
	++CallCount;
	if(CallCount==1)
	{
		theApp.OnNewPane = true; theApp.OnNewWeb();
	}
	else CallCount = 0;
}


void CMainFrame::StartAnimation()
{
	// Start the animation.  This is called when the browser begins to
	// navigate to a new location
	m_wndAnimate.Play();

	m_wndStatusBar.SetPaneAnimation (nStatusIcon, m_imlStatusAnimation);
}

void CMainFrame::SetAddress(LPCTSTR lpszUrl)
{
	// This is called when the browser has completely loaded the new location,
	// so make sure the text in the address bar is up to date and stop the
	// animation.
	//m_wndAddress.SetWindowText(lpszUrl);
	this->pAddressBox->AddItem(lpszUrl);

	m_wndAnimate.Stop();

	m_wndStatusBar.SetPaneIcon (nStatusIcon, m_bmpStatus);
}

void CMainFrame::SetProgress (long nCurr, long nTotal)
{
	m_wndStatusBar.EnablePaneProgressBar (nStatusProgress, nTotal);

	if (nTotal >= 0)
	{
		m_wndStatusBar.SetPaneProgress (nStatusProgress, min (nTotal, max (0, nCurr)));
	}
	else
	{
		m_wndStatusBar.RedrawWindow ();
	}
}

BOOL CMainFrame::CreateStatusBar()
{
	//-------------------
	// Create status bar:
	//-------------------
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return FALSE;      // fail to create
	}

	//------------------------------
	// First pane - image/animation:
	//------------------------------
	m_wndStatusBar.SetPaneStyle (nStatusIcon, SBPS_NOBORDERS);

	m_bmpStatus.LoadBitmap (IDB_STATUS_READY);
	m_imlStatusAnimation.Create (IDB_STATUS_ANIMATION, 11, 0, RGB (255, 0, 255));

	m_wndStatusBar.SetPaneIcon (nStatusIcon, m_bmpStatus);
	m_wndStatusBar.SetPaneText (nStatusIcon, NULL);
	m_wndStatusBar.SetPaneWidth (nStatusIcon, 0);

	m_wndStatusBar.SetPaneStyle (nStatusInfo, SBPS_STRETCH | SBPS_NOBORDERS);
	m_wndStatusBar.SetPaneWidth (nStatusProgress, 80);
	
	return TRUE;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CBCGPMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	OnAppLook(m_nAppLook);

	CBCGPVisualManager::SetDefaultManager (RUNTIME_CLASS (CBCGPVisualManager2007));

	CBCGPMDITabParams mdiTabParams;
	mdiTabParams.m_bTabIcons = TRUE;
	mdiTabParams.m_bAutoColor = TRUE;
	mdiTabParams.m_style = CBCGPTabWnd::STYLE_3D_VS2005;
	
	EnableMDITabbedGroups (TRUE, mdiTabParams);

	CBCGPDockManager::SetDockMode (DT_SMART);

	//-----------------------
	// Set up Favorites menu:
	//-----------------------
	VERIFY (theApp.m_Favorites.CreateMenu (m_menuFavotites));
		
	m_wndRibbonBar.Create (this);
	InitRibbon ();

	CreateStatusBar();

	// Load control bar icons:
	CBCGPToolBarImages imagesWorkspace;
	imagesWorkspace.SetImageSize (CSize (16, 16));
	imagesWorkspace.SetTransparentColor (RGB (255, 0, 255));
	imagesWorkspace.Load (IDB_WORKSPACE);

	/*
	if (!m_wndWorkSpace.Create (_T("View  1"), this, CRect (0, 0, 200, 200),
		TRUE, ID_VIEW_WORKSPACE,
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CBRS_LEFT | CBRS_FLOAT_MULTI))
	{
		TRACE0("Failed to create Workspace bar\n");
		return FALSE;      // fail to create
	}

	m_wndWorkSpace.SetIcon (imagesWorkspace.ExtractIcon (0), FALSE);

	if (!m_wndWorkSpace2.Create (_T("View 2"), this, CRect (0, 0, 200, 200),
		TRUE, ID_VIEW_WORKSPACE2,
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CBRS_LEFT | CBRS_FLOAT_MULTI))
	{
		TRACE0("Failed to create Workspace bar 2\n");
		return FALSE;      // fail to create
	}

	m_wndWorkSpace2.SetIcon (imagesWorkspace.ExtractIcon (1), FALSE);
	*/


	if (!m_wndOutputBar.Create (_T("Output"), this, CRect (0, 0, 150, 150),
		TRUE , ID_VIEW_OUTPUT,
		WS_CHILD | WS_VISIBLE | CBRS_BOTTOM | CBRS_FLOAT_MULTI))
	{
		TRACE0("Failed to create output bar\n");
		return -1;      // fail to create
	}

	if (!m_wndExplorerBar.Create (_T("My Links"), this, CRect (0, 0, 200, 200),
		TRUE, ID_VIEW_EXPLORERBAR,
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CBRS_LEFT | CBRS_FLOAT_MULTI))
	{
		TRACE0("Failed to create explorerbar\n");
		return FALSE;		// fail to create
	}

	m_wndExplorerBar.EnableDocking (CBRS_ALIGN_ANY);
		
	m_wndOutputBar.SetIcon (imagesWorkspace.ExtractIcon (2), FALSE);

	//m_wndWorkSpace.EnableDocking(CBRS_ALIGN_ANY);
	//m_wndWorkSpace2.EnableDocking(CBRS_ALIGN_ANY);
	m_wndOutputBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	EnableAutoHideBars(CBRS_ALIGN_ANY);
	//DockControlBar (&m_wndWorkSpace);
	//m_wndWorkSpace2.AttachToTabWnd (&m_wndWorkSpace, DM_STANDARD, FALSE, NULL);
	//m_wndExplorerBar.AttachToTabWnd(&m_wndWorkSpace2, DM_STANDARD, FALSE, NULL);
	
	DockControlBar (&m_wndExplorerBar);
	DockControlBar(&m_wndOutputBar);

	// Enable windows manager:
	EnableWindowsDialog (ID_WINDOW_MANAGER, IDS_WINDOWS_MANAGER, TRUE);

	return 0;
}

void CMainFrame::OnViewExplorerbar() 
{
	ShowControlBar (&m_wndExplorerBar, (m_wndExplorerBar.GetStyle () & WS_VISIBLE) == 0, FALSE, TRUE);
}
//********************************************************************************************
void CMainFrame::OnUpdateViewExplorerbar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndExplorerBar.IsWindowVisible ());
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CBCGPMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CBCGPMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CBCGPMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnWindowManager() 
{
	ShowWindowsDialog ();
}

void CMainFrame::OnUpdateWindowManager(CCmdUI* pCmdUI)
{
	pCmdUI->Enable (!IsPrintPreviewMode ());
}

BOOL CMainFrame::OnShowMDITabContextMenu (CPoint point, DWORD dwAllowedItems, BOOL bDrop)
{
	CMenu menu;
	VERIFY(menu.LoadMenu (bDrop ? IDR_POPUP_DROP_MDITABS : IDR_POPUP_MDITABS));

	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);

	if ((dwAllowedItems & BCGP_MDI_CREATE_HORZ_GROUP) == 0)
	{
		pPopup->DeleteMenu (ID_MDI_NEW_HORZ_TAB_GROUP, MF_BYCOMMAND);
	}

	if ((dwAllowedItems & BCGP_MDI_CREATE_VERT_GROUP) == 0)
	{
		pPopup->DeleteMenu (ID_MDI_NEW_VERT_TAB_GROUP, MF_BYCOMMAND);
	}

	if ((dwAllowedItems & BCGP_MDI_CAN_MOVE_NEXT) == 0)
	{
		pPopup->DeleteMenu (ID_MDI_MOVE_TO_NEXT_GROUP, MF_BYCOMMAND);
	}

	if ((dwAllowedItems & BCGP_MDI_CAN_MOVE_PREV) == 0)
	{
		pPopup->DeleteMenu (ID_MDI_MOVE_TO_PREV_GROUP, MF_BYCOMMAND);
	}

	CBCGPPopupMenu* pPopupMenu = new CBCGPPopupMenu;
	pPopupMenu->SetAutoDestroy (FALSE);
	pPopupMenu->Create (this, point.x, point.y, pPopup->GetSafeHmenu ());

	return TRUE;
}

void CMainFrame::OnMdiMoveToNextGroup() 
{
	MDITabMoveToNextGroup ();
}

void CMainFrame::OnMdiMoveToPrevGroup() 
{
	MDITabMoveToNextGroup (FALSE);
}

void CMainFrame::OnMdiNewHorzTabGroup() 
{
	MDITabNewGroup (FALSE);
}

void CMainFrame::OnMdiNewVertGroup() 
{
	MDITabNewGroup ();
}

void CMainFrame::OnMdiCancel() 
{
	// TODO: Add your command handler code here
	
}

CBCGPMDIChildWnd* CMainFrame::CreateDocumentWindow (LPCTSTR lpcszDocName, CObject* /*pObj*/)
{
	if (lpcszDocName != NULL && lpcszDocName [0] != _T('\0'))
	{
		CDocument* pDoc = AfxGetApp()->OpenDocumentFile (lpcszDocName);

		if (pDoc != NULL)
		{
			POSITION pos = pDoc->GetFirstViewPosition();

			if (pos != NULL)
			{
				CView* pView = pDoc->GetNextView (pos);
				if (pView == NULL)
				{
					return NULL;
				}

				return DYNAMIC_DOWNCAST (CBCGPMDIChildWnd, pView->GetParent ());
			}   
		}
	}

	return NULL;
}

void CMainFrame::OnViewWorkspace() 
{
	/*
	ShowControlBar (&m_wndWorkSpace,
					!(m_wndWorkSpace.IsVisible ()),
					FALSE, TRUE);
	RecalcLayout ();
	*/
}

void CMainFrame::OnUpdateViewWorkspace(CCmdUI* pCmdUI) 
{
	/*
	pCmdUI->SetCheck (m_wndWorkSpace.IsVisible ());
	pCmdUI->Enable (!IsPrintPreviewMode ());
	*/
}

void CMainFrame::OnViewWorkspace2() 
{
	/*
	ShowControlBar (&m_wndWorkSpace2,
					!(m_wndWorkSpace2.IsVisible ()),
					FALSE, TRUE);
	RecalcLayout ();
	*/
}

void CMainFrame::OnUpdateViewWorkspace2(CCmdUI* pCmdUI) 
{
	/*
	pCmdUI->SetCheck (m_wndWorkSpace2.IsVisible ());
	pCmdUI->Enable (!IsPrintPreviewMode ());
	*/

}

void CMainFrame::OnViewOutput() 
{
	ShowControlBar(&m_wndOutputBar, !(m_wndOutputBar.IsVisible()), FALSE, TRUE);
	RecalcLayout ();
}

void CMainFrame::OnUpdateViewOutput(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndOutputBar.IsVisible ());
	pCmdUI->Enable (!IsPrintPreviewMode ());
}


void CMainFrame::OnFavorite(UINT nID)
{
	pNewAddress->SetEditText(theApp.m_Favorites.GetURLofID(nID));
	theApp.OnNewPane = true; theApp.OnNewWeb();
}

void CMainFrame::OnHistory(UINT nID)
{
	
	CWebView* pView = ((CWebView*)GetActiveView());
	ASSERT_VALID (pView);

	CWebDoc* pDoc = pView->GetDocument();
	ASSERT_VALID(pDoc);

	CHistoryObj* pObj = pDoc->Go (nID);
	ASSERT (pObj != NULL);

	pView->Navigate2 (pObj->GetURL (), 0, NULL);
}

void CMainFrame::InitRibbon ()
{
	///////////////////////////////
	// Load panel images:
	///////////////////////////////
	m_PanelImages.SetImageSize (CSize (16, 16));
	m_PanelImages.Load (IDB_BUTTONS);

	m_LinkImages.SetImageSize(CSize(32,32));
	m_LinkImages.Load(IDB_LINK_LARGE);

	m_WebImages.SetImageSize(CSize(23, 23));
	m_WebImages.Load(IDB_HOTTOOLBAR);

	////////////////////////////
	// Init main button:
	//////////////////////////////
	m_MainButton.SetImage (IDB_MAIN);
	m_MainButton.SetToolTipText (_T("File"));

	m_wndRibbonBar.SetMainButton (&m_MainButton, CSize (45, 45));

	CBCGPRibbonMainPanel* pMainPanel = 
		m_wndRibbonBar.AddMainCategory (_T("File"), IDB_FILESMALL, IDB_FILELARGE);

	CBCGPRibbonButton* pBtnNewDoc = new CBCGPRibbonButton (ID_FILE_NEW, _T("New"), 0, 1);

	pBtnNewDoc->AddSubItem(new CBCGPRibbonLabel (_T("Select a new document type to create or open.")));
	pBtnNewDoc->AddSubItem(new CBCGPRibbonButton (ID_NEW_YAL, _T("Yet Another Language"), 7, 5, TRUE));
	pBtnNewDoc->AddSubItem(new CBCGPRibbonButton (ID_NEW_WEB, _T("New Web Page"), 7, 0, TRUE));

	pMainPanel->Add (pBtnNewDoc);

	pMainPanel->Add (new CBCGPRibbonButton (ID_FILE_OPEN, _T("Open..."), 1, 2));
	pMainPanel->Add (new CBCGPRibbonButton (ID_FILE_SAVE, _T("Save"), 2, 3));
	pMainPanel->Add (new CBCGPRibbonButton (ID_FILE_SAVE_ALL, _T("Save All"), 16, 15));
	pMainPanel->Add (new CBCGPRibbonButton (ID_FILE_SAVE_AS, _T("Save As..."), 3, 4));

	CBCGPRibbonButton* pBtnPrint = 
		new CBCGPRibbonButton (ID_FILE_PRINT, _T("Print"), 6, 7);

	pBtnPrint->AddSubItem (new CBCGPRibbonLabel (_T("Preview and print the document")));
	pBtnPrint->AddSubItem (new CBCGPRibbonButton (ID_FILE_PRINT_DIRECT, _T("Quick Print"), 7, 8, TRUE));
	pBtnPrint->AddSubItem (new CBCGPRibbonButton (ID_FILE_PRINT_PREVIEW, _T("Print Preview"), 8, 9, TRUE));

	pMainPanel->Add (pBtnPrint);
	pMainPanel->Add (new CBCGPRibbonSeparator (TRUE));
	pMainPanel->Add (new CBCGPRibbonButton (ID_FILE_CLOSE, _T("Close"), 9, 10));

	pMainPanel->AddRecentFilesList (_T("Recent Documents"));
	pMainPanel->AddToBottom (new CBCGPRibbonMainPanelButton (ID_TOOLS_OPTIONS, _T("Opt&ions"), 14));
	pMainPanel->AddToBottom (new CBCGPRibbonMainPanelButton (ID_APP_EXIT, _T("Exit"), 15));


	//////////////////////////////////////
	// Add "Yet Another Language" category with "Clipboard" panel:
	///////////////////////////////////////

	pCategoryYal = 
		m_wndRibbonBar.AddCategory(_T("Yet Another Language"), IDB_WRITE, IDB_WRITELARGE);

	pCategoryWeb = 
		m_wndRibbonBar.AddCategory(_T("World Wide Web"), IDB_MENU_IMAGES, IDB_WWWLARGE);
	
	////////////////// Command Panel ///////////////
	////////////////////////////////////////////////

	CBCGPRibbonPanel *pCommandWindow 
		= pCategoryYal->AddPanel(_T("Command"), m_PanelImages.ExtractIcon (27));

	pBtnRun = new CBCGPRibbonButton(ID_COMMAND_RUN, _T("  Run!  "), 19, 1); 
	pCommandWindow->Add(pBtnRun);

	////////////////////////////////
	// Create "Clipboard" panel:
	////////////////////////////////
	CBCGPRibbonPanel* pPanelClipboard = 
		pCategoryYal->AddPanel(_T("Edit"), m_PanelImages.ExtractIcon (27));

	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_COPY, _T("Copy"), 2));
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_CUT, _T("Cut"), 1));
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_PASTE, _T("Paste"), 0));
	pPanelClipboard->Add (new CBCGPRibbonSeparator);
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_UNDO, _T("Undo"), 9));
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_REDO, _T("Redo"), 10));
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_SELECT_ALL, _T("Select All")));
	pPanelClipboard->Add (new CBCGPRibbonSeparator);
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_FIND, _T("Find"), 4));
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_REPLACE, _T("Replace"), 5));
	pPanelClipboard->Add (new CBCGPRibbonButton (ID_EDIT_CLEAROUTPUT, _T("Clear"), 8));

	
//	pProgressBar = new CBCGPRibbonProgressBar(ID_STATUSBAR_PROGRESS, 70, 30);
//	pCommandWindow->Add(pProgressBar); pProgressBar->SetRange(0, 100);

	pPanelClipboard->Add (new CBCGPRibbonSeparator);
	pPanelClipboard->Add (new CBCGPRibbonButton(ID_EDIT_TOGGLEBOOKMARK, _T("Toggle Bookmark"), 13));
	pPanelClipboard->Add (new CBCGPRibbonButton(ID_EDIT_NEXTBOOKMARK, _T("Next Bookmark"), 14));
	pPanelClipboard->Add (new CBCGPRibbonButton(ID_EDIT_PREVIOUSBOOKMARK, _T("Previous Bookmark"), 15));
	
	CBCGPRibbonPanel *pPanelFont = pCategoryYal->AddPanel(_T("Font"));

	CBCGPRibbonButtonsGroup* pFontGroup = new CBCGPRibbonButtonsGroup;
	CBCGPRibbonFontComboBox::m_bDrawUsingFont = TRUE;

	pFontGroup->AddButton(new CBCGPRibbonLabel(_T("Code: ")));
	pFontCombo = new CBCGPRibbonFontComboBox(ID_FONT_FONT);

	CString fontname; LOGFONT logfont;
	BOOL rlt = GetDefaultSystemFont(fontname, &logfont);

	if(rlt) pFontCombo->SelectItem(fontname);
	else pFontCombo->SelectItem(logfont.lfFaceName);

	pFontGroup->AddButton (pFontCombo);

	pFontSizeCombo = new CBCGPRibbonComboBox(ID_FONT_FONTSIZE, TRUE, 20);
	pFontSizeCombo->AddItem (_T("8"));
	pFontSizeCombo->AddItem (_T("9"));
	pFontSizeCombo->AddItem (_T("10"));
	pFontSizeCombo->AddItem (_T("11"));
	pFontSizeCombo->AddItem (_T("12"));
	pFontSizeCombo->AddItem (_T("14"));
	pFontSizeCombo->AddItem (_T("16"));
	pFontSizeCombo->AddItem (_T("18"));
	pFontSizeCombo->AddItem (_T("20"));
	pFontSizeCombo->AddItem (_T("22"));
	pFontSizeCombo->AddItem (_T("24"));
	pFontSizeCombo->AddItem (_T("26"));
	pFontSizeCombo->AddItem (_T("28"));
		
	pFontSizeCombo->SelectItem(0);
	pFontGroup->AddButton(pFontSizeCombo);

	pPanelFont->Add(pFontGroup);
	

	pMainPanel->Add (new CBCGPRibbonSeparator (TRUE));
	pPanelFont->Add(new CBCGPRibbonButton(ID_COMMAND_RELOAD, _T("Reload Startup Program"), 16));
				
	/////////////////////////////////////////
	// Create "Window" panel:
	/////////////////////////////////////////
	CBCGPRibbonPanel* pPanelWindow 
		= pCategoryYal->AddPanel(_T("Window"), m_PanelImages.ExtractIcon (7));

	pPanelWindow->EnableLaunchButton (ID_WINDOW_MANAGER, -1, _T("l"));

	//pPanelWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_WORKSPACE, _T("View 1")));
	//pPanelWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_WORKSPACE2, _T("View 2")));
	pPanelWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_LINKS, _T("My Links")));
	pPanelWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_OUTPUT, _T("Output")));
	pPanelWindow->Add (new CBCGPRibbonSeparator);

	CBCGPRibbonButton* pBtnWindows = new CBCGPRibbonButton(0, _T("Windows"), -1, 0);
	pBtnWindows->SetMenu(IDR_WINDOWS_MENU);
	pPanelWindow->Add (pBtnWindows);

	CBCGPRibbonPanel *pWebPanel 
		= pCategoryWeb->AddPanel(_T("Donde voy"), m_LinkImages.ExtractIcon(0));
	
	pWebPanel->Add(new CBCGPRibbonLabel(_T("Old tab:")));
	pWebPanel->Add(new CBCGPRibbonLabel(_T("")));
	pWebPanel->Add(new CBCGPRibbonLabel(_T("New tab:")));
	pWebPanel->Add(new CBCGPRibbonSeparator(TRUE));
	
	pAddressBox = new CBCGPRibbonComboBox(ID_ADDRESSBOX, TRUE, 250);
	pAddressBox->AddItem(_T("http://www.silicondiners.com"));
	pAddressBox->SelectItem(0); pWebPanel->Add(pAddressBox); 
	pNewAddress = new CBCGPRibbonEdit(ID_NEW_TAB, 262);
	pWebPanel->Add(new CBCGPRibbonLabel(_T("")));
	pWebPanel->Add(pNewAddress);

	CBCGPRibbonPanel *pWebOper 
		= pCategoryWeb->AddPanel(_T("Operation"), m_LinkImages.ExtractIcon(1));
	
	pWebOper->Add(new CBCGPRibbonButton(ID_GO_START_PAGE, _T("Home"), 4));
	pWebOper->Add(new CBCGPRibbonButton(ID_GO_BACK, _T("Back"), 0));
	pWebOper->Add(new CBCGPRibbonButton(ID_GO_FORWARD, _T("Forward"), 1));
	pWebOper->AddSeparator();
	
	pWebOper->Add(new CBCGPRibbonButton(ID_VIEW_STOP, _T("Stop"), 2));
	pWebOper->Add(new CBCGPRibbonButton(ID_VIEW_REFRESH, _T("Refresh"), 3));
	pWebOper->Add(new CBCGPRibbonButton(ID_GO_SEARCH_THE_WEB, _T("Search"), 5));

	CBCGPRibbonPanel *pWebFavorite
		= pCategoryWeb->AddPanel(_T("Favorites"), m_WebImages.ExtractIcon(7));

	CBCGPRibbonButton* pBtnFavorite = new CBCGPRibbonButton(0, _T("Favorites"), -1, 0);
	//pBtnFavorite->SetMenu(IDR_FAVORITES_POPUP, TRUE);
	pBtnFavorite->SetMenu(m_menuFavotites.GetSafeHmenu());
	
	pWebFavorite->Add(pBtnFavorite);
	pWebFavorite->Add(new CBCGPRibbonSeparator);

	CBCGPRibbonButton* pBtnShortcut = new CBCGPRibbonButton(0, _T("Shortcut"), -1, 1);
	pBtnShortcut->SetMenu(IDR_LINK_MENU);
	pWebFavorite->Add(pBtnShortcut);
	
	CBCGPRibbonPanel *pPanelWebWindow 
		= pCategoryWeb->AddPanel(_T("Window"), m_WebImages.ExtractIcon(7));
	// Add the launch button at the bottom of the panel:
	pPanelWebWindow->EnableLaunchButton (ID_WINDOW_MANAGER, -1, _T("l"));


	//pPanelWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_WORKSPACE, _T("View 1")));
	//pPanelWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_WORKSPACE2, _T("View 2")));
	pPanelWebWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_LINKS, _T("My Links")));
	pPanelWebWindow->Add (new CBCGPRibbonCheckBox (ID_VIEW_OUTPUT, _T("Output")));
	
	CBCGPRibbonButton *pBtnFont =  new CBCGPRibbonButton(0, _T("Font"), 8) ;
	pBtnFont->SetMenu(IDR_WEB_FONT); pPanelWebWindow->Add(pBtnFont);

	pPanelWebWindow->Add (new CBCGPRibbonSeparator);

	CBCGPRibbonButton *pBtnWebWindows = new CBCGPRibbonButton(0, _T("Windows"), -1, 2);

	pBtnWebWindows->SetMenu(IDR_WINDOWS_MENU);
	pPanelWebWindow->Add (pBtnWebWindows);
		

	//////////////////////////////////////
	// Add quick access toolbar commands:
	//////////////////////////////////////

	CList<UINT, UINT> lstQATCmds;

	lstQATCmds.AddTail (ID_FILE_NEW);
	lstQATCmds.AddTail (ID_FILE_SAVE);
	lstQATCmds.AddTail (ID_FILE_SAVE_ALL);
	lstQATCmds.AddTail (ID_FILE_OPEN);
	lstQATCmds.AddTail (ID_COMMAND_RUN);
	lstQATCmds.AddTail (ID_FILE_PRINT_DIRECT);
	lstQATCmds.AddTail (ID_APP_EXIT);
	
	m_wndRibbonBar.SetQuickAccessCommands (lstQATCmds);
	
	CBCGPRibbonButton* pHelpButton = new CBCGPRibbonButton (-1, _T("Help\nh"), -1, -1);
	pHelpButton->SetMenu (IDR_MENU_HELP, TRUE /* Right align */);
	m_wndRibbonBar.AddToTabs(pHelpButton);
	
	// Add "Style" button to the right of tabs:
	CBCGPRibbonButton* pStyleButton = new CBCGPRibbonButton (-1, _T("Style\ns"), -1, -1);
	pStyleButton->SetMenu (IDR_THEME_MENU, TRUE /* Right align */);

	m_wndRibbonBar.AddToTabs (pStyleButton);

	m_wndRibbonBar.AddToTabs (new CBCGPRibbonButton (ID_APP_ABOUT, _T("About"), m_PanelImages.ExtractIcon (0)));
}


BOOL CMainFrame::LoadFrame(UINT nIDResource, DWORD dwDefaultStyle, CWnd* pParentWnd, CCreateContext* pContext) 
{
	if (!CBCGPMDIFrameWnd::LoadFrame(nIDResource, dwDefaultStyle, pParentWnd, pContext))
	{
		return FALSE;
	}

	CBCGPDockManager* pDockManager = GetDockManager ();

	if (pDockManager != NULL)
	{
		CWnd* pDockSite = pDockManager->GetDockSite ();

		if (pDockSite != NULL)
		{
			CRect rectWnd;
			pDockManager->GetDockSite ()->SetRedraw (FALSE);
			pDockManager->GetDockSite ()->GetWindowRect (rectWnd);
			pDockManager->GetDockSite ()->SetWindowPos (NULL, -1, -1, 
				rectWnd.Width () + 1, rectWnd.Height () + 1, 
				SWP_NOZORDER |  SWP_NOMOVE | SWP_NOACTIVATE);
			pDockManager->GetDockSite ()->SetWindowPos (NULL, -1, -1, 
				rectWnd.Width (), rectWnd.Height (), 
				SWP_NOZORDER |  SWP_NOMOVE  | SWP_NOACTIVATE);
			pDockManager->GetDockSite ()->SetRedraw (TRUE);
			pDockManager->GetDockSite ()->RedrawWindow (NULL, NULL, 
				RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		}
	}

	// Force resize:
	CRect rectWindow;
	GetWindowRect (rectWindow);

	rectWindow.right++;
	MoveWindow (rectWindow);

	return TRUE;
}

BOOL CMainFrame::IsPrintPreviewMode ()
{
	return GetDockManager ()->IsPrintPreviewValid ();
}

void CMainFrame::OnEditClearoutput()
{
	// TODO: Add your command handler code here
	this->m_wndOutputBar.m_wndOutput.SetWindowText(_T(""));
}

void CMainFrame::OnUpdateEditClearoutput(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(this->m_wndOutputBar.m_wndOutput.GetWindowTextLength()>0);
}

LRESULT CMainFrame::OnHelpCustomizeToolbars(WPARAM wp, LPARAM lp)
{
	int iPageNum = (int) wp;

	CBCGPToolbarCustomize* pDlg = (CBCGPToolbarCustomize*) lp;
	ASSERT_VALID (pDlg);

	// TODO: show help about page number iPageNum

	return 0;
}

void CMainFrame::OnTimer(UINT_PTR nIDEvent) 
{
	if (nIDEvent == IdStartProgressTimer)
	{
		ShowProgress ();
		KillTimer(IdStartProgressTimer);
		
		this->pBtnRun->SetImageIndex(1, TRUE);
		this->pBtnRun->SetText(_T("  Run!  "));
		this->pBtnRun->Redraw(); return;
	}

	if (nIDEvent == IdShowProgressTimer)
	{
		m_nProgressValue+=1;

		if(m_nProgressValue>100) m_nProgressValue = 0;
		
		int state = m_nProgressValue % RunnerCount;
		this->pBtnRun->SetImageIndex(state+2, TRUE);
		this->pBtnRun->Redraw();
		
		if(!IsExecuting())
		{
			theApp.m_pThread = NULL;
			ShowProgress (FALSE); return;
		}
	}
}

void CMainFrame::ShowProgress (BOOL bShow)
{
	if (bShow)
	{
		m_nProgressValue = 0;

		this->pBtnRun->SetText(_T("Break!"));
		this->pBtnRun->SetImageIndex(5, TRUE);
		this->pBtnRun->Redraw(); 
		SetTimer(IdShowProgressTimer, 200, NULL);
	}
	else
	{
		KillTimer (IdShowProgressTimer); 
		m_nProgressValue = -1;
		this->pBtnRun->SetText(_T("  Run!  "));
		this->pBtnRun->SetImageIndex(1, TRUE);
		this->pBtnRun->Redraw();
	}
}


BOOL CMainFrame::OnShowPopupMenu (CBCGPPopupMenu* pMenuPopup)
{
	CBCGPMDIFrameWnd::OnShowPopupMenu (pMenuPopup);

	if (pMenuPopup == NULL)
	{
        return TRUE;
    }

	CBCGPPopupMenuBar* pMenuBar = pMenuPopup->GetMenuBar ();
	ASSERT_VALID (pMenuBar);
	
	for (int i = 0; i < pMenuBar->GetCount (); i ++)
	{
		CBCGPToolbarButton* pButton = pMenuBar->GetButton (i);
		ASSERT_VALID (pButton);

		if (pButton->m_nID == ID_FAVORITS_DUMMY)
		{
			if (CBCGPToolBar::IsCustomizeMode ())
			{
				return FALSE;
			}

			pMenuBar->ImportFromMenu (m_menuFavotites);
			pMenuPopup->SetMaxWidth(200);

			return TRUE;
		}
	}

	CBCGPToolbarMenuButton* pParentButton = pMenuPopup->GetParentButton ();
	if (pParentButton == NULL)
	{
		return TRUE;
	}

	switch (pParentButton->m_nID)
	{
	case ID_GO_BACK:
	case ID_GO_FORWARD:
		{
			if (CBCGPToolBar::IsCustomizeMode ())
			{
				return FALSE;
			}

			CWebView *pView = DYNAMIC_DOWNCAST(CWebView, GetActiveView());
			if(pView)
			{
				CWebDoc *pDoc = pView->GetDocument();
				
				_T_HistotyList lst;

				if (pParentButton->m_nID == ID_GO_BACK)
				{
					pDoc->GetBackList (lst);
				}
				else
				{
					pDoc->GetFrwdList (lst);
				}
				
				if (!lst.IsEmpty ())
				{
					pMenuPopup->RemoveAllItems ();

					for (POSITION pos = lst.GetHeadPosition (); pos != NULL;)
					{
						CHistoryObj* pObj = lst.GetNext (pos);
						ASSERT (pObj != NULL);

						pMenuPopup->InsertItem (
							CBCGPToolbarMenuButton (pObj->GetCommand (), NULL, -1, 
													pObj->GetTitle ()));
					}
				}
			}
		}
	}

	return TRUE;
}

BOOL CMainFrame::OnDrawMenuImage (CDC* pDC,
								const CBCGPToolbarMenuButton* pMenuButton,
								const CRect& rectImage)
{
	if (theApp.m_Favorites.GetSysImages () == NULL)
	{
		return FALSE;
	}

	ASSERT_VALID (pDC);
	ASSERT_VALID (pMenuButton);

	int iIcon = -1;

	switch (pMenuButton->m_nID)
	{
	case ID_HELP_MICROSOFT_ON_THE_WEB_FREE_STUFF:
	case ID_HELP_MICROSOFT_ON_THE_WEB_GET_FASTER_INTERNET_ACCESS:
	case ID_HELP_MICROSOFT_ON_THE_WEB_FREQUENTLY_ASKED_QUESTIONS:
	case ID_HELP_MICROSOFT_ON_THE_WEB_INTERNET_START_PAGE:
	case ID_HELP_MICROSOFT_ON_THE_WEB_SEND_FEEDBACK:
	case ID_HELP_MICROSOFT_ON_THE_WEB_BEST_OF_THE_WEB:
	case ID_HELP_MICROSOFT_ON_THE_WEB_SEARCH_THE_WEB:
	case ID_HELP_MICROSOFT_ON_THE_WEB_MICROSOFT_HOME_PAGE:
		iIcon = theApp.m_Favorites.GetInternetShortcutIcon ();
		break;

	default:
		if (pMenuButton->m_nID >= FIRST_FAVORITE_COMMAND &&
			pMenuButton->m_nID <= LAST_FAVORITE_COMMAND)
		{
			iIcon = theApp.m_Favorites.GetIDIcon (pMenuButton->m_nID);
		}
		else if (IsFavoritesMenu (pMenuButton))	// Maybe, favorits folder?
		{
			iIcon = theApp.m_Favorites.GetFolderIcon ();
		}
	}

	if (iIcon == -1)
	{
		return FALSE;	// Don't draw it!
	}

	::ImageList_Draw (theApp.m_Favorites.GetSysImages (), iIcon, 
		pDC->GetSafeHdc (), 
		rectImage.left + (rectImage.Width () - theApp.m_Favorites.GetSysImageSize ().cx) / 2, 
		rectImage.top + (rectImage.Height () - theApp.m_Favorites.GetSysImageSize ().cy) / 2, ILD_TRANSPARENT);

	return TRUE;
}

BOOL CMainFrame::IsFavoritesMenu (const CBCGPToolbarMenuButton* pMenuButton)
{
	//TRACE(_T("Menu ID: %d\r\n"), pMenuButton->m_nID);

	//if (pMenuButton == NULL || pMenuButton->m_nID != ID_FAVORITS_DUMMY)
	//{
	//	return FALSE;
	//}

	//::AfxMessageBox(_T("Called here2"));

	ASSERT_VALID (pMenuButton);
	const CObList& lstCommands = pMenuButton->GetCommands ();
	
	for (POSITION pos = lstCommands.GetHeadPosition (); pos != NULL;)
	{
		CBCGPToolbarButton* pCmd = (CBCGPToolbarButton*) lstCommands.GetNext (pos);
		ASSERT_VALID (pCmd);

		if ((pCmd->m_nID >= FIRST_FAVORITE_COMMAND &&
			pCmd->m_nID <= LAST_FAVORITE_COMMAND) ||
			IsFavoritesMenu (DYNAMIC_DOWNCAST (CBCGPToolbarMenuButton, pCmd)))
		{
			return TRUE;
		}
	}

	return FALSE;
}

BOOL CMainFrame::OnMenuButtonToolHitTest (CBCGPToolbarButton* pButton, TOOLINFO* pTI)
{
	ASSERT_VALID (pButton);
	
	if (pButton->m_nID < FIRST_FAVORITE_COMMAND ||
		pButton->m_nID > LAST_FAVORITE_COMMAND)
	{
		return FALSE;
	}

	ASSERT (pTI != NULL);

	CString strText = theApp.m_Favorites.GetURLofID (pButton->m_nID);

	size_t length = strText.GetLength () + 1;
	pTI->lpszText = (LPTSTR) ::calloc(length, sizeof (TCHAR));
	_tcscpy_s(pTI->lpszText, length, strText);

	return TRUE;
}

void CMainFrame::OnViewLinks()
{
	// TODO: Add your command handler code here
	ShowControlBar(&m_wndExplorerBar, !(m_wndExplorerBar.IsVisible()), FALSE, TRUE);
	RecalcLayout ();
}

void CMainFrame::OnUpdateViewLinks(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (m_wndExplorerBar.IsVisible ());
	pCmdUI->Enable (!IsPrintPreviewMode ());
}


void CMainFrame::OnClose()
{
	// TODO: Add your message handler code here and/or call default

	if(theApp.m_DoNotExit==FALSE)
	{
		m_TrayIcon.RemoveIcon();
		m_TrayIcon.DestroyWindow();

		CBCGPMDIFrameWnd::OnClose();
		return;
	}
	if (!m_TrayIcon.Create(NULL,                            // Parent window
                           WM_ICON_NOTIFY,                  // Icon notify message to use
                           _T("This is a Tray Icon - Right click on me!"),  // tooltip
						   ::AfxGetApp()->LoadIcon(IDI_SYSTRAY),  // Icon to use
                           IDR_TRAY_POPUP))                 // ID of tray icon
	{
		CBCGPMDIFrameWnd::OnClose();
		return;
	}
	else
	{
		m_TrayIcon.SetMenuDefaultItem(4, TRUE);
		this->ShowWindow(SW_HIDE);
	}

	//CBCGPMDIFrameWnd::OnClose();
}

void CMainFrame::OnToolsOptions()
{
	ShowOptions (0);
}

void CMainFrame::ShowOptions (int nPage)
{
	// Create "Customize" page:
	CBCGPRibbonCustomizePage pageCustomize (&m_wndRibbonBar);

	// Add "popular" items:
	CList<UINT, UINT> lstPopular;

	lstPopular.AddTail (ID_FILE_NEW);
	lstPopular.AddTail (ID_FILE_OPEN);
	lstPopular.AddTail (ID_FILE_SAVE);
	lstPopular.AddTail (ID_FILE_PRINT_PREVIEW);
	lstPopular.AddTail (ID_FILE_PRINT_DIRECT);
	lstPopular.AddTail (ID_EDIT_UNDO);

	pageCustomize.AddCustomCategory (_T("Popular Commands"), lstPopular);

	// Add hidden commands:
	CList<UINT,UINT> lstHidden;
	m_wndRibbonBar.GetItemIDsList (lstHidden, TRUE);

	pageCustomize.AddCustomCategory (_T("Commands not in the Ribbon"), lstHidden);

	// Add all commands:
	CList<UINT,UINT> lstAll;
	m_wndRibbonBar.GetItemIDsList (lstAll);

	pageCustomize.AddCustomCategory (_T("All Commands"), lstAll);

	// Create property sheet:
	CBCGPPropertySheet propSheet (_T("Options"), this, nPage);
	propSheet.m_psh.dwFlags |= PSH_NOAPPLYNOW;

	propSheet.SetLook (CBCGPPropertySheet::PropSheetLook_List, 124 /* List width */);

	propSheet.AddPage (&pageCustomize);

	// TODO: add your option pages here:
	// COptionsPage1 pageOptions1;
	// propSheet.AddPage (&pageOptions1);
	//
	// COptionsPage1 pageOptions2;
	// propSheet.AddPage (&pageOptions2);

	if (propSheet.DoModal() != IDOK)
	{
		return;
	}
}

void CMainFrame::OnTutorial()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(_T("http://yal.silicondiners.com/yal.htm#tutorial/tutorial.htm"));
	this->OnNewAddress();
}

void CMainFrame::OnYalHelp()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(_T("http://yal.silicondiners.com/yal.htm#language_syntax/keywords.htm"));
	this->OnNewAddress();
}

void CMainFrame::OnYalhome()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(_T("http://yal.silicondiners.com/yal.htm"));
	this->OnNewAddress();
}

void CMainFrame::OnWindowCode(void)
{
	CBCGPMDIChildWnd *pActiveChild = 
		dynamic_cast<CBCGPMDIChildWnd*>(this->MDIGetActive());

	if(pActiveChild) return;
	
	CDocument *pDocument = pActiveChild->GetActiveDocument();
	if(pActiveChild==NULL || pDocument==NULL) return;

	CDocTemplate *pTemplate = theApp.pYalDocTemp;
	if(pTemplate==NULL) return;

	CBCGPFrameWnd *pFrame = (CBCGPFrameWnd*)pTemplate->CreateNewFrame(pDocument, NULL);

	if(pFrame==NULL) return;
	pTemplate->InitialUpdateFrame(pFrame, pDocument);
}

void CMainFrame::OnFileSaveAll()
{
	// TODO: Add your command handler code here
	
	theApp.SaveAllFiles();
}

void CMainFrame::OnUpdateFileSaveAll(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(theApp.IsFileChanged());
}

void CMainFrame::OnCommandReload()
{
	// TODO: Add your command handler code here

	CStartupDlg StartupDlg;
	StartupDlg.Create(IDD_STARTUP);
		
	CRect rect, scRect;

	theApp.SaveAllFiles();

	StartupDlg.GetWindowRect(rect);
	this->GetWindowRect(&scRect);
		
	StartupDlg.SetWindowPos(&CWnd::wndTopMost, scRect.left+(scRect.Width()-rect.Width())/2,
								  scRect.top+(scRect.Height() -rect.Height())/2,
								  0, 0, SWP_NOSIZE);
	StartupDlg.ShowWindow(SW_SHOW);								
	StartupDlg.UpdateWindow();

	try
	{
		//StartupDlg.InitializeApplication();
		
		StartupDlg.ReloadStartup();
		StartupDlg.SendMessage(WM_CLOSE);
	}
	catch(...) { ::AfxMessageBox(_T(" Startup Error"));  }
}

void CMainFrame::OnBestInfoPdr()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(L"http://www.wikipedia.org/");
	this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	theApp.OnNewPane = true; theApp.OnNewWeb();
}

void CMainFrame::OnLinkDocdoc()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(L"http://www.thedoctorsdoctor.com/");
	this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	theApp.OnNewPane = true; theApp.OnNewWeb();
}

void CMainFrame::OnLinkIop()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(L"http://www.iop.org/");
	this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	theApp.OnNewPane = true; theApp.OnNewWeb();
}

void CMainFrame::OnLinkSciam()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(L"http://www.sciam.com/");
	this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	theApp.OnNewPane = true; theApp.OnNewWeb();
}

void CMainFrame::OnLinkSciwolrd()
{
	// TODO: Add your command handler code here
	pAddressBox->SetEditText(L"http://scienceworld.wolfram.com/");
	this->pNewAddress->SetEditText(pAddressBox->GetEditText());
	theApp.OnNewPane = true; theApp.OnNewWeb();
}
