// StartupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Yal.h"
#include "StartupDlg.h"
//#include "SyntaxAnalyzer.h"

// CStartupDlg dialog

//const unsigned int StartDlgTimerID = 100;

IMPLEMENT_DYNAMIC(CStartupDlg, CBCGPDialog)

CStartupDlg::CStartupDlg(CWnd* pParent)
: CBCGPDialog(CStartupDlg::IDD, pParent) 
{ 
	this->TextOutput.SetWindow(this); 
}

CStartupDlg::~CStartupDlg()
{
	
}

void CStartupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CStartupDlg, CBCGPDialog)
	ON_WM_CLOSE()
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CStartupDlg message handlers

BOOL CStartupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	
	theBkImage.LoadBitmap(IDB_STARTUP);
	this->SetBackgroundImage((HBITMAP)theBkImage.GetSafeHandle());

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CStartupDlg::PutLogoMessage()
{
	CString fontname; fontname.LoadString(IDS_ABOUTFONT);
	TextOutput.DrawTitleText(10, _T("Yet Another Language Version 1.0"), 
		110, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);

	TextOutput.DrawTitleText(40,  IDS_WARN_MSG1, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(55,  IDS_WARN_MSG2, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(70,  IDS_WARN_MSG3, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(85,  IDS_WARN_MSG4, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(100, IDS_WARN_MSG5, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(115, IDS_HOWEVER, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(130, IDS_AS_LONG_AS, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);

	TextOutput.DrawTitleText(200, IDS_CREDITS, 90, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);

	TextOutput.DrawTitleText(220, IDS_KOREAN_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(230, IDS_FRENCH_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(240, IDS_CHINESE_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(250, IDS_JAPANESE_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(260, IDS_RUSSIAN_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(270, IDS_GRAPHIC_DESIGN, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);

	TextOutput.DrawTitleText(312, IDS_COPYRIGHT, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(324, IDS_ALLRIGHTS, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
}

void CStartupDlg::PutMessage(const CString& msg)
{
	CEdit *pEditor = (CEdit*)this->GetDlgItem(IDC_PROGRESS);

	pEditor->SetWindowText(msg); //OnTimer(100);
}

void CStartupDlg::PutMessage(const CString& msg, int sleep)
{
	PutMessage(msg); Sleep(sleep);
}

void CStartupDlg::InitializeApplication()
{
	TextOutput.DrawOutlineText(290, _T("Registering global functions ..."));
	RegisterFunctions();  Sleep(2000);
	
	TextOutput.DrawOutlineText(290, _T("Initializing keywords ..."));
	InitializeParser(); 
	InitializeKeywords((CEdit*)this->GetDlgItem(IDC_PROGRESS), theApp.theLangPath);
	Sleep(2000);
	
	gErrorStatusInfo.ErrorStatus = FALSE;
	SetErrorStatusInfo(&gErrorStatusInfo);

	TextOutput.DrawOutlineText(290, _T("Parsing startup.yal ..."));
	CString startup = theApp.theAppPath + _T("\\") + _T("startup.yal");
	SetOutputEditorCEdit((CEdit*)GetDlgItem(IDC_PROGRESS));
	ParseInitial(startup); SetOutputEditorCEdit(NULL); Sleep(1000);
}

void CStartupDlg::ReloadStartup()
{
	gErrorStatusInfo.ErrorStatus = FALSE;
	SetErrorStatusInfo(&gErrorStatusInfo);

	TextOutput.DrawTitleText(170, _T("Reloading Startup Program !"), 130);
	
	TextOutput.DrawOutlineText(290, _T("Parsing startup.yal ..."));
	CString startup = theApp.theAppPath + _T("\\") + _T("startup.yal");
	SetOutputEditorCEdit((CEdit*)GetDlgItem(IDC_PROGRESS));
	ParseInitial(startup); SetOutputEditorCEdit(NULL); 
	
	TextOutput.DrawOutlineText(290, _T("Parsing successful ..."));
	Sleep(2000);
}

void CStartupDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default

	CBCGPDialog::OnClose();
}

void CStartupDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CBCGPDialog::OnPaint() for painting messages
	PutLogoMessage();
}
