// Yal.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Yal.h"
#include "MainFrame.h"

#include "YalFrame.h"
#include "YalDoc.h"
#include "YalView.h"
#include "WebFrame.h"
#include "WebDoc.h"
#include "WebView.h"

#include "StartupDlg.h"
#include <shlwapi.h>
#include <kch_autodelete.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern "C" 
{
	RegisterFunctionsPtr RegisterFunctions = NULL;
	InitializeParserPtr InitializeParser = NULL;
	InitializeKeywordsPtr InitializeKeywords = NULL;
	ParseInitialPtr ParseInitial = NULL;
	ParseCodePtr ParseCode = NULL;
	SetPathSettingsPtr SetPathSettings = NULL;
	IsExecutingPtr IsExecuting = NULL;
	SetBreakPtr SetBreak = NULL;
	SetDocTitlePtr SetDocTitle = NULL;
	SetOutputEditorHandlePtr SetOutputEditorHandle = NULL;
	SetOutputEditorCEditPtr SetOutputEditorCEdit = NULL;
	SetInputCodeEditorPtr SetInputCodeEditor = NULL;
	SetStatusBarPtr SetStatusBar = NULL;
	PutStringUINTPtr PutStringUINT = NULL;
	PutStringCStringPtr PutStringCString = NULL;
	ClearOutputPtr ClearOutput = NULL;
	GetKeywordMapPtr GetKeywordMap = NULL;
	GetMemberMapPtr GetMemberMap = NULL;
	SetErrorStatusInfoPtr SetErrorStatusInfo = NULL;
}

// CYalApp

BEGIN_MESSAGE_MAP(CYalApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
	ON_COMMAND(ID_NEW_WEB, &CYalApp::OnNewWeb)
	ON_COMMAND(ID_NEW_YAL, &CYalApp::OnNewYal)
	ON_COMMAND(ID_FILE_NEW, &CYalApp::OnFileNew)
	ON_COMMAND(ID_APP_EXIT, &CYalApp::OnAppExit)
END_MESSAGE_MAP()


// CYalApp construction

CYalApp::CYalApp(): DocType(ID_NEW_YAL), 
	pYalView(NULL), CBCGPWorkspace(TRUE), OnNewPane(false), m_pThread(NULL)
{
	m_bBackgroundImage = FALSE;
	m_DoNotExit = TRUE;

	hTheParser = NULL;
	EnableHtmlHelp();

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// global error status
ErrorStatusInfo gErrorStatusInfo;

// The one and only CYalApp object

CYalApp theApp;


// CYalApp initialization

bool CYalApp::LoadTheParser(void)
{
	hTheParser = ::LoadLibrary(_T("TheParser.dll"));

	if(hTheParser==NULL)
		return false;
	else
	{
		GETADDRESS(hTheParser, RegisterFunctionsPtr, RegisterFunctions); 
		GETADDRESS(hTheParser, InitializeParserPtr, InitializeParser);
		GETADDRESS(hTheParser, InitializeKeywordsPtr, InitializeKeywords);
		GETADDRESS(hTheParser, ParseInitialPtr, ParseInitial);
		GETADDRESS(hTheParser, ParseCodePtr, ParseCode);
		GETADDRESS(hTheParser, SetPathSettingsPtr, SetPathSettings);
		GETADDRESS(hTheParser, IsExecutingPtr, IsExecuting);
		GETADDRESS(hTheParser, SetBreakPtr, SetBreak);
		GETADDRESS(hTheParser, SetDocTitlePtr, SetDocTitle);
		GETADDRESS(hTheParser, SetOutputEditorHandlePtr, SetOutputEditorHandle);
		GETADDRESS(hTheParser, SetOutputEditorCEditPtr, SetOutputEditorCEdit);
		GETADDRESS(hTheParser, SetInputCodeEditorPtr, SetInputCodeEditor);
		GETADDRESS(hTheParser, SetStatusBarPtr, SetStatusBar);
		GETADDRESS(hTheParser, PutStringUINTPtr, PutStringUINT);
		GETADDRESS(hTheParser, PutStringCStringPtr, PutStringCString);
		GETADDRESS(hTheParser, ClearOutputPtr, ClearOutput);
		GETADDRESS(hTheParser, GetKeywordMapPtr, GetKeywordMap);
		GETADDRESS(hTheParser, GetMemberMapPtr, GetMemberMap);
		GETADDRESS(hTheParser, SetErrorStatusInfoPtr, SetErrorStatusInfo);
		
		return true;
	}
}

void CYalApp::InitializePath(void)
{
	AutoDeleteArray<wchar_t> path(MAX_PATH);
	//::GetCurrentDirectoryW(MAX_PATH-1, path.DataPtr);
	CString subkey(_T("Yal.Document.1\\shell\\open\\command"));
	DWORD keytype = REG_SZ; DWORD size = MAX_PATH * sizeof(wchar_t);
	::SHGetValueW(HKEY_CLASSES_ROOT, subkey, NULL,  &keytype, path.DataPtr, &size);
	
	int length = ::lstrlen(path.DataPtr);
	path.DataPtr[length-5] = L'\0';
	
	extern std::wstring GetPath(const CString& fullpath);
	theAppPath = GetPath(CString(path.DataPtr)).c_str();
	//::AfxMessageBox(theAppPath);
	
	//theAppPath = path.DataPtr;
	theGraphPath = theAppPath + _T("Graphs");
	theLangPath = theAppPath + _T("Languages");
	theLibPath = theAppPath + _T("Libraries");
	
	HRESULT rlt = ::SHGetFolderPath(NULL, CSIDL_PERSONAL, 0, SHGFP_TYPE_CURRENT, path.DataPtr);

	if((rlt!=E_FAIL) && (rlt!=E_INVALIDARG))
	{
		this->theWorkPath = CString(path.DataPtr) + _T("\\YalWork");
		CreateDirectory(theWorkPath, NULL); //::SetCurrentDirectoryW(theWorkPath);
	}

	SetPathSettings(theAppPath, theLibPath, theLangPath, theWorkPath);
}

BOOL CYalApp::InitInstance()
{
	if(LoadTheParser()==false)
	{
		::AfxMessageBox(_T("Failed to load TheParser.dll."));
		return FALSE;
	}

	CStartupDlg StartupDlg;
	StartupDlg.Create(IDD_STARTUP);
	StartupDlg.ShowWindow(SW_SHOW);
	StartupDlg.UpdateWindow();
	//StartupDlg.PutLogoMessage();

	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);
	
	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("SiliconDiners International"));
	LoadStdProfileSettings(16);  // Load standard INI file options (including MRU)

	SetRegistryBase (_T("AppSettings"));

	// Initialize all Managers for usage. They are automatically constructed
	// if not yet present
	InitContextMenuManager();
	InitKeyboardManager();

	// Initialize favorites:
	m_Favorites.Load ();
	
	// TODO: Remove this if you don't want extended tooltips:
	InitTooltipManager();

	CBCGPToolTipParams params;
	params.m_bVislManagerTheme = TRUE;

	theApp.GetTooltipManager ()->SetTooltipParams (
		BCGP_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS (CBCGPToolTipCtrl),
		&params);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	pYalDocTemp = new CMultiDocTemplate(IDR_YalTYPE,
		RUNTIME_CLASS(CYalDoc),
		RUNTIME_CLASS(CYalFrame), // custom MDI child frame
		RUNTIME_CLASS(CYalView));
	
	if (!pYalDocTemp) return FALSE;

	pWebDocTemp = new CMultiDocTemplate(IDR_WebTYPE,
		RUNTIME_CLASS(CWebDoc),
		RUNTIME_CLASS(CWebFrame), // custom MDI child frame
		RUNTIME_CLASS(CWebView));
	
	if (!pWebDocTemp) return FALSE;

	AddDocTemplate(pYalDocTemp);
	AddDocTemplate(pWebDocTemp);

	// create main MDI Frame window
	this->pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	// call DragAcceptFiles only if there's a suffix
	//  In an MDI app, this should occur immediately after setting m_pMainWnd
	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	InitializePath();

	try
	{
		StartupDlg.InitializeApplication();
		StartupDlg.SendMessage(WM_CLOSE);
	}
	catch(...) { ::AfxMessageBox(_T(" Startup Error"));  }

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew)
	{
		if (!pMainFrame->LoadMDIState (GetRegSectionPath ()))
		{
			if (!ProcessShellCommand(cmdInfo))
				return FALSE;
		}
	}
	else
	{
		// Dispatch commands specified on the command line
		if (!ProcessShellCommand(cmdInfo))
		{
			::AfxMessageBox(_T("Here1"));
			return FALSE;
		}

		return TRUE;
	}
	// The main window has been initialized, so show and update it
	//pMainFrame->ShowWindow(m_nCmdShow);
	//pMainFrame->UpdateWindow();

	return TRUE;
}

// CYalApp message handlers

int CYalApp::ExitInstance() 
{
	BCGCBProCleanUp();

	if(this->hTheParser) ::FreeLibrary(hTheParser);

	return CWinApp::ExitInstance();
}

// CAboutDlg dialog used for App About
IMPLEMENT_DYNAMIC(CAboutDlg, CBCGPDialog)

CAboutDlg::CAboutDlg() : CBCGPDialog(CAboutDlg::IDD)
{
	this->m_btnURL.SetURL(_T("http://yal.silicondiners.com"));
	this->TextOutput.SetWindow(this); 
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMPANY_URL, m_btnURL);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CBCGPDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()

// App command to run the dialog
void CYalApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CYalApp::LoadCustomState ()
{
	m_bBackgroundImage = GetInt (_T("BackgroundImage"), FALSE);
}

void CYalApp::SaveCustomState ()
{
	WriteInt (_T("BackgroundImage"), m_bBackgroundImage);
}

// CYalApp message handlers


void CYalApp::PreLoadState ()
{

	GetContextMenuManager()->AddMenu (_T("My menu"), IDR_CONTEXT_MENU);

	// TODO: add another context menus here
}

BOOL GetDefaultSystemFont(CString& facename, LOGFONT* logfont)
{
	AutoDeleteArray<wchar_t> fontname(256);

	HFONT hFont = (HFONT)::GetStockObject(DEFAULT_GUI_FONT);
	CFont *pFont = CFont::FromHandle(hFont);
	pFont->GetLogFont(logfont); ::DeleteObject(hFont);
	DWORD size = 255, type = REG_SZ;
	DWORD result = SHGetValue(HKEY_LOCAL_MACHINE, 
		_T("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\FontSubstitutes"), 
		logfont->lfFaceName, &type, fontname.DataPtr, &size);
	
	if(result==ERROR_SUCCESS)
	{
		facename = fontname.DataPtr; return TRUE;
	}
	else return FALSE;
}

bool IsValidFileName(const CString& filename)
{
	CString invalid=_T("<>:\"/\\|");
	if(filename.FindOneOf(invalid)==-1) return true;
	else return false;
}

CString GetValidFileName(const CString& filename)
{
	if(IsValidFileName(filename)) return filename;
	CString name = filename,  invalid=_T("<>:\"/\\|");

	return name.Trim(invalid);
}

HRESULT GetBrowserVersion(LPDWORD pdwMajor, LPDWORD pdwMinor)
{
    HINSTANCE   hBrowser;

    if(IsBadWritePtr(pdwMajor, sizeof(DWORD)) ||
       IsBadWritePtr(pdwMinor, sizeof(DWORD)))
           return E_INVALIDARG;

    *pdwMajor = 0;
    *pdwMinor = 0;

    //Load the DLL.
    hBrowser = LoadLibrary(TEXT("shdocvw.dll"));
	
    if (hBrowser == NULL)
    {
       //Error loading module -- fail as securely as possible
       return E_FAIL;
    }

    if(hBrowser)
    {
        HRESULT hr = S_OK;
        DLLGETVERSIONPROC pDllGetVersion;

        // You must get this function explicitly.
        pDllGetVersion = (DLLGETVERSIONPROC)GetProcAddress(hBrowser, "DllGetVersion");

        if(pDllGetVersion)
        {
            DLLVERSIONINFO dvi;
            ZeroMemory(&dvi, sizeof(dvi));
            dvi.cbSize = sizeof(dvi);
			
            hr = (*pDllGetVersion)(&dvi);

            if(SUCCEEDED(hr))
            {
                *pdwMajor = dvi.dwMajorVersion;
                *pdwMinor = dvi.dwMinorVersion;
            }
        }
        else
        {
            // If GetProcAddress failed, there is a problem with the DLL.
            hr = E_FAIL;
        }

        FreeLibrary(hBrowser);

        return hr;
    }

    return E_FAIL;
}


void CYalApp::OnFileNew()
{
	// TODO: Add your command handler code here
	
	CDocument *pDoc = NULL; CFrameWnd *pFrame=NULL;
	pFrame = DYNAMIC_DOWNCAST(CFrameWnd, CWnd::GetActiveWindow());
	
	CDocTemplate* pTemplate = NULL;
	
	if (pFrame != NULL)
		pDoc = pFrame->GetActiveDocument();
	
	if (pFrame == NULL || pDoc == NULL)
	{
		// if it's the first document, create as normal
		pTemplate = this->GetDocTemplate();
		ASSERT(pTemplate != NULL);		
		ASSERT_KINDOF(CDocTemplate, pTemplate);
		pDoc = pTemplate->OpenDocumentFile(NULL);
		//if(pTemplate != pWebDocTemp) pDoc->DoFileSave();
	}
	else
	{
		// Otherwise, see if we have to save modified, then
		// ask the document to reinitialize itself.
		if(!pDoc->SaveModified()) return;
		
		pTemplate = this->GetDocTemplate();
		ASSERT(pTemplate != NULL);

		pTemplate->SetDefaultTitle(pDoc);
		pDoc->OnNewDocument();
	}
}


CMultiDocTemplate* CYalApp::GetDocTemplate() const
{
	switch(DocType)
	{
		case ID_NEW_YAL: return this->pYalDocTemp;
		case ID_NEW_WEB: return this->pWebDocTemp;
	}
	return NULL; // can not happen
}

void CYalApp::OnNewWeb()
{
	// TODO: Add your command handler code here
	DocType = ID_NEW_WEB; OnFileNew();
}

void CYalApp::OnNewYal()
{
	// TODO: Add your command handler code here
	DocType = ID_NEW_YAL; OnFileNew();
}

CString InterpretNavigateError(DWORD dwError)
{
	CString errormsg=_T("Unknown Navigation Error.");
	switch(dwError)
	{
		case	HTTP_STATUS_BAD_REQUEST	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_BAD_REQUEST	); break; }
		case	HTTP_STATUS_DENIED	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_DENIED	); break; }
		case	HTTP_STATUS_PAYMENT_REQ	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_PAYMENT_REQ	); break; }
		case	HTTP_STATUS_FORBIDDEN	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_FORBIDDEN	); break; }
		case	HTTP_STATUS_NOT_FOUND	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_NOT_FOUND	); break; }
		case	HTTP_STATUS_BAD_METHOD	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_BAD_METHOD	); break; }
		case	HTTP_STATUS_NONE_ACCEPTABLE	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_NONE_ACCEPTABLE	); break; }
		case	HTTP_STATUS_PROXY_AUTH_REQ	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_PROXY_AUTH_REQ	); break; }
		case	HTTP_STATUS_REQUEST_TIMEOUT	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_REQUEST_TIMEOUT	); break; }
		case	HTTP_STATUS_CONFLICT	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_CONFLICT	); break; }
		case	HTTP_STATUS_GONE	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_GONE	); break; }
		case	HTTP_STATUS_LENGTH_REQUIRED	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_LENGTH_REQUIRED	); break; }
		case	HTTP_STATUS_PRECOND_FAILED	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_PRECOND_FAILED	); break; }
		case	HTTP_STATUS_REQUEST_TOO_LARGE	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_REQUEST_TOO_LARGE	); break; }
		case	HTTP_STATUS_URI_TOO_LONG	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_URI_TOO_LONG	); break; }
		case	HTTP_STATUS_UNSUPPORTED_MEDIA	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_UNSUPPORTED_MEDIA	); break; }
		case	HTTP_STATUS_RETRY_WITH	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_RETRY_WITH	); break; }
		case	HTTP_STATUS_SERVER_ERROR	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_SERVER_ERROR	); break; }
		case	HTTP_STATUS_NOT_SUPPORTED	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_NOT_SUPPORTED	); break; }
		case	HTTP_STATUS_BAD_GATEWAY	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_BAD_GATEWAY	); break; }
		case	HTTP_STATUS_SERVICE_UNAVAIL	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_SERVICE_UNAVAIL	); break; }
		case	HTTP_STATUS_GATEWAY_TIMEOUT	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_GATEWAY_TIMEOUT	); break; }
		case	HTTP_STATUS_VERSION_NOT_SUP	: 
			{ errormsg.LoadString(IDS_HTTP_STATUS_VERSION_NOT_SUP	); break; }
		case	INET_E_INVALID_URL	: 
			{ errormsg.LoadString(IDS_INET_E_INVALID_URL	); break; }
		case	INET_E_NO_SESSION	: 
			{ errormsg.LoadString(IDS_INET_E_NO_SESSION	); break; }
		case	INET_E_CANNOT_CONNECT	: 
			{ errormsg.LoadString(IDS_INET_E_CANNOT_CONNECT	); break; }
		case	INET_E_RESOURCE_NOT_FOUND	: 
			{ errormsg.LoadString(IDS_INET_E_RESOURCE_NOT_FOUND	); break; }
		case	INET_E_OBJECT_NOT_FOUND	: 
			{ errormsg.LoadString(IDS_INET_E_OBJECT_NOT_FOUND	); break; }
		case	INET_E_DATA_NOT_AVAILABLE	: 
			{ errormsg.LoadString(IDS_INET_E_DATA_NOT_AVAILABLE	); break; }
		case	INET_E_DOWNLOAD_FAILURE	: 
			{ errormsg.LoadString(IDS_INET_E_DOWNLOAD_FAILURE	); break; }
		case	INET_E_AUTHENTICATION_REQUIRED	: 
			{ errormsg.LoadString(IDS_INET_E_AUTHENTICATION_REQUIRED	); break; }
		case	INET_E_NO_VALID_MEDIA	: 
			{ errormsg.LoadString(IDS_INET_E_NO_VALID_MEDIA	); break; }
		case	INET_E_CONNECTION_TIMEOUT	: 
			{ errormsg.LoadString(IDS_INET_E_CONNECTION_TIMEOUT	); break; }
		case	INET_E_INVALID_REQUEST	: 
			{ errormsg.LoadString(IDS_INET_E_INVALID_REQUEST	); break; }
		case	INET_E_UNKNOWN_PROTOCOL	: 
			{ errormsg.LoadString(IDS_INET_E_UNKNOWN_PROTOCOL	); break; }
		case	INET_E_SECURITY_PROBLEM	: 
			{ errormsg.LoadString(IDS_INET_E_SECURITY_PROBLEM	); break; }
		case	INET_E_CANNOT_LOAD_DATA	: 
			{ errormsg.LoadString(IDS_INET_E_CANNOT_LOAD_DATA	); break; }
		case	INET_E_CANNOT_INSTANTIATE_OBJECT	: 
			{ errormsg.LoadString(IDS_INET_E_CANNOT_INSTANTIATE_OBJECT	); break; }
		case	INET_E_REDIRECT_FAILED	: 
			{ errormsg.LoadString(IDS_INET_E_REDIRECT_FAILED	); break; }
		case	INET_E_REDIRECT_TO_DIR	: 
			{ errormsg.LoadString(IDS_INET_E_REDIRECT_TO_DIR	); break; }
		case	INET_E_CANNOT_LOCK_REQUEST	: 
			{ errormsg.LoadString(IDS_INET_E_CANNOT_LOCK_REQUEST	); break; }
		case	INET_E_USE_EXTEND_BINDING	: 
			{ errormsg.LoadString(IDS_INET_E_USE_EXTEND_BINDING	); break; }
		case	INET_E_TERMINATED_BIND	: 
			{ errormsg.LoadString(IDS_INET_E_TERMINATED_BIND	); break; }
		case	INET_E_CODE_DOWNLOAD_DECLINED	: 
			{ errormsg.LoadString(IDS_INET_E_CODE_DOWNLOAD_DECLINED	); break; }
		case	INET_E_RESULT_DISPATCHED	: 
			{ errormsg.LoadString(IDS_INET_E_RESULT_DISPATCHED	); break; }
		case	INET_E_CANNOT_REPLACE_SFP_FILE	: 
			{ errormsg.LoadString(IDS_INET_E_CANNOT_REPLACE_SFP_FILE	); break; }
	}

	return errormsg;
}

void CYalApp::OnAppExit()
{
	// TODO: Add your command handler code here

	if(IsExecuting())
	{
		SetBreak(); Sleep(2000);
	}

	m_DoNotExit = FALSE;
	::AfxGetMainWnd()->PostMessage(WM_CLOSE);
}


#include <UrlHist.h>
// Delete all items in History folder
HRESULT ClearHistory()
{
    IUrlHistoryStg2* pUrlHistoryStg2 = NULL;
    HRESULT hr = CoCreateInstance(CLSID_CUrlHistory,
        NULL, CLSCTX_INPROC, IID_IUrlHistoryStg2,
        (void**)&pUrlHistoryStg2);
    if (SUCCEEDED(hr))
    {
        hr = pUrlHistoryStg2->ClearHistory();
        pUrlHistoryStg2->Release();
    }
    return hr;
}

CString MakeShortString(const CString& str, int count)
{
	CString trimmed;
	if(str.GetLength()>count-3)
	{
		trimmed = str.Left(count-3);
		trimmed.Append(_T("..."));
	}
	else
		trimmed = str;

	return trimmed;
}

CString MakeShortString(const CString& str)
{
	CDC dc;

	dc.CreateCompatibleDC(NULL);
	CFont *pOldFont = (CFont*)dc.SelectStockObject(SYSTEM_FONT);
	
	CSize size; 
	CString trimmed = str;

	int count = str.GetLength()+1;
	
	do 
	{
		--count;
		trimmed = str.Left(count);
		size = dc.GetTextExtent(trimmed);
	
	}while(size.cx>200) ;

	dc.SelectObject(pOldFont);

	if(trimmed.GetLength()<str.GetLength())
		trimmed.Append(_T(" ..."));
	
	return trimmed;
}

#include <kch_path.h>
#include <string>
#include <sstream>

std::wstring GetPath(const CString& fullpath)
{
	PathInfo pinfo;
	_wsplitpath_s(fullpath.GetString(), pinfo.drive, _MAX_DRIVE, 
		pinfo.dir, _MAX_DIR, pinfo.fname, _MAX_FNAME, pinfo.ext, _MAX_EXT);

	std::wostringstream os;
	os<<pinfo.drive<<pinfo.dir;
	return os.str();
}
BOOL CAboutDlg::OnInitDialog()
{
	CBCGPDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	theBkImage.LoadBitmap(IDB_STARTUP);
	this->SetBackgroundImage((HBITMAP)theBkImage.GetSafeHandle());
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::PutLogoMessage()
{
	CString fontname; fontname.LoadString(IDS_ABOUTFONT);
	TextOutput.DrawTitleText(5, _T("Yet Another Language Version 1.0"), 
		110, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);

	TextOutput.DrawTitleText(40,  IDS_WARN_MSG1, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(55,  IDS_WARN_MSG2, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(70,  IDS_WARN_MSG3, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(85,  IDS_WARN_MSG4, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(100, IDS_WARN_MSG5, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(115, IDS_HOWEVER, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(130, IDS_AS_LONG_AS, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);

	TextOutput.DrawTitleText(200, IDS_CREDITS, 90, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);

	TextOutput.DrawTitleText(220, IDS_KOREAN_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(230, IDS_FRENCH_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(240, IDS_CHINESE_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(250, IDS_JAPANESE_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(260, IDS_RUSSIAN_TRANSLATOR, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);
	TextOutput.DrawTitleText(270, IDS_GRAPHIC_DESIGN, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0), 1);

	TextOutput.DrawTitleText(312, IDS_COPYRIGHT, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
	TextOutput.DrawTitleText(324, IDS_ALLRIGHTS, 80, fontname, RGB(0xFF, 0xFF, 0xFF), RGB(0, 0, 0xFF), 1);
}
void CAboutDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CBCGPDialog::OnPaint() for painting messages
	PutLogoMessage();
}

BOOL CYalApp::OnIdle(LONG lCount)
{
	// TODO: Add your specialized code here and/or call the base class

	if(gErrorStatusInfo.ErrorStatus==TRUE)
	{
		OpenErrorFile(); gErrorStatusInfo.ErrorStatus = FALSE;
	}

	return __super::OnIdle(lCount);
}

void CYalApp::OpenErrorFile(void)
{
	CDocument *pDoc; CYalDoc *pYalDoc=NULL;
	POSITION pos = this->pYalDocTemp->GetFirstDocPosition();
	while(pos)
	{
		pDoc = this->pYalDocTemp->GetNextDoc(pos);

		if(pDoc && 
			gErrorStatusInfo.ErrorFile == pDoc->GetPathName())
		{
			pYalDoc = (CYalDoc*)pDoc; break;
		}
	}

	if(pYalDoc)
	{
		pYalDoc->ActivateYalView();
		if(pYalDoc->pActiveYalView) 
			pYalDoc->pActiveYalView->
			GoToErrorLine(gErrorStatusInfo.ErrorChar,gErrorStatusInfo.ErrorChar); 
	}
	else
	{
		pYalDoc = (CYalDoc*)this->OpenDocumentFile(gErrorStatusInfo.ErrorFile);
		if(pYalDoc->pActiveYalView) 
			pYalDoc->pActiveYalView->
			GoToErrorLine(gErrorStatusInfo.ErrorChar,gErrorStatusInfo.ErrorChar); 
	}
}

void CYalApp::SaveAllFiles(void)
{
	CDocument *pDoc; CYalDoc *pYalDoc=NULL;
	POSITION pos = this->pYalDocTemp->GetFirstDocPosition();

	while(pos)
	{
		pDoc = this->pYalDocTemp->GetNextDoc(pos);
		
		if(pDoc && pDoc->IsModified())
		{
			pDoc->DoFileSave(); 
		}
	}
}

BOOL CYalApp::IsFileChanged(void)
{
	CDocument *pDoc; CYalDoc *pYalDoc=NULL;
	POSITION pos = this->pYalDocTemp->GetFirstDocPosition();

	while(pos)
	{
		pDoc = this->pYalDocTemp->GetNextDoc(pos);

		if(pDoc && pDoc->IsModified()) return TRUE;
	}

	return FALSE;
}