// Yal.h : main header file for the Yal application
//
#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include <kch_main.h>
#include <kch_parser_exports.h>

#include "FavoritesManager.h"

#include "ArtText.h"

#include "MainFrame.h"

extern ErrorStatusInfo gErrorStatusInfo;

class CYalView;

extern "C" 
{
	extern RegisterFunctionsPtr RegisterFunctions;
	extern InitializeParserPtr InitializeParser;
	extern InitializeKeywordsPtr InitializeKeywords;
	extern ParseInitialPtr ParseInitial;
	extern ParseCodePtr ParseCode;
	extern SetPathSettingsPtr SetPathSettings;
	extern IsExecutingPtr IsExecuting;
	extern SetBreakPtr SetBreak;
	extern SetDocTitlePtr SetDocTitle;
	extern SetOutputEditorHandlePtr SetOutputEditorHandle;
	extern SetOutputEditorCEditPtr SetOutputEditorCEdit;
	extern SetInputCodeEditorPtr SetInputCodeEditor;
	extern SetStatusBarPtr SetStatusBar;
	extern PutStringUINTPtr PutStringUINT;
	extern PutStringCStringPtr PutStringCString;
	extern ClearOutputPtr ClearOutput;
	extern GetKeywordMapPtr GetKeywordMap;
	extern GetMemberMapPtr GetMemberMap;
	extern SetErrorStatusInfoPtr SetErrorStatusInfo;
}

// CYalApp:
// See Yal.cpp for the implementation of this class
//

class CAboutDlg : public CBCGPDialog
{
	DECLARE_DYNAMIC(CAboutDlg)

public:
	CAboutDlg();

	CBitmap theBkImage;
	CArtText TextOutput;

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };
	CBCGPURLLinkButton m_btnURL;

protected:
	void PutLogoMessage();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
};

class CYalApp : public CWinApp,
							public CBCGPWorkspace
{
public:
	CYalApp();

	CWinThread  *m_pThread;
	
	CMainFrame *pMainFrame;

	// Override from CBCGPWorkspace
	virtual void PreLoadState ();

	CYalView *pYalView;
	bool OnNewPane;
	
	CMultiDocTemplate *pYalDocTemp;
	CMultiDocTemplate *pWebDocTemp;
	
	BOOL				m_bBackgroundImage;
	CFavoritesManager	m_Favorites;
	BOOL				m_DoNotExit;

	int DocType; 
	
	void InitializePath(void);
	bool LoadTheParser(void);

	CString theWorkPath;
	CString theAppPath;
	CString theLibPath;
	CString theLangPath;
	CString theGraphPath;
	
	HINSTANCE hTheParser;

	CMultiDocTemplate* GetDocTemplate() const;

	DECLARE_MESSAGE_MAP()
// Overrides
public:
	void SaveAllFiles(void);
	BOOL IsFileChanged(void);
	virtual BOOL InitInstance();
	virtual int ExitInstance();

// Implementation
	afx_msg void OnAppAbout();
	
	afx_msg void OnNewWeb();
	afx_msg void OnNewYal();
	afx_msg void OnFileNew();

	virtual void LoadCustomState ();
	virtual void SaveCustomState ();
	
	afx_msg void OnAppExit();
	virtual BOOL OnIdle(LONG lCount);
	void OpenErrorFile(void);
};

extern CYalApp theApp;

BOOL GetDefaultSystemFont(CString& facename, LOGFONT* logfont);
HRESULT GetBrowserVersion(LPDWORD pdwMajor, LPDWORD pdwMinor);
CString InterpretNavigateError(DWORD);
HRESULT CreateInterShortcut (LPCTSTR pszURL, LPCTSTR pszURLfilename,
	LPCTSTR szDescription, LPCTSTR szIconFile = NULL,int nIndex = -1);

bool IsValidFileName(const CString& filename);
CString GetValidFileName(const CString& filename);
CString MakeShortString(const CString& str, int count);
CString MakeShortString(const CString& str);