// YalDoc.cpp : implementation of the CYalDoc class
//

#include "stdafx.h"
#include "Yal.h"

#include "YalDoc.h"
#include "CodeEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CYalDoc

IMPLEMENT_DYNCREATE(CYalDoc, CDocument)

BEGIN_MESSAGE_MAP(CYalDoc, CDocument)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, &CYalDoc::OnUpdateFileSave)
END_MESSAGE_MAP()


// CYalDoc construction/destruction

CYalDoc::CYalDoc(): m_strBuffer(_T("")), 
	pActiveBuffer(&m_strBuffer), pActiveYalView(NULL) {  }

CYalDoc::~CYalDoc() {  }

int CYalDoc::GetViewCount() const
{
	return int(this->m_viewList.GetCount());
}

BOOL CYalDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}




// CYalDoc serialization

void CYalDoc::Serialize(CArchive& ar)
{
	// CCodeView contains an edit control which handles all serialization
	//CCodeView *pView = reinterpret_cast<CCodeView*>(m_viewList.GetHead());
	//pView->SerializeRaw(ar);
	//pView->GetEditor()->Serialize(ar);
	if(ar.IsStoring())
	{
		ar<<*pActiveBuffer; 
		this->SetModifiedFlag(FALSE);
	}
	else
	{
		ar>>m_strBuffer; 
	}
}


// CYalDoc diagnostics

#ifdef _DEBUG
void CYalDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CYalDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

void CYalDoc::ActivateYalView(void)
{
	CView *pView; CYalView *pYalView;

	POSITION pos; int count=0;
	for(pos=this->GetFirstViewPosition(); pos != NULL; )
	{
		pView = this->GetNextView(pos);
		pYalView = dynamic_cast<CYalView*>(pView);

		if(pYalView)
		{
			pYalView->GetParentFrame()->ActivateFrame();
			this->pActiveYalView = pYalView; return;
		}
	}

	theApp.pMainFrame->OnWindowCode();
}

void CYalDoc::OnUpdateFileSave(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(this->IsModified());
}
