// YalView.h : interface of the CYalView class
//

#pragma once
#include "CodeEditor.h"

class CYalDoc; class CYalView;

#define WM_MOVECURSOR (WM_USER+100)

class CEditFindDlg : public CFindReplaceDialog
{
	friend class CYalView;

	virtual ~CEditFindDlg ();

protected:
	CYalView* m_pParent;
};

class CYalView : public CCodeEditor
{
	friend class CEditFindDlg;

protected: // create from serialization only
	CYalView();
	DECLARE_DYNCREATE(CYalView)

protected:

	CEditFindDlg*		m_pFindDlg;
	static CString		m_strFindText;
	static CString		m_strReplaceText;
	static DWORD		m_dwFindMask;
	CWinThread			*m_pThread;

	bool m_bJustCreated;

	// Attributes
public:
	

	void EnableOutline();
	CYalDoc* GetDocument() const;
	
	void GoToErrorLine(int nStartSel, int nEndSel);
	
	static BOOL	m_bUpdateFindString;

// Operations
public:
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

	virtual BOOL FindText (const CString& strFind, DWORD dwFindMask);
	virtual void OnTextNotFound (LPCTSTR /*lpszFind*/) {}
	virtual void OnPrepareFindString (CString& strFind);

// Overrides
public:
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CYalView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void OnEndPrintPreview(CDC* pDC, CPrintInfo* pInfo, POINT point, CPreviewView* pView);

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()

	afx_msg void OnFilePrintPreview();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnDestroy();
	afx_msg void OnEditPreviousbookmark();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditSelectAll();
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditRedo();
	afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditFind();
	afx_msg void OnEditReplace();
	afx_msg LRESULT OnFindReplace(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnEditChange(WPARAM wParam, LPARAM lParam);
	
	afx_msg void OnUpdateFilePrintPreview(CCmdUI *pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI *pCmdUI);
	//afx_msg void OnUpdateFileSave(CCmdUI *pCmdUI);
	afx_msg void OnViewLinenumber();
	afx_msg void OnUpdateViewLinenumber(CCmdUI *pCmdUI);
	virtual void OnInitialUpdate();
	afx_msg void OnCommandRun();
	afx_msg void OnCommandBreak();

	afx_msg LRESULT OnMoveCursor(WPARAM, LPARAM);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnUpdateCommandRun(CCmdUI *pCmdUI);
	virtual void OnAfterTextChanged(int nOffsetFrom,const CString&strText,BOOL bInserted);

public:
	afx_msg void OnUpdateEditFind(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditSelectAll(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditReplace(CCmdUI *pCmdUI);
	afx_msg void OnWindowNew();

	afx_msg void OnEditTogglebookmark();
	afx_msg void OnEditNextbookmark();
	afx_msg void OnEditTogglebreakpoint();
	afx_msg void OnUpdateEditTogglebreakpoint(CCmdUI* pCmdUI);
	afx_msg void OnEditRemoveAllBreakpoints();
	afx_msg void OnUpdateEditRemoveAllBreakpoints(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditListmembers(CCmdUI* pCmdUI);

	afx_msg void OnFontname();
	afx_msg void OnFontsize();
};

#ifndef _DEBUG  // debug version in YalView.cpp
inline CYalDoc* CYalView::GetDocument() const
   { return reinterpret_cast<CYalDoc*>(m_pDocument); }
#endif

