#pragma once

template<typename T> class AutoDeleteArray
{
public:
	T* DataPtr; long Size;

	AutoDeleteArray()
	{
		Size = 0; DataPtr=NULL;
	}

	AutoDeleteArray(long size)
	{
		DataPtr = NULL; Allocate(size); 
	}

	void Allocate(long size)
	{
		if(DataPtr) delete[] DataPtr;

		try
		{
			if(size>0)
			{
				DataPtr = new T[size]; Size = size; 
			}
			else
			{
				Size = 0; DataPtr = NULL;
			}
		}
		catch(CMemoryException *pException)
		{
			DataPtr = NULL; Size = 0;
			pException->Delete();
		}
	}

	~AutoDeleteArray() 
	{ if(DataPtr != NULL) delete[] DataPtr; }
};
