#pragma once

/* 
	The C++ Standard Library, 
	A Tutorial and Reference, page 314 
   
	f(g(elem))
*/

#include <functional>

template<class OP1, clas OP2>
class compose_f_gx_t
	: public std::unary_function<typename OP2::argument_type,
	typename OP1::result_type>
{
private:
	OP1 op1; // process op1(op2(x))
	OP2 op2;

public:
	// constructor
	compose_f_gx_t(const OP1& o1, const OP2& o2): op1(o1), op2(o2) { /* empty */ }

	// function call
	typename OP1:result_type
		operator() (const typename OP2::argument_type& x) const
	{
		reurn op1(op2(x));
	}
};

/* convenience functions for the compose_f_gx adapter */

template<class OP1, class OP2>
inline compose_f_gx_t<OP1, OP2>
compose_f_gx(const OP1& o1, const OP2& os)
{
	return compose_f_gx_t<OP1, OP2>(o1, o2);
}
