#pragma once

#include <exception>

#include "drawpad.h"

class CYapDoc;
class ObjGroup;
class ObjLine;
class ObjStroke;

typedef __int64 integer;
typedef double realnum;

class Graph2D
{
protected:
	CYapDoc *pYapDoc; ObjGroup *pGroup;
	int thePage;

	void copy(const Graph2D& graph)
	{
		pYapDoc = graph.pYapDoc;
		pGroup = graph.pGroup;
		thePage = graph.thePage;
	}

public:

	Graph2D() 
	{
		pYapDoc = ::GetYapDoc();
		
		if(pYapDoc==NULL) 
			throw std::exception("YapDoc is NULL.\r\n");
		pGroup = ::CreateGroup(CRect(10, -10, 200, -200), 0);

		if(pGroup == NULL)
			throw std::exception("Failed to create Group.\r\n");
		
		thePage = 0;
	}

	Graph2D(integer left, integer top, integer right, integer bottom, integer page) 
	{
		pYapDoc = ::GetYapDoc();
		
		if(pYapDoc==NULL) 
			throw std::exception("YapDoc is NULL.\r\n");
		pGroup = ::CreateGroup(CRect(int(left), int(top), int(right), int(bottom)), int(page));

		if(pGroup == NULL)
			throw std::exception("Failed to create Group.\r\n");

		thePage = int(page);
	}

	Graph2D(const Graph2D& graph) { copy(graph); }

	Graph2D& operator=(const Graph2D& graph) { copy(graph); return *this;}

	void Flush() { FlushGraph(pYapDoc, pGroup, thePage); }

	virtual ~Graph2D() { }

};