#pragma once

#include <iostream>

class integer
{
private:
	__int64 data;

public:
	integer(): data(0) {}
	
	integer(int i): data(i) {}
	integer(__int64 i): data(i) {}
	//integer(double d): data(static_cast<__int64>(d)) {}
	
	integer(const integer& intg) { data = intg.data; }

	integer& operator = (const integer& intg) { data = intg.data; return *this; }
	
	integer& operator %= (const integer& intg) { data %= intg.data; return *this; }
	integer& operator += (const integer& intg) { data += intg.data; return *this; }
	integer& operator -= (const integer& intg) { data -= intg.data; return *this; }
	integer& operator *= (const integer& intg) { data *= intg.data; return *this; }
	integer& operator /= (const integer& intg) 
	{ 
		if(intg.data == __int64(0)) throw std::exception("Division By Zero");

		data /= intg.data; return *this; 
	}

	integer operator++() { ++data; return *this; }
	integer operator++(int) { integer t; t.data = data; ++data; return t; }

	integer operator--() { --data; return *this; }
	integer operator--(int) { integer t; t.data = data; --data; return t; }

	integer* operator&() { return this; }
	integer& operator*() { return *this; }
	
	operator char() { return static_cast<char>(data); }
	operator unsigned char() { return static_cast<unsigned char>(data); }
	operator short() { return static_cast<short>(data); }
	operator unsigned short() { return static_cast<short>(data); }
	operator int() { return static_cast<int>(data); }
	operator unsigned() { return static_cast<unsigned>(data); }
	operator long() { return static_cast<long>(data); }
	operator unsigned long() { return static_cast<unsigned long>(data); }
	operator long long() { return static_cast<long long>(data); }
	operator float() { return static_cast<float>(data); }
	operator double() { return static_cast<double>(data); }

	integer operator% (const integer& i) { return data % i.data; }
	integer operator+ (const integer& i) { return data + i.data; }
	integer operator- (const integer& i) { return data - i.data; }
	integer operator* (const integer& i) { return data * i.data; }
	integer operator/ (const integer& i) { return data / i.data; }

	bool operator==(const integer& i) { return data == i.data; }
	bool operator<(const integer& i) { return data < i.data; }
	bool operator>(const integer& i) { return data > i.data; }
	bool operator<=(const integer& i) { return data <= i.data; }
	bool operator>=(const integer& i) { return data >= i.data; }
	bool operator!=(const integer& i) { return data != i.data; }

	friend std::ostream& operator << (std::ostream& os, const integer& i)
	{
		os << i.data;
		return os;
	}


};