#pragma once

#include <kch_autodelete.h>

#ifdef LIBBUILD
#define KCH_EXP __declspec(dllexport)
#else
#define KCH_EXP __declspec(dllimport)
#endif

template<typename T>  T GetMin(T a, T b) { return (a>b ? b : a); }
template<typename T>  T GetMax(T a, T b) { return (a>b ? a : b); }

enum PaperType { PAPER_ISO_A0, PAPER_ISO_A1, PAPER_ISO_A2, PAPER_ISO_A3, PAPER_ISO_A4, PAPER_ISO_A5, 
                 PAPER_ISO_A6, PAPER_ISO_A7, PAPER_ISO_A8, PAPER_ISO_A9, PAPER_ISO_A10, 

				 PAPER_ISO_B0, PAPER_ISO_B1, PAPER_ISO_B2, PAPER_ISO_B3, PAPER_ISO_B4, PAPER_ISO_B5, 
				 PAPER_ISO_B6, PAPER_ISO_B7, PAPER_ISO_B8, PAPER_ISO_B9, PAPER_ISO_B10,
				 
				 PAPER_ISO_C0, PAPER_ISO_C1, PAPER_ISO_C2, PAPER_ISO_C3, PAPER_ISO_C4, PAPER_ISO_C5, 
				 PAPER_ISO_C6, PAPER_ISO_C7, PAPER_ISO_C8, PAPER_ISO_C9, PAPER_ISO_C10,

				 PAPER_G4A0, PAPER_G2A0,
				 
				 PAPER_JIS_B0, PAPER_JIS_B1, PAPER_JIS_B2, PAPER_JIS_B3, PAPER_JIS_B4, PAPER_JIS_B5,
				 PAPER_JIS_B6, PAPER_JIS_B7, PAPER_JIS_B8, PAPER_JIS_B9, PAPER_JIS_B10, PAPER_JIS_B11, PAPER_JIS_B12,
				 
				 PAPER_SB46_4, PAPER_SB46_5, PAPER_SB46_6, PAPER_SB46_7,
				 
				 PAPER_KK_4, PAPER_KK_5,
				 
				 PAPER_ANSI_A, PAPER_ANSI_B, PAPER_ANSI_C, PAPER_ANSI_D, PAPER_ANSI_E,
				 
				 PAPER_ARCH_A, PAPER_ARCH_B, PAPER_ARCH_C, PAPER_ARCH_D, PAPER_ARCH_E, PAPER_ARCH_E1,

				 PAPER_QUARTO, PAPER_EXECUTIVE_MONARCH,
				 PAPER_GOVERNMENT_LETTER, PAPER_LETTER, PAPER_LEGAL, PAPER_LEDGER_TABLOID,
				 PAPER_LARGE_POST, PAPER_DOUBLE_DEMY, PAPER_QUAD_DEMY, PAPER_STATEMENT, 
				 PAPER_INDEX_CARD35, PAPER_INDEX_CARD46, PAPER_INDEX_CARD58,
				 PAPER_INT_BUSINESS_CARD, PAPER_US_BUSINESS_CARD,

				 PAPER_EMPEROR, PAPER_ANTIQUARIAN, PAPER_GRAND_EAGLE, PAPER_DOUBLE_ELEPHANT,
				 PAPER_COLOMBIER, PAPER_ATLAS, PAPER_DOUBLE_LARGE_POST,
				 PAPER_IMPERIAL, PAPER_DOUBLE_POST, PAPER_ELEPHANT, PAPER_PRINCESS, PAPER_CARTRIDGE,
				 PAPER_SUPER_ROYAL, PAPER_ROYAL, PAPER_SHEET_AND_HALF_POST,
				 PAPER_MEDIUM, PAPER_DEMY, PAPER_COPY_DRAUGHT, PAPER_CROWN, PAPER_POST,
				 PAPER_PINCHED_POST, PAPER_FOOLSCAP,
				 PAPER_SMALL_FOOLSCAP, PAPER_BRIEF, PAPER_POTT,

				 PAPER_PA0, PAPER_PA1, PAPER_PA2, PAPER_PA3, PAPER_PA4, PAPER_PA5,
				 PAPER_PA6, PAPER_PA7, PAPER_PA8, PAPER_PA9, PAPER_PA10

};

enum ShapeType { ShapeNone=-1, ShapePencil, ShapeLine, ShapePolyline, ShapePolygon, ShapeCurve,
				 ShapeClosedCurve, ShapeEllipse, ShapeLasso, ShapeRectangle, 
				 ShapeText, ShapeGraph, ShapeEraser, ShapeSpoid };

enum StrPenType { StrPenTypeEraser=0, StrPenTypeThin, StrPenTypeThick, StrPenTypeTrans };

enum RegionOprType  { RegionComplement=0, RegionExclude, RegionIntersect, RegionUnion, RegionXor };

#define GDIPLUS_RATIO 0.0104164f

#define OUTLINE_CX 2
#define OUTLINE_CY 2

#define INLINE_CX 1
#define INLINE_CY 1

// Each logical unit is converted to 0.01 inch. 
// Positive x is to the right; positive y is up.
#define YAP_MAP_MONITOR MM_LOENGLISH
#define YAP_MAP_PRINTER MM_HIENGLISH

#define TOLERANCE  4.0f

#define ELLIPSE_POINTS 360

#define YAP_VER_ONE 1
#define OPR_CLEANUP	2048
//#define VIEW_HORZ_OFFSET 0

// e
#define MATH_E			2.71828182845904523536
 
// log2(e)
#define MATH_LOG2E		1.44269504088896340736
 
// log10(e)
#define MATH_LOG10E		0.434294481903251827651
 
// ln(2)
#define MATH_LN2		0.693147180559945309417
 
// ln(10)
#define MATH_LN10		2.30258509299404568402
 
// pi
#define MATH_PI			3.14159265358979323846

// 2 * pi
#define MATH_PI2		(2.0 * 3.14159265358979323846)
 
// pi/2
#define MATH_PI_2		1.57079632679489661923
 
// pi/4
#define MATH_PI_4		0.785398163397448309616
 
// 1/pi 
#define MATH_1_PI		0.318309886183790671538
 
// 2/pi
#define MATH_2_PI		0.636619772367581343076
 
// 2/sqrt(pi) 
#define MATH_2_SQRTPI	1.12837916709551257390
 
// sqrt(2)
#define MATH_SQRT2		1.41421356237309504880
 
// 1/sqrt(2)
#define MATH_SQRT1_2	0.707106781186547524401

typedef struct instructor_tag
{
	CString name;
	CString email;
	CString ipaddress;

} Instructor;

inline float DegToRad(float deg) { return deg * 0.017453292f; }
inline float RadToDeg(float rad) { return rad * 57.29577951f; }

inline bool EqualCRect(CRect& rect1, CRect& rect2)
{
	return (rect1.left == rect2.left) && (rect1.right  == rect2.right) && 
		   (rect1.top  == rect2.top)  && (rect1.bottom == rect2.bottom);
}

