#pragma once

#include <kch_tokenmap.h>
#include <kch_error_status.h>

typedef void (*RegisterFunctionsPtr)();
typedef void (*InitializeParserPtr)();
typedef void (*InitializeKeywordsPtr)(CEdit* pEditor, const CString& thePath);
typedef bool (*ParseInitialPtr)(const CString& filename);
typedef UINT (*ParseCodePtr)(LPVOID pParam);
typedef void (*SetPathSettingsPtr)(const CString& AppPath, 
			const CString& LibPath, const CString &LangPath, const CString& WorkPath);
typedef LONG (*IsExecutingPtr)();
typedef void (*SetBreakPtr)(); 
typedef void (*SetDocTitlePtr)(const CString& title);
typedef void (*SetOutputEditorHandlePtr)(HANDLE);
typedef void (*SetOutputEditorCEditPtr)(CEdit* pEdit);
typedef void (*SetInputCodeEditorPtr)(HANDLE);
typedef void (*SetStatusBarPtr)(HANDLE);
typedef void (*PutStringUINTPtr)(UINT); 
typedef void (*PutStringCStringPtr)(const CString& msg);
typedef void (*ClearOutputPtr)();
typedef const TransKeywords::KeywordMap& (*GetKeywordMapPtr)();
typedef const TransKeywords::KeywordMap& (*GetMemberMapPtr)();
typedef void (*SetErrorStatusInfoPtr)(ErrorStatusInfo *pESF);

#include <sstream>

#define GETADDRESS(module, procptr, proc) \
	if((proc=(procptr)::GetProcAddress(module, #proc))==NULL) \
{	\
	std::wostringstream os; \
	os<<L"Failed to get the procedure address of "<<L#proc; \
		::AfxMessageBox(os.str().c_str()); \
	return false; \
} 