#pragma once

#include <kch_afx.h>
#include <afxwin.h>

#include <iostream>
#include <sstream>

#ifndef KCH_EXP
#ifdef BUILD_THEPARSER
#define KCH_EXP __declspec(dllexport)
#else
#define KCH_EXP __declspec(dllimport)
#endif
#endif

class CCodeEditor;

extern bool InitializeLexer();
extern bool InitializeLexerForInput();

KCH_EXP int CountCharacters(CString& str);
KCH_EXP bool IsDoubleByte(CString& str);
KCH_EXP std::wstring ConvertChar(char const* msg);
KCH_EXP std::wstring ConvertChar(std::string& msg);

//KCH_EXP std::string ConvertChar(wchar_t const* sourceCode);
extern "C"  void SetDocTitle(const CString& title);
KCH_EXP void PrepareScanBuffer(CString& sourceCode, char* pScanBuffer);
KCH_EXP bool PrepareCodeBuffer(CCodeEditor* pEditor, char* pScanBuffer, int buf_size);
KCH_EXP bool GetFileContents(const CString& filename, CString& contents);
KCH_EXP void MoveTo(int cbegin, int cend);
KCH_EXP int GetErrorCharCount();
//KCH_EXP void CharToWideChar(char const* msg, wchar_t *msgbuf);
//KCH_EXP void WideCharToChar(const wchar_t *pWCBuffer, char *pMBBuffer);
KCH_EXP void PutString(const wchar_t* msg);
KCH_EXP void PutString(const std::wstring& msg);
KCH_EXP void PutString(const CString& msg);
KCH_EXP void PutString(UINT resourceid);
KCH_EXP void SetIOEditor(CEdit* pOutput, CEdit* pInput);
extern "C" void SetInputCodeEditor(HANDLE hInput);
KCH_EXP void SetInputEditor(HANDLE hInput);
extern "C" void SetOutputEditorHandle(HANDLE hOutput);
extern "C" void SetStatusBar(HANDLE hStatusBar);
extern "C" LONG IsExecuting();
KCH_EXP void SetCodePage();
extern "C" void ClearOutput();
extern "C" void SetBreak();
extern "C" UINT ParseCode(LPVOID pParam);
KCH_EXP void yyerror(char const* msg);
extern "C" void RegisterFunctions();
KCH_EXP void MoveCursor();

KCH_EXP int CountChar(char const* msg);
KCH_EXP int CountChar(char const* msg, int max);
KCH_EXP int CountChar(const std::string& msg);

KCH_EXP std::wstring LoadUnicodeMsg(UINT msgid);
KCH_EXP std::string LoadMsg(UINT msgid);

// 0: yap, 1: yhd, 2: txt, else 3
KCH_EXP int GetDocumentType(CString fname);
KCH_EXP int GetDocumentType(const char* file_name);

KCH_EXP bool DefineUnitVectors(const wchar_t *xcom, const wchar_t *ycom, const wchar_t *zcom);
KCH_EXP bool DefineUnitImaginary(const wchar_t *realnum, const wchar_t *imag);

extern "C"  void SetDocTitle(const CString& title);
extern SYSTEM_INFO gSystemInfo;

#define SET_USER_ABORT \
	if(gBreak) \
		throw UserAbortException(L"Execution aborted by user.\r\n"); \
	else { if(gSystemInfo.dwNumberOfProcessors==1) Sleep(0); }

#define STR_EQL_UNICODE(astr, bstr) !::lstrcmp(astr, bstr)




