#pragma once

#pragma warning(disable: 4060 4267 4102 4244 4273 4996 4065 4102)

#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <kch_theparser.h>
#include <kch_theparser_type2.h>

#include "SyntaxAnalyzer.h"

#include "garbagecollector.h"

#include "parser.hpp"

#define MAX_INCLUDE_DEPTH 50

#define YY_DECL extern int yylex(YYSTYPE *lvalp, YYLTYPE *llocp)
			
extern YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
extern int include_stack_ptr;

extern bool gInput;
extern char *scanbuffer;
extern int eof_seen, send_token;
extern int scanbuffer_size;
extern int scanbuffer_fsize;

extern ArrayInit gArrayInit;

extern int gLastLine, gLastCharCount;

extern std::wstring gPrevToken, gLastToken;

#define YY_USER_ACTION { CString txt(CharToWString(yytext, yyleng).c_str()); txt.Trim(); \
							if(!(txt == _T("%>")|| txt == _T("")) )  \
							{ gLastCharCount = gScanFileStack.top().charcount; \
							  gLastLine = gScanFileStack.top().lineno; \
							  gPrevToken = gLastToken; gLastToken = CharToWString(yytext, yyleng); } }

extern std::set<CString> gIncludeSet, gIncludeSetGlobal;
	
// The zero-based index of the first character in
// this string that is also in pszCharSet; if there is no match.
// Finds the first occurrence of any of the characters in pszCharSet.
extern int InvalidFileName(const CString& filename);

extern UserDefinedType *gUdtPtr;
extern Stack<UserDefinedType*> gUdtFactoryStack;
extern Stack<UserDefinedType*> gFactoryStack;
extern Stack<bool> gBlockTypeStack;
extern Stack<bool> gCatchBlockStack;

extern TransKeywords gTransKeyword, gTransOprType;
extern TransKeywords gTransKeywordTemplate, gTransOprTypeTemplate;

extern ScanFile gScanFile;
extern Stack<char*> gScanBuffer;
extern Stack<ScanFile> gScanFileStack;
extern Stack<StmtType> gLoopStack;
extern Stack<Statement*> gSelectStack;
			
extern int initial_set, gOpr; extern CString gDocTitle;
extern bool static_set, point_set, assign_set, literal_set, arg_set;
extern bool unitvctr, unitcplx, unitvctr_set, unitcplx_set;
extern bool goto_set, sol_set, class_set;

extern wchar_t decimal_point;
extern wchar_t thousand_point;
extern bool fmt_thousand;

extern FuncList gflist; extern DataType vartype;

extern Stack<ReturnSig> gReturnStack;
extern Stack<StatementList*> gStmtListStack;
extern StatementList *gStatementList, *gCurrentStmtList, *gStmtListGlobal;

extern GarbageCollector gGC;

extern UserDefinedType* gLastUdt;

extern bool fmt_clear, fmt_scientific, fmt_showpoint;
extern int fmt_precision;
	
extern wchar_t cplx_real_opr[BUF_LENGTH], cplx_imag_opr[BUF_LENGTH];
extern wchar_t vctr_xcom_opr[BUF_LENGTH], vctr_ycom_opr[BUF_LENGTH], vctr_zcom_opr[BUF_LENGTH];
			
extern int GetFunctionType(const wchar_t* id);
extern bool PrepareNewFileScan(const CString& fname);
extern "C" void ClearOutput();
extern int GetFunType(FunName& fn, YYSTYPE *lvalp);
extern int GetVarType(const wchar_t* id, YYSTYPE *lvalp);
extern void StrCopy(wchar_t* tgt, const wchar_t* src);
extern void StrCopy(wchar_t* tgt, const std::wstring& src);
extern UserDefinedType* LookupUdt(const std::wstring id);
extern DataType LookupDataAndType(const std::wstring id, Data** pData);
extern int HandleReturn(DataType type);

extern void yycleanup();
extern char* GetTokenText();
extern void DeleteCurrentBuffer(); 
extern YY_BUFFER_STATE GetCurrentBuffer();
extern void ResetLexer();
extern int HandleScanID(std::wstring token, YYSTYPE *lvalp);

extern std::wstring GetPath(const CString& fullpath);

KCH_EXP CString GetCurrentPath();

extern CString gLibPath;
extern CString gLangPath;
extern CString gAppPath;
extern CString gWorkPath;

extern Stack<ScanFile> gPuncCurly;
extern Stack<ScanFile> gPuncParan;

