%error-verbose
%locations
%pure-parser
%skeleton "unicode_yacc.c"

%{
	#pragma warning(disable: 4060 4065 4102 4996 4273)
	
	#include "parser_util.h"
	#include "SyntaxAnalyzer.h"
		
	#define YYINITDEPTH	4090

%}

%union
{
	VarType vart; const wchar_t *pstr; 
	wchar_t bufr[BUF_LENGTH]; 
	
	realnum scalar; integer intg; bool booln; FunName fname;
	
	integer* pintg; realnum *preal; bool   *pbool;
	Complex* pcplx; Vector  *pvctr; string *pstrn;
	
	Expression<bool*>*		pebool; Expression<string*>*  pestrn;
	Expression<integer*>*	peintg; Expression<realnum*>* pereal;
	Expression<Complex*>*	pecplx; Expression<Vector*>*  pevctr;
	Expression<UserData*>*  peuser;
		
	ExpVoid *vxpr; ExpIntg *eint; ExpReal *real; 
	ExpCplx *cplx; ExpVctr *vctr; ExpBool *blpr; 
	ExpStrn *strn; ExpUser *eusr;
			
	Expression<IntgVec1D> *i1d; Expression<IntgVec2D> *i2d;
	Expression<IntgVec3D> *i3d; Expression<IntgVec4D> *i4d; 
	Expression<IntgVec5D> *i5d; 
	
	Expression<RealVec1D> *r1d; Expression<RealVec2D> *r2d;
	Expression<RealVec3D> *r3d; Expression<RealVec4D> *r4d; 
	Expression<RealVec5D> *r5d; 
	
	Expression<CplxVec1D> *c1d; Expression<CplxVec2D> *c2d;
	Expression<CplxVec3D> *c3d; Expression<CplxVec4D> *c4d; 
	Expression<CplxVec5D> *c5d; 
	
	Expression<VctrVec1D> *v1d; Expression<VctrVec2D> *v2d;
	Expression<VctrVec3D> *v3d; Expression<VctrVec4D> *v4d; 
	Expression<VctrVec5D> *v5d; 
	
	PtrData<bool>     *bptr;    PtrData<integer> *iptr; 
	PtrData<realnum>  *rptr;    PtrData<Complex> *cptr; 
	PtrData<Vector>   *vptr;	PtrData<string>  *sptr;
	PtrData<UserData> *uptr; 
	
	AptrData<IntgVec1D> *ap1i; AptrData<RealVec1D> *ap1r;
	AptrData<CplxVec1D> *ap1c; AptrData<VctrVec1D> *ap1v;
	
	AptrData<IntgVec2D> *ap2i; AptrData<RealVec2D> *ap2r;
	AptrData<CplxVec2D> *ap2c; AptrData<VctrVec2D> *ap2v;
	
	AptrData<IntgVec3D> *ap3i; AptrData<RealVec3D> *ap3r;
	AptrData<CplxVec3D> *ap3c; AptrData<VctrVec3D> *ap3v;
	
	AptrData<IntgVec4D> *ap4i; AptrData<RealVec4D> *ap4r;
	AptrData<CplxVec4D> *ap4c; AptrData<VctrVec4D> *ap4v;
		
	AptrData<IntgVec5D> *ap5i; AptrData<RealVec5D> *ap5r;
	AptrData<CplxVec5D> *ap5c; AptrData<VctrVec5D> *ap5v;
						
	ExpTypeless *xpts; Data* dptr;
			
	Variable<bool>	  *vbool;  Variable<integer> *vintg; 
	Variable<realnum> *vreal;  Variable<Complex> *vcplx; 
	Variable<Vector>  *vvctr;  
	
	Function *pfunc;  Range *prng; 
	
	StmtOutput *pout; StmtInput *pinpt;
	Statement *pstmt; StatementList *pstmtlist;
				
	VarMemBase *vmb; VarUserBase *vub; UdtPtrBase *upb;
		
	VarMem<IntgAry1D> *vmi1d; VarMem<RealAry1D> *vmr1d; 
	VarMem<CplxAry1D> *vmc1d; VarMem<VctrAry1D> *vmv1d; 
	
	VarMem<IntgAry2D> *vmi2d; VarMem<RealAry2D> *vmr2d; 
	VarMem<CplxAry2D> *vmc2d; VarMem<VctrAry2D> *vmv2d; 
	
	VarMem<IntgAry3D> *vmi3d; VarMem<RealAry3D> *vmr3d; 
	VarMem<CplxAry3D> *vmc3d; VarMem<VctrAry3D> *vmv3d; 
	
	VarMem<IntgAry4D> *vmi4d; VarMem<RealAry4D> *vmr4d; 
	VarMem<CplxAry4D> *vmc4d; VarMem<VctrAry4D> *vmv4d; 
	
	VarMem<IntgAry5D> *vmi5d; VarMem<RealAry5D> *vmr5d; 
	VarMem<CplxAry5D> *vmc5d; VarMem<VctrAry5D> *vmv5d; 
			
	VarUser<IntgAry1D> *vai1d; VarUser<RealAry1D> *var1d; 
	VarUser<CplxAry1D> *vac1d; VarUser<VctrAry1D> *vav1d; 
	
	VarUser<IntgAry2D> *vai2d; VarUser<RealAry2D> *var2d; 
	VarUser<CplxAry2D> *vac2d; VarUser<VctrAry2D> *vav2d; 
	
	VarUser<IntgAry3D> *vai3d; VarUser<RealAry3D> *var3d; 
	VarUser<CplxAry3D> *vac3d; VarUser<VctrAry3D> *vav3d; 
	
	VarUser<IntgAry4D> *vai4d; VarUser<RealAry4D> *var4d; 
	VarUser<CplxAry4D> *vac4d; VarUser<VctrAry4D> *vav4d; 
	
	VarUser<IntgAry5D> *vai5d; VarUser<RealAry5D> *var5d; 
	VarUser<CplxAry5D> *vac5d; VarUser<VctrAry5D> *vav5d; 
		
	LeftHandSide<bool>	   *lhsbool; LeftHandSide<integer> *lhsintg;
	LeftHandSide<realnum>  *lhsreal; LeftHandSide<Complex> *lhscplx;
	LeftHandSide<Vector>   *lhsvctr; LeftHandSide<string>  *lhsstrn;
	LeftHandSide<UserData> *lhsuser; 
	
	LeftHandSide<bool*>    *lhsbptr; LeftHandSide<string*>  *lhssptr;
	LeftHandSide<integer*> *lhsiptr; LeftHandSide<realnum*> *lhsrptr;
	LeftHandSide<Complex*> *lhscptr; LeftHandSide<Vector*>  *lhsvptr;
		
	LeftHandSideArray<IntgVec1D> *lhsi1d; LeftHandSideArray<IntgVec2D> *lhsi2d;
	LeftHandSideArray<IntgVec3D> *lhsi3d; LeftHandSideArray<IntgVec4D> *lhsi4d; 
	LeftHandSideArray<IntgVec5D> *lhsi5d; 
	
	LeftHandSideArray<RealVec1D> *lhsr1d; LeftHandSideArray<RealVec2D> *lhsr2d;
	LeftHandSideArray<RealVec3D> *lhsr3d; LeftHandSideArray<RealVec4D> *lhsr4d; 
	LeftHandSideArray<RealVec5D> *lhsr5d; 
	
	LeftHandSideArray<CplxVec1D> *lhsc1d; LeftHandSideArray<CplxVec2D> *lhsc2d;
	LeftHandSideArray<CplxVec3D> *lhsc3d; LeftHandSideArray<CplxVec4D> *lhsc4d; 
	LeftHandSideArray<CplxVec5D> *lhsc5d; 
	
	LeftHandSideArray<VctrVec1D> *lhsv1d; LeftHandSideArray<VctrVec2D> *lhsv2d;
	LeftHandSideArray<VctrVec3D> *lhsv3d; LeftHandSideArray<VctrVec4D> *lhsv4d; 
	LeftHandSideArray<VctrVec5D> *lhsv5d; 
}

%{
	extern int yylex(YYSTYPE *lvalp, YYLTYPE *llocp);
%}

%token STMT_IF STMT_FOR STMT_DO STMT_IFTRUE STMT_IFFALSE
%token STMT_GOTO STMT_BREAK STMT_SKIP STMT_EXIT STMT_CLEAR
%token STMT_SELECT LABEL_CHOICE LABEL_ALWAYS TKN_EOF

%token OPR_DIMENSION OPR_SIZE OPR_RESIZE

%token TKN_TRY TKN_THROW TKN_NEW TKN_DELETE

%token END_LINE SET_PREC DECLARE

%token<pstr> TKN_STRING

%token<bufr> MEM_BOOL MEM_INTG  MEM_REAL MEM_CPLX MEM_VCTR MEM_STRN MEM_USER
%token<bufr> MEM_AI1D MEM_AI2D  MEM_AI3D MEM_AI4D MEM_AI5D 
%token<bufr> MEM_AR1D MEM_AR2D  MEM_AR3D MEM_AR4D MEM_AR5D
%token<bufr> MEM_AC1D MEM_AC2D  MEM_AC3D MEM_AC4D MEM_AC5D
%token<bufr> MEM_AV1D MEM_AV2D  MEM_AV3D MEM_AV4D MEM_AV5D

%token<bufr> MEM_BPTR MEM_SPTR MEM_IPTR MEM_RPTR MEM_CPTR MEM_VPTR MEM_UPTR  

%token<uptr> PTR_USER
%token<bptr> PTR_BOOL  %token<iptr> PTR_INTG %token<rptr> PTR_REAL 
%token<cptr> PTR_CPLX  %token<vptr> PTR_VCTR %token<sptr> PTR_STRN 

%token<ap1i> PTR_AP1I %token<ap1r> PTR_AP1R %token<ap1c> PTR_AP1C %token<ap1v> PTR_AP1V
%token<ap2i> PTR_AP2I %token<ap2r> PTR_AP2R %token<ap2c> PTR_AP2C %token<ap2v> PTR_AP2V
%token<ap3i> PTR_AP3I %token<ap3r> PTR_AP3R %token<ap3c> PTR_AP3C %token<ap3v> PTR_AP3V
%token<ap4i> PTR_AP4I %token<ap4r> PTR_AP4R %token<ap4c> PTR_AP4C %token<ap4v> PTR_AP4V
%token<ap5i> PTR_AP5I %token<ap5r> PTR_AP5R %token<ap5c> PTR_AP5C %token<ap5v> PTR_AP5V

%token<scalar> REAL %token<intg> INTG  %token<booln> BOOLN

%token TYPE_VOID TYPE_BOOL TYPE_INTG TYPE_REAL TYPE_CPLX TYPE_VCTR TYPE_STRN TYPE_CLASS TYPE_UDT
%token RTN_VOID RTN_BOOL RTN_REAL RTN_CPLX RTN_VCTR RTN_INTG RTN_VUB RTN_STRN TKN_EXTENDS 
%token RTN_BPTR RTN_SPTR RTN_IPTR RTN_RPTR RTN_CPTR RTN_VPTR

%token RTN_AI1D RTN_AI2D RTN_AI3D RTN_AI4D RTN_AI5D
%token RTN_AR1D RTN_AR2D RTN_AR3D RTN_AR4D RTN_AR5D
%token RTN_AC1D RTN_AC2D RTN_AC3D RTN_AC4D RTN_AC5D
%token RTN_AV1D RTN_AV2D RTN_AV3D RTN_AV4D RTN_AV5D

%token TKN_NEW TKN_DELETE

%type<pebool> expr_bptr %type<pestrn> expr_sptr
%type<peintg> expr_iptr %type<pereal> expr_rptr
%type<pecplx> expr_cptr %type<pevctr> expr_vptr

%type<peuser> expr_uptr %type<upb> lhs_uptr

%type<lhsbptr> lhs_bptr %type<lhssptr> lhs_sptr
%type<lhsiptr> lhs_iptr %type<lhsrptr> lhs_rptr
%type<lhscptr> lhs_cptr %type<lhsvptr> lhs_vptr  

%token CPLX_R CPLX_I TYPE_FILE VCTR_X VCTR_Y VCTR_Z

%token DEF_VUNIT DEF_CUNIT DEF_STATIC DEF_CLASS DEF_LITERAL

%token<bufr> VCTR_UNIT CPLX_UNIT VAR_VOID TYPE_UNDF

%token<vart> VAR_BOOL VAR_INTG VAR_REAL VAR_CPLX VAR_VCTR VAR_USER VAR_STRN 

%token<eint> LTL_INTG MEM_LTL_INTG  %token<real> LTL_REAL MEM_LTL_REAL 
%token<cplx> LTL_CPLX MEM_LTL_CPLX  %token<vctr> LTL_VCTR MEM_LTL_VCTR 
%token<strn> LTL_STRN MEM_LTL_STRN

%type<vart>  array_rc_dim2

%token<vart> ARY_INTG1D ARY_REAL1D ARY_CPLX1D ARY_VCTR1D
%token<vart> ARY_INTG2D ARY_REAL2D ARY_CPLX2D ARY_VCTR2D
%token<vart> ARY_INTG3D ARY_REAL3D ARY_CPLX3D ARY_VCTR3D
%token<vart> ARY_INTG4D ARY_REAL4D ARY_CPLX4D ARY_VCTR4D
%token<vart> ARY_INTG5D ARY_REAL5D ARY_CPLX5D ARY_VCTR5D

%token<bufr> VID_VOID VID_BOOL VID_INTG VID_REAL VID_CPLX VID_VCTR VID_FILE
%token<bufr> VID_CLASS VID_USER VID_STRN
%token<bufr> LID_INTG LID_REAL LID_CPLX LID_VCTR LID_STRN

%token<bufr> STMT_LABEL GOTO_TARGET

%token<pfunc> FNC_BOOL FNC_VOID FNC_INTG FNC_REAL FNC_CPLX FNC_VCTR FNC_STRN FNC_USER
%token<pfunc> FNC_IPTR FNC_RPTR FNC_CPTR FNC_VPTR FNC_BPTR FNC_SPTR

%token<pfunc> FNC_AI1D FNC_AI2D FNC_AI3D FNC_AI4D FNC_AI5D
%token<pfunc> FNC_AR1D FNC_AR2D FNC_AR3D FNC_AR4D FNC_AR5D
%token<pfunc> FNC_AC1D FNC_AC2D FNC_AC3D FNC_AC4D FNC_AC5D
%token<pfunc> FNC_AV1D FNC_AV2D FNC_AV3D FNC_AV4D FNC_AV5D

%type<pfunc> declare_fhdr declare_fhdr_static

%type<pfunc> hdr_void hdr_bool hdr_strn hdr_user 
%type<pfunc> hdr_intg hdr_real hdr_cplx hdr_vctr hdr_bptr
%type<pfunc> hdr_iptr hdr_rptr hdr_cptr hdr_vptr hdr_sptr

%type<pfunc> hdr_ai1d hdr_ai2d hdr_ai3d hdr_ai4d hdr_ai5d
%type<pfunc> hdr_ar1d hdr_ar2d hdr_ar3d hdr_ar4d hdr_ar5d
%type<pfunc> hdr_ac1d hdr_ac2d hdr_ac3d hdr_ac4d hdr_ac5d
%type<pfunc> hdr_av1d hdr_av2d hdr_av3d hdr_av4d hdr_av5d

%token<fname> FN_INTG FN_I_II FN_REAL FN_C_C FN_VO_MR_MR
%token<fname> FN_R_RR FN_R_RRR FN_R_RRRR FN_R_C FN_R_V 
%token<fname> FN_C_CC FN_C_CCCC FN_C_RR FN_R_I FN_R_II     
%token<fname> FN_V_V FN_V_RRR FN_VO_MAKEUNIT
%token<fname> FN_B_S FN_I_II_UI

%type<vxpr> expr_void	

%type<strn> expr_ini_strn expr_strn	%type<xpts> var_names // ExpTypeless*
%type<eint> expr_intg expr_inum	expr_dim  expr_ini_intg
%type<real> func_real expr_real expr_rnum expr_ini_real
%type<cplx> func_cplx expr_cplx expr_cnum expr_ini_cplx
%type<vctr> func_vctr expr_vctr expr_vnum expr_ini_vctr

%type<xpts> expr_typeless expr_rtn_typeless

%type<real> cplx_to_real vctr_to_real

%type<lhsuser> lhs_user %type<eusr> expr_user
%type<lhsbool> lhs_bool %type<lhsintg> lhs_intg %type<lhsreal> lhs_real
%type<lhscplx> lhs_cplx %type<lhsvctr> lhs_vctr %type<lhsstrn> lhs_strn

%type<blpr> opr_bool expr_ini_bool expr_boolean loop_bool %type<prng> idx_range

%type<lhsi1d> lhs_i1d %type<lhsi2d> lhs_i2d %type<lhsi3d> lhs_i3d
%type<lhsi4d> lhs_i4d %type<lhsi5d> lhs_i5d

%type<lhsr1d> lhs_r1d %type<lhsr2d> lhs_r2d %type<lhsr3d> lhs_r3d
%type<lhsr4d> lhs_r4d %type<lhsr5d> lhs_r5d

%type<lhsc1d> lhs_c1d %type<lhsc2d> lhs_c2d %type<lhsc3d> lhs_c3d
%type<lhsc4d> lhs_c4d %type<lhsc5d> lhs_c5d

%type<lhsv1d> lhs_v1d %type<lhsv2d> lhs_v2d %type<lhsv3d> lhs_v3d
%type<lhsv4d> lhs_v4d %type<lhsv5d> lhs_v5d

%type<i1d> expr_i1d %type<i2d> expr_i2d %type<i3d> expr_i3d
%type<i4d> expr_i4d %type<i5d> expr_i5d

%type<r1d> expr_r1d %type<r2d> expr_r2d %type<r3d> expr_r3d
%type<r4d> expr_r4d %type<r5d> expr_r5d

%type<c1d> expr_c1d %type<c2d> expr_c2d %type<c3d> expr_c3d
%type<c4d> expr_c4d %type<c5d> expr_c5d

%type<v1d> expr_v1d %type<v2d> expr_v2d %type<v3d> expr_v3d
%type<v4d> expr_v4d %type<v5d> expr_v5d

%type<pstmt> declare declare_list static_declare 
%type<pstmt> decl_void decl_bool init_bool 
%type<pstmt> decl_intg init_intg init_ary_intg
%type<pstmt> decl_strn init_strn
%type<pstmt> decl_real init_real init_ary_real
%type<pstmt> decl_cplx init_cplx init_ary_cplx
%type<pstmt> decl_vctr init_vctr init_ary_vctr
%type<pstmt> decl_udt  init_udt decl_tc_user decl_tp_user 

%type<pstmt> decl_tc_strn decl_tc_bool decl_tc_intg
%type<pstmt> decl_tc_real decl_tc_cplx decl_tc_vctr

%type<pstmt> decl_tp_strn decl_tp_bool decl_tp_intg
%type<pstmt> decl_tp_real decl_tp_cplx decl_tp_vctr

%type<pstmt> decl_tc_i1d decl_tc_r1d decl_tc_c1d decl_tc_v1d 
%type<pstmt> decl_tc_i2d decl_tc_r2d decl_tc_c2d decl_tc_v2d 
%type<pstmt> decl_tc_i3d decl_tc_r3d decl_tc_c3d decl_tc_v3d 
%type<pstmt> decl_tc_i4d decl_tc_r4d decl_tc_c4d decl_tc_v4d 
%type<pstmt> decl_tc_i5d decl_tc_r5d decl_tc_c5d decl_tc_v5d 

%type<pstmt> decl_tp_i1d decl_tp_r1d decl_tp_c1d decl_tp_v1d 
%type<pstmt> decl_tp_i2d decl_tp_r2d decl_tp_c2d decl_tp_v2d 
%type<pstmt> decl_tp_i3d decl_tp_r3d decl_tp_c3d decl_tp_v3d 
%type<pstmt> decl_tp_i4d decl_tp_r4d decl_tp_c4d decl_tp_v4d 
%type<pstmt> decl_tp_i5d decl_tp_r5d decl_tp_c5d decl_tp_v5d 
 
%type<pstmt> literal_declare literal_list declare_literal
%type<pstmt> decl_intg_literal init_intg_literal
%type<pstmt> decl_real_literal init_real_literal
%type<pstmt> decl_cplx_literal init_cplx_literal
%type<pstmt> decl_vctr_literal init_vctr_literal
%type<pstmt> decl_strn_literal init_strn_literal


%type<pstmt> assignment assign_array assign_ptr stmt_ary_makeunit
%type<pstmt> stmt_swap stmt_exit stmt_try stmt_throw stmt_catch 

%type<pfunc> stmt_func stmt_prec stmt_func_static
%type<pstmt> stmt stmtdefs stmt_return stmt_expr
%type<pstmt> stmt_if stmt_for stmt_while stmt_do stmt_select 
%type<pstmt> stmt_label stmt_goto stmt_break stmt_skip stmt_class
%type<pstmt> stmt_arsize stmt_arresize stmt_clear stmt_delete

%type<pout> stmt_outfile stmt_output 
%type<pinpt> stmt_input stmt_infile 

%token<pstmt> TO_CONSOLE FROM_CONSOLE IO_FILE
%type<pstmt> stmt_vctr_unit stmt_cplx_unit

%type<pstmtlist> stmtlist for_update 
%type<pstmtlist> stmtlist_catch stmtlist_catch_simple

%type<vmb> expr_udt %type<vub> expr_vub 

%type<vmi1d> expr_vmi1d %type<vmr1d> expr_vmr1d
%type<vmc1d> expr_vmc1d %type<vmv1d> expr_vmv1d

%type<vmi2d> expr_vmi2d %type<vmr2d> expr_vmr2d
%type<vmc2d> expr_vmc2d %type<vmv2d> expr_vmv2d

%type<vmi3d> expr_vmi3d %type<vmr3d> expr_vmr3d
%type<vmc3d> expr_vmc3d %type<vmv3d> expr_vmv3d

%type<vmi4d> expr_vmi4d %type<vmr4d> expr_vmr4d
%type<vmc4d> expr_vmc4d %type<vmv4d> expr_vmv4d

%type<vmi5d> expr_vmi5d %type<vmr5d> expr_vmr5d
%type<vmc5d> expr_vmc5d %type<vmv5d> expr_vmv5d

%type<vai1d>  expr_vai1d %type<var1d>  expr_var1d
%type<vac1d>  expr_vac1d %type<vav1d>  expr_vav1d

%type<vai2d>  expr_vai2d %type<var2d>  expr_var2d
%type<vac2d>  expr_vac2d %type<vav2d>  expr_vav2d

%type<vai3d>  expr_vai3d %type<var3d>  expr_var3d
%type<vac3d>  expr_vac3d %type<vav3d>  expr_vav3d

%type<vai4d>  expr_vai4d %type<var4d>  expr_var4d
%type<vac4d>  expr_vac4d %type<vav4d>  expr_vav4d

%type<vai5d>  expr_vai5d %type<var5d>  expr_var5d
%type<vac5d>  expr_vac5d %type<vav5d>  expr_vav5d


%type<pstmtlist> stmt_asg_bool	stmt_asg_strn
%type<pstmtlist> stmt_asg_intg	stmt_asg_real
%type<pstmtlist> stmt_asg_cplx  stmt_asg_vctr

%token OPR_OUTPUT OPR_INPUT ARY_OPEN ARY_CLOSE

%nonassoc STMT_LOWERTHANELSE STMT_LOWERTHANWHIlE 
%nonassoc STMT_WHILE STMT_ELSE STMT_ELSETRUE STMT_ELSEFALSE TKN_CATCH

%nonassoc ';'
%nonassoc ','

%right '=' OPR_SWAP OPR_INC OPR_DEC OPR_PLS OPR_MNS OPR_MUL OPR_DIV OPR_CRS OPR_XPR  
%right OPR_SOL
%right SOL_DETCRAMER SOL_SOLVECRAMER SOL_GAUSSJORDAN SOL_LUDECOMPO SOL_LUMETHOD SOL_INVERSE 
%nonassoc '?' ':' 
%left OR 
%left AND 
%nonassoc LE GE EQ NE '<' '>'
%left '|' '@' '#' 
%left '+' '-' 
%left CPLX_OPR_REAL CPLX_OPR_IMAG OPR_X OPR_Y OPR_Z
%left '*' '/' '%' OPR_PRO
%nonassoc UNARY 
%right '^' 
%nonassoc '!' OPR_LOWERTHANDOT
%left '.' 

%%
						
program: /* empty */ { gStatementList = NULL; return TypeNull; }
	| stmtlist {  gStatementList = $1; return TypeNull; }
	;
	
stmtlist: stmt			{ $$=gStmtListStack.top(); $$->Add($1); }
	| stmtdefs			{ $$=gStmtListStack.top(); $$->Add($1); }
	| stmtlist stmt		{ $$->Add($2); }
	| stmtlist stmtdefs { $$->Add($2); }
	;

stmtdefs: 
		stmt_func           { $$ = NULL; }
	|	stmt_class	        { $$ = $1; }
	|	declare_list ';'    { $$ = $1; vartype=TypeNull; assign_set=false; gUdtFactoryStack.clear();  }
	|	static_declare ';'  { $$ = $1; vartype=TypeNull; assign_set=false; gUdtFactoryStack.clear();  }
	|	literal_declare ';' { $$ = $1; vartype=TypeNull; literal_set = false; 
	                                   assign_set=false; gUdtFactoryStack.clear();  }
	;
	
stmt: ';' { $$ = NULL; }

	| expr_void ';' 
		{ $$ = gGC.GetExpr<voidtype>($1); }
	| expr_boolean ';' 
		{ if(gProgStatus == PS_InputTime) { gExpTypeless = $1; return TypeBool; }
		  else HandleSyntaxError(L"Dangling expression of type bool is not allowed.\r\n"); }
	| expr_intg ';' 
		{ if(gProgStatus == PS_InputTime) { gExpTypeless = $1; return TypeIntg; }
		  else HandleSyntaxError(L"Dangling expression of type integer is not allowed.\r\n"); }
	| expr_real ';' 
		{ if(gProgStatus == PS_InputTime) { gExpTypeless = $1; return TypeReal; }
		  else HandleSyntaxError(L"Dangling expression of type real is not allowed.\r\n"); }
	| expr_cplx ';'	
		{ if(gProgStatus == PS_InputTime) { gExpTypeless = $1; return TypeCplx; }
		  else HandleSyntaxError(L"Dangling expression of type complex is not allowed.\r\n"); }
	| expr_vctr ';' 
		{ if(gProgStatus == PS_InputTime) { gExpTypeless = $1; return TypeVctr; }
		  else HandleSyntaxError(L"Dangling expression of type vector is not allowed.\r\n"); }
	| expr_strn ';' 
		{ if(gProgStatus == PS_InputTime) { gExpTypeless = $1; return TypeStrn; }
		  else HandleSyntaxError(L"Dangling expression of type string is not allowed.\r\n"); }
		  
	| expr_user ';' 
		{ HandleSyntaxError(L"Dangling expression of user defined type is not allowed.\r\n"); }
		
	| expr_i1d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_i2d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_i3d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_i4d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_i5d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
		
	| expr_r1d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_r2d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_r3d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_r4d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_r5d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
		
	| expr_c1d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_c2d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_c3d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_c4d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_c5d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
		
	| expr_v1d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_v2d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_v3d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_v4d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_v5d ';' 
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
		
	| expr_bptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_sptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_iptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_rptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_cptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_vptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
	| expr_uptr ';'
		{ HandleSyntaxError(L"Dangling expression is not allowed.\r\n"); }
			
	| '{' stmtlist '}'    { $$ = $2; }
	| '{' '}'			  { $$ = NULL; }
	| for_update ';'   { $$ = $1; vartype=TypeNull; assign_set=false; }

	| stmt_vctr_unit   { $$ = $1; }  | stmt_cplx_unit   { $$ = $1; }
	| stmt_prec        { $$ = $1; }  | stmt_if		   { $$ = $1; }
	| stmt_select      { $$ = $1; }  | stmt_for		   { $$ = $1; }
	| stmt_do		   { $$ = $1; }  | stmt_while	   { $$ = $1; }
	| stmt_label       { $$ = $1; }	 | stmt_clear ';'  { $$ = $1;}
	
	| stmt_try		   { $$ = $1; }	 | stmt_throw	   { $$ = $1; }	
		
	| stmt_expr ';'	   { $$ = $1; }  | stmt_exit ';'	{ $$ = $1; }
	
	| stmt_arsize ';'   { $$ = $1; } | stmt_arresize ';' { $$ = $1; }
	
	| stmt_swap ';'   { $$ = $1; }	 | stmt_delete ';' { $$ = $1; }
	| stmt_return ';'  { $$ = $1; }  | stmt_goto ';'   { $$ = $1; }	
	| stmt_break ';'   { $$ = $1; }	 | stmt_skip ';'   { $$ = $1; }	
	| stmt_output ';'  { $$ = $1; }  | stmt_input ';'  { $$ = $1; }
		
	| stmt_ary_makeunit ';' { $$ = $1; }
	
	| TKN_EOF { $$ = NULL; }
	
	| error_state { /* yyerrok; */ }
	;

error_state: error all_tokens ;

all_tokens: STMT_IF | STMT_FOR | STMT_DO | STMT_EXIT
	| STMT_WHILE | STMT_IFTRUE | STMT_IFFALSE | STMT_CLEAR
	| STMT_GOTO | STMT_BREAK | STMT_SKIP | STMT_LABEL | GOTO_TARGET
	| STMT_SELECT | LABEL_CHOICE | LABEL_ALWAYS | TKN_EOF
	| OPR_DIMENSION | OPR_SIZE | OPR_RESIZE
	| TKN_TRY | TKN_CATCH | TKN_THROW | TKN_NEW | TKN_DELETE
	| END_LINE | SET_PREC | DECLARE | TKN_STRING 
	
	| MEM_USER | MEM_STRN
	| MEM_BOOL | MEM_INTG | MEM_REAL | MEM_CPLX | MEM_VCTR 
	| MEM_AI1D | MEM_AI2D | MEM_AI3D | MEM_AI4D | MEM_AI5D
	| MEM_AR1D | MEM_AR2D | MEM_AR3D | MEM_AR4D | MEM_AR5D
	| MEM_AC1D | MEM_AC2D | MEM_AC3D | MEM_AC4D | MEM_AC5D
	| MEM_AV1D | MEM_AV2D | MEM_AV3D | MEM_AV4D | MEM_AV5D
	
	| MEM_UPTR | MEM_SPTR
	| MEM_BPTR | MEM_IPTR | MEM_RPTR | MEM_CPTR | MEM_VPTR 
	
	| PTR_BOOL | PTR_INTG | PTR_REAL | PTR_CPLX | PTR_VCTR | PTR_STRN | PTR_USER
	
	| PTR_AP1I | PTR_AP1R | PTR_AP1C | PTR_AP1V
	| PTR_AP2I | PTR_AP2R | PTR_AP2C | PTR_AP2V
	| PTR_AP3I | PTR_AP3R | PTR_AP3C | PTR_AP3V
	| PTR_AP4I | PTR_AP4R | PTR_AP4C | PTR_AP4V
	| PTR_AP5I | PTR_AP5R | PTR_AP5C | PTR_AP5V
	
	| REAL | INTG | BOOLN
	
	| TYPE_VOID | TYPE_BOOL | TYPE_INTG | TYPE_REAL | TYPE_STRN 
	| TYPE_CPLX | TYPE_VCTR | TYPE_CLASS | TYPE_UDT
	| RTN_VOID | RTN_BOOL | RTN_REAL | RTN_CPLX 
	| RTN_VCTR | RTN_INTG | RTN_STRN | TKN_EXTENDS
	| RTN_BPTR | RTN_SPTR | RTN_IPTR | RTN_RPTR | RTN_CPTR | RTN_VPTR 
	
	| RTN_AI1D | RTN_AI2D | RTN_AI3D | RTN_AI4D | RTN_AI5D
	| RTN_AR1D | RTN_AR2D | RTN_AR3D | RTN_AR4D | RTN_AR5D
	| RTN_AC1D | RTN_AC2D | RTN_AC3D | RTN_AC4D | RTN_AC5D
	| RTN_AV1D | RTN_AV2D | RTN_AV3D | RTN_AV4D | RTN_AV5D
	
	| CPLX_R | CPLX_I | TYPE_FILE | VCTR_X | VCTR_Y | VCTR_Z
	
	| DEF_VUNIT | DEF_CUNIT | DEF_STATIC | DEF_CLASS | DEF_LITERAL
	| VCTR_UNIT | CPLX_UNIT | VAR_VOID | TYPE_UNDF
	
	| VAR_BOOL | VAR_INTG | VAR_REAL | VAR_CPLX | VAR_VCTR | VAR_USER | VAR_STRN
	
	| LTL_INTG | LTL_REAL | LTL_CPLX | LTL_VCTR | LTL_STRN
	| MEM_LTL_INTG | MEM_LTL_REAL | MEM_LTL_CPLX | MEM_LTL_VCTR | MEM_LTL_STRN
		
	| ARY_INTG1D | ARY_REAL1D | ARY_CPLX1D | ARY_VCTR1D
	| ARY_REAL2D | ARY_CPLX2D | ARY_VCTR2D
	| ARY_INTG3D | ARY_REAL3D | ARY_CPLX3D | ARY_VCTR3D
	| ARY_REAL4D | ARY_CPLX4D | ARY_VCTR4D
	| ARY_REAL5D | ARY_CPLX5D | ARY_VCTR5D
	
	| VID_VOID  | VID_BOOL | VID_INTG | VID_REAL | VID_CPLX | VID_VCTR | VID_FILE
	| VID_CLASS | VID_USER | LID_INTG | LID_REAL | LID_CPLX | LID_VCTR | VID_STRN 
	
	| FNC_BOOL | FNC_VOID | FNC_INTG | FNC_REAL | FNC_CPLX | FNC_VCTR 
	| FNC_IPTR | FNC_RPTR | FNC_CPTR | FNC_VPTR | FNC_BPTR | FNC_SPTR
	
	| FNC_AI1D | FNC_AI2D | FNC_AI3D | FNC_AI4D | FNC_AI5D
	| FNC_AR1D | FNC_AR2D | FNC_AR3D | FNC_AR4D | FNC_AR5D
	| FNC_AC1D | FNC_AC2D | FNC_AC3D | FNC_AC4D | FNC_AC5D
	| FNC_AV1D | FNC_AV2D | FNC_AV3D | FNC_AV4D | FNC_AV5D
	
	| FNC_STRN | FNC_USER
	
	| FN_INTG | FN_I_II | FN_REAL | FN_C_C | FN_VO_MR_MR
	| FN_R_RR | FN_R_RRR | FN_R_RRRR | FN_R_C | FN_R_V 
	| FN_C_CC | FN_C_CCCC | FN_C_RR | FN_R_I | FN_R_II
	| FN_V_V | FN_V_RRR | FN_VO_MAKEUNIT
	| FN_B_S | FN_I_II_UI
	
	| TO_CONSOLE | FROM_CONSOLE | IO_FILE
	| OPR_OUTPUT | OPR_INPUT | ARY_OPEN | ARY_CLOSE
	| STMT_LOWERTHANELSE | STMT_ELSE | STMT_ELSETRUE | STMT_ELSEFALSE
	
	| '=' | OPR_SWAP | OPR_INC | OPR_DEC | OPR_PLS | OPR_MNS 
	| OPR_MUL | OPR_DIV | OPR_CRS | OPR_XPR
	| OPR_SOL | SOL_DETCRAMER | SOL_SOLVECRAMER | SOL_GAUSSJORDAN 
	| SOL_LUDECOMPO | SOL_LUMETHOD | SOL_INVERSE 
	| '?' | ':' OR | AND | GE | EQ | NE | '<' | '>'
	| '|' | '@' | '#' | '+' | '-'
	| CPLX_OPR_REAL | CPLX_OPR_IMAG | OPR_X | OPR_Y | OPR_Z
	| '/' | '%' | OPR_PRO |UNARY 
	| '!' | '^' | '.' | '{' | '}' | '[' | ']' | '(' | ')' | ';' | ',' | '&' | '~'
	;	
	
stmt_arsize: 
		lhs_i1d '.' OPR_SIZE '(' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<IntgVec1D>($1, $5); }
	|	lhs_i2d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<IntgVec2D>($1, $5, $7); }
	|	lhs_i3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<IntgVec3D>($1, $5, $7, $9); }
	|	lhs_i4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<IntgVec4D>($1, $5, $7, $9, $11); }
	|	lhs_i5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<IntgVec5D>($1, $5, $7, $9, $11, $13); }
			
	|	lhs_r1d '.' OPR_SIZE '(' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<RealVec1D>($1, $5); }
	|	lhs_r2d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<RealVec2D>($1, $5, $7); }
	|	lhs_r3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<RealVec3D>($1, $5, $7, $9); }
	|	lhs_r4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<RealVec4D>($1, $5, $7, $9, $11); }
	|	lhs_r5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<RealVec5D>($1, $5, $7, $9, $11, $13); }
			
	|	lhs_c1d '.' OPR_SIZE '(' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<CplxVec1D>($1, $5); }
	|	lhs_c2d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<CplxVec2D>($1, $5, $7); }
	|	lhs_c3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<CplxVec3D>($1, $5, $7, $9); }
	|	lhs_c4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<CplxVec4D>($1, $5, $7, $9, $11); }
	|	lhs_c5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<CplxVec5D>($1, $5, $7, $9, $11, $13); }
	
	|	lhs_v1d '.' OPR_SIZE '(' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<VctrVec1D>($1, $5); }
	|	lhs_v2d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<VctrVec2D>($1, $5, $7); }
	|	lhs_v3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<VctrVec3D>($1, $5, $7, $9); }
	|	lhs_v4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<VctrVec4D>($1, $5, $7, $9, $11); }
	|	lhs_v5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
			{ $$ = gGC.GetArraySize<VctrVec5D>($1, $5, $7, $9, $11, $13); }
	;
	
stmt_arresize: 
		lhs_i1d '.' OPR_RESIZE '(' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<IntgVec1D>($1, $5)); }
	|	lhs_i2d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<IntgVec2D>($1, $5, $7)); }
	|	lhs_i3d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<IntgVec3D>($1, $5, $7, $9)); }
	|	lhs_i4d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<IntgVec4D>($1, $5, $7, $9, $11)); }
	|	lhs_i5d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<IntgVec5D>($1, $5, $7, $9, $11, $13)); }
	
	|	lhs_r1d '.' OPR_RESIZE '(' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<RealVec1D>($1, $5)); }
	|	lhs_r2d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<RealVec2D>($1, $5, $7)); }
	|	lhs_r3d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<RealVec3D>($1, $5, $7, $9)); }
	|	lhs_r4d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<RealVec4D>($1, $5, $7, $9, $11)); }
	|	lhs_r5d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<RealVec5D>($1, $5, $7, $9, $11, $13)); }

	|	lhs_c1d '.' OPR_RESIZE '(' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<CplxVec1D>($1, $5)); }
	|	lhs_c2d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<CplxVec2D>($1, $5, $7)); }
	|	lhs_c3d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<CplxVec3D>($1, $5, $7, $9)); }
	|	lhs_c4d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<CplxVec4D>($1, $5, $7, $9, $11)); }
	|	lhs_c5d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<CplxVec5D>($1, $5, $7, $9, $11, $13)); }
			
	|	lhs_v1d '.' OPR_RESIZE '(' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<VctrVec1D>($1, $5)); }
	|	lhs_v2d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<VctrVec2D>($1, $5, $7)); }
	|	lhs_v3d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<VctrVec3D>($1, $5, $7, $9)); }
	|	lhs_v4d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<VctrVec4D>($1, $5, $7, $9, $11)); }
	|	lhs_v5d '.' OPR_RESIZE '(' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ')' 
			{ $$ = dynamic_cast<Statement*>(gGC.GetArrayResize<VctrVec5D>($1, $5, $7, $9, $11, $13)); }
	;
	
stmt_class: 
		class_header '{' '}' 
		{ 
			std::wostringstream os;
			os<<_T("Class \'")<<gFactoryStack.top()->GetTypeTag()
			<<_T("\' should have at least one member.\r\n");
			HandleSyntaxError(os.str());
		}
	|	class_header '{' { gCatchBlockStack.push(false); } decl_elements { gCatchBlockStack.pop(); } '}' 
		{   
			if(!gBlockTypeStack.top()) 
			{
				gStmtListStack.top()->AddFactory(gFactoryStack.top()); 
			}
			else
			{
				gFactoryStack.getoffset(1)->AddFactory(gFactoryStack.top());
			}
			
			gFactoryStack.pop(); $$ = NULL; 
		} 
		;

class_header: class_flt_header | class_ext_header ;

class_flt_header: TYPE_CLASS VID_CLASS 
	{ gFactoryStack.push(gGC.GetUserDefinedType($2)); } ;
class_ext_header: TYPE_CLASS VID_CLASS TKN_EXTENDS expr_udt 
		{ 
			gFactoryStack.push(gGC.GetUserDefinedType($2)); 
			gFactoryStack.top()->InsertElement(gUdtFactoryStack.top()); 
			gUdtFactoryStack.pop();
		}
	| class_ext_header ',' expr_udt 
		{ 
			gFactoryStack.top()->InsertElement(gUdtFactoryStack.top()); 
		    gUdtFactoryStack.pop(); } 
	;
	
decl_elements:	
		stmt_class
	|   stmt_func
	|	stmt_func_static			 
	|	decl_element ';'                { vartype=TypeNull; gUdtFactoryStack.clear();}
	|   literal_declare ';'				{ vartype=TypeNull; literal_set=false; gUdtFactoryStack.clear();}
	|	decl_elements stmt_func
	|	decl_elements stmt_func_static
	|	decl_elements stmt_class
	|	decl_elements decl_element ';'    { vartype=TypeNull; gUdtFactoryStack.clear();}
	|   decl_elements literal_declare ';' { vartype=TypeNull; literal_set=false; gUdtFactoryStack.clear();}
	;
	 
decl_element: decl_ele 
	| decl_element ',' decl_ele 
	;
	
decl_ele: 
	  decl_ele_bool | decl_ele_strn | decl_ele_intg
	| decl_ele_real | decl_ele_cplx | decl_ele_vctr | decl_ele_user
	| decl_ini_bool | decl_ini_strn | decl_ini_intg | decl_ini_real
	| decl_ini_cplx | decl_ini_vctr | decl_ini_user
	
	;
	
decl_ele_bool:  TYPE_BOOL VID_BOOL { gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeBool)); } ;
decl_ele_strn:  TYPE_STRN VID_STRN { gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeStrn)); } ;

decl_ele_intg: TYPE_INTG VID_INTG 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeIntg)); } 
	|	TYPE_INTG '*' VID_INTG 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($3), TypeIPtr)); } 
	|	TYPE_INTG VID_INTG '[' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAi1D)); } 
	|	TYPE_INTG VID_INTG '[' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAi2D)); } 
	|	TYPE_INTG VID_INTG '[' ',' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAi3D)); } 
	|	TYPE_INTG VID_INTG '[' ',' ',' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAi4D)); } 
	|	TYPE_INTG VID_INTG '[' ',' ',' ',' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAi5D)); } 
	;

decl_ele_real:  TYPE_REAL VID_REAL 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeReal)); } 
	|	TYPE_REAL VID_REAL '[' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAr1D)); } 
	|	TYPE_REAL VID_REAL '[' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAr2D)); } 
	|	TYPE_REAL VID_REAL '[' ',' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAr3D)); }
	|	TYPE_REAL VID_REAL '[' ',' ',' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAr4D)); } 
	|	TYPE_REAL VID_REAL '[' ',' ',' ',' ',' ']'
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAr5D)); } 
	;

decl_ele_cplx:  TYPE_CPLX VID_CPLX 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeCplx)); } 
	| 	TYPE_CPLX VID_CPLX '[' ']' 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAc1D)); } 	
	| 	TYPE_CPLX VID_CPLX '[' ',' ']' 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAc2D)); } 
	| 	TYPE_CPLX VID_CPLX '[' ',' ',' ']' 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAc3D)); } 
	| 	TYPE_CPLX VID_CPLX '[' ',' ',' ',' ']' 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAc4D)); } 
	| 	TYPE_CPLX VID_CPLX '[' ',' ',' ',' ',' ']' 
			{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAc5D)); } 		
	;

decl_ele_vctr:  TYPE_VCTR VID_VCTR 
				{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeVctr)); } 
	|	TYPE_VCTR VID_VCTR '[' ']' 
				{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAv1D)); }
	|	TYPE_VCTR VID_VCTR '[' ',' ']' 
				{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAv2D)); }
	|	TYPE_VCTR VID_VCTR '[' ',' ',' ']' 
				{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAv3D)); }
	|	TYPE_VCTR VID_VCTR '[' ',' ',' ',' ']' 
				{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAv4D)); }
	|	TYPE_VCTR VID_VCTR '[' ',' ',' ',' ',' ']' 
				{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($2), TypeAv5D)); }			
	;
	
expr_udt: TYPE_UDT	
		{ 
			if(gReturnStack.empty())
				$$ = gGC.GetVarMemBase(gUdtFactoryStack.top());
			else
				$$ = gGC.GetVarMemBase(gUdtFactoryStack.top(), gReturnStack.top().fptr); 
		}
					
	| expr_udt '.' TYPE_UDT 
		{ 
			$$->InsertMemberID(gUdtFactoryStack.top()->GetTypeTag()); 
		
			$$->udtptr = gUdtFactoryStack.top();
		}
	| expr_udt '.' MEM_USER 
		{ 
			if($$->ptrFunc)
				{ $$->InsertMemberID($3); $$->udtptr = gUdtFactoryStack.top(); }
			else
				HandleSyntaxError(L"Non literal member is accessible only inside a member funtion.\r\n");
		}
		
	| expr_vub '.' TYPE_UDT 
		{
			if(gReturnStack.empty()) 
				$$ = gGC.GetVarMemBase(gUdtFactoryStack.top(), NULL, $1);
			else 
				$$ = gGC.GetVarMemBase(gUdtFactoryStack.top(), gReturnStack.top().fptr, $1);
			
			$$->InsertMemberID(gUdtFactoryStack.top()->GetTypeTag());
		}
	;

decl_ele_user:  expr_udt VID_USER 
		{
			if(gFactoryStack.top()->CheckRecursive(gUdtFactoryStack.top()))
			{
				std::wostringstream os;
				os<<L"Member \'"<<$2<<L"\' is recursively defined.\r\n";
				HandleSyntaxError(os.str());
			}
			else if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<L"Can not instantiate an object of type \'"
					<<gUdtFactoryStack.top()->GetTypeTag()<<L"\', all its members are literals.";
				HandleSyntaxError(os.str());
			
			}
			else
				gFactoryStack.top()->InsertElement(gUdtFactoryStack.top(), std::wstring($2)); 
		} 
	| expr_udt '*' VID_USER 
		{
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<L"Can not instantiate an object of type \'"
					<<gUdtFactoryStack.top()->GetTypeTag()<<L"\', all its members are literals.";
				HandleSyntaxError(os.str());
			
			}
			else
				gFactoryStack.top()->InsertElementUPtr(gUdtFactoryStack.top(), std::wstring($3)); 
		} 
	;

decl_ini_bool:  VID_BOOL { gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeBool)); }  ;

decl_ini_strn:  VID_STRN { gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeStrn)); }  ;

decl_ini_intg:  VID_INTG 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeIntg)); }  
	|	VID_INTG '[' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAi1D)); }  
	|	VID_INTG '[' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAi2D)); }  
	|	VID_INTG '[' ',' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAi3D)); }  
	|	VID_INTG '[' ',' ',' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAi4D)); }  
	|	VID_INTG '[' ',' ',' ',' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAi5D)); }  	
	;

decl_ini_real:  VID_REAL 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeReal)); }
	|	VID_REAL '[' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAr1D)); }
	|	VID_REAL '[' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAr2D)); }
	|	VID_REAL '[' ',' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAr3D)); }
	|	VID_REAL '[' ',' ',' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAr4D)); }
	|	VID_REAL '[' ',' ',' ',' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAr5D)); }
	;
	
decl_ini_cplx:  VID_CPLX 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeCplx)); }  
	|	VID_CPLX '[' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAc1D)); }  
	|	VID_CPLX '[' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAc2D)); }  
	|	VID_CPLX '[' ',' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAc3D)); }  
	|	VID_CPLX '[' ',' ',' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAc4D)); }  
	|	VID_CPLX '[' ',' ',' ',' ',' ']' 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAc5D)); }  
	;
decl_ini_vctr:  VID_VCTR 
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeVctr)); }  
	|	VID_VCTR '[' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAv1D)); }  
	|	VID_VCTR '[' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAv2D)); } 
	|	VID_VCTR '[' ',' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAv3D)); } 
	|	VID_VCTR '[' ',' ',' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAv4D)); } 
	|	VID_VCTR '[' ',' ',' ',' ',' ']'
		{ gFactoryStack.top()->InsertElement(TypePair(std::wstring($1), TypeAv5D)); } 
	;

decl_ini_user:  VID_USER { gFactoryStack.top()->InsertElement(gUdtFactoryStack.top(), std::wstring($1)); }  
	| '*' VID_USER { gFactoryStack.top()->InsertElementUPtr(gUdtFactoryStack.top(), std::wstring($2)); }  ;

stmt_output: stmt_outfile OPR_OUTPUT expr_typeless { $1->InsertExpr($3); $$=$1; }
	| stmt_output OPR_OUTPUT expr_typeless { $1->InsertExpr($3); } 
	;

stmt_outfile: /* empty */ { $$=gGC.GetStmtOutput(); }
	| TO_CONSOLE	{ $$=gGC.GetStmtOutput(); }
	;

stmt_input:
	  stmt_infile OPR_INPUT var_names		
		{ $1->InsertPrompt(strtype.c_str(), $3); $$=$1; }
	
	| stmt_infile OPR_INPUT TKN_STRING { strmsg = $3; } OPR_INPUT var_names 
		{  $1->InsertPrompt(strmsg.c_str(), $6); $$=$1; }
	| stmt_input OPR_INPUT var_names { $$->InsertPrompt(strtype.c_str(), $3); }
	
	| stmt_input OPR_INPUT TKN_STRING { strmsg = $3; } OPR_INPUT var_names 
		{ $$->InsertPrompt(strmsg.c_str(), $6); }
	;
stmt_infile: /* empty */ { $$=gGC.GetStmtInput(); }
	| FROM_CONSOLE	{ $$=gGC.GetStmtInput(); }
	;	
	
	
expr_typeless: 
	  expr_intg		{ $$ = $1; }
	| expr_real		{ $$ = $1; }
	| expr_cplx		{ $$ = $1; }
	| expr_vctr		{ $$ = $1; }
	| expr_boolean  { $$ = $1; }
	| expr_strn		{ $$ = $1; }
	| /* empty */   { $$ = gGC.GetExpEndLine(); }
	;

stmt_delete:
		TKN_DELETE lhs_bptr { $$=gGC.GetStmtDelete<bool>($2); }
	|	TKN_DELETE lhs_sptr { $$=gGC.GetStmtDelete<string>($2); }
	|	TKN_DELETE lhs_iptr { $$=gGC.GetStmtDelete<integer>($2); }
	|	TKN_DELETE lhs_rptr { $$=gGC.GetStmtDelete<realnum>($2); }
	|	TKN_DELETE lhs_cptr { $$=gGC.GetStmtDelete<Complex>($2); }
	|	TKN_DELETE lhs_vptr { $$=gGC.GetStmtDelete<Vector>($2); }
	|	TKN_DELETE lhs_uptr { $$=gGC.GetStmtDeleteUserData($2); }
	;

stmt_swap: 
	  lhs_bool OPR_SWAP lhs_bool { $$ = gGC.GetStmtSwapLHS<bool>($1, $3); }
	| lhs_strn OPR_SWAP lhs_strn { $$ = gGC.GetStmtSwapLHS<string>($1, $3); }
	| lhs_intg OPR_SWAP lhs_intg { $$ = gGC.GetStmtSwapLHS<integer>($1, $3); }
	| lhs_real OPR_SWAP lhs_real { $$ = gGC.GetStmtSwapLHS<realnum>($1, $3); }
	| lhs_cplx OPR_SWAP lhs_cplx { $$ = gGC.GetStmtSwapLHS<Complex>($1, $3); }
	| lhs_vctr OPR_SWAP lhs_vctr { $$ = gGC.GetStmtSwapLHS<Vector>($1, $3); }
	
	| lhs_user OPR_SWAP lhs_user
		{ 
			if($1->IsCompatible($3)) $$ = gGC.GetStmtSwapLHS<UserData>($1, $3);
			else HandleSyntaxError(_T("Type mismatch for user defined data type swapping.\r\n")); 
		}
		
	| lhs_i1d OPR_SWAP lhs_i1d { $$ = gGC.GetStmtSwapArrayLHS<IntgVec1D>($1, $3); } 
	| lhs_i2d OPR_SWAP lhs_i2d { $$ = gGC.GetStmtSwapArrayLHS<IntgVec2D>($1, $3); } 
	| lhs_i3d OPR_SWAP lhs_i3d { $$ = gGC.GetStmtSwapArrayLHS<IntgVec3D>($1, $3); } 
	| lhs_i4d OPR_SWAP lhs_i4d { $$ = gGC.GetStmtSwapArrayLHS<IntgVec4D>($1, $3); } 		
	| lhs_i5d OPR_SWAP lhs_i5d { $$ = gGC.GetStmtSwapArrayLHS<IntgVec5D>($1, $3); }
	
	| lhs_r1d OPR_SWAP lhs_r1d { $$ = gGC.GetStmtSwapArrayLHS<RealVec1D>($1, $3); } 
	| lhs_r2d OPR_SWAP lhs_r2d { $$ = gGC.GetStmtSwapArrayLHS<RealVec2D>($1, $3); } 
	| lhs_r3d OPR_SWAP lhs_r3d { $$ = gGC.GetStmtSwapArrayLHS<RealVec3D>($1, $3); } 
	| lhs_r4d OPR_SWAP lhs_r4d { $$ = gGC.GetStmtSwapArrayLHS<RealVec4D>($1, $3); } 		
	| lhs_r5d OPR_SWAP lhs_r5d { $$ = gGC.GetStmtSwapArrayLHS<RealVec5D>($1, $3); }
	
	| lhs_c1d OPR_SWAP lhs_c1d { $$ = gGC.GetStmtSwapArrayLHS<CplxVec1D>($1, $3); } 
	| lhs_c2d OPR_SWAP lhs_c2d { $$ = gGC.GetStmtSwapArrayLHS<CplxVec2D>($1, $3); } 
	| lhs_c3d OPR_SWAP lhs_c3d { $$ = gGC.GetStmtSwapArrayLHS<CplxVec3D>($1, $3); } 
	| lhs_c4d OPR_SWAP lhs_c4d { $$ = gGC.GetStmtSwapArrayLHS<CplxVec4D>($1, $3); } 		
	| lhs_c5d OPR_SWAP lhs_c5d { $$ = gGC.GetStmtSwapArrayLHS<CplxVec5D>($1, $3); }
	
	| lhs_v1d OPR_SWAP lhs_v1d { $$ = gGC.GetStmtSwapArrayLHS<VctrVec1D>($1, $3); } 
	| lhs_v2d OPR_SWAP lhs_v2d { $$ = gGC.GetStmtSwapArrayLHS<VctrVec2D>($1, $3); } 
	| lhs_v3d OPR_SWAP lhs_v3d { $$ = gGC.GetStmtSwapArrayLHS<VctrVec3D>($1, $3); } 
	| lhs_v4d OPR_SWAP lhs_v4d { $$ = gGC.GetStmtSwapArrayLHS<VctrVec4D>($1, $3); } 		
	| lhs_v5d OPR_SWAP lhs_v5d { $$ = gGC.GetStmtSwapArrayLHS<VctrVec5D>($1, $3); }
			
	| lhs_bptr OPR_SWAP lhs_bptr { $$=gGC.GetStmtSwapLHS<bool*>   ($1, $3); }		
	| lhs_iptr OPR_SWAP lhs_iptr { $$=gGC.GetStmtSwapLHS<integer*>($1, $3); }
	| lhs_rptr OPR_SWAP lhs_rptr { $$=gGC.GetStmtSwapLHS<realnum*>($1, $3); }
	| lhs_cptr OPR_SWAP lhs_cptr { $$=gGC.GetStmtSwapLHS<Complex*>($1, $3); }
	| lhs_vptr OPR_SWAP lhs_vptr { $$=gGC.GetStmtSwapLHS<Vector*> ($1, $3); }
	| lhs_sptr OPR_SWAP lhs_sptr { $$=gGC.GetStmtSwapLHS<string*> ($1, $3); }
	
	| PTR_AP1I OPR_SWAP PTR_AP1I { $$=gGC.GetStmtPtrSwap<AptrData<IntgVec1D> > ($1, $3); }
	| PTR_AP1R OPR_SWAP PTR_AP1R { $$=gGC.GetStmtPtrSwap<AptrData<RealVec1D> > ($1, $3); }
	| PTR_AP1C OPR_SWAP PTR_AP1C { $$=gGC.GetStmtPtrSwap<AptrData<CplxVec1D> > ($1, $3); }
	| PTR_AP1V OPR_SWAP PTR_AP1V { $$=gGC.GetStmtPtrSwap<AptrData<VctrVec1D> > ($1, $3); } 
	
	| PTR_AP2I OPR_SWAP PTR_AP2I { $$=gGC.GetStmtPtrSwap<AptrData<IntgVec2D> > ($1, $3); }
	| PTR_AP2R OPR_SWAP PTR_AP2R { $$=gGC.GetStmtPtrSwap<AptrData<RealVec2D> > ($1, $3); }
	| PTR_AP2C OPR_SWAP PTR_AP2C { $$=gGC.GetStmtPtrSwap<AptrData<CplxVec2D> > ($1, $3); }
	| PTR_AP2V OPR_SWAP PTR_AP2V { $$=gGC.GetStmtPtrSwap<AptrData<VctrVec2D> > ($1, $3); } 
	
	| PTR_AP3I OPR_SWAP PTR_AP3I { $$=gGC.GetStmtPtrSwap<AptrData<IntgVec3D> > ($1, $3); }
	| PTR_AP3R OPR_SWAP PTR_AP3R { $$=gGC.GetStmtPtrSwap<AptrData<RealVec3D> > ($1, $3); }
	| PTR_AP3C OPR_SWAP PTR_AP3C { $$=gGC.GetStmtPtrSwap<AptrData<CplxVec3D> > ($1, $3); }
	| PTR_AP3V OPR_SWAP PTR_AP3V { $$=gGC.GetStmtPtrSwap<AptrData<VctrVec3D> > ($1, $3); } 
	
	| PTR_AP4I OPR_SWAP PTR_AP4I { $$=gGC.GetStmtPtrSwap<AptrData<IntgVec4D> > ($1, $3); }
	| PTR_AP4R OPR_SWAP PTR_AP4R { $$=gGC.GetStmtPtrSwap<AptrData<RealVec4D> > ($1, $3); }
	| PTR_AP4C OPR_SWAP PTR_AP4C { $$=gGC.GetStmtPtrSwap<AptrData<CplxVec4D> > ($1, $3); }
	| PTR_AP4V OPR_SWAP PTR_AP4V { $$=gGC.GetStmtPtrSwap<AptrData<VctrVec4D> > ($1, $3); } 
	
	| PTR_AP5I OPR_SWAP PTR_AP5I { $$=gGC.GetStmtPtrSwap<AptrData<IntgVec5D> > ($1, $3); }
	| PTR_AP5R OPR_SWAP PTR_AP5R { $$=gGC.GetStmtPtrSwap<AptrData<RealVec5D> > ($1, $3); }
	| PTR_AP5C OPR_SWAP PTR_AP5C { $$=gGC.GetStmtPtrSwap<AptrData<CplxVec5D> > ($1, $3); }
	| PTR_AP5V OPR_SWAP PTR_AP5V { $$=gGC.GetStmtPtrSwap<AptrData<VctrVec5D> > ($1, $3); } 
	
	;
	

var_names: 
		lhs_bool { strtype = _T("VAR_BOOL"); $$ = $1; }
	|	lhs_intg { strtype = _T("VAR_INTG"); $$ = $1; }
	|	lhs_real { strtype = _T("VAR_REAL"); $$ = $1; }
	|   lhs_cplx { strtype = _T("VAR_CPLX"); $$ = $1; }
	|   lhs_vctr { strtype = _T("VAR_VCTR"); $$ = $1; }
	;
								                	 								                	 								                	 
stmt_vctr_unit:	DEF_VUNIT { unitvctr = false; unitvctr_set = false; $$=NULL; }
	|	DEF_VUNIT VCTR_UNIT ',' VCTR_UNIT ',' VCTR_UNIT 
		{ unitvctr = true; unitvctr_set = false; $$=NULL;
		  if(!DefineUnitVectors($2, $4, $6)) HandleSyntaxError(_T("")); } 
	;
								
stmt_cplx_unit: DEF_CUNIT { unitcplx = false; unitcplx_set=false; $$=NULL; }
	|	DEF_CUNIT CPLX_UNIT ',' CPLX_UNIT 
		{ unitcplx = true; unitcplx_set=false; $$=NULL; 
		  if(!DefineUnitImaginary($2, $4)) HandleSyntaxError(_T("")); } 
	;  

stmt_prec: SET_PREC INTG	
	{ 
	  if($2<0 || $2>16) { HandleSyntaxError(IDS_ERROR_PREC); }
	  else { extern int fmt_precision; fmt_precision = int($2); $$ = NULL; } 
	} ;

array_rc_dim2:
	  ARY_REAL2D { $$ = $1; } | ARY_CPLX2D { $$ = $1; } ;

expr_ini_bool: /* empty */ { $$ = NULL; } | expr_boolean	{ $$ = $1; } ;
expr_ini_strn: /* empty */ { $$ = NULL; } | expr_strn		{ $$ = $1; } ;
expr_ini_intg: /* empty */ { $$ = NULL; } | expr_inum		{ $$ = $1; } ;
expr_ini_real: /* empty */ { $$ = NULL; } | expr_rnum		{ $$ = $1; } ;
expr_ini_cplx: /* empty */ { $$ = NULL; } | expr_cnum		{ $$ = $1; } ;
expr_ini_vctr: /* empty */ { $$ = NULL; } | expr_vnum		{ $$ = $1; } ;

array_intg: expr_ini_intg {	InsertArrayInit($1); }
	| array_intg ',' expr_ini_intg {  InsertArrayInit($3); }
	| ARY_OPEN { ++gArrayInit.dim; } array_intg ARY_CLOSE { AfterArrayClose(); }
	| array_intg ',' ARY_OPEN { ++gArrayInit.dim; } array_intg ARY_CLOSE { AfterArrayClose(); }
	| error_state {	HandleSyntaxError(_T("Failed to initialize integer array.\r\n")); }
	;
		
array_real: expr_ini_real {	InsertArrayInit($1); }
	| array_real ',' expr_ini_real {  InsertArrayInit($3); }
	| ARY_OPEN { ++gArrayInit.dim; } array_real ARY_CLOSE { AfterArrayClose(); }
	| array_real ',' ARY_OPEN { ++gArrayInit.dim; } array_real ARY_CLOSE { AfterArrayClose(); }
	| error_state {	HandleSyntaxError(_T("Failed to initialize real array.\r\n")); } 
	;
	
array_cplx: expr_ini_cplx {	InsertArrayInit($1); }
	| array_cplx ',' expr_ini_cplx {  InsertArrayInit($3); }
	| ARY_OPEN { ++gArrayInit.dim; } array_cplx ARY_CLOSE { AfterArrayClose(); }	 
	| array_cplx ',' ARY_OPEN { ++gArrayInit.dim; } array_cplx ARY_CLOSE { AfterArrayClose(); }
	| error_state {	HandleSyntaxError(_T("Failed to initialize complex array.\r\n")); }
	;	

array_vctr: expr_ini_vctr {	InsertArrayInit($1); }
	| array_vctr ',' expr_ini_vctr {  InsertArrayInit($3); }
	| ARY_OPEN { ++gArrayInit.dim; } expr_vnum ARY_CLOSE { AfterArrayClose(); }	 
	| array_vctr ',' ARY_OPEN { ++gArrayInit.dim; } array_vctr ARY_CLOSE { AfterArrayClose(); }
	| error_state {	HandleSyntaxError(_T("Failed to initialize vector array.\r\n")); }
	;	
		  
stmt_func: declare_fhdr ';'  { AfterDeclareFunction($1); $$=NULL; }
	| define_fhdr '{' { gCatchBlockStack.push(false); } stmtlist { gCatchBlockStack.pop(); } '}'  
		{ AfterFunctionDefinition($4); $$=NULL;  }
	;
	
stmt_func_static: declare_fhdr_static ';'  { AfterDeclareFunction($1); $$=NULL; }
	| DEF_STATIC define_fhdr '{' { gCatchBlockStack.push(false); } stmtlist { gCatchBlockStack.pop(); } '}' 
		{ AfterFunctionDefinition($5); $$=NULL;  }
	;

declare_fhdr_static: 
	  DECLARE DEF_STATIC TYPE_VOID VID_VOID { $<pfunc>$=BeforeDeclareFunction(TypeVoid, $4); }
	   '(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_BOOL VID_BOOL { $<pfunc>$=BeforeDeclareFunction(TypeBool, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_INTG VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeIntg, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_REAL VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeReal, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_CPLX VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeCplx, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_VCTR VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeVctr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	
	| DECLARE DEF_STATIC TYPE_STRN VID_STRN { $<pfunc>$=BeforeDeclareFunction(TypeStrn, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
		
	| DECLARE DEF_STATIC expr_udt VID_USER { $<pfunc>$=BeforeDeclareFunction(TypeUser, $4, $3->udtptr); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	
	| DECLARE DEF_STATIC TYPE_BOOL '*' VID_BOOL { $<pfunc>$=BeforeDeclareFunction(TypeBPtr, $5); }
		'(' param_lists ')' { $$ = $<pfunc>6; }
	| DECLARE DEF_STATIC TYPE_STRN '*' VID_STRN { $<pfunc>$=BeforeDeclareFunction(TypeSPtr, $5); }
		'(' param_lists ')' { $$ = $<pfunc>6; }
	| DECLARE DEF_STATIC TYPE_INTG '*' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeIPtr, $5); }
		'(' param_lists ')' { $$ = $<pfunc>6; }
	| DECLARE DEF_STATIC TYPE_REAL '*' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeRPtr, $5); }
		'(' param_lists ')' { $$ = $<pfunc>6; }
	| DECLARE DEF_STATIC TYPE_CPLX '*' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeCPtr, $5); }
		'(' param_lists ')' { $$ = $<pfunc>6; }
	| DECLARE DEF_STATIC TYPE_VCTR '*' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeVPtr, $5); }
		'(' param_lists ')' { $$ = $<pfunc>6; }
	
	| DECLARE DEF_STATIC TYPE_INTG '[' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi1D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_REAL '[' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr1D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_CPLX '[' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc1D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_VCTR '[' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv1D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	
	| DECLARE DEF_STATIC TYPE_INTG '[' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi2D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_REAL '[' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr2D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_CPLX '[' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc2D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_VCTR '[' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv2D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	
	| DECLARE DEF_STATIC TYPE_INTG '[' ',' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi3D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_REAL '[' ',' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr3D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_CPLX '[' ',' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc3D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_VCTR '[' ',' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv3D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	
	| DECLARE DEF_STATIC TYPE_INTG '[' ',' ',' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi4D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_REAL '[' ',' ',' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr4D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_CPLX '[' ',' ',' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc4D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_VCTR '[' ',' ',' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv4D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	
	| DECLARE DEF_STATIC TYPE_INTG '[' ',' ',' ',' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi5D, $10); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_REAL '[' ',' ',' ',' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr5D, $10); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_CPLX '[' ',' ',' ',' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc5D, $10); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	| DECLARE DEF_STATIC TYPE_VCTR '[' ',' ',' ',' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv5D, $10); }
		'(' param_lists ')'  { $$ = $<pfunc>5; }
	;

	
declare_fhdr:  
	  DECLARE TYPE_VOID VID_VOID { $<pfunc>$=BeforeDeclareFunction(TypeVoid, $3); }
	   '(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_BOOL VID_BOOL { $<pfunc>$=BeforeDeclareFunction(TypeBool, $3); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
	| DECLARE TYPE_INTG VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeIntg, $3); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
	| DECLARE TYPE_REAL VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeReal, $3); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
	| DECLARE TYPE_CPLX VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeCplx, $3); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
	| DECLARE TYPE_VCTR VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeVctr, $3); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
	
	| DECLARE TYPE_STRN VID_STRN { $<pfunc>$=BeforeDeclareFunction(TypeStrn, $3); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
		
	| DECLARE expr_udt VID_USER { $<pfunc>$=BeforeDeclareFunction(TypeUser, $3, $2->udtptr); }
		'(' param_lists ')' { $$ = $<pfunc>4; }
	
	| DECLARE TYPE_STRN '*' VID_BOOL { $<pfunc>$=BeforeDeclareFunction(TypeBPtr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE TYPE_STRN '*' VID_STRN { $<pfunc>$=BeforeDeclareFunction(TypeSPtr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE TYPE_INTG '*' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeIPtr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE TYPE_REAL '*' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeRPtr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE TYPE_CPLX '*' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeCPtr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
	| DECLARE TYPE_VCTR '*' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeVPtr, $4); }
		'(' param_lists ')' { $$ = $<pfunc>5; }
		
	| DECLARE TYPE_INTG '[' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi1D, $5); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_REAL '[' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr1D, $5); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_CPLX '[' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc1D, $5); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_VCTR '[' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv1D, $5); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	
	| DECLARE TYPE_INTG '[' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi2D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_REAL '[' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr2D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_CPLX '[' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc2D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_VCTR '[' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv2D, $6); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	
	| DECLARE TYPE_INTG '[' ',' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi3D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_REAL '[' ',' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr3D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_CPLX '[' ',' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc3D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_VCTR '[' ',' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv3D, $7); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	
	| DECLARE TYPE_INTG '[' ',' ',' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi4D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_REAL '[' ',' ',' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr4D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_CPLX '[' ',' ',' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc4D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_VCTR '[' ',' ',' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv4D, $8); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	
	| DECLARE TYPE_INTG '[' ',' ',' ',' ',' ']' VID_INTG { $<pfunc>$=BeforeDeclareFunction(TypeAi5D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_REAL '[' ',' ',' ',' ',' ']' VID_REAL { $<pfunc>$=BeforeDeclareFunction(TypeAr5D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_CPLX '[' ',' ',' ',' ',' ']' VID_CPLX { $<pfunc>$=BeforeDeclareFunction(TypeAc5D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	| DECLARE TYPE_VCTR '[' ',' ',' ',' ',' ']' VID_VCTR { $<pfunc>$=BeforeDeclareFunction(TypeAv5D, $9); }
		'(' param_lists ')'  { $$ = $<pfunc>4; }
	;
					
define_fhdr:  
	  TYPE_VOID VID_VOID { CreateUDFunction(TypeVoid, $2); } '(' param_lists ')'  
	| TYPE_BOOL VID_BOOL { CreateUDFunction(TypeBool, $2); } '(' param_lists ')' 
	| TYPE_INTG VID_INTG { CreateUDFunction(TypeIntg, $2); } '(' param_lists ')' 
	| TYPE_REAL VID_REAL { CreateUDFunction(TypeReal, $2); } '(' param_lists ')' 
	| TYPE_CPLX VID_CPLX { CreateUDFunction(TypeCplx, $2); } '(' param_lists ')' 
	| TYPE_VCTR VID_VCTR { CreateUDFunction(TypeVctr, $2); } '(' param_lists ')' 
	
	| TYPE_BOOL '*' VID_BOOL { CreateUDFunction(TypeBPtr, $3); } '(' param_lists ')' 
	| TYPE_STRN '*' VID_STRN { CreateUDFunction(TypeSPtr, $3); } '(' param_lists ')' 
	| TYPE_INTG '*' VID_INTG { CreateUDFunction(TypeIPtr, $3); } '(' param_lists ')' 
	| TYPE_REAL '*' VID_REAL { CreateUDFunction(TypeRPtr, $3); } '(' param_lists ')' 
	| TYPE_CPLX '*' VID_CPLX { CreateUDFunction(TypeCPtr, $3); } '(' param_lists ')' 
	| TYPE_VCTR '*' VID_VCTR { CreateUDFunction(TypeVPtr, $3); } '(' param_lists ')' 
		
	| TYPE_STRN VID_STRN { CreateUDFunction(TypeStrn, $2); } '(' param_lists ')' 
		
	| expr_udt VID_USER { CreateUDFunction(TypeUser, $2, $1->udtptr); } '(' param_lists ')'
		
	| TYPE_INTG '[' ']' VID_INTG { CreateUDFunction(TypeAi1D, $4); } '(' param_lists ')' 
	| TYPE_REAL '[' ']' VID_REAL { CreateUDFunction(TypeAr1D, $4); } '(' param_lists ')' 
	| TYPE_CPLX '[' ']' VID_CPLX { CreateUDFunction(TypeAc1D, $4); } '(' param_lists ')' 
	| TYPE_VCTR '[' ']' VID_VCTR { CreateUDFunction(TypeAv1D, $4); } '(' param_lists ')' 
	
	| TYPE_INTG '[' ',' ']' VID_INTG { CreateUDFunction(TypeAi2D, $5); } '(' param_lists ')' 
	| TYPE_REAL '[' ',' ']' VID_REAL { CreateUDFunction(TypeAr2D, $5); } '(' param_lists ')' 
	| TYPE_CPLX '[' ',' ']' VID_CPLX { CreateUDFunction(TypeAc2D, $5); } '(' param_lists ')' 
	| TYPE_VCTR '[' ',' ']' VID_VCTR { CreateUDFunction(TypeAv2D, $5); } '(' param_lists ')' 
	
	| TYPE_INTG '[' ',' ',' ']' VID_INTG { CreateUDFunction(TypeAi3D, $6); } '(' param_lists ')' 
	| TYPE_REAL '[' ',' ',' ']' VID_REAL { CreateUDFunction(TypeAr3D, $6); } '(' param_lists ')' 
	| TYPE_CPLX '[' ',' ',' ']' VID_CPLX { CreateUDFunction(TypeAc3D, $6); } '(' param_lists ')' 
	| TYPE_VCTR '[' ',' ',' ']' VID_VCTR { CreateUDFunction(TypeAv3D, $6); } '(' param_lists ')' 
	
	| TYPE_INTG '[' ',' ',' ',' ']' VID_INTG { CreateUDFunction(TypeAi4D, $7); } '(' param_lists ')' 
	| TYPE_REAL '[' ',' ',' ',' ']' VID_REAL { CreateUDFunction(TypeAr4D, $7); } '(' param_lists ')' 
	| TYPE_CPLX '[' ',' ',' ',' ']' VID_CPLX { CreateUDFunction(TypeAc4D, $7); } '(' param_lists ')' 
	| TYPE_VCTR '[' ',' ',' ',' ']' VID_VCTR { CreateUDFunction(TypeAv4D, $7); } '(' param_lists ')' 
	
	| TYPE_INTG '[' ',' ',' ',' ',' ']' VID_INTG { CreateUDFunction(TypeAi5D, $8); } '(' param_lists ')' 
	| TYPE_REAL '[' ',' ',' ',' ',' ']' VID_REAL { CreateUDFunction(TypeAr5D, $8); } '(' param_lists ')' 
	| TYPE_CPLX '[' ',' ',' ',' ',' ']' VID_CPLX { CreateUDFunction(TypeAc5D, $8); } '(' param_lists ')' 
	| TYPE_VCTR '[' ',' ',' ',' ',' ']' VID_VCTR { CreateUDFunction(TypeAv5D, $8); } '(' param_lists ')' 
	;
	
param_lists: /* empty */
	| TYPE_VOID  {vartype=TypeNull; }
	| param_list 
	; 
param_list: 
	  paramlist_simple  { vartype=TypeNull; }
	| paramlist_pointer { vartype=TypeNull; }
	| paramlist_array   { vartype=TypeNull; }
	
	| param_list ',' paramlist_simple  { vartype=TypeNull; }
	| param_list ',' paramlist_pointer { vartype=TypeNull; }
	| param_list ',' paramlist_array   { vartype=TypeNull; }
	;

paramlist_simple: 
	  decl_tc_bool { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_intg { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_real { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_cplx { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_vctr { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_strn { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	
	| expr_udt VID_USER 
		{ gReturnStack.top().fptr->
			InsertParam(gGC.GetDeclUdt($2, gUdtFactoryStack.top()), gArgCount++);  gUdtFactoryStack.clear(); }
	;
		
paramlist_pointer:
	  decl_tp_bool { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_intg { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_real { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_cplx { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_vctr { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_strn { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	
	| decl_tp_user { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	
	| decl_tp_i1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_i2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_i3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_i4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_i5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }

	| decl_tp_r1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_r2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_r3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_r4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_r5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	
	| decl_tp_c1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_c2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_c3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_c4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_c5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	
	| decl_tp_v1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_v2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_v3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_v4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tp_v5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	;
	
paramlist_array:
	  decl_tc_i1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_r1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_c1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_v1d { gReturnStack.top().fptr->InsertParam($1, gArgCount++);  }
	
	  decl_tc_i2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_r2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_c2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_v2d { gReturnStack.top().fptr->InsertParam($1, gArgCount++);  }
	
	  decl_tc_i3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_r3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_c3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_v3d { gReturnStack.top().fptr->InsertParam($1, gArgCount++);  }
	
	  decl_tc_i4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_r4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_c4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_v4d { gReturnStack.top().fptr->InsertParam($1, gArgCount++);  }
	
	  decl_tc_i5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_r5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_c5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++); }
	| decl_tc_v5d { gReturnStack.top().fptr->InsertParam($1, gArgCount++);  }
	;
												
stmt_if : 
		  STMT_IFTRUE  '(' expr_boolean ')' stmt %prec STMT_LOWERTHANELSE 
			{ $$=gGC.GetStmtIf($3, $5, true);  } 
		| STMT_IFTRUE  '(' expr_boolean ')' stmt STMT_ELSE stmt
			{ $$=gGC.GetStmtIf($3, $5, true, $7);  } 
		| STMT_IFTRUE  '(' expr_boolean ')' stmt STMT_ELSEFALSE stmt
			{ $$=gGC.GetStmtIf($3, $5, true, $7);  } 
		
		| STMT_IFFALSE '(' expr_boolean ')' stmt %prec STMT_LOWERTHANELSE 
			{ $$=gGC.GetStmtIf($3, $5, false); } 
		| STMT_IFFALSE '(' expr_boolean ')' stmt STMT_ELSE stmt
			{ $$=gGC.GetStmtIf($3, $5, false, $7); }
		| STMT_IFFALSE '(' expr_boolean ')' stmt STMT_ELSETRUE stmt
			{ $$=gGC.GetStmtIf($3, $5, false, $7); }
			
		| STMT_IF '(' expr_boolean ')' stmt %prec STMT_LOWERTHANELSE 
			{ $$=gGC.GetStmtIfElse($3, $5, NULL); } 
		| STMT_IF '(' expr_boolean ')' stmt STMT_ELSE stmt 
			{ $$=gGC.GetStmtIfElse($3, $5, $7); } 
		
		| STMT_IFTRUE  '(' expr_strn ')' stmt %prec STMT_LOWERTHANELSE 
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn); 
				$$=gGC.GetStmtIf(gGC.GetBFunS(fn, $3), $5, true);  } 
		| STMT_IFTRUE  '(' expr_strn ')' stmt STMT_ELSE stmt
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn);  
				$$=gGC.GetStmtIf(gGC.GetBFunS(fn, $3), $5, true, $7);  } 
		| STMT_IFTRUE  '(' expr_strn ')' stmt STMT_ELSEFALSE stmt
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn);  
				$$=gGC.GetStmtIf(gGC.GetBFunS(fn, $3), $5, true, $7);  } 
		
		| STMT_IFFALSE '(' expr_strn ')' stmt %prec STMT_LOWERTHANELSE 
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn); 
				$$=gGC.GetStmtIf(gGC.GetBFunS(fn, $3), $5, false); } 
		| STMT_IFFALSE '(' expr_strn ')' stmt STMT_ELSE stmt
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn); 
				$$=gGC.GetStmtIf(gGC.GetBFunS(fn, $3), $5, false, $7); }
		| STMT_IFFALSE '(' expr_strn ')' stmt STMT_ELSETRUE stmt
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn); 
				$$=gGC.GetStmtIf(gGC.GetBFunS(fn, $3), $5, false, $7); }
			
		| STMT_IF '(' expr_strn ')' stmt %prec STMT_LOWERTHANELSE 
			{	FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn); 
				$$=gGC.GetStmtIfElse(gGC.GetBFunS(fn, $3), $5, NULL); } 
		| STMT_IF '(' expr_strn ')' stmt STMT_ELSE stmt 
			{   FunName fn; StrCopy(fn.fn, _T("yesno")); gflist.find(fn); 
				$$=gGC.GetStmtIfElse(gGC.GetBFunS(fn, $3), $5, $7); } 
			
		| STMT_IF error_state 
			{ 	std::wostringstream os;
				os<<_T("In the \'")<<gTokenMap.TranslateToken("STMT_IF")<<_T("\' statement.\r\n");
				HandleSyntaxError(os.str()); 
			}
		| STMT_IFTRUE error_state { HandleSyntaxError(_T("In the \'if_true\' statement.\r\n")); }
		| STMT_IFFALSE error_state { HandleSyntaxError(_T("In the \'if_false\' statement.\r\n")); }
		;
	
stmt_clear: STMT_CLEAR { $$ = gGC.GetStmtClear(); } ;

stmt_select: 
	  STMT_SELECT '(' expr_intg ')' { gSelectStack.push(gGC.GetStmtSelect<integer>($3)); }
			'{' select_list_intg '}' { $$ = gSelectStack.pop(); } 
	| STMT_SELECT '(' expr_real ')' { gSelectStack.push(gGC.GetStmtSelect<realnum>($3)); }
			'{' select_list_real '}' { $$ = gSelectStack.pop(); } 
	| STMT_SELECT '(' expr_cplx ')' { gSelectStack.push(gGC.GetStmtSelect<Complex>($3)); }
			'{' select_list_cplx '}' { $$ = gSelectStack.pop(); } 
	| STMT_SELECT '(' expr_vctr ')' { gSelectStack.push(gGC.GetStmtSelect<Vector>($3));  }
			'{' select_list_vctr '}' { $$ = gSelectStack.pop(); } 
			
	| STMT_SELECT error_state 
		{ 	std::wostringstream os;
			os<<_T("In the \'")<<gTokenMap.TranslateToken("STMT_SELECT")<<_T("\' statement.\r\n");
			HandleSyntaxError(os.str()); 
		}
	;

select_list_intg: 
	  select_always
	| choice_list_intg
	| select_always choice_list_intg 
	| choice_list_intg select_always
	| select_always choice_list_intg select_always
	;

select_list_real: 
	  select_always
	| choice_list_real
	| select_always choice_list_real 
	| choice_list_real select_always
	| select_always choice_list_real select_always
	;
	
select_list_cplx: 
	  select_always
	| choice_list_cplx
	| select_always choice_list_cplx 
	| choice_list_cplx select_always
	| select_always choice_list_cplx select_always
	;
	
select_list_vctr: 
	  select_always
	| choice_list_vctr
	| select_always choice_list_vctr
	| choice_list_vctr select_always
	| select_always choice_list_vctr select_always
	;
	
select_always: LABEL_ALWAYS ':' stmt 
	{	
		Statement *pStmt = gSelectStack.top();
		
		StmtSelect<integer> *pIntg = dynamic_cast<StmtSelect<integer>*>(pStmt);
		StmtSelect<realnum> *pReal = dynamic_cast<StmtSelect<realnum>*>(pStmt);
		StmtSelect<Complex> *pCplx = dynamic_cast<StmtSelect<Complex>*>(pStmt);
		StmtSelect<Vector>  *pVctr = dynamic_cast<StmtSelect<Vector>*>(pStmt);
				
		if(pIntg) pIntg->InsertChoice(NULL, $3);
		else if(pReal) pReal->InsertChoice(NULL, $3);
		else if(pCplx) pCplx->InsertChoice(NULL, $3);
		else if(pVctr) pVctr->InsertChoice(NULL, $3);
		else HandleSyntaxError(_T("Select always not resolved.\r\n"));
	} ;
	
choice_list_intg: LABEL_CHOICE expr_intg ':' stmt 
		{ 
			StmtSelect<integer> *pStmt = 
					dynamic_cast<StmtSelect<integer>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($2, $4); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
	| choice_list_intg LABEL_CHOICE expr_intg ':' stmt 
		{ 
			StmtSelect<integer> *pStmt = 
					dynamic_cast<StmtSelect<integer>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($3, $5); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
	
choice_list_real: LABEL_CHOICE expr_real ':' stmt 
		{ 
			StmtSelect<realnum> *pStmt = 
					dynamic_cast<StmtSelect<realnum>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($2, $4); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
	| choice_list_real LABEL_CHOICE expr_real ':' stmt 
		{ 
			StmtSelect<realnum> *pStmt = 
					dynamic_cast<StmtSelect<realnum>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($3, $5); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
		
choice_list_cplx: LABEL_CHOICE expr_cplx ':' stmt 
		{ 
			StmtSelect<Complex> *pStmt = 
					dynamic_cast<StmtSelect<Complex>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($2, $4); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
	| choice_list_cplx LABEL_CHOICE expr_cplx ':' stmt 
		{ 
			StmtSelect<Complex> *pStmt = 
					dynamic_cast<StmtSelect<Complex>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($3, $5); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
		
choice_list_vctr: LABEL_CHOICE expr_vctr ':' stmt 
		{ 
			StmtSelect<Vector> *pStmt = 
					dynamic_cast<StmtSelect<Vector>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($2, $4); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
	| choice_list_vctr LABEL_CHOICE expr_vctr ':' stmt 
		{ 
			StmtSelect<Vector> *pStmt = 
					dynamic_cast<StmtSelect<Vector>*>(gSelectStack.top());
					
			if(pStmt) pStmt->InsertChoice($3, $5); 
			else HandleSyntaxError(_T("Invalid expression in choice.\r\n"));
		}
		
stmt_for: 
	  STMT_FOR '(' for_decl ';' loop_bool ';' for_update ')' stmt 
		{	$$ = gGC.GetStmtFor(NULL, $5, $7, $9); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); }
	| STMT_FOR '(' for_decl ';' loop_bool ')' stmt 
		{	$$ = gGC.GetStmtFor(NULL, $5, NULL, $7);
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop();  }
	| STMT_FOR '(' for_decl ')' { vartype=TypeNull; } stmt 
		{	$$ = gGC.GetStmtFor(NULL, NULL, NULL, $6);
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); }
	| STMT_FOR '(' for_update ';' loop_bool ';' for_update ')' stmt 
		{	$$ = gGC.GetStmtFor($3, $5, $7, $9); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); }
	| STMT_FOR '(' for_update ';' loop_bool ')' stmt 
		{	$$ = gGC.GetStmtFor($3, $5, NULL, $7); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop();  }
	| STMT_FOR '(' for_update ')' { vartype=TypeNull; } stmt 
		{	$$ = gGC.GetStmtFor($3, NULL, NULL, $6); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); }
	| STMT_FOR error_state
		{ 	std::wostringstream os;
			os<<_T("In the \'")<<gTokenMap.TranslateToken("STMT_FOR")<<_T("\' statement.\r\n");
			HandleSyntaxError(os.str()); 
		} 
	;
			
stmt_while: 
		STMT_WHILE '(' loop_bool ')' stmt { $$ = gGC.GetStmtWhile($3, $5); gLoopStack.pop(); } 
	|	STMT_WHILE error_state
		{ 	std::wostringstream os;
			os<<_T("In the \'")<<gTokenMap.TranslateToken("STMT_WHILE")<<_T("\' statement.\r\n");
			gLoopStack.pop(); HandleSyntaxError(os.str()); 
		}
	; 
	
stmt_throw: TKN_THROW ';'       { $$ = gGC.GetStmtThrowBase(); }
	| TKN_THROW expr_boolean ';' { $$ = gGC.GetStmtThrow<bool>($2); }
	| TKN_THROW expr_intg  ';' { $$ = gGC.GetStmtThrow<integer>($2); }
	| TKN_THROW expr_real  ';' { $$ = gGC.GetStmtThrow<realnum>($2); }
	| TKN_THROW expr_cplx  ';' { $$ = gGC.GetStmtThrow<Complex>($2); }
	| TKN_THROW expr_vctr  ';' { $$ = gGC.GetStmtThrow<Vector>($2); }
	| TKN_THROW expr_strn  ';' { $$ = gGC.GetStmtThrow<string>($2); }
	| TKN_THROW lhs_user   ';' { $$ = gGC.GetStmtThrowExp($2); }
	
	| TKN_THROW expr_i1d	';'  { $$ = gGC.GetStmtThrow<IntgVec1D>($2); }
	| TKN_THROW expr_r1d	';'  { $$ = gGC.GetStmtThrow<RealVec1D>($2); }
	| TKN_THROW expr_c1d	';'  { $$ = gGC.GetStmtThrow<CplxVec1D>($2); }
	| TKN_THROW expr_v1d	';'  { $$ = gGC.GetStmtThrow<VctrVec1D>($2); }
	
	| TKN_THROW expr_i2d	';'  { $$ = gGC.GetStmtThrow<IntgVec2D>($2); }
	| TKN_THROW expr_r2d	';'  { $$ = gGC.GetStmtThrow<RealVec2D>($2); }
	| TKN_THROW expr_c2d	';'  { $$ = gGC.GetStmtThrow<CplxVec2D>($2); }
	| TKN_THROW expr_v2d	';'  { $$ = gGC.GetStmtThrow<VctrVec2D>($2); }
	
	| TKN_THROW expr_i3d	';'  { $$ = gGC.GetStmtThrow<IntgVec3D>($2); }
	| TKN_THROW expr_r3d	';'  { $$ = gGC.GetStmtThrow<RealVec3D>($2); }
	| TKN_THROW expr_c3d	';'  { $$ = gGC.GetStmtThrow<CplxVec3D>($2); }
	| TKN_THROW expr_v3d	';'  { $$ = gGC.GetStmtThrow<VctrVec3D>($2); }
	
	| TKN_THROW expr_i4d	';'  { $$ = gGC.GetStmtThrow<IntgVec4D>($2); }
	| TKN_THROW expr_r4d	';'  { $$ = gGC.GetStmtThrow<RealVec4D>($2); }
	| TKN_THROW expr_c4d	';'  { $$ = gGC.GetStmtThrow<CplxVec4D>($2); }
	| TKN_THROW expr_v4d	';'  { $$ = gGC.GetStmtThrow<VctrVec4D>($2); }
	
	| TKN_THROW expr_i5d	';'  { $$ = gGC.GetStmtThrow<IntgVec5D>($2); }
	| TKN_THROW expr_r5d	';'  { $$ = gGC.GetStmtThrow<RealVec5D>($2); }
	| TKN_THROW expr_c5d	';'  { $$ = gGC.GetStmtThrow<CplxVec5D>($2); }
	| TKN_THROW expr_v5d	';'  { $$ = gGC.GetStmtThrow<VctrVec5D>($2); }
	;
	
decl_tc_i1d: TYPE_INTG VID_INTG '[' ']' { $$ = gGC.GetDecAry1D<integer>($2); } ;
decl_tc_r1d: TYPE_REAL VID_REAL '[' ']' { $$ = gGC.GetDecAry1D<realnum>($2); } ;
decl_tc_c1d: TYPE_CPLX VID_CPLX '[' ']' { $$ = gGC.GetDecAry1D<Complex>($2); } ;
decl_tc_v1d: TYPE_VCTR VID_VCTR '[' ']' { $$ = gGC.GetDecAry1D<Vector> ($2); } ;

decl_tc_i2d: TYPE_INTG VID_INTG '[' ',' ']' { $$ = gGC.GetDecAry2D<integer>($2); } ;
decl_tc_r2d: TYPE_REAL VID_REAL '[' ',' ']' { $$ = gGC.GetDecAry2D<realnum>($2); } ;
decl_tc_c2d: TYPE_CPLX VID_CPLX '[' ',' ']' { $$ = gGC.GetDecAry2D<Complex>($2); } ;
decl_tc_v2d: TYPE_VCTR VID_VCTR '[' ',' ']' { $$ = gGC.GetDecAry2D<Vector> ($2); } ;

decl_tc_i3d: TYPE_INTG VID_INTG '[' ',' ',' ']' { $$ = gGC.GetDecAry3D<integer>($2); } ;
decl_tc_r3d: TYPE_REAL VID_REAL '[' ',' ',' ']' { $$ = gGC.GetDecAry3D<realnum>($2); } ;
decl_tc_c3d: TYPE_CPLX VID_CPLX '[' ',' ',' ']' { $$ = gGC.GetDecAry3D<Complex>($2); } ;
decl_tc_v3d: TYPE_VCTR VID_VCTR '[' ',' ',' ']' { $$ = gGC.GetDecAry3D<Vector> ($2); } ;

decl_tc_i4d: TYPE_INTG VID_INTG '[' ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<integer>($2); } ;
decl_tc_r4d: TYPE_REAL VID_REAL '[' ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<realnum>($2); } ;
decl_tc_c4d: TYPE_CPLX VID_CPLX '[' ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<Complex>($2); } ;
decl_tc_v4d: TYPE_VCTR VID_VCTR '[' ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<Vector> ($2); } ;

decl_tc_i5d: TYPE_INTG VID_INTG '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<integer>($2); } ;
decl_tc_r5d: TYPE_REAL VID_REAL '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<realnum>($2); } ;
decl_tc_c5d: TYPE_CPLX VID_CPLX '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<Complex>($2); } ;
decl_tc_v5d: TYPE_VCTR VID_VCTR '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<Vector> ($2); } ;

decl_tp_i1d: TYPE_INTG '*' VID_INTG '[' ']' { $$ = gGC.GetDeclareAptr<IntgVec1D>($3); } ;
decl_tp_r1d: TYPE_REAL '*' VID_REAL '[' ']' { $$ = gGC.GetDeclareAptr<RealVec1D>($3); } ;
decl_tp_c1d: TYPE_CPLX '*' VID_CPLX '[' ']' { $$ = gGC.GetDeclareAptr<CplxVec1D>($3); } ;
decl_tp_v1d: TYPE_VCTR '*' VID_VCTR '[' ']' { $$ = gGC.GetDeclareAptr<VctrVec1D>($3); } ;

decl_tp_i2d: TYPE_INTG '*' VID_INTG '[' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec2D>($3); } ;
decl_tp_r2d: TYPE_REAL '*' VID_REAL '[' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec2D>($3); } ;
decl_tp_c2d: TYPE_CPLX '*' VID_CPLX '[' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec2D>($3); } ;
decl_tp_v2d: TYPE_VCTR '*' VID_VCTR '[' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec2D>($3); } ;

decl_tp_i3d: TYPE_INTG '*' VID_INTG '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec3D>($3); } ;
decl_tp_r3d: TYPE_REAL '*' VID_REAL '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec3D>($3); } ;
decl_tp_c3d: TYPE_CPLX '*' VID_CPLX '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec3D>($3); } ;
decl_tp_v3d: TYPE_VCTR '*' VID_VCTR '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec3D>($3); } ;

decl_tp_i4d: TYPE_INTG '*' VID_INTG '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec4D>($3); } ;
decl_tp_r4d: TYPE_REAL '*' VID_REAL '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec4D>($3); } ;
decl_tp_c4d: TYPE_CPLX '*' VID_CPLX '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec4D>($3); } ;
decl_tp_v4d: TYPE_VCTR '*' VID_VCTR '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec4D>($3); } ;

decl_tp_i5d: TYPE_INTG '*' VID_INTG '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec5D>($3); } ;
decl_tp_r5d: TYPE_REAL '*' VID_REAL '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec5D>($3); } ;
decl_tp_c5d: TYPE_CPLX '*' VID_CPLX '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec5D>($3); } ;
decl_tp_v5d: TYPE_VCTR '*' VID_VCTR '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec5D>($3); } ;

stmt_try:  TKN_TRY '{' stmtlist '}' stmt_catch { $$ = $5; }  ;
	
stmtlist_catch: '{' { gCatchBlockStack.push(true); gStmtListStack.top()->Add($<pstmt>-1); }
		stmtlist { gCatchBlockStack.pop(); } '}' { $$ = $3; } ;
		
stmtlist_catch_simple:  '{' { gCatchBlockStack.push(true); } 
		stmtlist { gCatchBlockStack.pop(); } '}' { $$=$3; }
	
stmt_catch:  TKN_CATCH stmtlist_catch_simple
			{	$$ = gGC.GetStmtTryCatchBase(dynamic_cast<Statement*>($<pstmtlist>-1), $2); }
	|	TKN_CATCH '(' ')' stmtlist_catch_simple
			{	$$ = gGC.GetStmtTryCatchBase(dynamic_cast<Statement*>($<pstmtlist>-1), $4); }
	
	|	TKN_CATCH '(' decl_tc_bool ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<bool>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tc_intg ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<integer>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tc_real ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<realnum>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tc_cplx ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<Complex>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tc_vctr ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<Vector>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tc_strn ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<string>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tc_user ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<UserData>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
			
	|	TKN_CATCH '(' decl_tp_bool')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<bool>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tp_intg ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<integer>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tp_real ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<realnum>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tp_cplx ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<Complex>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tp_vctr ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<Vector>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tp_strn ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<string>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	|	TKN_CATCH '(' decl_tp_user ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<UserData>(dynamic_cast<Statement*>($<pstmtlist>-1), $5); }
	
	|	TKN_CATCH '(' decl_tc_i1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<IntgVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_r1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<RealVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_c1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<CplxVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_v1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<VctrVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	TKN_CATCH '(' decl_tc_i2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<IntgVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_r2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<RealVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_c2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<CplxVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_v2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<VctrVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	TKN_CATCH '(' decl_tc_i3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<IntgVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_r3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<RealVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_c3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<CplxVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_v3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<VctrVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	
	|	TKN_CATCH '(' decl_tc_i4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<IntgVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_r4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<RealVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_c4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<CplxVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_v4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<VctrVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	TKN_CATCH '(' decl_tc_i5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<IntgVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_r5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<RealVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_c5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<CplxVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tc_v5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatch<VctrVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }

	|	TKN_CATCH '(' decl_tp_i1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<IntgVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_r1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<RealVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_c1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<CplxVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_v1d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<VctrVec1D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	TKN_CATCH '(' decl_tp_i2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<IntgVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_r2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<RealVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_c2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<CplxVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_v2d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<VctrVec2D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	TKN_CATCH '(' decl_tp_i3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<IntgVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_r3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<RealVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_c3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<CplxVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_v3d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<VctrVec3D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	
	|	TKN_CATCH '(' decl_tp_i4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<IntgVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_r4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<RealVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_c4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<CplxVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_v4d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<VctrVec4D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	TKN_CATCH '(' decl_tp_i5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<IntgVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_r5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<RealVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_c5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<CplxVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
	|	TKN_CATCH '(' decl_tp_v5d ')' stmtlist_catch
			{	$$ = gGC.GetStmtTryCatchPtr<VctrVec5D>(dynamic_cast<Statement*>($<pstmtlist>-1), $5);  }
			
	|	stmt_catch TKN_CATCH stmtlist_catch_simple { $$ = gGC.GetStmtTryCatchBase($1, $3); }
			
	|	stmt_catch TKN_CATCH '(' ')' stmtlist_catch_simple { $$ = gGC.GetStmtTryCatchBase($1, $5);  }

	|	stmt_catch TKN_CATCH '(' decl_tc_bool ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<bool>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tc_intg ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<integer>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tc_real ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<realnum>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tc_cplx ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<Complex>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tc_vctr ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<Vector>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tc_strn ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<string>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tc_user ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<UserData>($1, $6); }
		
	|	stmt_catch TKN_CATCH '(' decl_tp_bool ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<bool>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tp_intg ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<integer>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tp_real ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<realnum>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tp_cplx ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<Complex>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tp_vctr ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<Vector>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tp_strn ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<string>($1, $6); }
	|	stmt_catch TKN_CATCH '(' decl_tp_user ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<UserData>($1, $6); }
		
	|	stmt_catch TKN_CATCH '(' decl_tc_i1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<IntgVec1D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_r1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<RealVec1D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_c1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<CplxVec1D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_v1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<VctrVec1D>($1, $6);  }

	|	stmt_catch TKN_CATCH '(' decl_tc_i2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<IntgVec2D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_r2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<RealVec2D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_c2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<CplxVec2D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_v2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<VctrVec2D>($1, $6);  }

	|	stmt_catch TKN_CATCH '(' decl_tc_i3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<IntgVec3D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_r3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<RealVec3D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_c3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<CplxVec3D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_v3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<VctrVec3D>($1, $6);  }
			
	|	stmt_catch TKN_CATCH '(' decl_tc_i4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<IntgVec4D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_r4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<RealVec4D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_c4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<CplxVec4D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_v4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<VctrVec4D>($1, $6);  }
			
	|	stmt_catch TKN_CATCH '(' decl_tc_i5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<IntgVec5D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_r5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<RealVec5D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_c5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<CplxVec5D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tc_v5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatch<VctrVec5D>($1, $6);  }
			
	|	stmt_catch TKN_CATCH '(' decl_tp_i1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<IntgVec1D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_r1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<RealVec1D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_c1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<CplxVec1D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_v1d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<VctrVec1D>($1, $6);  }

	|	stmt_catch TKN_CATCH '(' decl_tp_i2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<IntgVec2D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_r2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<RealVec2D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_c2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<CplxVec2D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_v2d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<VctrVec2D>($1, $6);  }

	|	stmt_catch TKN_CATCH '(' decl_tp_i3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<IntgVec3D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_r3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<RealVec3D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_c3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<CplxVec3D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_v3d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<VctrVec3D>($1, $6);  }
			
	|	stmt_catch TKN_CATCH '(' decl_tp_i4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<IntgVec4D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_r4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<RealVec4D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_c4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<CplxVec4D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_v4d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<VctrVec4D>($1, $6);  }
			
	|	stmt_catch TKN_CATCH '(' decl_tp_i5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<IntgVec5D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_r5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<RealVec5D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_c5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<CplxVec5D>($1, $6);  }
	|	stmt_catch TKN_CATCH '(' decl_tp_v5d ')' stmtlist_catch { $$ = gGC.GetStmtTryCatchPtr<VctrVec5D>($1, $6);  }
	;	

stmt_do: 
		STMT_DO stmt %prec STMT_LOWERTHANWHIlE 
		{	$$ = gGC.GetStmtDo(NULL, $2); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); }
			
	|	STMT_DO stmt STMT_WHILE '(' loop_bool ')' 
		{	$$ = gGC.GetStmtDo($5, $2); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); gLoopStack.pop(); }
		
	|	STMT_DO '(' for_decl ')' stmt %prec STMT_LOWERTHANWHIlE 
		{	$$ = gGC.GetStmtDo(NULL, $5); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop();  }
			
	|	STMT_DO '(' for_decl ')' stmt STMT_WHILE '(' loop_bool ')' 
		{	$$ = gGC.GetStmtDo($8, $5); 
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); gLoopStack.pop(); }
			
	|	STMT_DO '(' for_update ')' stmt %prec STMT_LOWERTHANWHIlE 
		{	$$ = gGC.GetStmtDo(NULL, $5); dynamic_cast<StmtDo*>($$)->pUpdate= $3;
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop();}
			
	|	STMT_DO '(' for_update ')' stmt STMT_WHILE '(' loop_bool ')' 
		{	$$ = gGC.GetStmtDo($8, $5); dynamic_cast<StmtDo*>($$)->pUpdate= $3;
			gStmtListStack.top()->Add($$); $$ = gStmtListStack.top(); 
			gStmtListStack.pop(); gLoopStack.pop(); gLoopStack.pop(); }
	; 

loop_bool: /* empty */	{ $$ = NULL; }
	| expr_boolean		{ $$ = $1; }
	| expr_strn {	FunName fn; StrCopy(fn.fn, _T("yesno")); 
					gflist.find(fn); $$=gGC.GetBFunS(fn, $1); }
	;

stmt_label: TYPE_UNDF ':' 
		{ 
			if(gStmtListStack.top()->FindLabel(std::wstring($1))==-1)
				$$ = gGC.GetStmtLabel($1); 
			else 
			{
				std::wostringstream os;
				os<<L"Label \'"<<$1<<L"\' is already defined in the current code block.\r\n";
				HandleSyntaxError(os.str());
			}
		} ;
		
stmt_break: STMT_BREAK	{ if(gLoopStack.empty() && gSelectStack.empty()) 
							HandleSyntaxError(_T("break statemenet is allowed inside of a loop/select construct.\r\n"));
						  else $$ = gGC.GetStmtBreak(); } ;
stmt_skip:  STMT_SKIP	{ if(gLoopStack.empty()) 
							HandleSyntaxError(_T("skip or continue statemenet is allowed inside of a loop construct.\r\n"));
						  else $$ = gGC.GetStmtSkip(); 
						  } ;
stmt_goto:  STMT_GOTO GOTO_TARGET   { $$ = gGC.GetStmtGoTo($2); goto_set = false;} ;

stmt_exit:	STMT_EXIT expr_strn { $$ = gGC.GetStmtAbort($2); }

stmt_return: 
	   RTN_VOID expr_rtn_typeless { $$ = gGC.GetReturn<voidtype>($2); } 
	|  RTN_BOOL expr_rtn_typeless { $$ = gGC.GetReturn<bool>($2); }
	|  RTN_INTG expr_intg		  { $$ = gGC.GetReturn<integer>($2); }
	|  RTN_INTG expr_real		  { $$ = gGC.GetReturn<integer>(gGC.GetR2I($2)); }
	|  RTN_REAL expr_intg         { $$ = gGC.GetReturn<realnum>(gGC.GetI2R($2)); }
	|  RTN_REAL expr_real		  { $$ = gGC.GetReturn<realnum>($2); }
	|  RTN_CPLX expr_rtn_typeless { $$ = gGC.GetReturn<Complex>($2); }
	|  RTN_VCTR expr_rtn_typeless { $$ = gGC.GetReturn<Vector>($2); }
	|  RTN_VUB	lhs_user		  { $$ = gGC.GetReturnUdt($2); }
	
	|  RTN_STRN	expr_rtn_typeless { $$ = gGC.GetReturn<string>($2); }
	
	|  RTN_BPTR expr_rtn_typeless { $$ = gGC.GetReturn<bool*>($2); }
	|  RTN_SPTR expr_rtn_typeless { $$ = gGC.GetReturn<string*>($2); }
	|  RTN_IPTR expr_rtn_typeless { $$ = gGC.GetReturn<integer*>($2); }
	|  RTN_RPTR expr_rtn_typeless { $$ = gGC.GetReturn<realnum*>($2); }
	|  RTN_CPTR expr_rtn_typeless { $$ = gGC.GetReturn<Complex*>($2); }
	|  RTN_VPTR expr_rtn_typeless { $$ = gGC.GetReturn<Vector*>($2); }
		
	|  RTN_AI1D expr_rtn_typeless { $$ = gGC.GetReturn<IntgVec1D>($2); }
	|  RTN_AR1D expr_rtn_typeless { $$ = gGC.GetReturn<RealVec1D>($2); }
	|  RTN_AC1D expr_rtn_typeless { $$ = gGC.GetReturn<CplxVec1D>($2); }
	|  RTN_AV1D expr_rtn_typeless { $$ = gGC.GetReturn<VctrVec1D>($2); }
	
	|  RTN_AI2D expr_rtn_typeless { $$ = gGC.GetReturn<IntgVec2D>($2); }
	|  RTN_AR2D expr_rtn_typeless { $$ = gGC.GetReturn<RealVec2D>($2); }
	|  RTN_AC2D expr_rtn_typeless { $$ = gGC.GetReturn<CplxVec2D>($2); }
	|  RTN_AV2D expr_rtn_typeless { $$ = gGC.GetReturn<VctrVec2D>($2); }
	
	|  RTN_AI3D expr_rtn_typeless { $$ = gGC.GetReturn<IntgVec3D>($2); }
	|  RTN_AR3D expr_rtn_typeless { $$ = gGC.GetReturn<RealVec3D>($2); }
	|  RTN_AC3D expr_rtn_typeless { $$ = gGC.GetReturn<CplxVec3D>($2); }
	|  RTN_AV3D expr_rtn_typeless { $$ = gGC.GetReturn<VctrVec3D>($2); }
	
	|  RTN_AI4D expr_rtn_typeless { $$ = gGC.GetReturn<IntgVec4D>($2); }
	|  RTN_AR4D expr_rtn_typeless { $$ = gGC.GetReturn<RealVec4D>($2); }
	|  RTN_AC4D expr_rtn_typeless { $$ = gGC.GetReturn<CplxVec4D>($2); }
	|  RTN_AV4D expr_rtn_typeless { $$ = gGC.GetReturn<VctrVec4D>($2); }
	
	|  RTN_AI5D expr_rtn_typeless { $$ = gGC.GetReturn<IntgVec5D>($2); }
	|  RTN_AR5D expr_rtn_typeless { $$ = gGC.GetReturn<RealVec5D>($2); }
	|  RTN_AC5D expr_rtn_typeless { $$ = gGC.GetReturn<CplxVec5D>($2); }
	|  RTN_AV5D expr_rtn_typeless { $$ = gGC.GetReturn<VctrVec5D>($2); }
	;
	
expr_rtn_typeless: /* empty */ { $$ = NULL; } 
	|	expr_boolean { $$ = $1; } |	expr_bptr { $$ = $1; } |  expr_sptr { $$ = $1; }
	|	expr_cplx { $$ = $1; }    | expr_vctr { $$ = $1; } |  expr_strn { $$ = $1; }
	|	expr_iptr { $$ = $1; }    | expr_rptr { $$ = $1; } |  expr_cptr { $$ = $1; } | expr_vptr { $$ = $1; } 
	|	expr_i1d  { $$ = $1; }    | expr_r1d  { $$ = $1; } |  expr_c1d  { $$ = $1; } | expr_v1d  { $$ = $1; }
	|	expr_i2d  { $$ = $1; }    | expr_r2d  { $$ = $1; } |  expr_c2d  { $$ = $1; } | expr_v2d  { $$ = $1; } 
	|	expr_i3d  { $$ = $1; }    | expr_r3d  { $$ = $1; } |  expr_c3d  { $$ = $1; } | expr_v3d  { $$ = $1; }
	|	expr_i4d  { $$ = $1; }    | expr_r4d  { $$ = $1; } |  expr_c4d  { $$ = $1; } | expr_v4d  { $$ = $1; }
	|	expr_i5d  { $$ = $1; }    | expr_r5d  { $$ = $1; } |  expr_c5d  { $$ = $1; } | expr_v5d  { $$ = $1; }
	;

for_decl: /* empty */ { vartype=TypeNull; assign_set = false; } 
	|	declare_list { vartype=TypeNull; assign_set = false; }
	;

for_update: assignment	{ $$ = gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add($1); }
	| for_update ',' assignment {$$->Add($3); } 
	;
	
literal_declare: DEF_LITERAL literal_list { $$ = $2; literal_set = false; }

decl_intg_literal:
	 TYPE_INTG LID_INTG '=' expr_inum 
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<integer>($2,$4); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<integer>($2, $4), TypeIntgL, $2);
				$$ = NULL;
			}
			
			vartype = TypeIntg; assign_set=false; 
		}
	;
init_intg_literal: 
	LID_INTG '=' expr_inum	
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<integer>($1,$3); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<integer>($1, $3), TypeIntgL, $1);
				$$ = NULL;
			}
			
			vartype = TypeIntg; assign_set=false; 
		}
	;
	
decl_real_literal:
	 TYPE_REAL LID_REAL '=' expr_rnum 
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<realnum>($2,$4); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<realnum>($2, $4), TypeRealL, $2);
				$$ = NULL;
			}
			
			vartype = TypeReal; assign_set=false; 
		}
	;
init_real_literal: 
	 LID_REAL '=' expr_rnum	
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<realnum>($1,$3); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<realnum>($1, $3), TypeRealL, $1);
				$$ = NULL;
			}
			
			vartype = TypeReal; assign_set=false; 
		}
	;
	
decl_cplx_literal:
	 TYPE_CPLX LID_CPLX '=' expr_cplx
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<Complex>($2,$4); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<Complex>($2, $4), TypeCplxL, $2);
				$$ = NULL;
			}
			
			vartype = TypeCplx; assign_set=false; 
		}
	;
init_cplx_literal: 
	 LID_CPLX '=' expr_cplx	
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<Complex>($1,$3); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<Complex>($1, $3), TypeRealL, $1);
				$$ = NULL;
			}
			
			vartype = TypeCplx; assign_set=false; 
		}
	;
	
decl_vctr_literal:
	 TYPE_VCTR LID_VCTR '=' expr_vctr
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<Vector>($2,$4); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<Vector>($2, $4), TypeVctrL, $2);
				$$ = NULL;
			}
			
			vartype = TypeVctr; assign_set=false; 
		}
	;
init_vctr_literal: 
	LID_VCTR '=' expr_vctr	
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<Vector>($1,$3); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<Vector>($1, $3), TypeVctrL, $1);
				$$ = NULL;
			}
			
			vartype = TypeVctr; assign_set=false; 
		}
	;
	

decl_strn_literal:
	 TYPE_STRN LID_STRN '=' expr_strn
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<string>($2,$4); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<string>($2, $4), TypeStrnL, $2);
				$$ = NULL;
			}
			
			vartype = TypeStrn; assign_set=false; 
		}
	;
	
init_strn_literal: 
	LID_STRN '=' expr_strn
		{ 
			if(gFactoryStack.empty())
				$$ = gGC.GetDeclareLiteral<string>($1,$3); 
			else
			{
				gFactoryStack.top()->InsertElement(gGC.GetLiteralData<string>($1, $3), TypeStrnL, $1);
				$$ = NULL;
			}
			
			vartype = TypeStrn; assign_set=false; 
		}
	;	


static_declare: DEF_STATIC declare_list { $$ = $2; static_set = false; }

literal_list: declare_literal			{ $$ = NULL; gStmtListStack.top()->Add($1);} 
	| literal_list ',' declare_literal	{ $$ = NULL; gStmtListStack.top()->Add($3);}
	
declare_list: declare          { $$ = NULL; gStmtListStack.top()->Add($1);} 
	| declare_list ',' declare { $$ = NULL; gStmtListStack.top()->Add($3);}
	;
	
declare: 
	  decl_void		{ $$ = $1; } 
	| decl_bool     { $$ = $1; } | init_bool    { $$ = $1; }
	| decl_intg     { $$ = $1; } | init_intg 	{ $$ = $1; } 
	| decl_real	    { $$ = $1; } | init_real 	{ $$ = $1; }
	| decl_cplx	    { $$ = $1; } | init_cplx 	{ $$ = $1; }
	| decl_vctr	    { $$ = $1; } | init_vctr 	{ $$ = $1; }
	| decl_udt		{ $$ = $1; } | init_udt	    { $$ = $1; }
	| decl_strn		{ $$ = $1; } | init_strn    { $$ = $1; }
	;
	
declare_literal: 
	  decl_intg_literal { $$ = $1; } | init_intg_literal { $$ = $1; } 
	| decl_real_literal { $$ = $1; } | init_real_literal { $$ = $1; }
	| decl_cplx_literal { $$ = $1; } | init_cplx_literal { $$ = $1; }
	| decl_vctr_literal { $$ = $1; } | init_vctr_literal { $$ = $1; }
	| decl_strn_literal { $$ = $1; } | init_strn_literal { $$ = $1; }
	;
	
stmt_expr:
	
		TYPE_UNDF '=' expr_boolean { $$ = gGC.GetDeclare<bool>($1, $3);  assign_set = false; }
	|	TYPE_UNDF '=' expr_intg { $$ = gGC.GetDeclare<integer>($1, $3);  assign_set = false; }
	|	TYPE_UNDF '=' expr_real { $$ = gGC.GetDeclare<realnum>($1, $3);  assign_set = false; }
	|	TYPE_UNDF '=' expr_cplx { $$ = gGC.GetDeclare<Complex>($1, $3);  assign_set = false; }
	|	TYPE_UNDF '=' expr_vctr { $$ = gGC.GetDeclare<Vector>($1, $3);  assign_set = false; }
	|	TYPE_UNDF '=' expr_strn { $$ = gGC.GetDeclare<string>($1, $3);  assign_set = false; }
	
	|	TYPE_UNDF '=' expr_i1d { DecAry1D<integer> *ptr = gGC.GetDecAry1D<integer>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<IntgVec1D, Array1D<integer> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_i2d { DecAry2D<integer> *ptr = gGC.GetDecAry2D<integer>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<IntgVec2D, Array2D<integer> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_i3d { DecAry3D<integer> *ptr = gGC.GetDecAry3D<integer>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<IntgVec3D, Array3D<integer> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_i4d { DecAry4D<integer> *ptr = gGC.GetDecAry4D<integer>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<IntgVec4D, Array4D<integer> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_i5d { DecAry5D<integer> *ptr = gGC.GetDecAry5D<integer>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<IntgVec5D, Array5D<integer> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_r1d { DecAry1D<realnum> *ptr = gGC.GetDecAry1D<realnum>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<RealVec1D, Array1D<realnum> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_r2d { DecAry2D<realnum> *ptr = gGC.GetDecAry2D<realnum>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<RealVec2D, Array2D<realnum> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_r3d { DecAry3D<realnum> *ptr = gGC.GetDecAry3D<realnum>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<RealVec3D, Array3D<realnum> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_r4d { DecAry4D<realnum> *ptr = gGC.GetDecAry4D<realnum>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<RealVec4D, Array4D<realnum> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_r5d { DecAry5D<realnum> *ptr = gGC.GetDecAry5D<realnum>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<RealVec5D, Array5D<realnum> >(vt, $3); } 
								
	|	TYPE_UNDF '=' expr_c1d { DecAry1D<Complex> *ptr = gGC.GetDecAry1D<Complex>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<CplxVec1D, Array1D<Complex> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_c2d { DecAry2D<Complex> *ptr = gGC.GetDecAry2D<Complex>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<CplxVec2D, Array2D<Complex> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_c3d { DecAry3D<Complex> *ptr = gGC.GetDecAry3D<Complex>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<CplxVec3D, Array3D<Complex> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_c4d { DecAry4D<Complex> *ptr = gGC.GetDecAry4D<Complex>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<CplxVec4D, Array4D<Complex> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_c5d { DecAry5D<Complex> *ptr = gGC.GetDecAry5D<Complex>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<CplxVec5D, Array5D<Complex> >(vt, $3); } 
								
	|	TYPE_UNDF '=' expr_v1d { DecAry1D<Vector> *ptr = gGC.GetDecAry1D<Vector>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<VctrVec1D, Array1D<Vector> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_v2d { DecAry2D<Vector> *ptr = gGC.GetDecAry2D<Vector>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<VctrVec2D, Array2D<Vector> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_v3d { DecAry3D<Vector> *ptr = gGC.GetDecAry3D<Vector>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<VctrVec3D, Array3D<Vector> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_v4d { DecAry4D<Vector> *ptr = gGC.GetDecAry4D<Vector>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<VctrVec4D, Array4D<Vector> >(vt, $3); } 
				
	|	TYPE_UNDF '=' expr_v5d { DecAry5D<Vector> *ptr = gGC.GetDecAry5D<Vector>($1, NULL);
				gStmtListStack.top()->Add(ptr); VarType vt; ptr->SetVarType(vt); 
				$$ = gGC.GetAssignArray<VctrVec5D, Array5D<Vector> >(vt, $3); } 			   
	;
	

stmt_asg_bool: 
	  lhs_bool '=' expr_boolean { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<bool>($1,$3)); } 
				
	| lhs_bool '=' stmt_asg_bool
		{
			LeftHandSide<bool> *pLHS = dynamic_cast<AssignmentLHS<bool>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<bool>($1, pLHS)); $$ = $3; 
		}
	;
	
stmt_asg_strn: 
	  lhs_strn '=' expr_strn { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1,$3)); } 
	| lhs_strn '=' expr_boolean { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<bool>($3)));   }
	| lhs_strn '=' expr_intg	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<integer>($3)));}
	| lhs_strn '=' expr_real	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<realnum>($3)));}
	| lhs_strn '=' expr_cplx	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<Complex>($3)));}
	| lhs_strn '=' expr_vctr	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<Vector>($3))); }
	
	| lhs_strn OPR_PLS expr_boolean { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<bool>($3)	,'!'));   }
	| lhs_strn OPR_PLS expr_intg	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<integer>($3),'!'));}
	| lhs_strn OPR_PLS expr_real	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<realnum>($3),'!'));}
	| lhs_strn OPR_PLS expr_cplx	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<Complex>($3),'!'));}
	| lhs_strn OPR_PLS expr_vctr	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, gGC.GetExprStrn<Vector>($3) ,'!')); }
	
	| lhs_strn OPR_PLS expr_strn    { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<string>($1, $3 ,'!')); }
	
	| lhs_strn '=' stmt_asg_strn
		{
			LeftHandSide<string> *pLHS = dynamic_cast<AssignmentLHS<string>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<string>($1, pLHS)); $$ = $3; 
		}
		
	| lhs_strn OPR_PLS stmt_asg_strn
		{
			LeftHandSide<string> *pLHS = dynamic_cast<AssignmentLHS<string>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<string>($1, pLHS, '!')); $$ = $3; 
		}
	;
	
stmt_asg_intg: 
      lhs_intg '=' expr_inum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1,$3)); } 
	
	| OPR_INC lhs_intg	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($2, NULL, '%')); }
	| OPR_DEC lhs_intg	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($2, NULL, '^')); } 
	| lhs_intg OPR_INC 	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1, NULL, '%')); }
	| lhs_intg OPR_DEC  { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1, NULL, '^')); } 
	
	| lhs_intg OPR_PLS expr_inum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1,$3, '!'));} 
	| lhs_intg OPR_MNS expr_inum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1,$3, '@'));} 
	| lhs_intg OPR_MUL expr_inum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1,$3, '#'));} 
	| lhs_intg OPR_DIV expr_inum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1,$3, '$'));} 
	
	// OPR_CRS for type integer is Modulo operator
	| lhs_intg OPR_CRS expr_inum 
	{ 
		$$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<integer>($1,$3, '~'));
	} 
	
	| lhs_intg '=' stmt_asg_intg 
		{
			LeftHandSide<integer> *pLHS = dynamic_cast<AssignmentLHS<integer>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<integer>($1, pLHS)); $$ = $3; 
		}
	| lhs_intg OPR_PLS stmt_asg_intg 
		{
			LeftHandSide<integer> *pLHS = dynamic_cast<AssignmentLHS<integer>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<integer>($1, pLHS, '!')); $$ = $3; 
		}
	| lhs_intg OPR_MNS stmt_asg_intg 
		{
			LeftHandSide<integer> *pLHS = dynamic_cast<AssignmentLHS<integer>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<integer>($1, pLHS, '@')); $$ = $3; 
		}
	| lhs_intg OPR_MUL stmt_asg_intg 
		{
			LeftHandSide<integer> *pLHS = dynamic_cast<AssignmentLHS<integer>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<integer>($1, pLHS, '#')); $$ = $3; 
		}
	| lhs_intg OPR_DIV stmt_asg_intg 
		{
			LeftHandSide<integer> *pLHS = dynamic_cast<AssignmentLHS<integer>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<integer>($1, pLHS, '$')); $$ = $3; 
		}
		
	| lhs_intg OPR_CRS stmt_asg_intg // Modulo operator
		{
			LeftHandSide<integer> *pLHS = dynamic_cast<AssignmentLHS<integer>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<integer>($1, pLHS, '~')); $$ = $3; 
		}
	;
	
stmt_asg_real: 
      lhs_real '=' expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1,$3)); } 
	
	| OPR_INC lhs_real	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($2, NULL, '%')); }
	| OPR_DEC lhs_real	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($2, NULL, '^')); } 
	| lhs_real OPR_INC 	{ $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1, NULL, '%')); }
	| lhs_real OPR_DEC  { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1, NULL, '^')); } 
	
	| lhs_real OPR_PLS expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1,$3, '!'));} 
	| lhs_real OPR_MNS expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1,$3, '@'));} 
	| lhs_real OPR_MUL expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1,$3, '#'));} 
	| lhs_real OPR_DIV expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<realnum>($1,$3, '$'));} 
			
	| lhs_real '=' stmt_asg_real 
		{
			LeftHandSide<realnum> *pLHS = dynamic_cast<AssignmentLHS<realnum>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<realnum>($1, pLHS)); $$ = $3; 
		}
	| lhs_real OPR_PLS stmt_asg_real 
		{
			LeftHandSide<realnum> *pLHS = dynamic_cast<AssignmentLHS<realnum>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<realnum>($1, pLHS, '!')); $$ = $3; 
		}
	| lhs_real OPR_MNS stmt_asg_real 
		{
			LeftHandSide<realnum> *pLHS = dynamic_cast<AssignmentLHS<realnum>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<realnum>($1, pLHS, '@')); $$ = $3; 
		}
	| lhs_real OPR_MUL stmt_asg_real 
		{
			LeftHandSide<realnum> *pLHS = dynamic_cast<AssignmentLHS<realnum>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<realnum>($1, pLHS, '#')); $$ = $3; 
		}
	| lhs_real OPR_DIV stmt_asg_real 
		{
			LeftHandSide<realnum> *pLHS = dynamic_cast<AssignmentLHS<realnum>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<realnum>($1, pLHS, '$')); $$ = $3; 
		}
	;
	
stmt_asg_cplx:
	  lhs_cplx '=' expr_cplx { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Complex>($1,$3));}
	| lhs_cplx '=' expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Complex>($1, gGC.GetR2C($3)));}
	
	| lhs_cplx OPR_PLS expr_cplx { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Complex>($1,$3, '!'));} 
	| lhs_cplx OPR_MNS expr_cplx { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Complex>($1,$3, '@'));} 
	| lhs_cplx OPR_MUL expr_cplx { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Complex>($1,$3, '#'));} 
	| lhs_cplx OPR_DIV expr_cplx { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Complex>($1,$3, '$'));} 
	
	| lhs_cplx OPR_PLS expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignCplx<Complex>($1, $3, '!'));} 
	| lhs_cplx OPR_MNS expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignCplx<Complex>($1, $3, '@'));} 
	| lhs_cplx OPR_MUL expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignCplx<Complex>($1, $3, '#'));} 
	| lhs_cplx OPR_DIV expr_rnum { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignCplx<Complex>($1, $3, '$'));} 
	
	| lhs_cplx '=' stmt_asg_cplx 
		{
			LeftHandSide<Complex> *pLHS = dynamic_cast<AssignmentLHS<Complex>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<Complex>($1, pLHS)); $$ = $3; 
		}
	| lhs_cplx OPR_PLS stmt_asg_cplx
		{
			LeftHandSide<Complex> *pLHS = dynamic_cast<AssignmentLHS<Complex>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<Complex>($1, pLHS, '!')); $$ = $3; 
		}
	| lhs_cplx OPR_MNS stmt_asg_cplx 
		{
			LeftHandSide<Complex> *pLHS = dynamic_cast<AssignmentLHS<Complex>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<Complex>($1, pLHS, '@')); $$ = $3; 
		}
	| lhs_cplx OPR_MUL stmt_asg_cplx 
		{
			LeftHandSide<Complex> *pLHS = dynamic_cast<AssignmentLHS<Complex>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<Complex>($1, pLHS, '#')); $$ = $3; 
		}
	| lhs_cplx OPR_DIV stmt_asg_cplx 
		{
			LeftHandSide<Complex> *pLHS = dynamic_cast<AssignmentLHS<Complex>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<Complex>($1, pLHS, '$')); $$ = $3; 
		}
	;
	
stmt_asg_vctr:
	  lhs_vctr '=' expr_vctr { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Vector>($1,$3)); }
	
	| lhs_vctr OPR_PLS expr_vctr { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Vector>($1, $3, '!'));} 
	| lhs_vctr OPR_MNS expr_vctr { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Vector>($1, $3, '@'));} 
	| lhs_vctr OPR_CRS expr_vctr { $$=gGC.GetStmtList(); $$->stmttype=StmtAslt; $$->Add(gGC.GetAssignmentLHS<Vector>($1, $3, '%'));} 
	
	| lhs_vctr '=' stmt_asg_vctr
		{
			LeftHandSide<Vector> *pLHS = dynamic_cast<AssignmentLHS<Vector>*>($3->GetLastStmt())->GetLHS();  	
			$3->Add(gGC.GetAssignmentLHS<Vector>($1, pLHS)); $$ = $3; 
		}
	
	;
	
	
assignment: 
      stmt_asg_bool { $$ = dynamic_cast<Statement*>($1); }
	| stmt_asg_strn { $$ = dynamic_cast<Statement*>($1); }
	| stmt_asg_intg { $$ = dynamic_cast<Statement*>($1); }
	| stmt_asg_real { $$ = dynamic_cast<Statement*>($1); }
	| stmt_asg_cplx { $$ = dynamic_cast<Statement*>($1); }
	| stmt_asg_vctr { $$ = dynamic_cast<Statement*>($1); }
	
	| lhs_intg OPR_XPR	expr_inum	{ $$ = gGC.GetAssignmentLHS<integer>($1, $3, '&'); }
	| lhs_real OPR_XPR	expr_rnum	{ $$ = gGC.GetAssignmentLHS<realnum>($1, $3, '&'); }
	| lhs_cplx OPR_XPR	expr_cplx	{ $$ = gGC.GetAssignmentLHS<Complex>($1, $3, '&'); }
	| lhs_vctr OPR_XPR	expr_vctr	{ $$ = gGC.GetAssignmentLHS<Vector> ($1, $3, '&'); }
			
	| lhs_user '=' expr_user
		{	
			LeftHandSide<UserData> *pRHS = dynamic_cast<LeftHandSide<UserData>*>($3);
			CallFunc<UserData>* pCallFunc = dynamic_cast<CallFunc<UserData>*>($3);
			bool okay = false;
			
			if(pRHS) 
			{
				if($1->IsCompatible(pRHS)) okay=true;
			}
			else if(pCallFunc && pCallFunc->GetFunPtr()->pUDTFactory)
			{
				if($1->IsCompatible(pCallFunc->GetFunPtr()->pUDTFactory)) okay=true;
			}
			
			if(okay==false) 
				HandleSyntaxError(_T("Failed to check user defined data types.\r\n"));  
			
			$$=gGC.GetAssignExpUser($1, $3); gUdtFactoryStack.clear(); 
		}
		
	| assign_ptr      { $$ = $1; }
	| assign_array    { $$ = $1; }	
	;

assign_array: 
	  lhs_i1d '=' expr_i1d { $$ = gGC.GetAssignmentArrayLHS<IntgVec1D>($1, $3); }
	| lhs_r1d '=' expr_r1d { $$ = gGC.GetAssignmentArrayLHS<RealVec1D>($1, $3); }
	| lhs_c1d '=' expr_c1d { $$ = gGC.GetAssignmentArrayLHS<CplxVec1D>($1, $3); }
	| lhs_v1d '=' expr_v1d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec1D>($1, $3); }
	
	| lhs_i2d '=' expr_i2d { $$ = gGC.GetAssignmentArrayLHS<IntgVec2D>($1, $3); }
	| lhs_r2d '=' expr_r2d { $$ = gGC.GetAssignmentArrayLHS<RealVec2D>($1, $3); }
	| lhs_c2d '=' expr_c2d { $$ = gGC.GetAssignmentArrayLHS<CplxVec2D>($1, $3); }
	| lhs_v2d '=' expr_v2d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec2D>($1, $3); }
	
	| lhs_i3d '=' expr_i3d { $$ = gGC.GetAssignmentArrayLHS<IntgVec3D>($1, $3); }
	| lhs_r3d '=' expr_r3d { $$ = gGC.GetAssignmentArrayLHS<RealVec3D>($1, $3); }
	| lhs_c3d '=' expr_c3d { $$ = gGC.GetAssignmentArrayLHS<CplxVec3D>($1, $3); }
	| lhs_v3d '=' expr_v3d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec3D>($1, $3); }
	
	| lhs_i4d '=' expr_i4d { $$ = gGC.GetAssignmentArrayLHS<IntgVec4D>($1, $3); }
	| lhs_r4d '=' expr_r4d { $$ = gGC.GetAssignmentArrayLHS<RealVec4D>($1, $3); }
	| lhs_c4d '=' expr_c4d { $$ = gGC.GetAssignmentArrayLHS<CplxVec4D>($1, $3); }
	| lhs_v4d '=' expr_v4d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec4D>($1, $3); }
	
	| lhs_i5d '=' expr_i5d { $$ = gGC.GetAssignmentArrayLHS<IntgVec5D>($1, $3); }
	| lhs_r5d '=' expr_r5d { $$ = gGC.GetAssignmentArrayLHS<RealVec5D>($1, $3); }
	| lhs_c5d '=' expr_c5d { $$ = gGC.GetAssignmentArrayLHS<CplxVec5D>($1, $3); }
	| lhs_v5d '=' expr_v5d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec5D>($1, $3); }
		
	| lhs_i1d OPR_PLS expr_i1d { $$ = gGC.GetAssignmentArrayLHS<IntgVec1D>($1, $3, '!'); }
	| lhs_r1d OPR_PLS expr_r1d { $$ = gGC.GetAssignmentArrayLHS<RealVec1D>($1, $3, '!'); }
	| lhs_c1d OPR_PLS expr_c1d { $$ = gGC.GetAssignmentArrayLHS<CplxVec1D>($1, $3, '!'); }
	| lhs_v1d OPR_PLS expr_v1d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec1D>($1, $3, '!'); }
	
	| lhs_i2d OPR_PLS expr_i2d { $$ = gGC.GetAssignmentArrayLHS<IntgVec2D>($1, $3, '!'); }
	| lhs_r2d OPR_PLS expr_r2d { $$ = gGC.GetAssignmentArrayLHS<RealVec2D>($1, $3, '!'); }
	| lhs_c2d OPR_PLS expr_c2d { $$ = gGC.GetAssignmentArrayLHS<CplxVec2D>($1, $3, '!'); }
	| lhs_v2d OPR_PLS expr_v2d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec2D>($1, $3, '!'); }
	
	| lhs_i3d OPR_PLS expr_i3d { $$ = gGC.GetAssignmentArrayLHS<IntgVec3D>($1, $3, '!'); }
	| lhs_r3d OPR_PLS expr_r3d { $$ = gGC.GetAssignmentArrayLHS<RealVec3D>($1, $3, '!'); }
	| lhs_c3d OPR_PLS expr_c3d { $$ = gGC.GetAssignmentArrayLHS<CplxVec3D>($1, $3, '!'); }
	| lhs_v3d OPR_PLS expr_v3d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec3D>($1, $3, '!'); }
	
	| lhs_i4d OPR_PLS expr_i4d { $$ = gGC.GetAssignmentArrayLHS<IntgVec4D>($1, $3, '!'); }
	| lhs_r4d OPR_PLS expr_r4d { $$ = gGC.GetAssignmentArrayLHS<RealVec4D>($1, $3, '!'); }
	| lhs_c4d OPR_PLS expr_c4d { $$ = gGC.GetAssignmentArrayLHS<CplxVec4D>($1, $3, '!'); }
	| lhs_v4d OPR_PLS expr_v4d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec4D>($1, $3, '!'); }
	
	| lhs_i5d OPR_PLS expr_i5d { $$ = gGC.GetAssignmentArrayLHS<IntgVec5D>($1, $3, '!'); }
	| lhs_r5d OPR_PLS expr_r5d { $$ = gGC.GetAssignmentArrayLHS<RealVec5D>($1, $3, '!'); }
	| lhs_c5d OPR_PLS expr_c5d { $$ = gGC.GetAssignmentArrayLHS<CplxVec5D>($1, $3, '!'); }
	| lhs_v5d OPR_PLS expr_v5d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec5D>($1, $3, '!'); }
		
	| lhs_i1d OPR_MNS expr_i1d { $$ = gGC.GetAssignmentArrayLHS<IntgVec1D>($1, $3, '@'); }
	| lhs_r1d OPR_MNS expr_r1d { $$ = gGC.GetAssignmentArrayLHS<RealVec1D>($1, $3, '@'); }
	| lhs_c1d OPR_MNS expr_c1d { $$ = gGC.GetAssignmentArrayLHS<CplxVec1D>($1, $3, '@'); }
	| lhs_v1d OPR_MNS expr_v1d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec1D>($1, $3, '@'); }
	
	| lhs_i2d OPR_MNS expr_i2d { $$ = gGC.GetAssignmentArrayLHS<IntgVec2D>($1, $3, '@'); }
	| lhs_r2d OPR_MNS expr_r2d { $$ = gGC.GetAssignmentArrayLHS<RealVec2D>($1, $3, '@'); }
	| lhs_c2d OPR_MNS expr_c2d { $$ = gGC.GetAssignmentArrayLHS<CplxVec2D>($1, $3, '@'); }
	| lhs_v2d OPR_MNS expr_v2d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec2D>($1, $3, '@'); }
	
	| lhs_i3d OPR_MNS expr_i3d { $$ = gGC.GetAssignmentArrayLHS<IntgVec3D>($1, $3, '@'); }
	| lhs_r3d OPR_MNS expr_r3d { $$ = gGC.GetAssignmentArrayLHS<RealVec3D>($1, $3, '@'); }
	| lhs_c3d OPR_MNS expr_c3d { $$ = gGC.GetAssignmentArrayLHS<CplxVec3D>($1, $3, '@'); }
	| lhs_v3d OPR_MNS expr_v3d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec3D>($1, $3, '@'); }
	
	| lhs_i4d OPR_MNS expr_i4d { $$ = gGC.GetAssignmentArrayLHS<IntgVec4D>($1, $3, '@'); }
	| lhs_r4d OPR_MNS expr_r4d { $$ = gGC.GetAssignmentArrayLHS<RealVec4D>($1, $3, '@'); }
	| lhs_c4d OPR_MNS expr_c4d { $$ = gGC.GetAssignmentArrayLHS<CplxVec4D>($1, $3, '@'); }
	| lhs_v4d OPR_MNS expr_v4d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec4D>($1, $3, '@'); }
	
	| lhs_i5d OPR_MNS expr_i5d { $$ = gGC.GetAssignmentArrayLHS<IntgVec5D>($1, $3, '@'); }
	| lhs_r5d OPR_MNS expr_r5d { $$ = gGC.GetAssignmentArrayLHS<RealVec5D>($1, $3, '@'); }
	| lhs_c5d OPR_MNS expr_c5d { $$ = gGC.GetAssignmentArrayLHS<CplxVec5D>($1, $3, '@'); }
	| lhs_v5d OPR_MNS expr_v5d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec5D>($1, $3, '@'); }
		
	| lhs_i1d OPR_MUL expr_i1d { $$ = gGC.GetAssignmentArrayLHS<IntgVec1D>($1, $3, '#'); }
	| lhs_r1d OPR_MUL expr_r1d { $$ = gGC.GetAssignmentArrayLHS<RealVec1D>($1, $3, '#'); }
	| lhs_c1d OPR_MUL expr_c1d { $$ = gGC.GetAssignmentArrayLHS<CplxVec1D>($1, $3, '#'); }
	| lhs_v1d OPR_CRS expr_v1d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec1D>($1, $3, '%'); }
	
	| lhs_i2d OPR_MUL expr_i2d { $$ = gGC.GetAssignmentArrayLHS<IntgVec2D>($1, $3, '#'); }
	| lhs_r2d OPR_MUL expr_r2d { $$ = gGC.GetAssignmentArrayLHS<RealVec2D>($1, $3, '#'); }
	| lhs_c2d OPR_MUL expr_c2d { $$ = gGC.GetAssignmentArrayLHS<CplxVec2D>($1, $3, '#'); }
	| lhs_v2d OPR_CRS expr_v2d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec2D>($1, $3, '%'); }
	
	| lhs_i3d OPR_MUL expr_i3d { $$ = gGC.GetAssignmentArrayLHS<IntgVec3D>($1, $3, '#'); }
	| lhs_r3d OPR_MUL expr_r3d { $$ = gGC.GetAssignmentArrayLHS<RealVec3D>($1, $3, '#'); }
	| lhs_c3d OPR_MUL expr_c3d { $$ = gGC.GetAssignmentArrayLHS<CplxVec3D>($1, $3, '#'); }
	| lhs_v3d OPR_CRS expr_v3d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec3D>($1, $3, '%'); }
	
	| lhs_i4d OPR_MUL expr_i4d { $$ = gGC.GetAssignmentArrayLHS<IntgVec4D>($1, $3, '#'); }
	| lhs_r4d OPR_MUL expr_r4d { $$ = gGC.GetAssignmentArrayLHS<RealVec4D>($1, $3, '#'); }
	| lhs_c4d OPR_MUL expr_c4d { $$ = gGC.GetAssignmentArrayLHS<CplxVec4D>($1, $3, '#'); }
	| lhs_v4d OPR_CRS expr_v4d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec4D>($1, $3, '%'); }
	
	| lhs_i5d OPR_MUL expr_i5d { $$ = gGC.GetAssignmentArrayLHS<IntgVec5D>($1, $3, '#'); }
	| lhs_r5d OPR_MUL expr_r5d { $$ = gGC.GetAssignmentArrayLHS<RealVec5D>($1, $3, '#'); }
	| lhs_c5d OPR_MUL expr_c5d { $$ = gGC.GetAssignmentArrayLHS<CplxVec5D>($1, $3, '#'); }
	| lhs_v5d OPR_CRS expr_v5d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec5D>($1, $3, '%'); }
		
	| lhs_i1d OPR_DIV expr_i1d { $$ = gGC.GetAssignmentArrayLHS<IntgVec1D>($1, $3, '$'); }
	| lhs_r1d OPR_DIV expr_r1d { $$ = gGC.GetAssignmentArrayLHS<RealVec1D>($1, $3, '$'); }
	| lhs_c1d OPR_DIV expr_c1d { $$ = gGC.GetAssignmentArrayLHS<CplxVec1D>($1, $3, '$'); }
		
	| lhs_i2d OPR_DIV expr_i2d { $$ = gGC.GetAssignmentArrayLHS<IntgVec2D>($1, $3, '$'); }
	| lhs_r2d OPR_DIV expr_r2d { $$ = gGC.GetAssignmentArrayLHS<RealVec2D>($1, $3, '$'); }
	| lhs_c2d OPR_DIV expr_c2d { $$ = gGC.GetAssignmentArrayLHS<CplxVec2D>($1, $3, '$'); }
	
	| lhs_i3d OPR_DIV expr_i3d { $$ = gGC.GetAssignmentArrayLHS<IntgVec3D>($1, $3, '$'); }
	| lhs_r3d OPR_DIV expr_r3d { $$ = gGC.GetAssignmentArrayLHS<RealVec3D>($1, $3, '$'); }
	| lhs_c3d OPR_DIV expr_c3d { $$ = gGC.GetAssignmentArrayLHS<CplxVec3D>($1, $3, '$'); }
		
	| lhs_i4d OPR_DIV expr_i4d { $$ = gGC.GetAssignmentArrayLHS<IntgVec4D>($1, $3, '$'); }
	| lhs_r4d OPR_DIV expr_r4d { $$ = gGC.GetAssignmentArrayLHS<RealVec4D>($1, $3, '$'); }
	| lhs_c4d OPR_DIV expr_c4d { $$ = gGC.GetAssignmentArrayLHS<CplxVec4D>($1, $3, '$'); }
		
	| lhs_i5d OPR_DIV expr_i5d { $$ = gGC.GetAssignmentArrayLHS<IntgVec5D>($1, $3, '$'); }
	| lhs_r5d OPR_DIV expr_r5d { $$ = gGC.GetAssignmentArrayLHS<RealVec5D>($1, $3, '$'); }
	| lhs_c5d OPR_DIV expr_c5d { $$ = gGC.GetAssignmentArrayLHS<CplxVec5D>($1, $3, '$'); }
			
	| lhs_i1d '=' ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i2d '=' ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i3d '=' ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i4d '=' ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i5d '=' ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	
	| lhs_r1d '=' ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r2d '=' ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r3d '=' ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r4d '=' ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r5d '=' ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	
	| lhs_c1d '=' ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c2d '=' ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c3d '=' ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c4d '=' ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c5d '=' ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	
	| lhs_v1d '=' ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v2d '=' ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v3d '=' ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v4d '=' ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v5d '=' ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
		
	| lhs_i1d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i2d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i3d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i4d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_i5d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	
	| lhs_r1d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r2d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r3d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r4d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_r5d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	
	| lhs_c1d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c2d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c3d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c4d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_c5d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	
	| lhs_v1d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v2d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v3d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v4d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 
	| lhs_v5d OPR_XPR ARY_OPEN { PreArrayInit($1, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit(); } 	
	;

idx_range: 
      expr_inum	'~' { $$ = gGC.GetRange($1,   NULL); }
	| '~' expr_inum { $$ = gGC.GetRange(NULL, $2);   }
	| expr_inum '~' expr_inum { $$ = gGC.GetRange($1, $3); }
	
lhs_i1d: ARY_INTG1D { $$ = gGC.GetVaArray<IntgVec1D, Array1D<integer> >($1); } 
	|	expr_vai1d  { $$ = gGC.GetVarUserAry<IntgVec1D, IntgAry1D>($1); }
	|	expr_vmi1d  { $$ = gGC.GetVarMemAry <IntgVec1D, IntgAry1D>($1); }
	| '*' PTR_AP1I %prec UNARY { $$ = gGC.GetExprAptr<IntgVec1D>($2); }
	;
	
lhs_r1d: ARY_REAL1D { $$ = gGC.GetVaArray<RealVec1D, Array1D<realnum> >($1); } 
	|	expr_var1d  { $$ = gGC.GetVarUserAry<RealVec1D, RealAry1D>($1); }
	|	expr_vmr1d  { $$ = gGC.GetVarMemAry <RealVec1D, RealAry1D>($1); }
	| '*' PTR_AP1R %prec UNARY { $$ = gGC.GetExprAptr<RealVec1D>($2); }
	;
	
lhs_c1d: ARY_CPLX1D { $$ = gGC.GetVaArray<CplxVec1D, Array1D<Complex> >($1); } 
	|	expr_vac1d  { $$ = gGC.GetVarUserAry<CplxVec1D, CplxAry1D>($1); }
	|	expr_vmc1d  { $$ = gGC.GetVarMemAry <CplxVec1D, CplxAry1D>($1); }
	| '*' PTR_AP1C %prec UNARY { $$ = gGC.GetExprAptr<CplxVec1D>($2); }
	;
	
lhs_v1d: ARY_VCTR1D { $$ = gGC.GetVaArray<VctrVec1D, Array1D<Vector>  >($1); } 
	|	 expr_vav1d  { $$ = gGC.GetVarUserAry<VctrVec1D, VctrAry1D>($1); }
	|	 expr_vmv1d  { $$ = gGC.GetVarMemAry <VctrVec1D, VctrAry1D>($1); }
	| '*' PTR_AP1V %prec UNARY { $$ = gGC.GetExprAptr<VctrVec1D>($2); }
	;
	
lhs_i2d: ARY_INTG2D  { $$ = gGC.GetVaArray   <IntgVec2D, Array2D<integer> >($1); } 
	|	 expr_vai2d  { $$ = gGC.GetVarUserAry<IntgVec2D, IntgAry2D>($1); }
	|	 expr_vmi2d  { $$ = gGC.GetVarMemAry <IntgVec2D, IntgAry2D>($1); }
	| '*' PTR_AP2I %prec UNARY { $$ = gGC.GetExprAptr<IntgVec2D>($2); }
	;
	
lhs_r2d: ARY_REAL2D  { $$ = gGC.GetVaArray   <RealVec2D, Array2D<realnum> >($1); } 
	|	 expr_var2d  { $$ = gGC.GetVarUserAry<RealVec2D, RealAry2D>($1); }
	|	 expr_vmr2d  { $$ = gGC.GetVarMemAry <RealVec2D, RealAry2D>($1); }
	| '*' PTR_AP2R %prec UNARY { $$ = gGC.GetExprAptr<RealVec2D>($2); }
	;
	
lhs_c2d: ARY_CPLX2D  { $$ = gGC.GetVaArray   <CplxVec2D, Array2D<Complex> >($1); } 
	|	 expr_vac2d  { $$ = gGC.GetVarUserAry<CplxVec2D, CplxAry2D>($1); }
	|	 expr_vmc2d  { $$ = gGC.GetVarMemAry <CplxVec2D, CplxAry2D>($1); }
	| '*' PTR_AP2C %prec UNARY { $$ = gGC.GetExprAptr<CplxVec2D>($2); }
	;
	
lhs_v2d: ARY_VCTR2D  { $$ = gGC.GetVaArray   <VctrVec2D, Array2D<Vector>  >($1); } 
	|	 expr_vav2d  { $$ = gGC.GetVarUserAry<VctrVec2D, VctrAry2D>($1); }
	|	 expr_vmv2d  { $$ = gGC.GetVarMemAry <VctrVec2D, VctrAry2D>($1); }
	| '*' PTR_AP2V %prec UNARY { $$ = gGC.GetExprAptr<VctrVec2D>($2); }
	;
	
	
lhs_i3d: ARY_INTG3D  { $$ = gGC.GetVaArray   <IntgVec3D, Array3D<integer> >($1); } 
	|	 expr_vai3d  { $$ = gGC.GetVarUserAry<IntgVec3D, IntgAry3D>($1); }
	|	 expr_vmi3d  { $$ = gGC.GetVarMemAry <IntgVec3D, IntgAry3D>($1); }
	| '*' PTR_AP3I %prec UNARY { $$ = gGC.GetExprAptr<IntgVec3D>($2); }
	;
	
lhs_r3d: ARY_REAL3D  { $$ = gGC.GetVaArray   <RealVec3D, Array3D<realnum> >($1); } 
	|	 expr_var3d  { $$ = gGC.GetVarUserAry<RealVec3D, RealAry3D>($1); }
	|	 expr_vmr3d  { $$ = gGC.GetVarMemAry <RealVec3D, RealAry3D>($1); }
	| '*' PTR_AP3R %prec UNARY { $$ = gGC.GetExprAptr<RealVec3D>($2); }
	;
	
lhs_c3d: ARY_CPLX3D  { $$ = gGC.GetVaArray   <CplxVec3D, Array3D<Complex> >($1); } 
	|	 expr_vac3d  { $$ = gGC.GetVarUserAry<CplxVec3D, CplxAry3D>($1); }
	|	 expr_vmc3d  { $$ = gGC.GetVarMemAry <CplxVec3D, CplxAry3D>($1); }
	| '*' PTR_AP3C %prec UNARY { $$ = gGC.GetExprAptr<CplxVec3D>($2); }
	;
	
lhs_v3d: ARY_VCTR3D  { $$ = gGC.GetVaArray   <VctrVec3D, Array3D<Vector>  >($1); } 
	|	 expr_vav3d  { $$ = gGC.GetVarUserAry<VctrVec3D, VctrAry3D>($1); }
	|	 expr_vmv3d  { $$ = gGC.GetVarMemAry <VctrVec3D, VctrAry3D>($1); }
	| '*' PTR_AP3V %prec UNARY { $$ = gGC.GetExprAptr<VctrVec3D>($2); }
	;
	
lhs_i4d: ARY_INTG4D  { $$ = gGC.GetVaArray   <IntgVec4D, Array4D<integer> >($1); } 
	|	 expr_vai4d  { $$ = gGC.GetVarUserAry<IntgVec4D, IntgAry4D>($1); }
	|	 expr_vmi4d  { $$ = gGC.GetVarMemAry <IntgVec4D, IntgAry4D>($1); }
	| '*' PTR_AP4I %prec UNARY { $$ = gGC.GetExprAptr<IntgVec4D>($2); }
	;
	
lhs_r4d: ARY_REAL4D  { $$ = gGC.GetVaArray   <RealVec4D, Array4D<realnum> >($1); } 
	|	 expr_var4d  { $$ = gGC.GetVarUserAry<RealVec4D, RealAry4D>($1); }
	|	 expr_vmr4d  { $$ = gGC.GetVarMemAry <RealVec4D, RealAry4D>($1); }
	| '*' PTR_AP4R %prec UNARY { $$ = gGC.GetExprAptr<RealVec4D>($2); }
	;
	
lhs_c4d: ARY_CPLX4D  { $$ = gGC.GetVaArray   <CplxVec4D, Array4D<Complex> >($1); } 
	|	 expr_vac4d  { $$ = gGC.GetVarUserAry<CplxVec4D, CplxAry4D>($1); }
	|	 expr_vmc4d  { $$ = gGC.GetVarMemAry <CplxVec4D, CplxAry4D>($1); }
	| '*' PTR_AP4C %prec UNARY { $$ = gGC.GetExprAptr<CplxVec4D>($2); }
	;
	
lhs_v4d: ARY_VCTR4D  { $$ = gGC.GetVaArray   <VctrVec4D, Array4D<Vector>  >($1); } 
	|	 expr_vav4d  { $$ = gGC.GetVarUserAry<VctrVec4D, VctrAry4D>($1); }
	|	 expr_vmv4d  { $$ = gGC.GetVarMemAry <VctrVec4D, VctrAry4D>($1); }
	| '*' PTR_AP4V %prec UNARY { $$ = gGC.GetExprAptr<VctrVec4D>($2); }
	;
	
	
lhs_i5d: ARY_INTG5D  { $$ = gGC.GetVaArray   <IntgVec5D, Array5D<integer> >($1); } 
	|	 expr_vai5d  { $$ = gGC.GetVarUserAry<IntgVec5D, IntgAry5D>($1); }
	|	 expr_vmi5d  { $$ = gGC.GetVarMemAry <IntgVec5D, IntgAry5D>($1); }
	| '*' PTR_AP5I %prec UNARY { $$ = gGC.GetExprAptr<IntgVec5D>($2); }
	;
	
lhs_r5d: ARY_REAL5D  { $$ = gGC.GetVaArray   <RealVec5D, Array5D<realnum> >($1); } 
	|	 expr_var5d  { $$ = gGC.GetVarUserAry<RealVec5D, RealAry5D>($1); }
	|	 expr_vmr5d  { $$ = gGC.GetVarMemAry <RealVec5D, RealAry5D>($1); }
	| '*' PTR_AP5R %prec UNARY { $$ = gGC.GetExprAptr<RealVec5D>($2); }
	;
	
lhs_c5d: ARY_CPLX5D  { $$ = gGC.GetVaArray   <CplxVec5D, Array5D<Complex> >($1); } 
	|	 expr_vac5d  { $$ = gGC.GetVarUserAry<CplxVec5D, CplxAry5D>($1); }
	|	 expr_vmc5d  { $$ = gGC.GetVarMemAry <CplxVec5D, CplxAry5D>($1); }
	| '*' PTR_AP5C %prec UNARY { $$ = gGC.GetExprAptr<CplxVec5D>($2); }
	;
	
lhs_v5d: ARY_VCTR5D  { $$ = gGC.GetVaArray   <VctrVec5D, Array5D<Vector>  >($1); } 
	|	 expr_vav5d  { $$ = gGC.GetVarUserAry<VctrVec5D, VctrAry5D>($1); }
	|	 expr_vmv5d  { $$ = gGC.GetVarMemAry <VctrVec5D, VctrAry5D>($1); }
	| '*' PTR_AP5V %prec UNARY { $$ = gGC.GetExprAptr<VctrVec5D>($2); }
	;
	
expr_i1d: lhs_i1d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ai1d arguments ')' 
		{
			CallFunc<IntgVec1D>* ptr
					= dynamic_cast<CallFunc<IntgVec1D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_i1d '(' ')' { $$ = gGC.GetCallExprVec<IntgVec1D>($1); }
	| lhs_i1d '(' for_update ')' { $$ = gGC.GetCallExprVec<IntgVec1D>($1, $3); }
	      
	| '(' expr_i1d ')' { $$= $2; }
	
	| expr_boolean '?' expr_i1d ':' expr_i1d
		{ $$ = gGC.GetExprWhich<IntgVec1D>($1, $3, $5); }
	
	| '~' expr_i1d ARY_OPEN expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<integer, IntgVec1D>($2, $4); }
	| '~' expr_i1d ARY_OPEN idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec1D>($2, $4, true); }
	| '!' expr_i1d ARY_OPEN idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec1D>($2, $4, false); }
		
	| expr_intg '*' expr_i1d  { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '*'); }
	| expr_i1d  '*' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '*'); }
	| expr_intg '+' expr_i1d  { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '+'); }
	| expr_i1d  '+' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '+'); }
	| expr_intg '-' expr_i1d  { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '-'); }
	| expr_i1d  '-' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '-'); }
	| expr_intg '/' expr_i1d  { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '/'); }
	| expr_i1d  '/' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec1D>($1, $3, '/'); }
		
	| expr_i1d '*' expr_i1d { $$ = gGC.GetArrayBin<IntgVec1D>($1, $3, '*'); }
	| expr_i1d '/' expr_i1d { $$ = gGC.GetArrayBin<IntgVec1D>($1, $3, '/'); }
	| expr_i1d '+' expr_i1d { $$ = gGC.GetArrayBin<IntgVec1D>($1, $3, '+'); }
	| expr_i1d '-' expr_i1d { $$ = gGC.GetArrayBin<IntgVec1D>($1, $3, '-'); }
		
	;
	
expr_i2d: lhs_i2d %prec OPR_LOWERTHANDOT { $$ = $1; }
				
	| hdr_ai2d arguments ')' 
		{
			CallFunc<IntgVec2D>* ptr
					= dynamic_cast<CallFunc<IntgVec2D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_i2d '(' ')' { $$ = gGC.GetCallExprVec<IntgVec2D>($1); }
	| lhs_i2d '(' for_update ')' { $$ = gGC.GetCallExprVec<IntgVec2D>($1, $3); }
	
	| expr_boolean '?' expr_i2d ':' expr_i2d 
		{ $$ = gGC.GetExprWhich<IntgVec2D>($1, $3, $5); }
	
	| '(' expr_i2d ')' { $$= $2; }
	
	| '~' expr_i2d ARY_OPEN expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<integer, IntgVec2D>($2, $4, $6); }
	| '~' expr_i2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE
		{ $$ = gGC.GetClsSubArray<integer, IntgVec2D>($2, $4, $6, true); }
	| '!' expr_i2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec2D>($2, $4, $6, false); }
	
	| expr_intg '*' expr_i2d  { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '*'); }
	| expr_i2d  '*' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '*'); }
	| expr_intg '+' expr_i2d  { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '+'); }
	| expr_i2d  '+' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '+'); }
	| expr_intg '-' expr_i2d  { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '-'); }
	| expr_i2d  '-' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '-'); }
	| expr_intg '/' expr_i2d  { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '/'); }
	| expr_i2d  '/' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec2D>($1, $3, '/'); }
		
	| expr_i2d '*' expr_i2d { $$ = gGC.GetArrayBin<IntgVec2D>($1, $3, '*'); }
	| expr_i2d '/' expr_i2d { $$ = gGC.GetArrayBin<IntgVec2D>($1, $3, '/'); }
	| expr_i2d '+' expr_i2d { $$ = gGC.GetArrayBin<IntgVec2D>($1, $3, '+'); }
	| expr_i2d '-' expr_i2d { $$ = gGC.GetArrayBin<IntgVec2D>($1, $3, '-'); }
	;

expr_i3d: lhs_i3d %prec OPR_LOWERTHANDOT { $$ = $1; }
				
	| hdr_ai3d arguments ')' 
		{
			CallFunc<IntgVec3D>* ptr
					= dynamic_cast<CallFunc<IntgVec3D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_i3d '(' ')' { $$ = gGC.GetCallExprVec<IntgVec3D>($1); }
	| lhs_i3d '(' for_update ')' { $$ = gGC.GetCallExprVec<IntgVec3D>($1, $3); }
	
	| expr_boolean '?' expr_i3d ':' expr_i3d
		{ $$ = gGC.GetExprWhich<IntgVec3D>($1, $3, $5); }
			
	| '(' expr_i3d ')' { $$= $2; }
		
	| '~' expr_i3d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<integer, IntgVec3D>($2, $4, $6, $8); }
	| '~' expr_i3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec3D>($2, $4, $6, $8, true); }
	| '!' expr_i3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec3D>($2, $4, $6, $8, false); }
	
	| expr_intg '*' expr_i3d  { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '*'); }
	| expr_i3d  '*' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '*'); }
	| expr_intg '+' expr_i3d  { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '+'); }
	| expr_i3d  '+' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '+'); }
	| expr_intg '-' expr_i3d  { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '-'); }
	| expr_i3d  '-' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '-'); }
	| expr_intg '/' expr_i3d  { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '/'); }
	| expr_i3d  '/' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec3D>($1, $3, '/'); }
		
	| expr_i3d '*' expr_i3d { $$ = gGC.GetArrayBin<IntgVec3D>($1, $3, '*'); }
	| expr_i3d '/' expr_i3d { $$ = gGC.GetArrayBin<IntgVec3D>($1, $3, '/'); }
	| expr_i3d '+' expr_i3d { $$ = gGC.GetArrayBin<IntgVec3D>($1, $3, '+'); }
	| expr_i3d '-' expr_i3d { $$ = gGC.GetArrayBin<IntgVec3D>($1, $3, '-'); }
	;

expr_i4d: lhs_i4d %prec OPR_LOWERTHANDOT { $$ = $1; }

	| hdr_ai4d arguments ')' 
		{
			CallFunc<IntgVec4D>* ptr
					= dynamic_cast<CallFunc<IntgVec4D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_i4d '(' ')' { $$ = gGC.GetCallExprVec<IntgVec4D>($1); }
	| lhs_i4d '(' for_update ')' { $$ = gGC.GetCallExprVec<IntgVec4D>($1, $3); }
	
	| expr_boolean '?' expr_i4d ':' expr_i4d
		{ $$ = gGC.GetExprWhich<IntgVec4D>($1, $3, $5); }
		
	| '(' expr_i4d ')' { $$= $2; }
		
	| '~' expr_i4d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<integer, IntgVec4D>($2, $4, $6, $8, $10); }
	| '~' expr_i4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec4D>($2, $4, $6, $8, $10, true); }
	| '!' expr_i4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec4D>($2, $4, $6, $8, $10, false); }
			
	| expr_intg '*' expr_i4d  { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '*'); }
	| expr_i4d  '*' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '*'); }
	| expr_intg '+' expr_i4d  { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '+'); }
	| expr_i4d  '+' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '+'); }
	| expr_intg '-' expr_i4d  { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '-'); }
	| expr_i4d  '-' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '-'); }
	| expr_intg '/' expr_i4d  { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '/'); }
	| expr_i4d  '/' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec4D>($1, $3, '/'); }
		
	| expr_i4d '*' expr_i4d { $$ = gGC.GetArrayBin<IntgVec4D>($1, $3, '*'); }
	| expr_i4d '/' expr_i4d { $$ = gGC.GetArrayBin<IntgVec4D>($1, $3, '/'); }
	| expr_i4d '+' expr_i4d { $$ = gGC.GetArrayBin<IntgVec4D>($1, $3, '+'); }
	| expr_i4d '-' expr_i4d { $$ = gGC.GetArrayBin<IntgVec4D>($1, $3, '-'); }
	;

expr_i5d: lhs_i5d %prec OPR_LOWERTHANDOT { $$ = $1; }

	| hdr_ai5d arguments ')' 
		{
			CallFunc<IntgVec5D>* ptr
					= dynamic_cast<CallFunc<IntgVec5D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_i5d '(' ')' { $$ = gGC.GetCallExprVec<IntgVec5D>($1); }
	| lhs_i5d '(' for_update ')' { $$ = gGC.GetCallExprVec<IntgVec5D>($1, $3); }
	
	| expr_boolean '?' expr_i5d ':' expr_i5d
		{ $$ = gGC.GetExprWhich<IntgVec5D>($1, $3, $5); }
	
	| '(' expr_i5d ')' { $$= $2; }
		
	| '~' expr_i5d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<integer, IntgVec5D>($2, $4, $6, $8, $10, $12); }
	| '~' expr_i5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec5D>($2, $4, $6, $8, $10, $12, true); }
	| '!' expr_i5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<integer, IntgVec5D>($2, $4, $6, $8, $10, $12, false); }
			
	| expr_intg '*' expr_i5d  { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '*'); }
	| expr_i5d  '*' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '*'); }
	| expr_intg '+' expr_i5d  { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '+'); }
	| expr_i5d  '+' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '+'); }
	| expr_intg '-' expr_i5d  { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '-'); }
	| expr_i5d  '-' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '-'); }
	| expr_intg '/' expr_i5d  { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '/'); }
	| expr_i5d  '/' expr_intg { $$ = gGC.GetVaAryBin<integer, IntgVec5D>($1, $3, '/'); }
		
	| expr_i5d '*' expr_i5d { $$ = gGC.GetArrayBin<IntgVec5D>($1, $3, '*'); }
	| expr_i5d '/' expr_i5d { $$ = gGC.GetArrayBin<IntgVec5D>($1, $3, '/'); }
	| expr_i5d '+' expr_i5d { $$ = gGC.GetArrayBin<IntgVec5D>($1, $3, '+'); }
	| expr_i5d '-' expr_i5d { $$ = gGC.GetArrayBin<IntgVec5D>($1, $3, '-'); }
	;

expr_r1d: lhs_r1d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ar1d arguments ')' 
		{
			CallFunc<RealVec1D>* ptr
					= dynamic_cast<CallFunc<RealVec1D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_r1d '(' ')' { $$ = gGC.GetCallExprVec<RealVec1D>($1); }
	| lhs_r1d '(' for_update ')' { $$ = gGC.GetCallExprVec<RealVec1D>($1, $3); }
	
	| expr_boolean '?' expr_r1d ':' expr_r1d
		{ $$ = gGC.GetExprWhich<RealVec1D>($1, $3, $5); }
			
	| '(' expr_r1d ')' { $$= $2; }
	
	| '~' expr_r1d ARY_OPEN expr_inum ARY_CLOSE  
		{ $$ = gGC.GetClsComplement<realnum, RealVec1D>($2, $4); }
	| '~' expr_r1d ARY_OPEN idx_range ARY_CLOSE  
		{ $$ = gGC.GetClsSubArray<realnum, RealVec1D>($2, $4, true); }
	| '!' expr_r1d ARY_OPEN idx_range ARY_CLOSE  
		{ $$ = gGC.GetClsSubArray<realnum, RealVec1D>($2, $4, false); }
		
	| OPR_SOL SOL_SOLVECRAMER expr_r2d { $$ = gGC.GetSolveCramer<realnum, RealVec1D, RealVec2D>($3); }
	
	| OPR_SOL SOL_LUMETHOD expr_r2d { $$ = gGC.GetSolveLUMethod<realnum, RealVec1D, RealVec2D>($3); }
		
	| lhs_real '(' expr_rnum '~' expr_rnum ':' expr_real ')' 
			{ $$ = gGC.GetSolveEquation($1, $3, $5, $7); } 
	
	| lhs_real '(' expr_intg ':' expr_rnum '~' expr_rnum ':' expr_real ')' 
		{ $$ = gGC.GetSolveEquation($1, $5, $7, $9, $3); } 	
	
	| lhs_real '(' expr_real ':' expr_rnum '~' expr_rnum ':' expr_real ')' 
		{ $$ = gGC.GetSolveEquation($1, $5, $7, $9, $3); } 
	
	| lhs_real '(' expr_intg ',' expr_real ':' expr_rnum '~' expr_rnum ':' expr_real ')' 
		{ $$ = gGC.GetSolveEquation($1, $7, $9, $11, $3, $5); } 
		
	| lhs_real '(' expr_real ',' expr_intg ':' expr_rnum '~' expr_rnum ':' expr_real ')' 
		{ $$ = gGC.GetSolveEquation($1, $7, $9, $11, $3, $5); } 
		
	| lhs_real '[' expr_rnum '~' expr_rnum ':' expr_real ']' 
			{ $$ = gGC.GetSolveExtrema($1, $3, $5, $7); } 
	
	| lhs_real '[' expr_intg ':' expr_rnum '~' expr_rnum ':' expr_real ']' 
		{ $$ = gGC.GetSolveExtrema($1, $5, $7, $9, $3); } 	
	
	| lhs_real '[' expr_real ':' expr_rnum '~' expr_rnum ':' expr_real ']' 
		{ $$ = gGC.GetSolveExtrema($1, $5, $7, $9, $3); } 
	
	| lhs_real '[' expr_intg ',' expr_real ':' expr_rnum '~' expr_rnum ':' expr_real ']' 
		{ $$ = gGC.GetSolveExtrema($1, $7, $9, $11, $3, $5); } 
		
	| lhs_real '[' expr_real ',' expr_intg ':' expr_rnum '~' expr_rnum ':' expr_real ']' 
		{ $$ = gGC.GetSolveExtrema($1, $7, $9, $11, $3, $5); } 
	
	| expr_real '*' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '*'); }
	| expr_r1d  '*' expr_real { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '*'); }
	| expr_real '+' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '+'); }
	| expr_r1d  '+' expr_real { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '+'); }
	| expr_real '-' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '-'); }
	| expr_r1d  '-' expr_real { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '-'); }
	| expr_real '/' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '/'); }
	| expr_r1d  '/' expr_real { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, $3, '/'); }
		
	| expr_intg '*' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>(gGC.GetI2R($1), $3, '*'); }
	| expr_r1d  '*' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, gGC.GetI2R($3), '*'); }
	| expr_intg '+' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>(gGC.GetI2R($1), $3, '+'); }
	| expr_r1d  '+' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, gGC.GetI2R($3), '+'); }
	| expr_intg '-' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>(gGC.GetI2R($1), $3, '-'); }
	| expr_r1d  '-' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, gGC.GetI2R($3), '-'); }
	| expr_intg '/' expr_r1d  { $$ = gGC.GetVaAryBin<double, RealVec1D>(gGC.GetI2R($1), $3, '/'); }
	| expr_r1d  '/' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec1D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_r1d '*' expr_r1d { $$ = gGC.GetArrayBin<RealVec1D>($1, $3, '*'); }
	| expr_r1d '/' expr_r1d { $$ = gGC.GetArrayBin<RealVec1D>($1, $3, '/'); }
	| expr_r1d '+' expr_r1d { $$ = gGC.GetArrayBin<RealVec1D>($1, $3, '+'); }
	| expr_r1d '-' expr_r1d { $$ = gGC.GetArrayBin<RealVec1D>($1, $3, '-'); }
	
	| expr_v1d  '*' expr_v1d  { $$ = gGC.GetDotProduct <RealVec1D, VctrVec1D>($1, $3); }
	| expr_v1d  '*' expr_vctr { $$ = gGC.GetSDotProduct<RealVec1D, VctrVec1D>($1, $3); }
	| expr_vctr '*' expr_v1d  { $$ = gGC.GetSDotProduct<RealVec1D, VctrVec1D>($1, $3); }
	;
	
expr_r2d: lhs_r2d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ar2d arguments ')' 
		{
			CallFunc<RealVec2D>* ptr
					= dynamic_cast<CallFunc<RealVec2D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_r2d '(' ')' { $$ = gGC.GetCallExprVec<RealVec2D>($1); }
	| lhs_r2d '(' for_update ')' { $$ = gGC.GetCallExprVec<RealVec2D>($1, $3); }
	
	| expr_boolean '?' expr_r2d ':' expr_r2d
		{ $$ = gGC.GetExprWhich<RealVec2D>($1, $3, $5); }
	
	| '(' expr_r2d ')' { $$= $2; }
		
	| '~' expr_r2d ARY_OPEN expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<realnum, RealVec2D>($2, $4, $6); }
	| '~' expr_r2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec2D>($2, $4, $6, true); }
	| '!' expr_r2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec2D>($2, $4, $6, false); }
	
	| OPR_SOL SOL_GAUSSJORDAN expr_r2d { $$ = gGC.GetSolveGaussJordan<realnum, RealVec2D>($3); } 
	
	| OPR_SOL SOL_LUDECOMPO expr_r2d ARY_REAL2D 
			{ $$ = gGC.GetSolveLUDecompo<realnum, RealVec2D, Array2D<realnum> >($3, $4); }
			
	| OPR_SOL SOL_INVERSE expr_r2d 
			{ $$ = gGC.GetSolveInverse<realnum, RealVec2D>($3); }
	
	| expr_real '*' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '*'); }
	| expr_r2d  '*' expr_real { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '*'); }
	| expr_real '+' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '+'); }
	| expr_r2d  '+' expr_real { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '+'); }
	| expr_real '-' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '-'); }
	| expr_r2d  '-' expr_real { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '-'); }
	| expr_real '/' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '/'); }
	| expr_r2d  '/' expr_real { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, $3, '/'); }
		
	| expr_intg '*' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>(gGC.GetI2R($1), $3, '*'); }
	| expr_r2d  '*' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, gGC.GetI2R($3), '*'); }
	| expr_intg '+' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>(gGC.GetI2R($1), $3, '+'); }
	| expr_r2d  '+' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, gGC.GetI2R($3), '+'); }
	| expr_intg '-' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>(gGC.GetI2R($1), $3, '-'); }
	| expr_r2d  '-' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, gGC.GetI2R($3), '-'); }
	| expr_intg '/' expr_r2d  { $$ = gGC.GetVaAryBin<double, RealVec2D>(gGC.GetI2R($1), $3, '/'); }
	| expr_r2d  '/' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec2D>($1, gGC.GetI2R($3), '/'); }
	
	| expr_r2d '*' expr_r2d { $$ = gGC.GetArrayBin<RealVec2D>($1, $3, '*'); }
	| expr_r2d '/' expr_r2d { $$ = gGC.GetArrayBin<RealVec2D>($1, $3, '/'); }
	| expr_r2d '+' expr_r2d { $$ = gGC.GetArrayBin<RealVec2D>($1, $3, '+'); }
	| expr_r2d '-' expr_r2d { $$ = gGC.GetArrayBin<RealVec2D>($1, $3, '-'); }
	| expr_r2d OPR_PRO expr_r2d { $$ = gGC.GetMatrixPro<realnum, RealVec2D>($1, $3); }
	
	| expr_v2d  '*' expr_v2d  { $$ = gGC.GetDotProduct <RealVec2D, VctrVec2D>($1, $3); }
	| expr_v2d  '*' expr_vctr { $$ = gGC.GetSDotProduct<RealVec2D, VctrVec2D>($1, $3); }
	| expr_vctr '*' expr_v2d  { $$ = gGC.GetSDotProduct<RealVec2D, VctrVec2D>($1, $3); }
	;
	
expr_r3d: lhs_r3d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ar3d arguments ')' 
		{
			CallFunc<RealVec3D>* ptr
					= dynamic_cast<CallFunc<RealVec3D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_r3d '(' ')' { $$ = gGC.GetCallExprVec<RealVec3D>($1); }
	| lhs_r3d '(' for_update ')' { $$ = gGC.GetCallExprVec<RealVec3D>($1, $3); }
	
	| expr_boolean '?' expr_r3d ':' expr_r3d
		{ $$ = gGC.GetExprWhich<RealVec3D>($1, $3, $5); }
	
	| '(' expr_r3d ')' { $$= $2; }
		
	| '~' expr_r3d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<realnum, RealVec3D>($2, $4, $6, $8); }
	
	| '~' expr_r3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec3D>($2, $4, $6, $8, true); }
	
	| '!' expr_r3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec3D>($2, $4, $6, $8, false); }
		
	| expr_real '*' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '*'); }
	| expr_r3d  '*' expr_real { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '*'); }
	| expr_real '+' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '+'); }
	| expr_r3d  '+' expr_real { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '+'); }
	| expr_real '-' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '-'); }
	| expr_r3d  '-' expr_real { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '-'); }
	| expr_real '/' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '/'); }
	| expr_r3d  '/' expr_real { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, $3, '/'); }
		
	| expr_intg '*' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>(gGC.GetI2R($1), $3, '*'); }
	| expr_r3d  '*' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, gGC.GetI2R($3), '*'); }
	| expr_intg '+' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>(gGC.GetI2R($1), $3, '+'); }
	| expr_r3d  '+' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, gGC.GetI2R($3), '+'); }
	| expr_intg '-' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>(gGC.GetI2R($1), $3, '-'); }
	| expr_r3d  '-' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, gGC.GetI2R($3), '-'); }
	| expr_intg '/' expr_r3d  { $$ = gGC.GetVaAryBin<double, RealVec3D>(gGC.GetI2R($1), $3, '/'); }
	| expr_r3d  '/' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec3D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_r3d '*' expr_r3d { $$ = gGC.GetArrayBin<RealVec3D>($1, $3, '*'); }
	| expr_r3d '/' expr_r3d { $$ = gGC.GetArrayBin<RealVec3D>($1, $3, '/'); }
	| expr_r3d '+' expr_r3d { $$ = gGC.GetArrayBin<RealVec3D>($1, $3, '+'); }
	| expr_r3d '-' expr_r3d { $$ = gGC.GetArrayBin<RealVec3D>($1, $3, '-'); }
	
	| expr_v3d  '*' expr_v3d  { $$ = gGC.GetDotProduct <RealVec3D, VctrVec3D>($1, $3); }
	| expr_v3d  '*' expr_vctr { $$ = gGC.GetSDotProduct<RealVec3D, VctrVec3D>($1, $3); }
	| expr_vctr '*' expr_v3d  { $$ = gGC.GetSDotProduct<RealVec3D, VctrVec3D>($1, $3); }
	;
	
expr_r4d: lhs_r4d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ar4d arguments ')' 
		{
			CallFunc<RealVec4D>* ptr
					= dynamic_cast<CallFunc<RealVec4D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_r4d '(' ')' { $$ = gGC.GetCallExprVec<RealVec4D>($1); }
	| lhs_r4d '(' for_update ')' { $$ = gGC.GetCallExprVec<RealVec4D>($1, $3); }
				
	| expr_boolean '?' expr_r4d ':' expr_r4d
		{ $$ = gGC.GetExprWhich<RealVec4D>($1, $3, $5); }
			
	| '(' expr_r4d ')' { $$= $2; }
		
	| '~' expr_r4d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<realnum, RealVec4D>($2, $4, $6, $8, $10); }
	| '~' expr_r4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec4D>($2, $4, $6, $8, $10, true); }
	| '!' expr_r4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec4D>($2, $4, $6, $8, $10, false); }
		
	| expr_real '*' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '*'); }
	| expr_r4d  '*' expr_real { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '*'); }
	| expr_real '+' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '+'); }
	| expr_r4d  '+' expr_real { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '+'); }
	| expr_real '-' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '-'); }
	| expr_r4d  '-' expr_real { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '-'); }
	| expr_real '/' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '/'); }
	| expr_r4d  '/' expr_real { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, $3, '/'); }
		
	| expr_intg '*' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>(gGC.GetI2R($1), $3, '*'); }
	| expr_r4d  '*' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, gGC.GetI2R($3), '*'); }
	| expr_intg '+' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>(gGC.GetI2R($1), $3, '+'); }
	| expr_r4d  '+' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, gGC.GetI2R($3), '+'); }
	| expr_intg '-' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>(gGC.GetI2R($1), $3, '-'); }
	| expr_r4d  '-' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, gGC.GetI2R($3), '-'); }
	| expr_intg '/' expr_r4d  { $$ = gGC.GetVaAryBin<double, RealVec4D>(gGC.GetI2R($1), $3, '/'); }
	| expr_r4d  '/' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec4D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_r4d '*' expr_r4d { $$ = gGC.GetArrayBin<RealVec4D>($1, $3, '*'); }
	| expr_r4d '/' expr_r4d { $$ = gGC.GetArrayBin<RealVec4D>($1, $3, '/'); }
	| expr_r4d '+' expr_r4d { $$ = gGC.GetArrayBin<RealVec4D>($1, $3, '+'); }
	| expr_r4d '-' expr_r4d { $$ = gGC.GetArrayBin<RealVec4D>($1, $3, '-'); }
	
	| expr_v4d  '*' expr_v4d  { $$ = gGC.GetDotProduct <RealVec4D, VctrVec4D>($1, $3); }
	| expr_v4d  '*' expr_vctr { $$ = gGC.GetSDotProduct<RealVec4D, VctrVec4D>($1, $3); }
	| expr_vctr '*' expr_v4d  { $$ = gGC.GetSDotProduct<RealVec4D, VctrVec4D>($1, $3); }
	;
	
expr_r5d: lhs_r5d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ar5d arguments ')' 
		{
			CallFunc<RealVec5D>* ptr
					= dynamic_cast<CallFunc<RealVec5D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_r5d '(' ')' { $$ = gGC.GetCallExprVec<RealVec5D>($1); }
	| lhs_r5d '(' for_update ')' { $$ = gGC.GetCallExprVec<RealVec5D>($1, $3); }
				
	| expr_boolean '?' expr_r5d ':' expr_r5d
		{ $$ = gGC.GetExprWhich<RealVec5D>($1, $3, $5); }
	
	| '(' expr_r5d ')' { $$= $2; }
	
	| '~' expr_r5d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<realnum, RealVec5D>($2, $4, $6, $8, $10, $12); }
	
	| '~' expr_r5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<realnum, RealVec5D>($2, $4, $6, $8, $10, $12, true); }
	
	| '!' expr_r5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE
		{ $$ = gGC.GetClsSubArray<realnum, RealVec5D>($2, $4, $6, $8, $10, $12, false); } 

	| expr_real '*' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '*'); }
	| expr_r5d  '*' expr_real { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '*'); }
	| expr_real '+' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '+'); }
	| expr_r5d  '+' expr_real { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '+'); }
	| expr_real '-' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '-'); }
	| expr_r5d  '-' expr_real { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '-'); }
	| expr_real '/' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '/'); }
	| expr_r5d  '/' expr_real { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, $3, '/'); }
		
	| expr_intg '*' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>(gGC.GetI2R($1), $3, '*'); }
	| expr_r5d  '*' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, gGC.GetI2R($3), '*'); }
	| expr_intg '+' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>(gGC.GetI2R($1), $3, '+'); }
	| expr_r5d  '+' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, gGC.GetI2R($3), '+'); }
	| expr_intg '-' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>(gGC.GetI2R($1), $3, '-'); }
	| expr_r5d  '-' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, gGC.GetI2R($3), '-'); }
	| expr_intg '/' expr_r5d  { $$ = gGC.GetVaAryBin<double, RealVec5D>(gGC.GetI2R($1), $3, '/'); }
	| expr_r5d  '/' expr_intg { $$ = gGC.GetVaAryBin<double, RealVec5D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_r5d '*' expr_r5d { $$ = gGC.GetArrayBin<RealVec5D>($1, $3, '*'); }
	| expr_r5d '/' expr_r5d { $$ = gGC.GetArrayBin<RealVec5D>($1, $3, '/'); }
	| expr_r5d '+' expr_r5d { $$ = gGC.GetArrayBin<RealVec5D>($1, $3, '+'); }
	| expr_r5d '-' expr_r5d { $$ = gGC.GetArrayBin<RealVec5D>($1, $3, '-'); }
	
	| expr_v5d  '*' expr_v5d  { $$ = gGC.GetDotProduct <RealVec5D, VctrVec5D>($1, $3); }
	| expr_v5d  '*' expr_vctr { $$ = gGC.GetSDotProduct<RealVec5D, VctrVec5D>($1, $3); }
	| expr_vctr '*' expr_v5d  { $$ = gGC.GetSDotProduct<RealVec5D, VctrVec5D>($1, $3); }
	;
	
expr_c1d: lhs_c1d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ac1d arguments ')' 
		{
			CallFunc<CplxVec1D>* ptr
					= dynamic_cast<CallFunc<CplxVec1D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_c1d '(' ')' { $$ = gGC.GetCallExprVec<CplxVec1D>($1); }
	| lhs_c1d '(' for_update ')' { $$ = gGC.GetCallExprVec<CplxVec1D>($1, $3); }
	
	| expr_boolean '?' expr_c1d ':' expr_c1d
		{ $$ = gGC.GetExprWhich<CplxVec1D>($1, $3, $5); }
		
	| '(' expr_c1d ')' { $$= $2; }
		
	| '~' expr_c1d ARY_OPEN expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Complex, CplxVec1D>($2, $4); }
	| '~' expr_c1d ARY_OPEN idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec1D>($2, $4, true); }
	| '!' expr_c1d ARY_OPEN idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec1D>($2, $4, false); }
		
	| OPR_SOL SOL_SOLVECRAMER expr_c2d { $$ = gGC.GetSolveCramer<Complex, CplxVec1D, CplxVec2D>($3); }
	| OPR_SOL SOL_LUMETHOD expr_c2d { $$ = gGC.GetSolveLUMethod<Complex, CplxVec1D, CplxVec2D>($3); }
		
	| expr_cplx '*' expr_c1d  { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '*'); }
	| expr_c1d  '*' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '*'); }
	| expr_cplx '+' expr_c1d  { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '+'); }
	| expr_c1d  '+' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '+'); }
	| expr_cplx '-' expr_c1d  { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '-'); }
	| expr_c1d  '-' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '-'); }
	| expr_cplx '/' expr_c1d  { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '/'); }
	| expr_c1d  '/' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec1D>($1, $3, '/'); }
		
	| expr_c1d '*' expr_c1d { $$ = gGC.GetArrayBin<CplxVec1D>($1, $3, '*'); }
	| expr_c1d '/' expr_c1d { $$ = gGC.GetArrayBin<CplxVec1D>($1, $3, '/'); }
	| expr_c1d '+' expr_c1d { $$ = gGC.GetArrayBin<CplxVec1D>($1, $3, '+'); }
	| expr_c1d '-' expr_c1d { $$ = gGC.GetArrayBin<CplxVec1D>($1, $3, '-'); }
	
	;
	
expr_c2d: lhs_c2d %prec OPR_LOWERTHANDOT { $$ = $1; }

	| hdr_ac2d arguments ')' 
		{
			CallFunc<CplxVec2D>* ptr
					= dynamic_cast<CallFunc<CplxVec2D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_c2d '(' ')' { $$ = gGC.GetCallExprVec<CplxVec2D>($1); }
	| lhs_c2d '(' for_update ')' { $$ = gGC.GetCallExprVec<CplxVec2D>($1, $3); }
	
	| expr_boolean '?' expr_c2d ':' expr_c2d
		{ $$ = gGC.GetExprWhich<CplxVec2D>($1, $3, $5); }
		
	| '(' expr_c2d ')' { $$= $2; }
		
	| '~' expr_c2d ARY_OPEN expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Complex, CplxVec2D>($2, $4, $6); }
	| '~' expr_c2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec2D>($2, $4, $6, true); }
	| '!' expr_c2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec2D>($2, $4, $6, false); }
		
	| OPR_SOL SOL_GAUSSJORDAN expr_c2d { $$ = gGC.GetSolveGaussJordan<Complex, CplxVec2D>($3); } 
	| OPR_SOL SOL_INVERSE expr_c2d 
			{ $$ = gGC.GetSolveInverse<Complex, CplxVec2D>($3); }
			
	| expr_cplx '*' expr_c2d  { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '*'); }
	| expr_c2d  '*' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '*'); }
	| expr_cplx '+' expr_c2d  { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '+'); }
	| expr_c2d  '+' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '+'); }
	| expr_cplx '-' expr_c2d  { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '-'); }
	| expr_c2d  '-' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '-'); }
	| expr_cplx '/' expr_c2d  { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '/'); }
	| expr_c2d  '/' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec2D>($1, $3, '/'); }
		
	| expr_c2d '*' expr_c2d { $$ = gGC.GetArrayBin<CplxVec2D>($1, $3, '*'); }
	| expr_c2d '/' expr_c2d { $$ = gGC.GetArrayBin<CplxVec2D>($1, $3, '/'); }
	| expr_c2d '+' expr_c2d { $$ = gGC.GetArrayBin<CplxVec2D>($1, $3, '+'); }
	| expr_c2d '-' expr_c2d { $$ = gGC.GetArrayBin<CplxVec2D>($1, $3, '-'); }
	| expr_c2d OPR_PRO expr_c2d { $$ = gGC.GetMatrixPro<Complex, CplxVec2D>($1, $3); }
	
	;

expr_c3d: lhs_c3d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ac3d arguments ')' 
		{
			CallFunc<CplxVec3D>* ptr
					= dynamic_cast<CallFunc<CplxVec3D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_c3d '(' ')' { $$ = gGC.GetCallExprVec<CplxVec3D>($1); }
	| lhs_c3d '(' for_update ')' { $$ = gGC.GetCallExprVec<CplxVec3D>($1, $3); }
	
	| expr_boolean '?' expr_c3d ':' expr_c3d
		{ $$ = gGC.GetExprWhich<CplxVec3D>($1, $3, $5); }
		
	| '(' expr_c3d ')' { $$= $2; }
		
	| '~' expr_c3d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Complex, CplxVec3D>($2, $4, $6, $8); }
	| '~' expr_c3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec3D>($2, $4, $6, $8, true); }
	| '!' expr_c3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec3D>($2, $4, $6, $8, false); }
		
	| expr_cplx '*' expr_c3d  { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '*'); }
	| expr_c3d  '*' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '*'); }
	| expr_cplx '+' expr_c3d  { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '+'); }
	| expr_c3d  '+' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '+'); }
	| expr_cplx '-' expr_c3d  { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '-'); }
	| expr_c3d  '-' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '-'); }
	| expr_cplx '/' expr_c3d  { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '/'); }
	| expr_c3d  '/' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec3D>($1, $3, '/'); }
				
	| expr_c3d '*' expr_c3d { $$ = gGC.GetArrayBin<CplxVec3D>($1, $3, '*'); }
	| expr_c3d '/' expr_c3d { $$ = gGC.GetArrayBin<CplxVec3D>($1, $3, '/'); }
	| expr_c3d '+' expr_c3d { $$ = gGC.GetArrayBin<CplxVec3D>($1, $3, '+'); }
	| expr_c3d '-' expr_c3d { $$ = gGC.GetArrayBin<CplxVec3D>($1, $3, '-'); }
	;

expr_c4d: lhs_c4d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ac4d arguments ')' 
		{
			CallFunc<CplxVec4D>* ptr
					= dynamic_cast<CallFunc<CplxVec4D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_c4d '(' ')' { $$ = gGC.GetCallExprVec<CplxVec4D>($1); }
	| lhs_c4d '(' for_update ')' { $$ = gGC.GetCallExprVec<CplxVec4D>($1, $3); }
				
	| expr_boolean '?' expr_c4d ':' expr_c4d
		{ $$ = gGC.GetExprWhich<CplxVec4D>($1, $3, $5); }
		
	| '(' expr_c4d ')' { $$= $2; }
		
	| '~' expr_c4d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Complex, CplxVec4D>($2, $4, $6, $8, $10); }
	| '~' expr_c4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec4D>($2, $4, $6, $8, $10, true); }
	| '!' expr_c4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec4D>($2, $4, $6, $8, $10, false); }
		
	| expr_cplx '*' expr_c4d  { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '*'); }
	| expr_c4d  '*' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '*'); }
	| expr_cplx '+' expr_c4d  { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '+'); }
	| expr_c4d  '+' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '+'); }
	| expr_cplx '-' expr_c4d  { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '-'); }
	| expr_c4d  '-' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '-'); }
	| expr_cplx '/' expr_c4d  { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '/'); }
	| expr_c4d  '/' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec4D>($1, $3, '/'); }
		
	| expr_c4d '*' expr_c4d { $$ = gGC.GetArrayBin<CplxVec4D>($1, $3, '*'); }
	| expr_c4d '/' expr_c4d { $$ = gGC.GetArrayBin<CplxVec4D>($1, $3, '/'); }
	| expr_c4d '+' expr_c4d { $$ = gGC.GetArrayBin<CplxVec4D>($1, $3, '+'); }
	| expr_c4d '-' expr_c4d { $$ = gGC.GetArrayBin<CplxVec4D>($1, $3, '-'); }
	;

expr_c5d: lhs_c5d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_ac5d arguments ')' 
		{
			CallFunc<CplxVec5D>* ptr
					= dynamic_cast<CallFunc<CplxVec5D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_c5d '(' ')' { $$ = gGC.GetCallExprVec<CplxVec5D>($1); }
	| lhs_c5d '(' for_update ')' { $$ = gGC.GetCallExprVec<CplxVec5D>($1, $3); }
	
	| expr_boolean '?' expr_c5d ':' expr_c5d
		{ $$ = gGC.GetExprWhich<CplxVec5D>($1, $3, $5); }
		
	| '(' expr_c5d ')' { $$= $2; }
		
	| '~' expr_c5d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Complex, CplxVec5D>($2, $4, $6, $8, $10, $12); }
	| '~' expr_c5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec5D>($2, $4, $6, $8, $10, $12, true); }
	| '!' expr_c5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Complex, CplxVec5D>($2, $4, $6, $8, $10, $12, false); }
		
	| expr_cplx '*' expr_c5d  { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '*'); }
	| expr_c5d  '*' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '*'); }
	| expr_cplx '+' expr_c5d  { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '+'); }
	| expr_c5d  '+' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '+'); }
	| expr_cplx '-' expr_c5d  { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '-'); }
	| expr_c5d  '-' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '-'); }
	| expr_cplx '/' expr_c5d  { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '/'); }
	| expr_c5d  '/' expr_cplx { $$ = gGC.GetVaAryBin<Complex, CplxVec5D>($1, $3, '/'); }
		
	| expr_c5d '*' expr_c5d { $$ = gGC.GetArrayBin<CplxVec5D>($1, $3, '*'); }
	| expr_c5d '/' expr_c5d { $$ = gGC.GetArrayBin<CplxVec5D>($1, $3, '/'); }
	| expr_c5d '+' expr_c5d { $$ = gGC.GetArrayBin<CplxVec5D>($1, $3, '+'); }
	| expr_c5d '-' expr_c5d { $$ = gGC.GetArrayBin<CplxVec5D>($1, $3, '-'); }
	
	;

expr_v1d: lhs_v1d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_av1d arguments ')' 
		{
			CallFunc<VctrVec1D>* ptr
					= dynamic_cast<CallFunc<VctrVec1D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
				
	| lhs_v1d '(' ')' { $$ = gGC.GetCallExprVec<VctrVec1D>($1); }
	| lhs_v1d '(' for_update ')' { $$ = gGC.GetCallExprVec<VctrVec1D>($1, $3); }
	
	| expr_boolean '?' expr_v1d ':' expr_v1d
		{ $$ = gGC.GetExprWhich<VctrVec1D>($1, $3, $5); }
		
	| '(' expr_v1d ')' { $$= $2; }
		
	| '~' expr_v1d ARY_OPEN expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Vector, VctrVec1D>($2, $4); }
	| '~' expr_v1d ARY_OPEN idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec1D>($2, $4, true); }
	| '!' expr_v1d ARY_OPEN idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec1D>($2, $4, false); }
		
	| expr_real '*' expr_v1d  { $$ = gGC.GetVaVRBin<VctrVec1D>($1, $3, '*'); }
	| expr_v1d  '*' expr_real { $$ = gGC.GetVaVRBin<VctrVec1D>($1, $3, '*'); }
	| expr_v1d  '/' expr_real { $$ = gGC.GetVaVRBin<VctrVec1D>($1, $3, '/'); }
		
	| expr_intg '*' expr_v1d  { $$ = gGC.GetVaVRBin<VctrVec1D>(gGC.GetI2R($1), $3, '*'); }
	| expr_v1d  '*' expr_intg { $$ = gGC.GetVaVRBin<VctrVec1D>($1, gGC.GetI2R($3), '*'); }
	| expr_v1d  '/' expr_intg { $$ = gGC.GetVaVRBin<VctrVec1D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_v1d  '+' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec1D>($1, $3, '+'); }
	| expr_vctr '+' expr_v1d  { $$ = gGC.GetVaAryBin<Vector, VctrVec1D>($1, $3, '+'); }
		
	| expr_v1d  '-' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec1D>($1, $3, '-'); }
	| expr_vctr '-' expr_v1d  { $$ = gGC.GetVaAryBin<Vector, VctrVec1D>($1, $3, '-'); }

	| expr_v1d  '%' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec1D>($1, $3, '%'); }
	| expr_vctr '%' expr_v1d  { $$ = gGC.GetVaAryBin<Vector, VctrVec1D>($1, $3, '%'); }
	
	| expr_v1d '+' expr_v1d { $$ = gGC.GetArrayBinVec<VctrVec1D>($1, $3, '+'); }
	| expr_v1d '-' expr_v1d { $$ = gGC.GetArrayBinVec<VctrVec1D>($1, $3, '-'); }
	| expr_v1d '%' expr_v1d { $$ = gGC.GetArrayBinVec<VctrVec1D>($1, $3, '%'); }
	;

expr_v2d: lhs_v2d %prec OPR_LOWERTHANDOT { $$ = $1; } 
	
	| hdr_av2d arguments ')' 
		{
			CallFunc<VctrVec2D>* ptr
					= dynamic_cast<CallFunc<VctrVec2D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_v2d '(' ')' { $$ = gGC.GetCallExprVec<VctrVec2D>($1); }
	| lhs_v2d '(' for_update ')' { $$ = gGC.GetCallExprVec<VctrVec2D>($1, $3); }
	
	| expr_boolean '?' expr_v2d ':' expr_v2d
		{ $$ = gGC.GetExprWhich<VctrVec2D>($1, $3, $5); }
		
	| '(' expr_v2d ')' { $$= $2; }
		
	| '~' expr_v2d ARY_OPEN expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Vector, VctrVec2D>($2, $4, $6); }
	| '~' expr_v2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec2D>($2, $4, $6, true); }
	| '!' expr_v2d ARY_OPEN idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec2D>($2, $4, $6, false); }
		
	| expr_real '*' expr_v2d  { $$ = gGC.GetVaVRBin<VctrVec2D>($1, $3, '*'); }
	| expr_v2d  '*' expr_real { $$ = gGC.GetVaVRBin<VctrVec2D>($1, $3, '*'); }
	| expr_v2d  '/' expr_real { $$ = gGC.GetVaVRBin<VctrVec2D>($1, $3, '/'); }
		
	| expr_intg '*' expr_v2d  { $$ = gGC.GetVaVRBin<VctrVec2D>(gGC.GetI2R($1), $3, '*'); }
	| expr_v2d  '*' expr_intg { $$ = gGC.GetVaVRBin<VctrVec2D>($1, gGC.GetI2R($3), '*'); }
	| expr_v2d  '/' expr_intg { $$ = gGC.GetVaVRBin<VctrVec2D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_v2d  '+' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec2D>($1, $3, '+'); }
	| expr_vctr '+' expr_v2d  { $$ = gGC.GetVaAryBin<Vector, VctrVec2D>($1, $3, '+'); }
		
	| expr_v2d  '-' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec2D>($1, $3, '-'); }
	| expr_vctr '-' expr_v2d  { $$ = gGC.GetVaAryBin<Vector, VctrVec2D>($1, $3, '-'); }
		
	| expr_v2d  '%' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec2D>($1, $3, '%'); }
	| expr_vctr '%' expr_v2d  { $$ = gGC.GetVaAryBin<Vector, VctrVec2D>($1, $3, '%'); }
	
	| expr_v2d '+' expr_v2d { $$ = gGC.GetArrayBinVec<VctrVec2D>($1, $3, '+'); }
	| expr_v2d '-' expr_v2d { $$ = gGC.GetArrayBinVec<VctrVec2D>($1, $3, '-'); }
	| expr_v2d '%' expr_v2d { $$ = gGC.GetArrayBinVec<VctrVec2D>($1, $3, '%'); }
	;
	
expr_v3d: lhs_v3d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_av3d arguments ')' 
		{
			CallFunc<VctrVec3D>* ptr
					= dynamic_cast<CallFunc<VctrVec3D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_v3d '(' ')' { $$ = gGC.GetCallExprVec<VctrVec3D>($1); }
	| lhs_v3d '(' for_update ')' { $$ = gGC.GetCallExprVec<VctrVec3D>($1, $3); }
	
	| expr_boolean '?' expr_v3d ':' expr_v3d
		{ $$ = gGC.GetExprWhich<VctrVec3D>($1, $3, $5); }
		
	| '(' expr_v3d ')' { $$= $2; }
		
	| '~' expr_v3d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Vector, VctrVec3D>($2, $4, $6, $8); }
	| '~' expr_v3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec3D>($2, $4, $6, $8, true); }
	| '!' expr_v3d ARY_OPEN idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec3D>($2, $4, $6, $8, false); }
		
	| expr_real '*' expr_v3d  { $$ = gGC.GetVaVRBin<VctrVec3D>($1, $3, '*'); }
	| expr_v3d  '*' expr_real { $$ = gGC.GetVaVRBin<VctrVec3D>($1, $3, '*'); }
	| expr_v3d  '/' expr_real { $$ = gGC.GetVaVRBin<VctrVec3D>($1, $3, '/'); }
	
	| expr_intg '*' expr_v3d  { $$ = gGC.GetVaVRBin<VctrVec3D>(gGC.GetI2R($1), $3, '*'); }
	| expr_v3d  '*' expr_intg { $$ = gGC.GetVaVRBin<VctrVec3D>($1, gGC.GetI2R($3), '*'); }
	| expr_v3d  '/' expr_intg { $$ = gGC.GetVaVRBin<VctrVec3D>($1, gGC.GetI2R($3), '/'); }
			
	| expr_v3d  '+' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec3D>($1, $3, '+'); }
	| expr_vctr '+' expr_v3d  { $$ = gGC.GetVaAryBin<Vector, VctrVec3D>($1, $3, '+'); }
		
	| expr_v3d  '-' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec3D>($1, $3, '-'); }
	| expr_vctr '-' expr_v3d  { $$ = gGC.GetVaAryBin<Vector, VctrVec3D>($1, $3, '-'); }
		
	| expr_v3d  '%' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec3D>($1, $3, '%'); }
	| expr_vctr '%' expr_v3d  { $$ = gGC.GetVaAryBin<Vector, VctrVec3D>($1, $3, '%'); }
	
	| expr_v3d '+' expr_v3d { $$ = gGC.GetArrayBinVec<VctrVec3D>($1, $3, '+'); }
	| expr_v3d '-' expr_v3d { $$ = gGC.GetArrayBinVec<VctrVec3D>($1, $3, '-'); }
	| expr_v3d '%' expr_v3d { $$ = gGC.GetArrayBinVec<VctrVec3D>($1, $3, '%'); }
	;
	
expr_v4d: lhs_v4d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_av4d arguments ')' 
		{
			CallFunc<VctrVec4D>* ptr
					= dynamic_cast<CallFunc<VctrVec4D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_v4d '(' ')' { $$ = gGC.GetCallExprVec<VctrVec4D>($1); }
	| lhs_v4d '(' for_update ')' { $$ = gGC.GetCallExprVec<VctrVec4D>($1, $3); }
		
	| expr_boolean '?' expr_v4d ':' expr_v4d
		{ $$ = gGC.GetExprWhich<VctrVec4D>($1, $3, $5); }
		
	| '(' expr_v4d ')' { $$= $2; }
		
	| '~' expr_v4d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Vector, VctrVec4D>($2, $4, $6, $8, $10); }
	| '~' expr_v4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec4D>($2, $4, $6, $8, $10, true); }
	| '!' expr_v4d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec4D>($2, $4, $6, $8, $10, false); }
		
	| expr_real '*' expr_v4d  { $$ = gGC.GetVaVRBin<VctrVec4D>($1, $3, '*'); }
	| expr_v4d  '*' expr_real { $$ = gGC.GetVaVRBin<VctrVec4D>($1, $3, '*'); }
	| expr_v4d  '/' expr_real { $$ = gGC.GetVaVRBin<VctrVec4D>($1, $3, '/'); }
		
	| expr_intg '*' expr_v4d  { $$ = gGC.GetVaVRBin<VctrVec4D>(gGC.GetI2R($1), $3, '*'); }
	| expr_v4d  '*' expr_intg { $$ = gGC.GetVaVRBin<VctrVec4D>($1, gGC.GetI2R($3), '*'); }
	| expr_v4d  '/' expr_intg { $$ = gGC.GetVaVRBin<VctrVec4D>($1, gGC.GetI2R($3), '/'); }
		
	| expr_v4d  '+' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec4D>($1, $3, '+'); }
	| expr_vctr '+' expr_v4d  { $$ = gGC.GetVaAryBin<Vector, VctrVec4D>($1, $3, '+'); }
		
	| expr_v4d  '-' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec4D>($1, $3, '-'); }
	| expr_vctr '-' expr_v4d  { $$ = gGC.GetVaAryBin<Vector, VctrVec4D>($1, $3, '-'); }
		
	| expr_v4d  '%' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec4D>($1, $3, '%'); }
	| expr_vctr '%' expr_v4d  { $$ = gGC.GetVaAryBin<Vector, VctrVec4D>($1, $3, '%'); }
	
	| expr_v4d '+' expr_v4d { $$ = gGC.GetArrayBinVec<VctrVec4D>($1, $3, '+'); }
	| expr_v4d '-' expr_v4d { $$ = gGC.GetArrayBinVec<VctrVec4D>($1, $3, '-'); }
	| expr_v4d '%' expr_v4d { $$ = gGC.GetArrayBinVec<VctrVec4D>($1, $3, '%'); }
	
	;
	
expr_v5d: lhs_v5d %prec OPR_LOWERTHANDOT { $$ = $1; }
	
	| hdr_av5d arguments ')' 
		{
			CallFunc<VctrVec5D>* ptr
					= dynamic_cast<CallFunc<VctrVec5D>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	
	| lhs_v5d '(' ')' { $$ = gGC.GetCallExprVec<VctrVec5D>($1); }
	| lhs_v5d '(' for_update ')' { $$ = gGC.GetCallExprVec<VctrVec5D>($1, $3); }
	
	| expr_boolean '?' expr_v5d ':' expr_v5d
		{ $$ = gGC.GetExprWhich<VctrVec5D>($1, $3, $5); }
	
	| '(' expr_v5d ')' { $$= $2; }
		
	| '~' expr_v5d ARY_OPEN expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ARY_CLOSE 
		{ $$ = gGC.GetClsComplement<Vector, VctrVec5D>($2, $4, $6, $8, $10, $12); }
	| '~' expr_v5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec5D>($2, $4, $6, $8, $10, $12, true); }
	| '!' expr_v5d ARY_OPEN idx_range ',' idx_range ',' idx_range ',' idx_range ',' idx_range ARY_CLOSE 
		{ $$ = gGC.GetClsSubArray<Vector, VctrVec5D>($2, $4, $6, $8, $10, $12, false); }
		
	| expr_real '*' expr_v5d  { $$ = gGC.GetVaVRBin<VctrVec5D>($1, $3, '*'); }
	| expr_v5d  '*' expr_real { $$ = gGC.GetVaVRBin<VctrVec5D>($1, $3, '*'); }
	| expr_v5d  '/' expr_real { $$ = gGC.GetVaVRBin<VctrVec5D>($1, $3, '/'); }
		
	| expr_intg '*' expr_v5d  { $$ = gGC.GetVaVRBin<VctrVec5D>(gGC.GetI2R($1), $3, '*'); }
	| expr_v5d  '*' expr_intg { $$ = gGC.GetVaVRBin<VctrVec5D>($1, gGC.GetI2R($3), '*'); }
	| expr_v5d  '/' expr_intg { $$ = gGC.GetVaVRBin<VctrVec5D>($1, gGC.GetI2R($3), '/'); }
			
	| expr_v5d  '+' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec5D>($1, $3, '+'); }
	| expr_vctr '+' expr_v5d  { $$ = gGC.GetVaAryBin<Vector, VctrVec5D>($1, $3, '+'); }
		
	| expr_v5d  '-' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec5D>($1, $3, '-'); }
	| expr_vctr '-' expr_v5d  { $$ = gGC.GetVaAryBin<Vector, VctrVec5D>($1, $3, '-'); }
	
	| expr_v5d  '%' expr_vctr { $$ = gGC.GetVaAryBin<Vector, VctrVec5D>($1, $3, '%'); }
	| expr_vctr '%' expr_v5d  { $$ = gGC.GetVaAryBin<Vector, VctrVec5D>($1, $3, '%'); }
	
	| expr_v5d '+' expr_v5d { $$ = gGC.GetArrayBinVec<VctrVec5D>($1, $3, '+'); }
	| expr_v5d '-' expr_v5d { $$ = gGC.GetArrayBinVec<VctrVec5D>($1, $3, '-'); }
	| expr_v5d '%' expr_v5d { $$ = gGC.GetArrayBinVec<VctrVec5D>($1, $3, '%'); }	
	;

assign_ptr: 
      lhs_bptr '=' lhs_bool		{ $$=gGC.GetAssignVarToPtr<bool>($1, $3); }
	| lhs_bptr '=' expr_bptr	{ $$=gGC.GetAssignExpPtrToPtr<bool>($1, $3);}
	
	| lhs_sptr '=' lhs_strn		{ $$=gGC.GetAssignVarToPtr<string>($1, $3); }
	| lhs_sptr '=' expr_sptr	{ $$=gGC.GetAssignExpPtrToPtr<string>($1, $3);}
	
	| lhs_iptr '=' lhs_intg		{ $$=gGC.GetAssignVarToPtr<integer>($1, $3); }
	| lhs_iptr '=' expr_iptr	{ $$=gGC.GetAssignExpPtrToPtr<integer>($1, $3);}
	
	| lhs_rptr '=' lhs_real		{ $$=gGC.GetAssignVarToPtr<realnum>($1, $3); }
	| lhs_rptr '=' expr_rptr	{ $$=gGC.GetAssignExpPtrToPtr<realnum>($1, $3);}
	
	| lhs_cptr '=' lhs_cplx		{ $$=gGC.GetAssignVarToPtr<Complex>($1, $3); }
	| lhs_cptr '=' expr_cptr	{ $$=gGC.GetAssignExpPtrToPtr<Complex>($1, $3);}
	
	| lhs_vptr '=' lhs_vctr		{ $$=gGC.GetAssignVarToPtr<Vector>($1, $3); }
	| lhs_vptr '=' expr_vptr	{ $$=gGC.GetAssignExpPtrToPtr<Vector>($1, $3);}
	
	| lhs_uptr '=' lhs_user	    { $$=gGC.GetAssignVarToPtrUserData($1, $3); }
	| lhs_uptr '=' expr_uptr    { $$=gGC.GetAssignExpPtrToPtrUserData($1, $3);}
						
	| PTR_AP1I '=' lhs_i1d { $$=gGC.GetAssignmentAptr<IntgVec1D>($1, $3); }
	| PTR_AP1R '=' lhs_r1d { $$=gGC.GetAssignmentAptr<RealVec1D>($1, $3); }
	| PTR_AP1C '=' lhs_c1d { $$=gGC.GetAssignmentAptr<CplxVec1D>($1, $3); }
	| PTR_AP1V '=' lhs_v1d { $$=gGC.GetAssignmentAptr<VctrVec1D>($1, $3); }
	
	| PTR_AP2I '=' lhs_i2d { $$=gGC.GetAssignmentAptr<IntgVec2D>($1, $3); }
	| PTR_AP2R '=' lhs_r2d { $$=gGC.GetAssignmentAptr<RealVec2D>($1, $3); }
	| PTR_AP2C '=' lhs_c2d { $$=gGC.GetAssignmentAptr<CplxVec2D>($1, $3); }
	| PTR_AP2V '=' lhs_v2d { $$=gGC.GetAssignmentAptr<VctrVec2D>($1, $3); }
	
	| PTR_AP3I '=' lhs_i3d { $$=gGC.GetAssignmentAptr<IntgVec3D>($1, $3); }
	| PTR_AP3R '=' lhs_r3d { $$=gGC.GetAssignmentAptr<RealVec3D>($1, $3); }
	| PTR_AP3C '=' lhs_c3d { $$=gGC.GetAssignmentAptr<CplxVec3D>($1, $3); }
	| PTR_AP3V '=' lhs_v3d { $$=gGC.GetAssignmentAptr<VctrVec3D>($1, $3); }
	
	| PTR_AP4I '=' lhs_i4d { $$=gGC.GetAssignmentAptr<IntgVec4D>($1, $3); }
	| PTR_AP4R '=' lhs_r4d { $$=gGC.GetAssignmentAptr<RealVec4D>($1, $3); }
	| PTR_AP4C '=' lhs_c4d { $$=gGC.GetAssignmentAptr<CplxVec4D>($1, $3); }
	| PTR_AP4V '=' lhs_v4d { $$=gGC.GetAssignmentAptr<VctrVec4D>($1, $3); }
	
	| PTR_AP5I '=' lhs_i5d { $$=gGC.GetAssignmentAptr<IntgVec5D>($1, $3); }
	| PTR_AP5R '=' lhs_r5d { $$=gGC.GetAssignmentAptr<RealVec5D>($1, $3); }
	| PTR_AP5C '=' lhs_c5d { $$=gGC.GetAssignmentAptr<CplxVec5D>($1, $3); }
	| PTR_AP5V '=' lhs_v5d { $$=gGC.GetAssignmentAptr<VctrVec5D>($1, $3); }
			
	| PTR_AP1I '=' PTR_AP1I { $$=gGC.GetAssignAptrAptr<IntgVec1D>($1, $3); }
	| PTR_AP1R '=' PTR_AP1R	{ $$=gGC.GetAssignAptrAptr<RealVec1D>($1, $3); }
	| PTR_AP1C '=' PTR_AP1C { $$=gGC.GetAssignAptrAptr<CplxVec1D>($1, $3); }
	| PTR_AP1V '=' PTR_AP1V { $$=gGC.GetAssignAptrAptr<VctrVec1D>($1, $3); }
	
	| PTR_AP2I '=' PTR_AP2I { $$=gGC.GetAssignAptrAptr<IntgVec2D>($1, $3); }
	| PTR_AP2R '=' PTR_AP2R { $$=gGC.GetAssignAptrAptr<RealVec2D>($1, $3); }
	| PTR_AP2C '=' PTR_AP2C { $$=gGC.GetAssignAptrAptr<CplxVec2D>($1, $3); }
	| PTR_AP2V '=' PTR_AP2V { $$=gGC.GetAssignAptrAptr<VctrVec2D>($1, $3); }
	
	| PTR_AP3I '=' PTR_AP3I { $$=gGC.GetAssignAptrAptr<IntgVec3D>($1, $3); }
	| PTR_AP3R '=' PTR_AP3R { $$=gGC.GetAssignAptrAptr<RealVec3D>($1, $3); }
	| PTR_AP3C '=' PTR_AP3C { $$=gGC.GetAssignAptrAptr<CplxVec3D>($1, $3); }
	| PTR_AP3V '=' PTR_AP3V { $$=gGC.GetAssignAptrAptr<VctrVec3D>($1, $3); }
	
	| PTR_AP4I '=' PTR_AP4I { $$=gGC.GetAssignAptrAptr<IntgVec4D>($1, $3); }
	| PTR_AP4R '=' PTR_AP4R { $$=gGC.GetAssignAptrAptr<RealVec4D>($1, $3); }
	| PTR_AP4C '=' PTR_AP4C { $$=gGC.GetAssignAptrAptr<CplxVec4D>($1, $3); }
	| PTR_AP4V '=' PTR_AP4V { $$=gGC.GetAssignAptrAptr<VctrVec4D>($1, $3); }
	
	| PTR_AP5I '=' PTR_AP5I { $$=gGC.GetAssignAptrAptr<IntgVec5D>($1, $3); }
	| PTR_AP5R '=' PTR_AP5R { $$=gGC.GetAssignAptrAptr<RealVec5D>($1, $3); }
	| PTR_AP5C '=' PTR_AP5C { $$=gGC.GetAssignAptrAptr<CplxVec5D>($1, $3); }
	| PTR_AP5V '=' PTR_AP5V { $$=gGC.GetAssignAptrAptr<VctrVec5D>($1, $3); }
	;

decl_void: TYPE_VOID VID_VOID { $$ = gGC.GetDeclare<voidtype>($2); }  ;

decl_strn: decl_tc_strn { $$ = $1; } | decl_tp_strn { $$= $1; }
	
	| decl_tc_strn '=' expr_strn { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);}
			
	| decl_tc_strn '=' expr_boolean { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr(gGC.GetExprStrn<bool>($3)); }
			
	| decl_tc_strn '=' expr_intg { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr(gGC.GetExprStrn<integer>($3)); }
			
	| decl_tc_strn '=' expr_real { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr(gGC.GetExprStrn<realnum>($3)); }
			
	| decl_tc_strn '=' expr_cplx { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr(gGC.GetExprStrn<Complex>($3)); }
			
	| decl_tc_strn '=' expr_vctr { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr(gGC.GetExprStrn<Vector>($3)); }
				
	| decl_tp_strn '=' lhs_strn { $$ = $1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);}
	
	| decl_tp_strn '=' expr_sptr { $$=$1; vartype=TypeStrn; assign_set=false; 
			dynamic_cast<DeclarePtr<string>*>($1)->pExpr = $3; }
	;

decl_tc_bool: TYPE_BOOL VID_BOOL { $$ = gGC.GetDeclare<bool>($2); }    ;
decl_tc_intg: TYPE_INTG VID_INTG { $$ = gGC.GetDeclare<integer>($2); } ;
decl_tc_real: TYPE_REAL VID_REAL { $$ = gGC.GetDeclare<realnum>($2); } ;
decl_tc_cplx: TYPE_CPLX VID_CPLX { $$ = gGC.GetDeclare<Complex>($2); } ;
decl_tc_vctr: TYPE_VCTR VID_VCTR { $$ = gGC.GetDeclare<Vector>($2); }  ;
decl_tc_strn: TYPE_STRN VID_STRN { $$ = gGC.GetDeclare<string>($2); }  ;

decl_tc_user: expr_udt VID_USER 
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else $$ = gGC.GetDeclUdt($2, gUdtFactoryStack.top());  
			
			gUdtFactoryStack.clear(); 
		} 
	;
	
decl_tp_user:  expr_udt '*' VID_USER 
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else $$ = gGC.GetDeclUdtPtr($3, gUdtFactoryStack.top()); 
			
			gUdtFactoryStack.clear(); 
		}
	;
	
decl_tp_bool: TYPE_BOOL '*' VID_BOOL { $$ = gGC.GetDeclarePtr<bool>($3); } ;
decl_tp_intg: TYPE_INTG '*' VID_INTG { $$ = gGC.GetDeclarePtr<integer>($3); } ;
decl_tp_real: TYPE_REAL '*' VID_REAL { $$ = gGC.GetDeclarePtr<realnum>($3); } ;
decl_tp_cplx: TYPE_CPLX '*' VID_CPLX { $$ = gGC.GetDeclarePtr<Complex>($3); } ;
decl_tp_vctr: TYPE_VCTR '*' VID_VCTR { $$ = gGC.GetDeclarePtr<Vector>($3); } ;
decl_tp_strn: TYPE_STRN '*' VID_STRN { $$ = gGC.GetDeclarePtr<string>($3); } ;

decl_intg: 
	  decl_tc_intg { $$ = $1; } 
	| decl_tp_intg { $$ = $1; }	| decl_tp_i1d { $$ = $1; } 
	| decl_tp_i2d { $$ = $1; }	| decl_tp_i3d { $$ = $1; } 
	| decl_tp_i4d { $$ = $1; }	| decl_tp_i5d { $$ = $1; } 
				
	| decl_tc_intg OPR_XPR { pDecIntg =dynamic_cast<Declare<integer>*>($1); 
		gStmtListStack.top()->Add($1); } expr_inum { assign_set = false; vartype=TypeIntg; 
		$$ = gGC.GetAssignmentLHS<integer>(gGC.GetVariable<integer>(pDecIntg), $4, '&');  }
			
	| decl_tc_intg '=' expr_inum { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	
	| decl_tp_intg '=' expr_iptr { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclarePtr<integer>*>($1)->pExpr = $3; }
			
	| decl_tp_intg '=' lhs_intg { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
		
	| decl_tp_i1d '=' lhs_i1d { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	| decl_tp_i2d '=' lhs_i2d { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	| decl_tp_i3d '=' lhs_i3d { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	| decl_tp_i4d '=' lhs_i4d { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	| decl_tp_i5d '=' lhs_i5d { $$=$1; vartype=TypeIntg; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	
	| TYPE_INTG VID_INTG '[' {assign_set = true;} 
					init_ary_intg { $$ = $5; vartype=TypeIntg; }
	;
	
decl_bool: decl_tc_bool { $$ = $1; } | decl_tp_bool { $$ = $1; }
	| decl_tc_bool '=' expr_boolean { $$ = $1; vartype = TypeBool; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); }
	
	| decl_tp_bool '=' lhs_bool { $$ = $1; vartype = TypeBool; assign_set=false; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);}
	
	| decl_tp_bool '=' expr_bptr { $$=$1; vartype=TypeBool;  assign_set=false; 
			dynamic_cast<DeclarePtr<bool>*>($1)->pExpr = $3; }
	;

init_bool: VID_BOOL	 { $$ = gGC.GetDeclare<bool>($1); }
	| VID_BOOL '=' expr_boolean	
		{ $$ = gGC.GetDeclare<bool>($1,$3); vartype=TypeBool; assign_set=false; }
	| '*' VID_BOOL { $$ = gGC.GetDeclarePtr<bool>($2); } 
	| '*' VID_BOOL '=' lhs_bool 
		{ $$ = gGC.GetDeclarePtr<bool>($2, $4); vartype=TypeBool; assign_set=false; }
		
	| '*' VID_BOOL '=' expr_bptr {	$$ = gGC.GetDeclarePtr<bool>($2, $4);
			vartype = TypeBool; assign_set=false; }
	;	

init_strn: VID_STRN { $$ = gGC.GetDeclare<string>($1); }
	| VID_STRN '=' expr_strn 
		{ $$ = gGC.GetDeclare<string>($1, $3); assign_set=false; vartype=TypeStrn; }
		
	| VID_STRN '=' expr_boolean
		{ $$ = gGC.GetDeclare<string>($1, gGC.GetExprStrn<bool>($3)); assign_set=false; vartype=TypeStrn; }
		
	| VID_STRN '=' expr_intg 
		{ $$ = gGC.GetDeclare<string>($1, gGC.GetExprStrn<integer>($3)); assign_set=false; vartype=TypeStrn; }
		
	| VID_STRN '=' expr_real
		{ $$ = gGC.GetDeclare<string>($1, gGC.GetExprStrn<realnum>($3)); assign_set=false; vartype=TypeStrn; }
		
	| VID_STRN '=' expr_cplx
		{ $$ = gGC.GetDeclare<string>($1, gGC.GetExprStrn<Complex>($3)); assign_set=false; vartype=TypeStrn; }
		
	| VID_STRN '=' expr_vctr
		{ $$ = gGC.GetDeclare<string>($1, gGC.GetExprStrn<Vector>($3)); assign_set=false; vartype=TypeStrn; }
		
	| '*' VID_STRN { $$ = gGC.GetDeclarePtr<string>($2); } 
	| '*' VID_STRN '=' lhs_strn 
		{ $$ = gGC.GetDeclarePtr<string>($2, $4); assign_set=false; vartype=TypeStrn; }
	
	| '*' VID_STRN '=' expr_sptr {	$$ = gGC.GetDeclarePtr<string>($2, $4);
			vartype = TypeStrn; assign_set=false; }
	;
	
init_intg: VID_INTG { $$ = gGC.GetDeclare<integer>($1); }
	
	| VID_INTG '=' expr_inum	
		{ $$ = gGC.GetDeclare<integer>($1,$3); vartype=TypeIntg; assign_set=false; }
		
	| VID_INTG OPR_XPR { pDecIntg=gGC.GetDeclare<integer>($1); 
		gStmtListStack.top()->Add(pDecIntg); } expr_inum { assign_set = false; vartype=TypeIntg; 
		$$ = gGC.GetAssignmentLHS<integer>(gGC.GetVariable<integer>(pDecIntg), $4, '&'); }
			
	| '*' VID_INTG { $$ = gGC.GetDeclarePtr<integer>($2); } 
	
	| '*' VID_INTG '[' ']' { $$ = gGC.GetDeclareAptr<IntgVec1D>($2); }
	| '*' VID_INTG '[' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec2D>($2); }
	| '*' VID_INTG '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec3D>($2); }
	| '*' VID_INTG '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec4D>($2); }
	| '*' VID_INTG '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<IntgVec5D>($2); }
	
	| '*' VID_INTG '=' lhs_intg
		{ $$ = gGC.GetDeclarePtr<integer>($2, $4); vartype = TypeIntg; assign_set=false; }
		
	| '*' VID_INTG '=' expr_iptr {	$$ = gGC.GetDeclarePtr<integer>($2, $4);
			vartype = TypeIntg; assign_set=false; }
	
	| '*' VID_INTG '[' ']' '=' lhs_i1d	
		{ $$ = gGC.GetDeclareAptr<IntgVec1D>($2, $6); vartype = TypeIntg; assign_set=false; }
	| '*' VID_INTG '[' ',' ']' '=' lhs_i2d
		{ $$ = gGC.GetDeclareAptr<IntgVec2D>($2, $7); vartype = TypeIntg; assign_set=false; }
	| '*' VID_INTG '[' ',' ',' ']' '=' lhs_i3d
		{ $$ = gGC.GetDeclareAptr<IntgVec3D>($2, $8); vartype = TypeIntg; assign_set=false; }
	| '*' VID_INTG '[' ',' ',' ',' ']' '=' lhs_i4d
		{ $$ = gGC.GetDeclareAptr<IntgVec4D>($2, $9); vartype = TypeIntg; assign_set=false; }
	| '*' VID_INTG '[' ',' ',' ',' ',' ']' '=' lhs_i5d
		{ $$ = gGC.GetDeclareAptr<IntgVec5D>($2, $10); vartype = TypeIntg; assign_set=false; }
	
	| VID_INTG '[' {assign_set = true; } 
			init_ary_intg { $$ = $4; vartype = TypeIntg; }
	;
	
init_ary_intg: ']'  { $$ = gGC.GetDecAry1D<integer>($<bufr>-2);  }
	| expr_inum ']' { $$ = gGC.GetDecAry1D<integer>($<bufr>-2, $1);  }
	
	| ',' ']' { $$ = gGC.GetDecAry2D<integer>($<bufr>-2);  }
	| expr_inum ',' expr_inum ']' { $$ = gGC.GetDecAry2D<integer>($<bufr>-2, $1, $3); }
							  
	| ',' ',' ']' { $$ = gGC.GetDecAry3D<integer>($<bufr>-2); }	
	| expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry3D<integer>($<bufr>-2, $1, $3, $5); }
	
	| ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<integer>($<bufr>-2); }		  
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry4D<integer>($<bufr>-2, $1, $3, $5, $7); }
	
	| ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<integer>($<bufr>-2); }	
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry5D<integer>($<bufr>-2, $1, $3, $5, $7, $9); }
	
	| ']' '=' { DecAry1D<integer> *ptr = gGC.GetDecAry1D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi1d>$ = gGC.GetVaArray<IntgVec1D, Array1D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi1d>3); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
	
	| ']' '=' { DecAry1D<integer> *ptr = gGC.GetDecAry1D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi1d>$ = gGC.GetVaArray<IntgVec1D, Array1D<integer> >(ptr->GetVarPtr()); } 
			expr_i1d { $$ = gGC.GetAssignmentArrayLHS<IntgVec1D>($<lhsi1d>3, $4); vartype=TypeIntg; } 
		
	| ',' ']' '=' { DecAry2D<integer> *ptr = gGC.GetDecAry2D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi2d>$ = gGC.GetVaArray<IntgVec2D, Array2D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi2d>4); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
	
	| ',' ']' '=' { DecAry2D<integer> *ptr = gGC.GetDecAry2D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi2d>$ = gGC.GetVaArray<IntgVec2D, Array2D<integer> >(ptr->GetVarPtr()); } 
			expr_i2d { $$ = gGC.GetAssignmentArrayLHS<IntgVec2D>($<lhsi2d>4, $5); vartype=TypeIntg; } 
		
	| ',' ',' ']' '=' { DecAry3D<integer> *ptr = gGC.GetDecAry3D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi3d>$ = gGC.GetVaArray<IntgVec3D, Array3D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi3d>5); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
		
	| ',' ',' ']' '=' { DecAry3D<integer> *ptr = gGC.GetDecAry3D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi3d>$ = gGC.GetVaArray<IntgVec3D, Array3D<integer> >(ptr->GetVarPtr()); } 
			expr_i3d { $$ = gGC.GetAssignmentArrayLHS<IntgVec3D>($<lhsi3d>5, $6); vartype=TypeIntg; }
		
	| ',' ',' ',' ']' '=' { DecAry4D<integer> *ptr = gGC.GetDecAry4D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi4d>$ = gGC.GetVaArray<IntgVec4D, Array4D<integer> >(ptr->GetVarPtr());  } 
			ARY_OPEN { PreArrayInit($<lhsi4d>6); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
		
	| ',' ',' ',' ']' '=' { DecAry4D<integer> *ptr = gGC.GetDecAry4D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi4d>$ = gGC.GetVaArray<IntgVec4D, Array4D<integer> >(ptr->GetVarPtr()); } 
			expr_i4d { $$ = gGC.GetAssignmentArrayLHS<IntgVec4D>($<lhsi4d>6, $7); vartype=TypeIntg; }
		
	| ',' ',' ',' ',' ']' '=' { DecAry5D<integer> *ptr = gGC.GetDecAry5D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr);
			 $<lhsi5d>$ = gGC.GetVaArray<IntgVec5D, Array5D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi5d>7); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
	
	| ',' ',' ',' ',' ']' '=' { DecAry5D<integer> *ptr = gGC.GetDecAry5D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi5d>$ = gGC.GetVaArray<IntgVec5D, Array5D<integer> >(ptr->GetVarPtr()); } 
			expr_i5d { $$ = gGC.GetAssignmentArrayLHS<IntgVec5D>($<lhsi5d>7, $8); vartype=TypeIntg; }
			
	
	| ']' OPR_XPR { DecAry1D<integer> *ptr = gGC.GetDecAry1D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi1d>$ = gGC.GetVaArray<IntgVec1D, Array1D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi1d>3, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
			
	| ',' ']' OPR_XPR { DecAry2D<integer> *ptr = gGC.GetDecAry2D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi2d>$ = gGC.GetVaArray<IntgVec2D, Array2D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi2d>4, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
	
	| ',' ',' ']' OPR_XPR { DecAry3D<integer> *ptr = gGC.GetDecAry3D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi3d>$ = gGC.GetVaArray<IntgVec3D, Array3D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi3d>5, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
		
	| ',' ',' ',' ']' OPR_XPR { DecAry4D<integer> *ptr = gGC.GetDecAry4D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsi4d>$ = gGC.GetVaArray<IntgVec4D, Array4D<integer> >(ptr->GetVarPtr());  } 
			ARY_OPEN { PreArrayInit($<lhsi4d>6, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
		
	| ',' ',' ',' ',' ']' OPR_XPR { DecAry5D<integer> *ptr = gGC.GetDecAry5D<integer>($<bufr>-2); gStmtListStack.top()->Add(ptr);
			 $<lhsi5d>$ = gGC.GetVaArray<IntgVec5D, Array5D<integer> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsi5d>7, false); } array_intg ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeIntg; } 
	;

decl_real: decl_tc_real { $$ = $1; }
	| decl_tp_real { $$ = $1; }	| decl_tp_r1d { $$ = $1; } 
	| decl_tp_r2d { $$ = $1; }	| decl_tp_r3d { $$ = $1; } 
	| decl_tp_r4d { $$ = $1; }	| decl_tp_r5d { $$ = $1; } 
	 			
	| decl_tc_real OPR_XPR { pDecReal=dynamic_cast<Declare<realnum>*>($1); 
		gStmtListStack.top()->Add($1); } expr_rnum { assign_set = false; vartype=TypeReal; 
		$$ = gGC.GetAssignmentLHS<realnum>(gGC.GetVariable<realnum>(pDecReal), $4, '&');  }
			 			
	| decl_tc_real '=' expr_rnum { $$ = $1; vartype=TypeReal;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
			
	| decl_tp_real '=' expr_rptr 
		{	$$=$1; vartype=TypeReal; assign_set=false;
			dynamic_cast<DeclarePtr<realnum>*>($1)->pExpr = $3; assign_set=false;  }
			
	| decl_tp_real '=' lhs_real { $$ = $1; vartype=TypeReal;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);assign_set=false;  }
	
	| decl_tp_r1d '=' lhs_r1d { $$=$1; vartype=TypeReal; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_r2d '=' lhs_r2d { $$=$1; vartype=TypeReal; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_r3d '=' lhs_r3d { $$=$1; vartype=TypeReal; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_r4d '=' lhs_r4d { $$=$1; vartype=TypeReal;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_r5d '=' lhs_r5d { $$=$1; vartype=TypeReal;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	
	| TYPE_REAL VID_REAL '[' {assign_set = true;} 
			init_ary_real { $$ = $5; vartype = TypeReal;}
	;
	
init_real: VID_REAL { $$ = gGC.GetDeclare<realnum>($1); }
	
	| VID_REAL OPR_XPR { pDecReal=gGC.GetDeclare<realnum>($1); 
		gStmtListStack.top()->Add(pDecReal); } expr_rnum { assign_set = false; vartype=TypeReal; 
		$$ = gGC.GetAssignmentLHS<realnum>(gGC.GetVariable<realnum>(pDecReal), $4, '&'); }
		
	| VID_REAL '=' expr_rnum 
		{ $$ = gGC.GetDeclare<realnum>($1,$3); vartype = TypeReal; assign_set=false;  }
		
	| '*' VID_REAL	{ $$ = gGC.GetDeclarePtr<double>($2); } 
	
	| '*' VID_REAL '=' expr_rptr {	$$ = gGC.GetDeclarePtr<realnum>($2, $4);
			vartype = TypeReal; assign_set=false; }
			
	| '*' VID_REAL '=' lhs_real
			{ $$ = gGC.GetDeclarePtr<double>($2, $4); vartype = TypeReal; assign_set=false; }
	
	| '*' VID_REAL '[' ']' { $$ = gGC.GetDeclareAptr<RealVec1D>($2); }
	| '*' VID_REAL '[' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec2D>($2); }
	| '*' VID_REAL '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec3D>($2); }
	| '*' VID_REAL '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec4D>($2); }
	| '*' VID_REAL '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<RealVec5D>($2); }
	
	| '*' VID_REAL '[' ']' '=' lhs_r1d
		{ $$ = gGC.GetDeclareAptr<RealVec1D>($2, $6); vartype = TypeReal; assign_set=false; }
	| '*' VID_REAL '[' ',' ']' '=' lhs_r2d
		{ $$ = gGC.GetDeclareAptr<RealVec2D>($2, $7); vartype = TypeReal; assign_set=false; }		
	| '*' VID_REAL '[' ',' ',' ']' '=' lhs_r3d
		{ $$ = gGC.GetDeclareAptr<RealVec3D>($2, $8); vartype = TypeReal; assign_set=false; }
	| '*' VID_REAL '[' ',' ',' ',' ']' '=' lhs_r4d
		{ $$ = gGC.GetDeclareAptr<RealVec4D>($2, $9); vartype = TypeReal; assign_set=false; }
	| '*' VID_REAL '[' ',' ',' ',' ',' ']' '=' lhs_r5d
		{ $$ = gGC.GetDeclareAptr<RealVec5D>($2, $10); vartype = TypeReal; assign_set=false; }

	| VID_REAL '[' {assign_set = true; } 
			init_ary_real { $$=$4; vartype=TypeReal; }
	;
	
init_ary_real:  ']' { $$ = gGC.GetDecAry1D<realnum>($<bufr>-2); }
	| expr_inum ']' { $$ = gGC.GetDecAry1D<realnum>($<bufr>-2, $1); }
	| expr_inum ',' expr_inum ']' { $$ = gGC.GetDecAry2D<realnum>($<bufr>-2, $1, $3); }
	| ',' ']' { $$ = gGC.GetDecAry2D<realnum>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry3D<realnum>($<bufr>-2, $1, $3, $5); }
	| ',' ',' ']' { $$ = gGC.GetDecAry3D<realnum>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry4D<realnum>($<bufr>-2, $1, $3, $5, $7); }
	| ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<realnum>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry5D<realnum>($<bufr>-2, $1, $3, $5, $7, $9); }
	| ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<realnum>($<bufr>-2); }	
		
	| ']' '=' { DecAry1D<realnum> *ptr = gGC.GetDecAry1D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr1d>$ = gGC.GetVaArray<RealVec1D, Array1D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr1d>3); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal; } 
		
	| ']' '=' { DecAry1D<realnum> *ptr = gGC.GetDecAry1D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			 $<lhsr1d>$ = gGC.GetVaArray<RealVec1D, Array1D<realnum> >(ptr->GetVarPtr()); } 
			expr_r1d { $$ = gGC.GetAssignmentArrayLHS<RealVec1D>($<lhsr1d>3, $4); vartype=TypeReal; } 
			
	| ',' ']' '=' { DecAry2D<realnum> *ptr = gGC.GetDecAry2D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
						$<lhsr2d>$ = gGC.GetVaArray<RealVec2D, Array2D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr2d>4); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal; } 
		
	| ',' ']' '=' { DecAry2D<realnum> *ptr = gGC.GetDecAry2D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr2d>$ = gGC.GetVaArray<RealVec2D, Array2D<realnum> >(ptr->GetVarPtr()); } 
			expr_r2d { $$ = gGC.GetAssignmentArrayLHS<RealVec2D>($<lhsr2d>4, $5); vartype=TypeReal; } 
				
	| ',' ',' ']' '=' { DecAry3D<realnum> *ptr = gGC.GetDecAry3D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr3d>$ = gGC.GetVaArray<RealVec3D, Array3D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr3d>5); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal; } 
		
	| ',' ',' ']' '=' { DecAry3D<realnum> *ptr = gGC.GetDecAry3D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr3d>$ = gGC.GetVaArray<RealVec3D, Array3D<realnum> >(ptr->GetVarPtr()); } 
			expr_r3d { $$ = gGC.GetAssignmentArrayLHS<RealVec3D>($<lhsr3d>5, $6); vartype=TypeReal; } 
			
	| ',' ',' ',' ']' '=' { DecAry4D<realnum> *ptr = gGC.GetDecAry4D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr4d>$ = gGC.GetVaArray<RealVec4D, Array4D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr4d>6); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal; } 
	
	| ',' ',' ',' ']' '=' { DecAry4D<realnum> *ptr = gGC.GetDecAry4D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr4d>$ = gGC.GetVaArray<RealVec4D, Array4D<realnum> >(ptr->GetVarPtr()); } 
			expr_r4d { $$ = gGC.GetAssignmentArrayLHS<RealVec4D>($<lhsr4d>6, $7); vartype=TypeReal; } 
			
	| ',' ',' ',' ',' ']' '=' { DecAry5D<realnum> *ptr = gGC.GetDecAry5D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr5d>$ = gGC.GetVaArray<RealVec5D, Array5D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr5d>7); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal;} 
	
	| ',' ',' ',' ',' ']' '=' { DecAry5D<realnum> *ptr = gGC.GetDecAry5D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr5d>$ = gGC.GetVaArray<RealVec5D, Array5D<realnum> >(ptr->GetVarPtr());} 
			expr_r5d { $$ = gGC.GetAssignmentArrayLHS<RealVec5D>($<lhsr5d>7, $8); vartype=TypeReal;} 
			
			
	| ']' OPR_XPR { DecAry1D<realnum> *ptr = gGC.GetDecAry1D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr1d>$ = gGC.GetVaArray<RealVec1D, Array1D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr1d>3, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal;} 
		
	| ',' ']' OPR_XPR { DecAry2D<realnum> *ptr = gGC.GetDecAry2D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
						$<lhsr2d>$ = gGC.GetVaArray<RealVec2D, Array2D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr2d>4, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal;} 
		
	| ',' ',' ']' OPR_XPR { DecAry3D<realnum> *ptr = gGC.GetDecAry3D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr3d>$ = gGC.GetVaArray<RealVec3D, Array3D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr3d>5, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal;} 
		
	| ',' ',' ',' ']' OPR_XPR { DecAry4D<realnum> *ptr = gGC.GetDecAry4D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr4d>$ = gGC.GetVaArray<RealVec4D, Array4D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr4d>6, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal;} 
	
	| ',' ',' ',' ',' ']' OPR_XPR { DecAry5D<realnum> *ptr = gGC.GetDecAry5D<realnum>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsr5d>$ = gGC.GetVaArray<RealVec5D, Array5D<realnum> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsr5d>7, false); } array_real ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeReal;} 
	
	;

decl_cplx: decl_tc_cplx { $$ = $1; }
	| decl_tp_cplx { $$ = $1; }	| decl_tp_c1d { $$ = $1; } 
	| decl_tp_c2d { $$ = $1; }	| decl_tp_c3d { $$ = $1; } 
	| decl_tp_c4d { $$ = $1; }	| decl_tp_c5d { $$ = $1; } 
		
	| decl_tc_cplx OPR_XPR { pDecCplx=dynamic_cast<Declare<Complex>*>($1);
		gStmtListStack.top()->Add($1); } expr_cnum { assign_set = false; vartype=TypeCplx; 
		$$ = gGC.GetAssignmentLHS<Complex>(gGC.GetVariable<Complex>(pDecCplx), $4, '&');  }
	
	| decl_tc_cplx '=' expr_cnum { $$ = $1; vartype=TypeCplx;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);assign_set=false;  }
			
	| decl_tp_cplx '=' expr_cptr 
		{	$$=$1; vartype=TypeCplx; assign_set = false;
			dynamic_cast<DeclarePtr<Complex>*>($1)->pExpr = $3;assign_set=false;  }
	
	| decl_tp_cplx '=' lhs_cplx { $$=$1; vartype=TypeCplx; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);assign_set=false;  }
		
	| decl_tp_c1d '=' lhs_c1d { $$=$1; vartype=TypeCplx; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_c2d '=' lhs_c2d { $$=$1; vartype=TypeCplx; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);assign_set=false;  }
	| decl_tp_c3d '=' lhs_c3d { $$=$1; vartype=TypeCplx; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_c4d '=' lhs_c4d { $$=$1; vartype=TypeCplx;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_c5d '=' lhs_c5d { $$=$1; vartype=TypeCplx;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);assign_set=false;  }
		
	| TYPE_CPLX VID_CPLX '[' {assign_set = true; } 
			init_ary_cplx { $$ = $5; vartype = TypeCplx;}
	;
	
init_cplx: 
	  VID_CPLX { $$ = gGC.GetDeclare<Complex>($1);  }
	
	| VID_CPLX OPR_XPR { pDecCplx=gGC.GetDeclare<Complex>($1); 
		gStmtListStack.top()->Add(pDecCplx); } expr_cnum { assign_set = false; vartype=TypeCplx; 
		$$ = gGC.GetAssignmentLHS<Complex>(gGC.GetVariable<Complex>(pDecCplx), $4, '&'); }
		
	| VID_CPLX '=' expr_cnum
		{ $$ = gGC.GetDeclare<Complex>($1,$3); vartype = TypeCplx; assign_set=false; }
		
	| '*' VID_CPLX '=' expr_cptr {	$$ = gGC.GetDeclarePtr<Complex>($2, $4);
			vartype = TypeCplx; assign_set=false; }
	
	| '*' VID_CPLX '=' lhs_cplx	
		{ $$ = gGC.GetDeclarePtr<Complex>($2, $4); vartype=TypeCplx;assign_set=false;  }
				
	| '*' VID_CPLX { $$ = gGC.GetDeclarePtr<Complex>($2); } 
	| '*' VID_CPLX '[' ']' { $$ = gGC.GetDeclareAptr<CplxVec1D>($2); }
	| '*' VID_CPLX '[' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec2D>($2); }
	| '*' VID_CPLX '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec3D>($2); }
	| '*' VID_CPLX '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec4D>($2); }
	| '*' VID_CPLX '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<CplxVec5D>($2); }
	
	| '*' VID_CPLX '[' ']' '=' lhs_c1d
		{ $$ = gGC.GetDeclareAptr<CplxVec1D>($2, $6); vartype=TypeCplx; assign_set=false; }
	| '*' VID_CPLX '[' ',' ']' '=' lhs_c2d
		{ $$ = gGC.GetDeclareAptr<CplxVec2D>($2, $7); vartype=TypeCplx; assign_set=false; }
	| '*' VID_CPLX '[' ',' ',' ']' '=' lhs_c3d
		{ $$ = gGC.GetDeclareAptr<CplxVec3D>($2, $8); vartype=TypeCplx; assign_set=false; }
	| '*' VID_CPLX '[' ',' ',' ',' ']' '=' lhs_c4d
		{ $$ = gGC.GetDeclareAptr<CplxVec4D>($2, $9); vartype=TypeCplx; assign_set=false; }
	| '*' VID_CPLX '[' ',' ',' ',' ',' ']' '=' lhs_c5d
		{ $$ = gGC.GetDeclareAptr<CplxVec5D>($2, $10); vartype=TypeCplx; assign_set=false; }
	
	| VID_CPLX '[' {assign_set = true; } 
			init_ary_cplx { $$=$4; vartype=TypeCplx; }			
	;

init_ary_cplx: ']'  { $$ = gGC.GetDecAry1D<Complex>($<bufr>-2);  }
	| expr_inum ']' { $$ = gGC.GetDecAry1D<Complex>($<bufr>-2, $1);  }
	| expr_inum ',' expr_inum ']' { $$ = gGC.GetDecAry2D<Complex>($<bufr>-2, $1, $3);  }
	| ',' ']' { $$ = gGC.GetDecAry2D<Complex>($<bufr>-2);  }
							  
	| expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry3D<Complex>($<bufr>-2, $1, $3, $5); }
	| ',' ',' ']' { $$ = gGC.GetDecAry3D<Complex>($<bufr>-2); }
	
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry4D<Complex>($<bufr>-2, $1, $3, $5, $7); }
	| ',' ',' ',' ']' { $$ = gGC.GetDecAry4D<Complex>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry5D<Complex>($<bufr>-2, $1, $3, $5, $7, $9); }
	| ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<Complex>($<bufr>-2); }
		
	| ']' '=' { DecAry1D<Complex> *ptr = gGC.GetDecAry1D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc1d>$ = gGC.GetVaArray<CplxVec1D, Array1D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc1d>3); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit(); vartype=TypeCplx; } 
		
	| ']' '='  { DecAry1D<Complex> *ptr = gGC.GetDecAry1D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc1d>$ = gGC.GetVaArray<CplxVec1D, Array1D<Complex> >(ptr->GetVarPtr()); } 
			expr_c1d { $$ = gGC.GetAssignmentArrayLHS<CplxVec1D>($<lhsc1d>3, $4); vartype=TypeCplx; } 
		
	| ',' ']' '=' { DecAry2D<Complex> *ptr = gGC.GetDecAry2D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc2d>$ = gGC.GetVaArray<CplxVec2D, Array2D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc2d>4); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ']' '=' { DecAry2D<Complex> *ptr = gGC.GetDecAry2D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc2d>$ = gGC.GetVaArray<CplxVec2D, Array2D<Complex> >(ptr->GetVarPtr());  } 
			expr_c2d { $$ = gGC.GetAssignmentArrayLHS<CplxVec2D>($<lhsc2d>4, $5); vartype=TypeCplx; } 
		
	| ',' ',' ']' '=' { DecAry3D<Complex> *ptr = gGC.GetDecAry3D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr);  
			$<lhsc3d>$ = gGC.GetVaArray<CplxVec3D, Array3D<Complex> >(ptr->GetVarPtr());  } 
			ARY_OPEN { PreArrayInit($<lhsc3d>5); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ',' ']' '=' { DecAry3D<Complex> *ptr = gGC.GetDecAry3D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc3d>$ = gGC.GetVaArray<CplxVec3D, Array3D<Complex> >(ptr->GetVarPtr());  } 
			expr_c3d { $$ = gGC.GetAssignmentArrayLHS<CplxVec3D>($<lhsc3d>5, $6); vartype=TypeCplx; } 
			
	| ',' ',' ',' ']' '=' { DecAry4D<Complex> *ptr = gGC.GetDecAry4D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc4d>$ = gGC.GetVaArray<CplxVec4D, Array4D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc4d>6); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ',' ',' ']' '=' { DecAry4D<Complex> *ptr = gGC.GetDecAry4D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc4d>$ = gGC.GetVaArray<CplxVec4D, Array4D<Complex> >(ptr->GetVarPtr()); } 
			expr_c4d { $$ = gGC.GetAssignmentArrayLHS<CplxVec4D>($<lhsc4d>6, $7); vartype=TypeCplx;} 
			
	| ',' ',' ',' ',' ']' '=' { DecAry5D<Complex> *ptr = gGC.GetDecAry5D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc5d>$ = gGC.GetVaArray<CplxVec5D, Array5D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc5d>7); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ',' ',' ',' ']' '=' { DecAry5D<Complex> *ptr = gGC.GetDecAry5D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc5d>$ = gGC.GetVaArray<CplxVec5D, Array5D<Complex> >(ptr->GetVarPtr()); } 
			expr_c5d { $$ = gGC.GetAssignmentArrayLHS<CplxVec5D>($<lhsc5d>7, $8);  vartype=TypeCplx; } 
			
			
	| ']' OPR_XPR { DecAry1D<Complex> *ptr = gGC.GetDecAry1D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc1d>$ = gGC.GetVaArray<CplxVec1D, Array1D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc1d>3, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ']' OPR_XPR { DecAry2D<Complex> *ptr = gGC.GetDecAry2D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc2d>$ = gGC.GetVaArray<CplxVec2D, Array2D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc2d>4, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ',' ']' OPR_XPR { DecAry3D<Complex> *ptr = gGC.GetDecAry3D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr);  
			$<lhsc3d>$ = gGC.GetVaArray<CplxVec3D, Array3D<Complex> >(ptr->GetVarPtr());  } 
			ARY_OPEN { PreArrayInit($<lhsc3d>5, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ',' ',' ']' OPR_XPR { DecAry4D<Complex> *ptr = gGC.GetDecAry4D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc4d>$ = gGC.GetVaArray<CplxVec4D, Array4D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc4d>6, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
		
	| ',' ',' ',' ',' ']' OPR_XPR { DecAry5D<Complex> *ptr = gGC.GetDecAry5D<Complex>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsc5d>$ = gGC.GetVaArray<CplxVec5D, Array5D<Complex> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsc5d>7, false); } array_cplx ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeCplx; } 
	;
	
decl_vctr: decl_tc_vctr { $$ = $1; }
	| decl_tp_vctr { $$ = $1; }	| decl_tp_v1d { $$ = $1; } 
	| decl_tp_v2d { $$ = $1; }	| decl_tp_v3d { $$ = $1; } 
	| decl_tp_v4d { $$ = $1; }	| decl_tp_v5d { $$ = $1; } 
	
	| decl_tc_vctr OPR_XPR { pDecVctr=dynamic_cast<Declare<Vector>*>($1); 
		gStmtListStack.top()->Add($1); } expr_vnum { assign_set = false; vartype=TypeVctr; 
		$$ = gGC.GetAssignmentLHS<Vector>(gGC.GetVariable<Vector>(pDecVctr), $4, '&');   }

	| decl_tc_vctr '=' expr_vnum { $$ = $1; vartype = TypeVctr;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3);assign_set=false;  }
	
	| decl_tp_vctr '=' expr_vptr 
		{	$$=$1; vartype=TypeVctr; assign_set = false;
			dynamic_cast<DeclarePtr<Vector>*>($1)->pExpr = $3; assign_set=false; }
			
	| decl_tp_vctr '=' lhs_vctr { $$=$1; vartype=TypeVctr; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
		
	| decl_tp_v1d '=' lhs_v1d { $$=$1; vartype=TypeVctr; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_v2d '=' lhs_v2d { $$=$1; vartype=TypeVctr; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_v3d '=' lhs_v3d { $$=$1; vartype=TypeVctr; 
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_v4d '=' lhs_v4d { $$=$1; vartype=TypeVctr;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	| decl_tp_v5d '=' lhs_v5d { $$=$1; vartype=TypeVctr;
			dynamic_cast<DeclareBase*>($1)->SetInitExpr($3); assign_set=false; }
	
	| TYPE_VCTR VID_VCTR '[' {assign_set = true; } 
			init_ary_vctr { $$ = $5; vartype=TypeVctr; }
	;

decl_udt: expr_udt VID_USER 
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else $$ = gGC.GetDeclUdt($2, gUdtFactoryStack.top()); 
		} 
	
	| expr_udt VID_USER '=' expr_user
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else
			{
				CallFunc<UserData>* pCallFunc = dynamic_cast<CallFunc<UserData>*>($4);
				
				if(pCallFunc)
				{
					if(gLastUdt == gUdtFactoryStack.top())
					{
						DeclUdt *pUdt = gGC.GetDeclUdt($2, gLastUdt);
						gStmtListStack.top()->Add(pUdt);
						
						VarUserBase *pVub = gGC.GetVarUserBase(pUdt->GetVarPtr());
						pVub->udtptr = gLastUdt;
						gStmtListStack.top()->Add(
						gGC.GetAssignExpUser(gGC.GetVarUserExp(pVub), $4));
						
						gUdtFactoryStack.clear(); gUdtFactoryStack.push(gLastUdt); 
						gLastUdt=NULL; $$ = NULL; vartype = TypeUser; assign_set=false; 
					}
					else
						HandleSyntaxError(L"At the initialization for user defined type, type-mismatch.\r\n");
				}
				else 
				{
					if(gUdtFactoryStack.top() == gLastUdt)
					{
						$$ = gGC.GetDeclUdt($2, gLastUdt, $4); 
						gUdtFactoryStack.clear(); vartype = TypeUser;
						gUdtFactoryStack.push(gLastUdt); gLastUdt=NULL; assign_set=false; 
					}
					else
						HandleSyntaxError(L"At the initialization for user defined type, type-mismatch.\r\n");
				}
			}
		} 
		
	| expr_udt '*' VID_USER 
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else $$ = gGC.GetDeclUdtPtr($3, gUdtFactoryStack.top()); 
		}
	| expr_udt '*' VID_USER '=' lhs_user
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else if($5->IsCompatible(gUdtFactoryStack.top()))
			{
				$$ = gGC.GetDeclUdtPtr($3, gLastUdt, $5); 
				gUdtFactoryStack.clear(); vartype = TypeUser;
				gUdtFactoryStack.push(gLastUdt); gLastUdt=NULL; assign_set=false; 
			}
			else
				HandleSyntaxError(L"User defined type mismatch.\r\n");
		}
	| expr_udt '*' VID_USER '=' expr_uptr 
		{ 
			if(gUdtFactoryStack.top()->IsLiteral())
			{
				std::wostringstream os;
				os<<_T("Can not instantiate an object of class \'")
					<<gUdtFactoryStack.top()->GetTypeTag()<<_T("\', all its members are literals.\r\n");
				HandleSyntaxError(os.str());
			}
			else if($1->IsCompatible(gUdtFactoryStack.top()))
			{
				DeclarePtr<UserData> *ptr= gGC.GetDeclUdtPtr($3, gLastUdt); 
				ptr->pExpr = $5; $$ = dynamic_cast<Statement*>(ptr);
								
				gUdtFactoryStack.clear(); vartype = TypeUser;
				gUdtFactoryStack.push(gLastUdt); gLastUdt=NULL; assign_set=false; 
			}
			else
				HandleSyntaxError(L"User defined type mismatch.\r\n");
		}
	;

init_udt: VID_USER { $$ = gGC.GetDeclUdt($1, gUdtFactoryStack.top()); } 
	| VID_USER '=' expr_user 
		{ 
			CallFunc<UserData>* pCallFunc = dynamic_cast<CallFunc<UserData>*>($3);
			
			if(pCallFunc)
			{
				if(gLastUdt == gUdtFactoryStack.top())
				{
					DeclUdt *pUdt = gGC.GetDeclUdt($1, gLastUdt);
					gStmtListStack.top()->Add(pUdt);
					
					VarUserBase *pVub = gGC.GetVarUserBase(pUdt->GetVarPtr());
					pVub->udtptr = gLastUdt;
					gStmtListStack.top()->Add(
					gGC.GetAssignExpUser(gGC.GetVarUserExp(pVub), $3));
					
					gUdtFactoryStack.clear(); gUdtFactoryStack.push(gLastUdt); 
					gLastUdt=NULL; $$ = NULL; vartype = TypeUser; assign_set=false; 
				}
				else
					HandleSyntaxError(L"At the initialization for user defined type, type-mismatch.\r\n");
			}
			else 
			{
				if(gUdtFactoryStack.top() == gLastUdt)
				{
					$$ = gGC.GetDeclUdt($1, gLastUdt, $3); 
					gUdtFactoryStack.clear(); vartype = TypeUser;
					gUdtFactoryStack.push(gLastUdt); gLastUdt=NULL; assign_set=false; 
				}
				else
					HandleSyntaxError(L"At the initialization for user defined type, type-mismatch.\r\n");
			}
		} 
		
	| '*' VID_USER { $$ = gGC.GetDeclUdtPtr($2, gUdtFactoryStack.top()); } 
	| '*' VID_USER '=' lhs_user
		{ 
			if($4->IsCompatible(gLastUdt))
			{
				$$ = gGC.GetDeclUdtPtr($2, gLastUdt, $4); 
				gUdtFactoryStack.clear(); vartype = TypeUser;
				gUdtFactoryStack.push(gLastUdt); gLastUdt=NULL; assign_set=false; 
			}
			else
				HandleSyntaxError(L"User defined type mismatch.\r\n");
		}
		
	| '*' VID_USER '=' expr_uptr 
		{ 
			if(gLastUdt == gUdtFactoryStack.top())
			{
				DeclarePtr<UserData> *ptr= gGC.GetDeclUdtPtr($2, gLastUdt); 
				ptr->pExpr = $4; $$ = dynamic_cast<Statement*>(ptr);
								
				gUdtFactoryStack.clear(); vartype = TypeUser;
				gUdtFactoryStack.push(gLastUdt); gLastUdt=NULL; assign_set=false; 
			}
			else
				HandleSyntaxError(L"User defined type mismatch.\r\n");
		}
	;
			
init_vctr: VID_VCTR { $$ = gGC.GetDeclare<Vector>($1); }
		
	| VID_VCTR OPR_XPR { pDecVctr=gGC.GetDeclare<Vector>($1); 
		gStmtListStack.top()->Add(pDecVctr); } expr_vnum { assign_set = false; vartype=TypeVctr; 
		$$ = gGC.GetAssignmentLHS<Vector>(gGC.GetVariable<Vector>(pDecVctr), $4, '&');  }
		
	| VID_VCTR '=' expr_vnum
		{ $$ = gGC.GetDeclare<Vector>($1,$3); vartype = TypeVctr; assign_set=false; }
		
	| '*' VID_VCTR '=' expr_vptr {	$$ = gGC.GetDeclarePtr<Vector>($2, $4);
			vartype = TypeVctr; assign_set=false; }
	
	| '*' VID_VCTR '=' lhs_vctr
		{ $$ = gGC.GetDeclarePtr<Vector>($2, $4); vartype = TypeVctr; assign_set=false; }
		
	| '*' VID_VCTR { $$ = gGC.GetDeclarePtr<Vector>($2); } 
	
	| '*' VID_VCTR '[' ']' { $$ = gGC.GetDeclareAptr<VctrVec1D>($2); }
	| '*' VID_VCTR '[' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec2D>($2); }
	| '*' VID_VCTR '[' ',' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec3D>($2); }
	| '*' VID_VCTR '[' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec4D>($2); }
	| '*' VID_VCTR '[' ',' ',' ',' ',' ']' { $$ = gGC.GetDeclareAptr<VctrVec5D>($2); }
		
	| '*' VID_VCTR '[' ']' '=' lhs_v1d
		{ $$ = gGC.GetDeclareAptr<VctrVec1D>($2, $6); vartype = TypeVctr; assign_set=false; }
	| '*' VID_VCTR '[' ',' ']' '=' lhs_v2d
		{ $$ = gGC.GetDeclareAptr<VctrVec2D>($2, $7); vartype = TypeVctr; assign_set=false; }
	| '*' VID_VCTR '[' ',' ',' ']' '=' lhs_v3d
		{ $$ = gGC.GetDeclareAptr<VctrVec3D>($2, $8); vartype = TypeVctr; assign_set=false; }
	| '*' VID_VCTR '[' ',' ',' ',' ']' '=' lhs_v4d
		{ $$ = gGC.GetDeclareAptr<VctrVec4D>($2, $9); vartype = TypeVctr; assign_set=false; }
	| '*' VID_VCTR '[' ',' ',' ',' ',' ']' '=' lhs_v5d
		{ $$ = gGC.GetDeclareAptr<VctrVec5D>($2, $10); vartype = TypeVctr; assign_set=false; }		

	| VID_VCTR '[' {assign_set = true; } 
		init_ary_vctr { $$=$4; vartype=TypeVctr; }	
	;
	
init_ary_vctr: ']' { $$ = gGC.GetDecAry1D<Vector>($<bufr>-2); }
	| expr_inum ']' { $$ = gGC.GetDecAry1D<Vector>($<bufr>-2, $1); }
	| expr_inum ',' expr_inum ']' { $$ = gGC.GetDecAry2D<Vector>($<bufr>-2, $1, $3); }
	| ',' ']' { $$ = gGC.GetDecAry2D<Vector>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry3D<Vector>($<bufr>-2, $1, $3, $5); }
	| ',' ',' ']' { assign_set = false; $$ = gGC.GetDecAry3D<Vector>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry4D<Vector>($<bufr>-2, $1, $3, $5, $7); }
	| ',' ',' ',' ']' { assign_set = false; $$ = gGC.GetDecAry4D<Vector>($<bufr>-2); }
	| expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetDecAry5D<Vector>($<bufr>-2, $1, $3, $5, $7, $9); }
	| ',' ',' ',' ',' ']' { $$ = gGC.GetDecAry5D<Vector>($<bufr>-2); }
		
	| ']' '=' { DecAry1D<Vector> *ptr = gGC.GetDecAry1D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv1d>$ = gGC.GetVaArray<VctrVec1D, Array1D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv1d>3); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ']' '=' { DecAry1D<Vector> *ptr = gGC.GetDecAry1D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv1d>$ = gGC.GetVaArray<VctrVec1D, Array1D<Vector> >(ptr->GetVarPtr()); } 
			expr_v1d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec1D>($<lhsv1d>3, $4); vartype=TypeVctr; } 
			   
	| ',' ']' '=' { DecAry2D<Vector> *ptr = gGC.GetDecAry2D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv2d>$ = gGC.GetVaArray<VctrVec2D, Array2D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv2d>4); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ',' ']' '=' { DecAry2D<Vector> *ptr = gGC.GetDecAry2D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv2d>$ = gGC.GetVaArray<VctrVec2D, Array2D<Vector> >(ptr->GetVarPtr()); } 
			expr_v2d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec2D>($<lhsv2d>4, $5);  vartype=TypeVctr; } 
			
	| ',' ',' ']' '=' { DecAry3D<Vector> *ptr = gGC.GetDecAry3D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv3d>$ = gGC.GetVaArray<VctrVec3D, Array3D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv3d>5); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ',' ',' ']' '=' { DecAry3D<Vector> *ptr = gGC.GetDecAry3D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv3d>$ = gGC.GetVaArray<VctrVec3D, Array3D<Vector> >(ptr->GetVarPtr()); } 
			expr_v3d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec3D>($<lhsv3d>5, $6);  vartype=TypeVctr; } 
	
	| ',' ',' ',' ']' '=' { DecAry4D<Vector> *ptr = gGC.GetDecAry4D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv4d>$ = gGC.GetVaArray<VctrVec4D, Array4D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv4d>6); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ',' ',' ',' ']' '=' { DecAry4D<Vector> *ptr = gGC.GetDecAry4D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv4d>$ = gGC.GetVaArray<VctrVec4D, Array4D<Vector> >(ptr->GetVarPtr()); } 
			expr_v4d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec4D>($<lhsv4d>6, $7);  vartype=TypeVctr; } 
			
	| ',' ',' ',' ',' ']' '=' { DecAry5D<Vector> *ptr = gGC.GetDecAry5D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv5d>$ = gGC.GetVaArray<VctrVec5D, Array5D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv5d>7); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ',' ',' ',' ',' ']' '=' { DecAry5D<Vector> *ptr = gGC.GetDecAry5D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv5d>$ = gGC.GetVaArray<VctrVec5D, Array5D<Vector> >(ptr->GetVarPtr()); } 
			expr_v5d { $$ = gGC.GetAssignmentArrayVctrLHS<VctrVec5D>($<lhsv5d>7, $8); vartype=TypeVctr; } 
			
			
	| ']' OPR_XPR { DecAry1D<Vector> *ptr = gGC.GetDecAry1D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv1d>$ = gGC.GetVaArray<VctrVec1D, Array1D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv1d>3, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ',' ']' OPR_XPR { DecAry2D<Vector> *ptr = gGC.GetDecAry2D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv2d>$ = gGC.GetVaArray<VctrVec2D, Array2D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv2d>4, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
		
	| ',' ',' ']' OPR_XPR { DecAry3D<Vector> *ptr = gGC.GetDecAry3D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv3d>$ = gGC.GetVaArray<VctrVec3D, Array3D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv3d>5, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
	
	| ',' ',' ',' ']' OPR_XPR { DecAry4D<Vector> *ptr = gGC.GetDecAry4D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv4d>$ = gGC.GetVaArray<VctrVec4D, Array4D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv4d>6, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
			
	| ',' ',' ',' ',' ']' OPR_XPR { DecAry5D<Vector> *ptr = gGC.GetDecAry5D<Vector>($<bufr>-2); gStmtListStack.top()->Add(ptr); 
			$<lhsv5d>$ = gGC.GetVaArray<VctrVec5D, Array5D<Vector> >(ptr->GetVarPtr()); } 
			ARY_OPEN { PreArrayInit($<lhsv5d>7, false); } array_vctr ARY_CLOSE { $$ = NULL; AfterArrayInit();  vartype=TypeVctr; } 
	;

expr_void: 
		hdr_void  arguments ')' 
		{
			CallFunc<voidtype>* ptr
					= dynamic_cast<CallFunc<voidtype>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| FN_VO_MR_MR '(' ARY_REAL2D ',' ARY_REAL2D ')' { $$ = gGC.GetVOFunMRMR($1, $3, $5); }
	;

expr_vmi1d: expr_udt '.' MEM_AI1D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<IntgAry1D>($1);  } ; 
expr_vmr1d: expr_udt '.' MEM_AR1D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<RealAry1D>($1);  } ; 
expr_vmc1d: expr_udt '.' MEM_AC1D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<CplxAry1D>($1);  } ; 
expr_vmv1d: expr_udt '.' MEM_AV1D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<VctrAry1D>($1);  } ; 
		
expr_vmi2d: expr_udt '.' MEM_AI2D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<IntgAry2D>($1);  } ; 
expr_vmr2d: expr_udt '.' MEM_AR2D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<RealAry2D>($1);  } ; 
expr_vmc2d: expr_udt '.' MEM_AC2D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<CplxAry2D>($1);  } ; 
expr_vmv2d: expr_udt '.' MEM_AV2D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<VctrAry2D>($1);  } ; 
		
expr_vmi3d: expr_udt '.' MEM_AI3D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<IntgAry3D>($1);  } ; 
expr_vmr3d: expr_udt '.' MEM_AR3D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<RealAry3D>($1);  } ; 
expr_vmc3d: expr_udt '.' MEM_AC3D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<CplxAry3D>($1);  } ; 
expr_vmv3d: expr_udt '.' MEM_AV3D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<VctrAry3D>($1);  } ; 
		
expr_vmi4d: expr_udt '.' MEM_AI4D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<IntgAry4D>($1);  } ; 
expr_vmr4d: expr_udt '.' MEM_AR4D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<RealAry4D>($1);  } ; 
expr_vmc4d: expr_udt '.' MEM_AC4D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<CplxAry4D>($1);  } ; 
expr_vmv4d: expr_udt '.' MEM_AV4D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<VctrAry4D>($1);  } ; 

expr_vmi5d: expr_udt '.' MEM_AI5D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<IntgAry5D>($1);  } ; 
expr_vmr5d: expr_udt '.' MEM_AR5D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<RealAry5D>($1);  } ; 
expr_vmc5d: expr_udt '.' MEM_AC5D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<CplxAry5D>($1);  } ; 
expr_vmv5d: expr_udt '.' MEM_AV5D { $1->InsertMemberID($3); $$ = gGC.GetVarMem<VctrAry5D>($1);  } ; 

expr_vai1d: expr_vub '.' MEM_AI1D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<IntgAry1D>($1); } ;
expr_var1d: expr_vub '.' MEM_AR1D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<RealAry1D>($1); } ;
expr_vac1d: expr_vub '.' MEM_AC1D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<CplxAry1D>($1); } ;
expr_vav1d: expr_vub '.' MEM_AV1D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<VctrAry1D>($1); } ;

expr_vai2d: expr_vub '.' MEM_AI2D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<IntgAry2D>($1); } ;
expr_var2d: expr_vub '.' MEM_AR2D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<RealAry2D>($1); } ;
expr_vac2d: expr_vub '.' MEM_AC2D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<CplxAry2D>($1); } ;
expr_vav2d: expr_vub '.' MEM_AV2D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<VctrAry2D>($1); } ;

expr_vai3d: expr_vub '.' MEM_AI3D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<IntgAry3D>($1); } ;
expr_var3d: expr_vub '.' MEM_AR3D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<RealAry3D>($1); } ;
expr_vac3d: expr_vub '.' MEM_AC3D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<CplxAry3D>($1); } ;
expr_vav3d: expr_vub '.' MEM_AV3D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<VctrAry3D>($1); } ;

expr_vai4d: expr_vub '.' MEM_AI4D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<IntgAry4D>($1); } ;
expr_var4d: expr_vub '.' MEM_AR4D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<RealAry4D>($1); } ;
expr_vac4d: expr_vub '.' MEM_AC4D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<CplxAry4D>($1); } ;
expr_vav4d: expr_vub '.' MEM_AV4D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<VctrAry4D>($1); } ;

expr_vai5d: expr_vub '.' MEM_AI5D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<IntgAry5D>($1); } ;
expr_var5d: expr_vub '.' MEM_AR5D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<RealAry5D>($1); } ;
expr_vac5d: expr_vub '.' MEM_AC5D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<CplxAry5D>($1); } ;
expr_vav5d: expr_vub '.' MEM_AV5D { $1->InsertMemberID($3); $$ = gGC.GetVarUser<VctrAry5D>($1); } ;


expr_vub: VAR_USER 
		{ $$ = gGC.GetVarUserBase($1); $$->udtptr = gUdtFactoryStack.top(); }
	| expr_vub '.' MEM_USER 
		{ $$->InsertMemberID($3); $$->udtptr = gUdtFactoryStack.top(); }
	;

cast_intg: TYPE_INTG '(' { vartype = TypeNull; } ;	
cast_real: TYPE_REAL '(' { vartype = TypeNull; } ;
cast_cplx: TYPE_CPLX '(' { vartype = TypeNull; } ;	
cast_vctr: TYPE_VCTR '(' { vartype = TypeNull; } ;	
		
expr_strn: TKN_STRING	{ $$ = gGC.GetLiteral($1); }
	| lhs_strn { $$ = dynamic_cast<ExpStrn*>($1); }

	| LTL_STRN { $$ = $1; } 
	
	| expr_udt '.' MEM_LTL_STRN { $$ = $3; gUdtFactoryStack.clear(); }
	| expr_vub '.' MEM_LTL_STRN { $$ = $3; gUdtFactoryStack.clear(); }
	
	| END_LINE			{ $$ = gGC.GetLiteral(_T("\r\n")); }
	| '(' expr_strn ')' { $$ = $2; }
	| expr_strn '+' expr_strn 
		{ $$ = gGC.GetBinOpr<string>('+', $1, $3); }
	
	| expr_strn '+' expr_boolean 
		{ $$ = gGC.GetBinOpr<string>('+', $1, gGC.GetExprStrn<bool>($3)); }
	| expr_strn '+' expr_intg 
		{ $$ = gGC.GetBinOpr<string>('+', $1, gGC.GetExprStrn<integer>($3)); }
	| expr_strn '+' expr_real 
		{ $$ = gGC.GetBinOpr<string>('+', $1, gGC.GetExprStrn<realnum>($3)); }
	| expr_strn '+' expr_cplx 
		{ $$ = gGC.GetBinOpr<string>('+', $1, gGC.GetExprStrn<Complex>($3)); }
	| expr_strn '+' expr_vctr 
		{ $$ = gGC.GetBinOpr<string>('+', $1, gGC.GetExprStrn<Vector>($3)); }
	
	| expr_boolean '+' expr_strn 
		{ $$ = gGC.GetBinOpr<string>('+', gGC.GetExprStrn<bool>($1), $3); }
	| expr_intg '+' expr_strn 
		{ $$ = gGC.GetBinOpr<string>('+', gGC.GetExprStrn<integer>($1), $3); }
	| expr_real '+' expr_strn 
		{ $$ = gGC.GetBinOpr<string>('+', gGC.GetExprStrn<realnum>($1), $3); }
	| expr_cplx '+' expr_strn 
		{ $$ = gGC.GetBinOpr<string>('+', gGC.GetExprStrn<Complex>($1), $3); }
	| expr_vctr '+' expr_strn 
		{ $$ = gGC.GetBinOpr<string>('+', gGC.GetExprStrn<Vector>($1), $3); }
		
	| hdr_strn arguments ')' 
	{
		CallFunc<string>* ptr
				= dynamic_cast<CallFunc<string>*>(gFuncCallStack.pop());
				
		if(ptr->ArgCountNotCompatible()) 
			HandleSyntaxError(L"Argument count mismatch.\r\n");
		$$ = ptr; arg_set = false; 
	}
	;

lhs_bptr: PTR_BOOL { $$ = gGC.GetPtrVariable<bool>($1); } ;
lhs_sptr: PTR_STRN { $$ = gGC.GetPtrVariable<string>($1); } ;
lhs_iptr: PTR_INTG { $$ = gGC.GetPtrVariable<integer>($1); } ;
lhs_rptr: PTR_REAL { $$ = gGC.GetPtrVariable<realnum>($1); } ;
lhs_cptr: PTR_CPLX { $$ = gGC.GetPtrVariable<Complex>($1); } ;
lhs_vptr: PTR_VCTR { $$ = gGC.GetPtrVariable<Vector>($1); } ;
lhs_uptr: PTR_USER { $$ = gGC.GetUdtPtrBase($1); $$->udtptr = $1->factory; } 
	
	| expr_vub '.' MEM_UPTR 
		{ $1->InsertMemberID($3); $1->udtptr = gUdtFactoryStack.top();  
			$$ = gGC.GetUserMemUPtrData(gGC.GetVarUser<UPtrData>($1)); 
			$$->udtptr = $1->udtptr; gUdtFactoryStack.push($1->udtptr);
		}
		
	| lhs_uptr '.' MEM_UPTR 
		{  
			$1->InsertMemberID($3); $1->udtptr = gUdtFactoryStack.top();  
			$$ = gGC.GetMemUPtrData($1); $$->udtptr = $1->udtptr; }
	
	| expr_udt '.' MEM_UPTR
		{ 
			if($1->ptrFunc)
				{ 
					$1->InsertMemberID($3); $1->udtptr = gUdtFactoryStack.top(); 
					
					$$ = gGC.GetVarMemUPtrData(gGC.GetVarMem<UPtrData>($1)); 
					$$->udtptr = $1->udtptr; gUdtFactoryStack.push($1->udtptr);
				}
			else
				HandleSyntaxError(L"Non literal member is accessible only inside a member funtion.\r\n");
				
			//$$ = NULL;
		}
	;
		
lhs_bool: VAR_BOOL { $$ = gGC.GetVariable<bool>($1);} 

	|	expr_vub '.' MEM_BOOL { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<bool>*>(gGC.GetVarUser<bool>($1)); }
		
	|	expr_udt '.' MEM_BOOL { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<bool>*>(gGC.GetVarMem<bool>($1)); } 
		
	|	lhs_uptr '.' MEM_BOOL { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<bool>*>(gGC.GetVarUserPtr<bool>($1)); } 
	
	| '*' lhs_bptr %prec UNARY { $$ = gGC.GetPtrExpToVar<bool>($2); }
	
	;
	

lhs_intg: VAR_INTG { $$ = gGC.GetVariable<integer>($1);} 

	|	expr_vub '.' MEM_INTG { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<integer>*>(gGC.GetVarUser<integer>($1)); } 
		
	|	expr_udt '.' MEM_INTG { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<integer>*>(gGC.GetVarMem<integer>($1)); } 
		
	|	lhs_uptr '.' MEM_INTG { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<integer>*>(gGC.GetVarUserPtr<integer>($1)); } 
					
	|	lhs_i1d '[' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<integer,IntgVec1D>($1, $3); } 
	|	lhs_i2d '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<integer,IntgVec2D>($1, $3, $5); } 
	|	lhs_i3d '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<integer,IntgVec3D>($1, $3, $5, $7); }
	|	lhs_i4d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<integer,IntgVec4D>($1, $3, $5, $7, $9); } 
	|	lhs_i5d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<integer,IntgVec5D>($1, $3, $5, $7, $9, $11); } 
		
	| PTR_AP1I '[' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<integer, IntgVec1D>($1, $3);}
	| PTR_AP2I '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<integer, IntgVec2D>($1, $3, $5); }
	| PTR_AP3I '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<integer, IntgVec3D>($1, $3, $5, $7);}
	| PTR_AP4I '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<integer, IntgVec4D>($1, $3, $5, $7, $9);}
	| PTR_AP5I '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<integer, IntgVec5D>($1, $3, $5, $7, $9, $11); }
	
	| '*' lhs_iptr %prec UNARY { $$ = gGC.GetPtrExpToVar<integer>($2); }
			
	;
		
lhs_real: 
		VAR_REAL { $$ = gGC.GetVariable<realnum>($1);}
	
	|	expr_vub '.' MEM_REAL { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<realnum>*>(gGC.GetVarUser<realnum>($1)); } 
		
	|	expr_udt '.' MEM_REAL { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<realnum>*>(gGC.GetVarMem<realnum>($1)); } 
		
	|	lhs_uptr '.' MEM_REAL { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<realnum>*>(gGC.GetVarUserPtr<realnum>($1)); } 
	
	|	lhs_cplx '.' CPLX_R { $$ = gGC.GetCplxLHSReal($1); }
	|	lhs_cplx '.' CPLX_I { $$ = gGC.GetCplxLHSImag($1); }
	
	|	lhs_vctr '.' VCTR_X { $$ = gGC.GetVctrLHSX($1); }
	|	lhs_vctr '.' VCTR_Y { $$ = gGC.GetVctrLHSY($1); }
	|	lhs_vctr '.' VCTR_Z { $$ = gGC.GetVctrLHSZ($1); }
	
	|	lhs_r1d '[' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<realnum,RealVec1D>($1, $3); } 
	|	lhs_r2d '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<realnum,RealVec2D>($1, $3, $5); } 
	|	lhs_r3d '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<realnum,RealVec3D>($1, $3, $5, $7); }
	|	lhs_r4d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<realnum,RealVec4D>($1, $3, $5, $7, $9); } 
	|	lhs_r5d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<realnum,RealVec5D>($1, $3, $5, $7, $9, $11); } 
		
	| PTR_AP1R '[' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<double, RealVec1D>($1, $3);}
	| PTR_AP2R '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<double, RealVec2D>($1, $3, $5); }
	| PTR_AP3R '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<double, RealVec3D>($1, $3, $5, $7);}
	| PTR_AP4R '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<double, RealVec4D>($1, $3, $5, $7, $9);}
	| PTR_AP5R '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<double, RealVec5D>($1, $3, $5, $7, $9, $11);}
		
	| '*' lhs_rptr %prec UNARY { $$ = gGC.GetPtrToVar<realnum>($2); }
	
	;
	

lhs_cplx: VAR_CPLX { $$ = gGC.GetVariable<Complex>($1);} 
	
	|	expr_vub '.' MEM_CPLX { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<Complex>*>(gGC.GetVarUser<Complex>($1)); } 
		
	|	expr_udt '.' MEM_CPLX { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<Complex>*>(gGC.GetVarMem<Complex>($1)); } 
		
	|	lhs_uptr '.' MEM_CPLX { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<Complex>*>(gGC.GetVarUserPtr<Complex>($1)); } 
		
	|	lhs_c1d '[' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Complex,CplxVec1D>($1, $3); } 
	|	lhs_c2d '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Complex,CplxVec2D>($1, $3, $5); } 
	|	lhs_c3d '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Complex,CplxVec3D>($1, $3, $5, $7); }
	|	lhs_c4d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Complex,CplxVec4D>($1, $3, $5, $7, $9); } 
	|	lhs_c5d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Complex,CplxVec5D>($1, $3, $5, $7, $9, $11); } 
		
	| PTR_AP1C '[' expr_inum ']' { $$ = gGC.GetExprAptr<Complex, CplxVec1D>($1, $3);}
	| PTR_AP2C '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Complex, CplxVec2D>($1, $3, $5); }
	| PTR_AP3C '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Complex, CplxVec3D>($1, $3, $5, $7);}
	| PTR_AP4C '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Complex, CplxVec4D>($1, $3, $5, $7, $9);}
	| PTR_AP5C '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Complex, CplxVec5D>($1, $3, $5, $7, $9, $11);}
		
	| '*' lhs_cptr %prec UNARY { $$ = gGC.GetPtrExpToVar<Complex>($2); }
	
	;
	

lhs_vctr: VAR_VCTR { $$ = gGC.GetVariable<Vector>($1);} 

	|	expr_vub '.' MEM_VCTR { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<Vector>*>(gGC.GetVarUser<Vector>($1));  } 
		
	|	expr_udt '.' MEM_VCTR { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<Vector>*>(gGC.GetVarMem<Vector>($1)); } 
		
	|	lhs_uptr '.' MEM_VCTR { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<Vector>*>(gGC.GetVarUserPtr<Vector>($1)); } 
			
	|	lhs_v1d '[' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Vector, VctrVec1D>($1, $3); } 
	|	lhs_v2d '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Vector, VctrVec2D>($1, $3, $5); } 
	|	lhs_v3d '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Vector, VctrVec3D>($1, $3, $5, $7); }
	|	lhs_v4d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Vector, VctrVec4D>($1, $3, $5, $7, $9); } 
	|	lhs_v5d '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetVarAryEle<Vector, VctrVec5D>($1, $3, $5, $7, $9, $11); } 
		
	| PTR_AP1V '[' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Vector, VctrVec1D>($1, $3);}
	| PTR_AP2V '[' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Vector, VctrVec2D>($1, $3, $5); }
	| PTR_AP3V '[' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Vector, VctrVec3D>($1, $3, $5, $7);}
	| PTR_AP4V '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Vector, VctrVec4D>($1, $3, $5, $7, $9);}
	| PTR_AP5V '[' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ',' expr_inum ']' 
		{ $$ = gGC.GetExprAptr<Vector, VctrVec5D>($1, $3, $5, $7, $9, $11);}
		
	| '*' lhs_vptr %prec UNARY { $$ = gGC.GetPtrExpToVar<Vector>($2); }
	
	;

lhs_strn: VAR_STRN { $$ = gGC.GetVariable<string>($1);} 
	
	|	expr_vub '.' MEM_STRN { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<string>*>(gGC.GetVarUser<string>($1)); }
	|	expr_udt '.' MEM_STRN { $1->InsertMemberID($3); 
		$$ = dynamic_cast<LeftHandSide<string>*>(gGC.GetVarMem<string>($1)); }
		
	|	lhs_uptr '.' MEM_STRN { $1->InsertMemberID($3);
		$$ = dynamic_cast<LeftHandSide<string>*>(gGC.GetVarUserPtr<string>($1)); } 
	
	| '*' lhs_sptr %prec UNARY { $$ = gGC.GetPtrExpToVar<string>($2); }
	;
	
lhs_user: expr_udt %prec OPR_LOWERTHANDOT { $$ = gGC.GetVarMemExp($1); }
	|	expr_vub %prec OPR_LOWERTHANDOT { $$ = gGC.GetVarUserExp($1); }
	|	lhs_uptr '.' MEM_USER { $1->InsertMemberID($3); 
			$1->udtptr = gUdtFactoryStack.top(); $$ = gGC.GetUdtPtrExp($1); }
	| '*' lhs_uptr %prec UNARY { $$ = gGC.GetPtrExpToVarUserData($2); }
	;
	
expr_user: lhs_user { $$ = dynamic_cast<ExpUserPtr>($1); }
	|  hdr_user arguments ')' 
		{
			CallFunc<UserData>* ptr
					= dynamic_cast<CallFunc<UserData>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			gUdtFactoryStack.clear(); gUdtFactoryStack.push
			(ptr->GetFunPtr()->pUDTFactory); $$ = ptr; arg_set = false; 
		}
	;

new_hdr_bool: TKN_NEW TYPE_BOOL { vartype = TypeNull; } ;
new_hdr_strn: TKN_NEW TYPE_STRN { vartype = TypeNull; } ;
new_hdr_intg: TKN_NEW TYPE_INTG { vartype = TypeNull; } ;
new_hdr_real: TKN_NEW TYPE_REAL { vartype = TypeNull; } ;
new_hdr_cplx: TKN_NEW TYPE_CPLX { vartype = TypeNull; } ;
new_hdr_vctr: TKN_NEW TYPE_VCTR { vartype = TypeNull; } ;
new_hdr_user: TKN_NEW TYPE_UDT { vartype = TypeNull; } ;
	
expr_bptr: new_hdr_bool { $$ = gGC.GetDynamicAllocation<bool>(); } 
	|	new_hdr_bool '(' expr_ini_bool ')' 
		{ $$ = gGC.GetDynamicAllocation<bool>($3); } 
	
	| lhs_bptr { $$ = dynamic_cast<Expression<bool*>*>($1); }
	
	| hdr_bptr arguments ')' 
		{
			CallFunc<bool*>* ptr
					= dynamic_cast<CallFunc<bool*>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
expr_sptr: new_hdr_strn { $$ = gGC.GetDynamicAllocation<string>(); } 
	|	new_hdr_strn '(' expr_ini_strn ')' 
		{ $$ = gGC.GetDynamicAllocation<string>($3); } 
		
	| lhs_sptr { $$ = dynamic_cast<Expression<string*>*>($1); }
	
	| hdr_sptr arguments ')' 
		{
			CallFunc<string*>* ptr
					= dynamic_cast<CallFunc<string*>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
expr_uptr: new_hdr_user 
		{ $$ = gGC.GetAllocateUserData(gUdtFactoryStack.top()); } 
	
	//| lhs_uptr { $$ = dynamic_cast<Expression<UserData*>*>($1); }
	
	;

expr_iptr: new_hdr_intg { $$ = gGC.GetDynamicAllocation<integer>(); } 
	|	new_hdr_intg '(' expr_ini_intg ')' 
		{ $$ = gGC.GetDynamicAllocation<integer>($3); } 
	
	| lhs_iptr { $$ = dynamic_cast<Expression<integer*>*>($1); }
			
	| hdr_iptr arguments ')' 
		{
			CallFunc<integer*>* ptr
					= dynamic_cast<CallFunc<integer*>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
expr_rptr: new_hdr_real { $$ = gGC.GetDynamicAllocation<realnum>(); } 
	|	new_hdr_real '(' expr_ini_real ')' 
		{ $$ = gGC.GetDynamicAllocation<realnum>($3); } 
		
	| lhs_rptr { $$ = dynamic_cast<Expression<realnum*>*>($1); }
	
	| hdr_rptr arguments ')' 
		{
			CallFunc<realnum*>* ptr
					= dynamic_cast<CallFunc<realnum*>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
expr_cptr: new_hdr_cplx { $$ = gGC.GetDynamicAllocation<Complex>(); } 
	|	new_hdr_cplx '(' expr_ini_cplx ')' 
		{ $$ = gGC.GetDynamicAllocation<Complex>($3); } 
	
	| lhs_cptr { $$ = dynamic_cast<Expression<Complex*>*>($1); }
	
	| hdr_cptr arguments ')' 
		{
			CallFunc<Complex*>* ptr
					= dynamic_cast<CallFunc<Complex*>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
expr_vptr: new_hdr_vctr { $$ = gGC.GetDynamicAllocation<Vector>(); } 
	|	new_hdr_vctr '(' expr_ini_vctr ')' 
		{ $$ = gGC.GetDynamicAllocation<Vector>($3); } 
	
	| lhs_vptr { $$ = dynamic_cast<Expression<Vector*>*>($1); }
	
	| hdr_vptr arguments ')' 
		{
			CallFunc<Vector*>* ptr
					= dynamic_cast<CallFunc<Vector*>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
expr_intg:  INTG { $$ = gGC.GetLiteral($1); }
	
	| lhs_intg	{ $$ = dynamic_cast<ExpIntgPtr>($1); }
	
	| LTL_INTG  { $$ = $1; } 
	
	| expr_udt '.' MEM_LTL_INTG { $$ = $3; gUdtFactoryStack.clear(); }
	| expr_vub '.' MEM_LTL_INTG { $$ = $3; gUdtFactoryStack.clear(); }
		
	| expr_boolean '?' expr_intg ':' expr_intg 
		{ $$ = gGC.GetExprWhich<integer>($1, $3, $5); }
	
	| cast_intg ')'	{ $$=gGC.GetLiteral(integer()); }
	| cast_intg expr_real ')' { $$ = gGC.GetR2I($2);  }
	| cast_intg expr_intg ')' { $$ = $2;  }
									
	| hdr_intg  arguments ')' 
		{
			CallFunc<integer>* ptr
					= dynamic_cast<CallFunc<integer>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
		
	| lhs_intg '(' ')' { $$ = gGC.GetCallExpression<integer>($1); }
	| lhs_intg '(' for_update ')' { $$ = gGC.GetCallExpression<integer>($1, $3); }
	| '[' lhs_intg ']' { $$ = gGC.GetAssignExpression<integer>($2); }
	| '[' lhs_intg ']' '(' for_update ')' { $$ = gGC.GetAssignExpression<integer>($2, $5); }
				
	| expr_intg '+' expr_intg { $$ = gGC.GetBinOpr<integer>('+', $1, $3); }
	| expr_intg '-' expr_intg { $$ = gGC.GetBinOpr<integer>('-', $1, $3); }
	| expr_intg '*' expr_intg { $$ = gGC.GetBinOpr<integer>('*', $1, $3); }
	| expr_intg '/' expr_intg { $$ = gGC.GetBinOpr<integer>('/', $1, $3); }
	| expr_intg '%' expr_intg { $$ = gGC.GetBinOpr<integer>('%', $1, $3); }
	
	| expr_intg '#' expr_intg { $$ = gGC.GetExprMaxMin<integer>($1, $3, false); } // minimum
	| expr_intg '@' expr_intg { $$ = gGC.GetExprMaxMin<integer>($1, $3, true);  }  // maximum
		
	| '-' expr_intg %prec UNARY { $$ = gGC.GetUnaryOpr<integer>('-', $2); }
	| '+' expr_intg %prec UNARY { $$ = $2; }
	| '(' expr_intg ')'		    { $$ = $2; }
	| '|' expr_intg '|'			{ $$ = gGC.GetAbs($2);       }
	| expr_intg '!'			    { $$ = gGC.GetFactorial($1); }
	| expr_real '!'			    { $$ = gGC.GetFactorial(gGC.GetR2I($1)); }
	
	| '[' expr_inum '|' expr_inum ']' // permutation
			{ $$ = gGC.GetBinOpr<integer>('P', $2, $4); }
	| '[' expr_inum ':' expr_inum ']'  // combination
			{ $$ = gGC.GetBinOpr<integer>('C', $2, $4); }
	| '(' expr_inum '|' expr_inum ')' // greatest common divisor
			{ $$ = gGC.GetBinOpr<integer>('G', $2, $4); }
	| '(' expr_inum ':' expr_inum ')' // least common multiple
			{ $$ = gGC.GetBinOpr<integer>('L', $2, $4); }
	
	| FN_INTG '(' ')' { $$=gGC.GetIFunIntg($1); }
	| FN_I_II '(' expr_inum ',' expr_inum ')' { $$=gGC.GetIFunII($1, $3, $5); }
			
	| '#' expr_i1d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec1D>($2, '-'); }
	| '#' expr_i2d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec2D>($2, '-'); }
	| '#' expr_i3d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec3D>($2, '-'); }
	| '#' expr_i4d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec4D>($2, '-'); }
	| '#' expr_i5d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec5D>($2, '-'); }
	
	| '@' expr_i1d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec1D>($2, '+'); }
	| '@' expr_i2d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec2D>($2, '+'); }
	| '@' expr_i3d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec3D>($2, '+'); }
	| '@' expr_i4d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec4D>($2, '+'); }
	| '@' expr_i5d %prec UNARY { $$ = gGC.GetMinMaxEle<integer, IntgVec5D>($2, '+'); }
	
	| expr_dim { $$ = $1; }
	
	| lhs_i1d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<IntgVec1D>($1); }
	| lhs_r1d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<RealVec1D>($1); }
	| lhs_c1d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<CplxVec1D>($1); }
	| lhs_v1d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<VctrVec1D>($1); }
	
	| lhs_i2d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<IntgVec2D>($1); }
	| lhs_r2d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<RealVec2D>($1); }
	| lhs_c2d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<CplxVec2D>($1); }
	| lhs_v2d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<VctrVec2D>($1); }
	
	| lhs_i2d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec2D>($1, $5); }
	| lhs_r2d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec2D>($1, $5); }
	| lhs_c2d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec2D>($1, $5); }
	| lhs_v2d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec2D>($1, $5); }
	
	| lhs_i3d '.' OPR_SIZE 
		{ $$ = gGC.GetArraySizeExp<IntgVec3D>($1); }
	| lhs_r3d '.' OPR_SIZE 
		{ $$ = gGC.GetArraySizeExp<RealVec3D>($1); }
	| lhs_c3d '.' OPR_SIZE 
		{ $$ = gGC.GetArraySizeExp<CplxVec3D>($1); }
	| lhs_v3d '.' OPR_SIZE 
		{ $$ = gGC.GetArraySizeExp<VctrVec3D>($1); }
	
	| lhs_i3d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec3D>($1, $5); }
	| lhs_r3d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec3D>($1, $5); }
	| lhs_c3d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec3D>($1, $5); }
	| lhs_v3d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec3D>($1, $5); }
	
	| lhs_i3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec3D>($1, $5, $7); }
	| lhs_r3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec3D>($1, $5, $7); }
	| lhs_c3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec3D>($1, $5, $7); }
	| lhs_v3d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec3D>($1, $5, $7); }
	
	| lhs_i4d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<IntgVec4D>($1); }
	| lhs_r4d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<RealVec4D>($1); }
	| lhs_c4d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<CplxVec4D>($1); }
	| lhs_v4d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<VctrVec4D>($1); }
	
	| lhs_i4d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec4D>($1, $5); }
	| lhs_r4d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec4D>($1, $5); }
	| lhs_c4d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec4D>($1, $5); }
	| lhs_v4d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec4D>($1, $5); }
	
	| lhs_i4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec4D>($1, $5, $7); }
	| lhs_r4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec4D>($1, $5, $7); }
	| lhs_c4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec4D>($1, $5, $7); }
	| lhs_v4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec4D>($1, $5, $7); }
	
	| lhs_i4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec4D>($1, $5, $7, $9); }
	| lhs_r4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec4D>($1, $5, $7, $9); }
	| lhs_c4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec4D>($1, $5, $7, $9); }
	| lhs_v4d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec4D>($1, $5, $7, $9); }
	
	| lhs_i5d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<IntgVec5D>($1); }
	| lhs_r5d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<RealVec5D>($1); }
	| lhs_c5d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<CplxVec5D>($1); }
	| lhs_v5d '.' OPR_SIZE { $$ = gGC.GetArraySizeExp<VctrVec5D>($1); }
	
	| lhs_i5d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec5D>($1, $5); }
	| lhs_r5d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec5D>($1, $5); }
	| lhs_c5d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec5D>($1, $5); }
	| lhs_v5d '.' OPR_SIZE '(' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec5D>($1, $5); }
	
	| lhs_i5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec5D>($1, $5, $7); }
	| lhs_r5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec5D>($1, $5, $7); }
	| lhs_c5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec5D>($1, $5, $7); }
	| lhs_v5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec5D>($1, $5, $7); }
	
	| lhs_i5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec5D>($1, $5, $7, $9); }
	| lhs_r5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec5D>($1, $5, $7, $9); }
	| lhs_c5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec5D>($1, $5, $7, $9); }
	| lhs_v5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec5D>($1, $5, $7, $9); }
	
	| lhs_i5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<IntgVec5D>($1, $5, $7, $9, $11); }
	| lhs_r5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<RealVec5D>($1, $5, $7, $9, $11); }
	| lhs_c5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<CplxVec5D>($1, $5, $7, $9, $11); }
	| lhs_v5d '.' OPR_SIZE '(' lhs_intg ',' lhs_intg ',' lhs_intg ',' lhs_intg ')' 
		{ $$ = gGC.GetArraySizeExp<VctrVec5D>($1, $5, $7, $9, $11); }
	;
					
expr_dim: 
		expr_i1d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(1)); }
	|	expr_r1d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(1)); }
	|	expr_c1d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(1)); }
	|	expr_v1d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(1)); }
	
	|	expr_i2d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(2)); }
	|	expr_r2d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(2)); }
	|	expr_c2d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(2)); }
	|	expr_v2d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(2)); }
	
	|	expr_i3d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(3)); }
	|	expr_r3d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(3)); }
	|	expr_c3d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(3)); }
	|	expr_v3d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(3)); }
	
	|	expr_i4d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(4)); }
	|	expr_r4d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(4)); }
	|	expr_c4d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(4)); }
	|	expr_v4d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(4)); }
	
	|	expr_i5d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(5)); }
	|	expr_r5d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(5)); }
	|	expr_c5d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(5)); }
	|	expr_v5d '.' OPR_DIMENSION { $$ = gGC.GetLiteral(integer(5)); }
	
	;

stmt_ary_makeunit:
	  FN_VO_MAKEUNIT '(' array_rc_dim2 ')' { $$=gGC.GetVOFunMakeUnit($1, $3);  }
	| FN_VO_MAKEUNIT '(' array_rc_dim2 ',' expr_inum ')' { $$=gGC.GetVOFunMakeUnit($1, $3, $5);  }
	;

hdr_user: FNC_USER '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<UserData>($1)); }
	| expr_udt '.' FNC_USER '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<UserData>($3, NULL, $1)); } 
	| expr_vub '.' FNC_USER '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<UserData>($3, $1)); 
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;

hdr_bptr: FNC_BPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<bool*>($1)); } 
	| expr_udt '.' FNC_BPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<bool*>($3, NULL, $1)); } 
	| expr_vub '.' FNC_BPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<bool*>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_sptr: FNC_SPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<string*>($1)); } 
	| expr_udt '.' FNC_SPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<string*>($3, NULL, $1)); } 
	| expr_vub '.' FNC_SPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<string*>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_iptr: FNC_IPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<integer*>($1)); } 
	| expr_udt '.' FNC_IPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<integer*>($3, NULL, $1)); } 
	| expr_vub '.' FNC_IPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<integer*>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_rptr: FNC_RPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<realnum*>($1)); } 
	| expr_udt '.' FNC_RPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<realnum*>($3, NULL, $1)); } 
	| expr_vub '.' FNC_RPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<realnum*>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_cptr: FNC_CPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<Complex*>($1)); } 
	| expr_udt '.' FNC_CPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<Complex*>($3, NULL, $1)); } 
	| expr_vub '.' FNC_CPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<Complex*>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_vptr: FNC_VPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<Vector*>($1)); } 
	| expr_udt '.' FNC_VPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<Vector*>($3, NULL, $1)); } 
	| expr_vub '.' FNC_VPTR '(' 
	{ gFuncCallStack.push(gGC.GetFunCall<Vector*>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_void: FNC_VOID '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<voidtype>($1)); }
	| expr_udt '.' FNC_VOID '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<voidtype>($3, NULL, $1)); } 
	| expr_vub '.' FNC_VOID '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<voidtype>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_VOID '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<voidtype>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
			
	;
	
hdr_bool: FNC_BOOL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<bool>($1)); } 
	| expr_udt '.' FNC_BOOL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<bool>($3, NULL, $1)); } 
	| expr_vub '.' FNC_BOOL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<bool>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_BOOL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<bool>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
			
	;

hdr_intg: FNC_INTG '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<integer>($1)); } 
	| expr_udt '.' FNC_INTG '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<integer>($3, NULL, $1)); } 
	| expr_vub '.' FNC_INTG '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<integer>($3, $1));
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_INTG '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<integer>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_real: FNC_REAL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<realnum>($1)); } 
	| expr_udt '.' FNC_REAL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<realnum>($3, NULL, $1)); } 
	| expr_vub '.' FNC_REAL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<realnum>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_REAL '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<realnum>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;

hdr_cplx: FNC_CPLX '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Complex>($1)); } 
	| expr_udt '.' FNC_CPLX '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Complex>($3, NULL, $1)); } 
	| expr_vub '.' FNC_CPLX '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Complex>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_CPLX '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Complex>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_vctr: FNC_VCTR '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Vector>($1)); }
	| expr_udt '.' FNC_VCTR '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Vector>($3, NULL, $1)); } 
	| expr_vub '.' FNC_VCTR '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Vector>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_VCTR '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<Vector>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_strn: FNC_STRN '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<string>($1)); }
	| expr_udt '.' FNC_STRN '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<string>($3, NULL, $1)); } 
	| expr_vub '.' FNC_STRN '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<string>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_STRN '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<string>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
			
	;

hdr_ai1d: FNC_AI1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec1D>($1)); }
	| expr_udt '.' FNC_AI1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec1D>($3, NULL, $1)); } 
	| expr_vub '.' FNC_AI1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec1D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AI1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec1D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_ai2d: FNC_AI2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec2D>($1)); } 
	| expr_udt '.' FNC_AI2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec2D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AI2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec2D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AI2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec2D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
			
	;
	
hdr_ai3d: FNC_AI3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec3D>($1)); } 
	| expr_udt '.' FNC_AI3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec3D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AI3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec3D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AI3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec3D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_ai4d: FNC_AI4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec4D>($1)); } 
	| expr_udt '.' FNC_AI4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec4D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AI4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec4D>($3, $1)); 
		gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AI4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec4D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_ai5d: FNC_AI5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec5D>($1)); } 
	| expr_udt '.' FNC_AI5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec5D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AI5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec5D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AI5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<IntgVec5D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;

hdr_ar1d: FNC_AR1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec1D>($1)); } 
	| expr_udt '.' FNC_AR1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec1D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AR1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec1D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AR1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec1D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
			
	;
hdr_ar2d: FNC_AR2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec2D>($1)); } 
	| expr_udt '.' FNC_AR2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec2D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AR2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec2D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AR2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec2D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
			
	;
hdr_ar3d: FNC_AR3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec3D>($1)); } 
	| expr_udt '.' FNC_AR3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec3D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AR3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec3D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AR3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec3D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_ar4d: FNC_AR4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec4D>($1)); } 
	| expr_udt '.' FNC_AR4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec4D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AR4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec4D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AR4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec4D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 	
	;
hdr_ar5d: FNC_AR5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec5D>($1)); } 
	| expr_udt '.' FNC_AR5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec5D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AR5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec5D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AR5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<RealVec5D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;

hdr_ac1d: FNC_AC1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec1D>($1)); } 
	| expr_udt '.' FNC_AC1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec1D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AC1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec1D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AC1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec1D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_ac2d: FNC_AC2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec2D>($1)); } 
	| expr_udt '.' FNC_AC2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec2D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AC2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec2D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AC2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec2D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_ac3d: FNC_AC3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec3D>($1)); } 
	| expr_udt '.' FNC_AC3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec3D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AC3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec3D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AC3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec3D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_ac4d: FNC_AC4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec4D>($1)); } 
	| expr_udt '.' FNC_AC4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec4D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AC4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec4D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AC4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec4D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
	
hdr_ac5d: FNC_AC5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec5D>($1)); } 
	| expr_udt '.' FNC_AC5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec5D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AC5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec5D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AC5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<CplxVec5D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;

hdr_av1d: FNC_AV1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec1D>($1)); } 
	| expr_udt '.' FNC_AV1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec1D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AV1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec1D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AV1D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec1D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_av2d: FNC_AV2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec2D>($1)); } 
	| expr_udt '.' FNC_AV2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec2D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AV2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec2D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AV2D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec2D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_av3d: FNC_AV3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec3D>($1)); } 
	| expr_udt '.' FNC_AV3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec3D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AV3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec3D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AV3D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec3D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_av4d: FNC_AV4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec4D>($1)); } 
	| expr_udt '.' FNC_AV4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec4D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AV4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec4D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AV4D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec4D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;
hdr_av5d: FNC_AV5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec5D>($1)); } 
	| expr_udt '.' FNC_AV5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec5D>($3, NULL, $1)); }
	| expr_vub '.' FNC_AV5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec5D>($3, $1)); 
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	| lhs_uptr '.' FNC_AV5D '(' 
		{ gFuncCallStack.push(gGC.GetFunCall<VctrVec5D>($3, NULL, NULL, $1));
			gUdtFactoryStack.clear(); vartype = TypeNull; } 
	;

cplx_to_real:
		expr_cplx '.' CPLX_R { $$=gGC.GetCplxRHSReal($1); }
	|	expr_cplx '.' CPLX_I { $$=gGC.GetCplxRHSImag($1); }
	;
	
vctr_to_real:
		expr_vctr '.' VCTR_X { $$ = gGC.GetVctrRHSX($1); }
	|	expr_vctr '.' VCTR_Y { $$ = gGC.GetVctrRHSY($1); }
	|	expr_vctr '.' VCTR_Z { $$ = gGC.GetVctrRHSZ($1); }
	;

expr_real: REAL { $$ = gGC.GetLiteral($1); }
	
	| lhs_real { $$ = dynamic_cast<ExpReal*>($1); }
	
	| cplx_to_real { $$ = $1; } | vctr_to_real { $$ = $1; }
	
	| LTL_REAL { $$ = $1; } 
	
	| expr_udt '.' MEM_LTL_REAL { $$ = $3; gUdtFactoryStack.clear(); }
	| expr_vub '.' MEM_LTL_REAL { $$ = $3; gUdtFactoryStack.clear(); }
	
	| expr_boolean '?' expr_real ':' expr_real  
		{ $$ = gGC.GetExprWhich<realnum>($1, $3, $5); }
		
	| expr_boolean '?' expr_intg ':' expr_real  
		{ $$ = gGC.GetExprWhich<realnum>($1, gGC.GetI2R($3), $5); } 
		
	| expr_boolean '?' expr_real ':' expr_intg 
		{ $$ = gGC.GetExprWhich<realnum>($1, $3, gGC.GetI2R($5)) ; }
				
	| cast_real ')'	{ $$=gGC.GetLiteral(realnum()); }
	| cast_real expr_intg ')' { $$ = gGC.GetI2R($2);  }
	| cast_real expr_real ')' { $$ = $2;  }
		
	| hdr_real arguments ')' 
		{ 
			CallFunc<realnum>* ptr
				= dynamic_cast<CallFunc<realnum>*>(gFuncCallStack.pop());
			
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}

	| lhs_real '(' ')' { $$ = gGC.GetCallExpression<realnum>($1); }
	| lhs_real '(' for_update ')' { $$ = gGC.GetCallExpression<realnum>($1, $3); }
	| '[' lhs_real ']' { $$ = gGC.GetAssignExpression<realnum>($2); }
	| '[' lhs_real ']' '(' for_update ')' { $$ = gGC.GetAssignExpression<realnum>($2, $5); }
			
	| expr_real '+' expr_real { $$ = gGC.GetBinOpr<realnum>('+', $1, $3); }
	| expr_real '-' expr_real { $$ = gGC.GetBinOpr<realnum>('-', $1, $3); }
	| expr_real '*' expr_real { $$ = gGC.GetBinOpr<realnum>('*', $1, $3); }
	| expr_real '/' expr_real { $$ = gGC.GetBinOpr<realnum>('/', $1, $3); }
	
	| expr_intg '+' expr_real { $$ = gGC.GetBinOpr<realnum>('+', gGC.GetI2R($1), $3); }
	| expr_intg '-' expr_real { $$ = gGC.GetBinOpr<realnum>('-', gGC.GetI2R($1), $3); }
	| expr_intg '*' expr_real { $$ = gGC.GetBinOpr<realnum>('*', gGC.GetI2R($1), $3); }
	| expr_intg '/' expr_real { $$ = gGC.GetBinOpr<realnum>('/', gGC.GetI2R($1), $3); }
	
	| expr_real '+' expr_intg { $$ = gGC.GetBinOpr<realnum>('+', $1, gGC.GetI2R($3)); }
	| expr_real '-' expr_intg { $$ = gGC.GetBinOpr<realnum>('-', $1, gGC.GetI2R($3)); }
	| expr_real '*' expr_intg { $$ = gGC.GetBinOpr<realnum>('*', $1, gGC.GetI2R($3)); }
	| expr_real '/' expr_intg { $$ = gGC.GetBinOpr<realnum>('/', $1, gGC.GetI2R($3)); }
	
	| expr_real '#' expr_real { $$ = gGC.GetExprMaxMin<realnum>($1, $3, false); } // minimum
	| expr_real '@' expr_real { $$ = gGC.GetExprMaxMin<realnum>($1, $3, true);  } // maximum
			
	| expr_vctr '*' expr_vctr { $$ = gGC.GetVVDotOpr($1, $3); }
	| '-' expr_real %prec UNARY { $$ = gGC.GetUnaryOpr<realnum>('-', $2); }
	| '+' expr_real %prec UNARY { $$ = $2; }
	| '(' expr_real ')'		  { $$ = $2; }
	| expr_real '^' expr_real 
		{ FunName fn; StrCopy(fn.fn, _T("pow")); gflist.find(fn); $$ = gGC.GetFunSimple(fn, $1, $3); } 
	| expr_real '^' expr_intg 
		{ FunName fn; StrCopy(fn.fn, _T("pow")); gflist.find(fn); $$ = gGC.GetFunSimple(fn, $1, gGC.GetI2R($3)); } 
	| expr_intg '^' expr_intg 
		{ FunName fn; StrCopy(fn.fn, _T("pow")); gflist.find(fn); $$ = gGC.GetFunSimple(fn, gGC.GetI2R($1), gGC.GetI2R($3)); } 
	| expr_intg '^' expr_real 
		{ FunName fn; StrCopy(fn.fn, _T("pow")); gflist.find(fn); $$ = gGC.GetFunSimple(fn, gGC.GetI2R($1), $3); } 
	
	| func_real	{ $$ = $1; }
	
	| '|' expr_r2d '|' { $$ = gGC.GetExpDet<realnum, RealVec2D>($2); }
	| OPR_SOL SOL_DETCRAMER expr_r2d { $$ = gGC.GetExpDet<realnum, RealVec2D>($3); }
			
	| '#' expr_r1d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec1D>($2, '-'); }
	| '#' expr_r2d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec2D>($2, '-'); }
	| '#' expr_r3d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec3D>($2, '-'); }
	| '#' expr_r4d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec4D>($2, '-'); }
	| '#' expr_r5d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec5D>($2, '-'); }
	
	| '@' expr_r1d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec1D>($2, '+'); }
	| '@' expr_r2d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec2D>($2, '+'); }
	| '@' expr_r3d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec3D>($2, '+'); }
	| '@' expr_r4d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec4D>($2, '+'); }
	| '@' expr_r5d %prec UNARY { $$ = gGC.GetMinMaxEle<realnum, RealVec5D>($2, '+'); }
	
	;

func_real: 
	  '|' expr_cplx '|'	
		{ FunName fn; StrCopy(fn.fn, _T("absc")); gflist.find(fn); $$ = gGC.GetRFunC(fn, $2); } 
	| '|' expr_vctr '|' 
		{ FunName fn; StrCopy(fn.fn, _T("absv")); gflist.find(fn); $$ = gGC.GetRFunV(fn, $2); } 
	
	// argument of a complex number
	| '@' expr_cplx %prec UNARY
		{ FunName fn; StrCopy(fn.fn, _T("argc")); gflist.find(fn); $$ = gGC.GetRFunC(fn, $2); } 
	
	| '|' expr_real '|' 
		{ FunName fn; StrCopy(fn.fn, _T("fabs")); gflist.find(fn); $$ = gGC.GetFunSimple(fn, $2); } 
	
	| FN_REAL '(' expr_rnum ')' { $$ = gGC.GetFunSimple($1, $3); }
	
	| FN_R_I '(' expr_inum ')' { $$ = gGC.GetFunSimple($1, $3); }	
	
	| FN_R_II '(' expr_inum ',' expr_inum ')' { $$ = gGC.GetFunSimple($1, $3, $5); }	
		
	| FN_R_RR '(' expr_rnum ',' expr_rnum ')' { $$ = gGC.GetFunSimple($1, $3, $5); }	
	| FN_R_RRR '(' expr_rnum ',' expr_rnum ',' expr_rnum ')' { $$ = gGC.GetFunSimple($1, $3, $5, $7); }	
	| FN_R_RRRR '(' expr_rnum ',' expr_rnum ',' expr_rnum ',' expr_rnum')' 
		{ $$ = gGC.GetFunSimple($1, $3, $5, $7, $9); }	
	| FN_R_C '(' expr_cplx ')' { $$ = gGC.GetRFunC($1, $3); }
	| FN_R_V '(' expr_vctr ')' { $$ = gGC.GetRFunV($1, $3); }
	
	;

expr_cnum: expr_cplx { $$ = $1; } 
	| expr_real { $$ = gGC.GetR2C($1); } | expr_intg { $$ = gGC.GetI2C($1); } ;
		
expr_rnum: expr_real { $$ = $1; } | expr_intg { $$ = gGC.GetI2R($1); } ;

expr_inum: expr_real { $$ = gGC.GetR2I($1); } | expr_intg { $$ = $1; } ;

expr_cplx: '(' expr_rnum ',' expr_rnum ')' { $$ = gGC.GetLiteral($2, $4); }
	
	| lhs_cplx %prec OPR_LOWERTHANDOT { $$ = dynamic_cast<ExpCplx*>($1); }
	
	| LTL_CPLX  { $$ = $1; } 
	
	| expr_udt '.' MEM_LTL_CPLX { $$ = $3; gUdtFactoryStack.clear(); }
	| expr_vub '.' MEM_LTL_CPLX { $$ = $3; gUdtFactoryStack.clear(); }
	
	| expr_boolean '?' expr_cplx ':' expr_cplx
		{ $$ = gGC.GetExprWhich<Complex>($1, $3, $5); }
	
	| expr_boolean '?' expr_real ':' expr_cplx
		{ $$ = gGC.GetExprWhich<Complex>($1, gGC.GetR2C($3), $5); }
		
	| expr_boolean '?' expr_cplx ':' expr_real
		{ $$ = gGC.GetExprWhich<Complex>($1, $3, gGC.GetR2C($5) ); }
		
	| expr_boolean '?' expr_intg ':' expr_cplx
		{ $$ = gGC.GetExprWhich<Complex>($1, gGC.GetI2C($3), $5); }
		
	| expr_boolean '?' expr_cplx ':' expr_intg
		{ $$ = gGC.GetExprWhich<Complex>($1, $3, gGC.GetI2C($5) ); }
		
	| CPLX_OPR_IMAG	{ $$ = gGC.GetLiteral(gGC.GetLiteral(0.0), gGC.GetLiteral(1.0)); }
	| expr_real CPLX_OPR_IMAG { $$ = gGC.GetLiteral(gGC.GetLiteral(0.0) , $1); }
	| expr_intg CPLX_OPR_IMAG { $$ = gGC.GetLiteral(gGC.GetLiteral(0.0) , gGC.GetI2R($1)); }
	| CPLX_OPR_REAL { $$ = gGC.GetLiteral(gGC.GetLiteral(1.0), gGC.GetLiteral(0.0)); }
	| expr_real CPLX_OPR_REAL { $$ = gGC.GetLiteral($1, gGC.GetLiteral(0.0) ); }
	| expr_intg CPLX_OPR_REAL { $$ = gGC.GetLiteral(gGC.GetI2R($1), gGC.GetLiteral(0.0)); }				
			
	| hdr_cplx  arguments ')' 
	{
		CallFunc<Complex>* ptr
				= dynamic_cast<CallFunc<Complex>*>(gFuncCallStack.pop());
				
		if(ptr->ArgCountNotCompatible()) 
			HandleSyntaxError(L"Argument count mismatch.\r\n");
		$$ = ptr; arg_set = false; 
	}
	
	| cast_cplx ')'	{ $$=gGC.GetLiteral(gGC.GetLiteral(0.0), gGC.GetLiteral(0.0)); }
	| cast_cplx expr_rnum ',' expr_rnum ')' { $$=gGC.GetLiteral($2, $4); }
		
	| lhs_cplx '(' ')' { $$ = gGC.GetCallExpression<Complex>($1); }
	| lhs_cplx '(' for_update ')' { $$ = gGC.GetCallExpression<Complex>($1, $3); }
	| '[' lhs_cplx ']' { $$ = gGC.GetAssignExpression<Complex>($2); }
	| '[' lhs_cplx ']' '(' for_update ')' { $$ = gGC.GetAssignExpression<Complex>($2, $5); }
		
	| func_cplx	{ $$ = $1; }
	
	| '|' expr_c2d '|' { $$ = gGC.GetExpDet<Complex, CplxVec2D>($2); }
	| OPR_SOL SOL_DETCRAMER expr_c2d { $$ = gGC.GetExpDet<Complex, CplxVec2D>($3); }
	
	| expr_cplx '+' expr_cplx { $$ = gGC.GetBinOpr<Complex>('+', $1, $3); }
	| expr_cplx '-' expr_cplx { $$ = gGC.GetBinOpr<Complex>('-', $1, $3); }
	| expr_cplx '*' expr_cplx { $$ = gGC.GetBinOpr<Complex>('*', $1, $3); }
	| expr_cplx '/' expr_cplx { $$ = gGC.GetBinOpr<Complex>('/', $1, $3); }
	
	| expr_real '+' expr_cplx { $$ = gGC.GetBinOpr<Complex>('+', gGC.GetR2C($1), $3); }
	| expr_real '-' expr_cplx { $$ = gGC.GetBinOpr<Complex>('-', gGC.GetR2C($1), $3); }
	| expr_real '*' expr_cplx { $$ = gGC.GetBinOpr<Complex>('*', gGC.GetR2C($1), $3); }
	| expr_real '/' expr_cplx { $$ = gGC.GetBinOpr<Complex>('/', gGC.GetR2C($1), $3); }
	
	| expr_intg '+' expr_cplx { $$ = gGC.GetBinOpr<Complex>('+', gGC.GetI2C($1), $3); }
	| expr_intg '-' expr_cplx { $$ = gGC.GetBinOpr<Complex>('-', gGC.GetI2C($1), $3); }
	| expr_intg '*' expr_cplx { $$ = gGC.GetBinOpr<Complex>('*', gGC.GetI2C($1), $3); }
	| expr_intg '/' expr_cplx { $$ = gGC.GetBinOpr<Complex>('/', gGC.GetI2C($1), $3); }
	
	| expr_cplx '+' expr_real { $$ = gGC.GetBinOpr<Complex>('+', $1, gGC.GetR2C($3)); }
	| expr_cplx '-' expr_real { $$ = gGC.GetBinOpr<Complex>('-', $1, gGC.GetR2C($3)); }
	| expr_cplx '*' expr_real { $$ = gGC.GetBinOpr<Complex>('*', $1, gGC.GetR2C($3)); }
	| expr_cplx '/' expr_real { $$ = gGC.GetBinOpr<Complex>('/', $1, gGC.GetR2C($3)); }
	
	| expr_cplx '+' expr_intg { $$ = gGC.GetBinOpr<Complex>('+', $1, gGC.GetI2C($3)); }
	| expr_cplx '-' expr_intg { $$ = gGC.GetBinOpr<Complex>('-', $1, gGC.GetI2C($3)); }
	| expr_cplx '*' expr_intg { $$ = gGC.GetBinOpr<Complex>('*', $1, gGC.GetI2C($3)); }
	| expr_cplx '/' expr_intg { $$ = gGC.GetBinOpr<Complex>('/', $1, gGC.GetI2C($3)); }
	
	| expr_cplx '#' expr_cplx { $$ = gGC.GetExprMaxMin<Complex>($1, $3, false); } // minimum
	| expr_cplx '@' expr_cplx { $$ = gGC.GetExprMaxMin<Complex>($1, $3, true);  } // maximum
	
	| '-' expr_cplx %prec UNARY { $$ = gGC.GetUnaryOpr<Complex>('-', $2); }
	| '+' expr_cplx %prec UNARY { $$ = $2; }
	
	// complex conjugate
	| '~' expr_cplx %prec UNARY { $$ = gGC.GetUnaryOpr<Complex>('~', $2); }
			
	| '(' expr_cplx ')'		    { $$ = $2; }
	
	| expr_cplx '^' expr_cplx {	FunName fn; StrCopy(fn.fn, _T("powc")); gflist.find(fn);
									$$ = gGC.GetFunSimple(fn, $1, $3); } 
	| expr_real '^' expr_cplx {	FunName fn; StrCopy(fn.fn, _T("powc")); gflist.find(fn);
									$$ = gGC.GetFunSimple(fn, gGC.GetR2C($1), $3); } 
	| expr_cplx '^' expr_real {	FunName fn; StrCopy(fn.fn, _T("powc")); gflist.find(fn);
									$$ = gGC.GetFunSimple(fn, $1, gGC.GetR2C($3)); } 
	| expr_intg '^' expr_cplx {	FunName fn; StrCopy(fn.fn, _T("powc")); gflist.find(fn);
									$$ = gGC.GetFunSimple(fn, gGC.GetI2C($1), $3); } 
	| expr_cplx '^' expr_intg {	FunName fn; StrCopy(fn.fn, _T("powc")); gflist.find(fn);
								$$ = gGC.GetFunSimple(fn, $1, gGC.GetI2C($3)); } 
	
	| '#' expr_c1d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec1D>($2, '-'); }
	| '#' expr_c2d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec2D>($2, '-'); }
	| '#' expr_c3d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec3D>($2, '-'); }
	| '#' expr_c4d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec4D>($2, '-'); }
	| '#' expr_c5d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec5D>($2, '-'); }
	
	| '@' expr_c1d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec1D>($2, '+'); }
	| '@' expr_c2d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec2D>($2, '+'); }
	| '@' expr_c3d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec3D>($2, '+'); }
	| '@' expr_c4d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec4D>($2, '+'); }
	| '@' expr_c5d %prec UNARY { $$ = gGC.GetMinMaxEle<Complex, CplxVec5D>($2, '+'); }
	
	;
	
func_cplx:
	  FN_C_C '(' expr_cplx ')' { $$ = gGC.GetFunSimple($1, $3); }
	| FN_C_CC '(' expr_cplx ',' expr_cplx ')' { $$ = gGC.GetFunSimple($1, $3, $5); }	
	| FN_C_RR '(' expr_rnum ',' expr_rnum ')' { $$ = gGC.GetCFunRR($1, $3, $5);    }
	| FN_C_CCCC '(' expr_cplx ',' expr_cplx ',' expr_cplx ',' expr_cplx ')' 
		{ $$ = gGC.GetFunSimple($1, $3, $5, $7, $9); }
	;

expr_vnum: expr_rnum { $$ = gGC.GetR2V($1); }
	| expr_vctr { $$ = $1; }
	;

expr_vctr: '(' expr_rnum ',' expr_rnum ',' expr_rnum ')' { $$ = gGC.GetLiteral($2, $4, $6); }
		
	| lhs_vctr %prec OPR_LOWERTHANDOT { $$ = dynamic_cast<ExpVctr*>($1); }

	| LTL_VCTR { $$ = $1; } 
	
	| expr_udt '.' MEM_LTL_VCTR { $$ = $3; gUdtFactoryStack.clear(); }
	| expr_vub '.' MEM_LTL_VCTR { $$ = $3; gUdtFactoryStack.clear(); }
	
	| expr_boolean '?' expr_vctr ':' expr_vctr 
		{ $$ = gGC.GetExprWhich<Vector>($1, $3, $5); }
		
	| expr_boolean '?' expr_real ':' expr_vctr 
		{ $$ = gGC.GetExprWhich<Vector>($1, gGC.GetR2V($3), $5); }
		
	| expr_boolean '?' expr_vctr ':' expr_real
		{ $$ = gGC.GetExprWhich<Vector>($1, $3, gGC.GetR2V($5) ); }
		
	| expr_boolean '?' expr_intg ':' expr_vctr 
		{ $$ = gGC.GetExprWhich<Vector>($1, gGC.GetI2V($3), $5); }
		
	| expr_boolean '?' expr_vctr ':' expr_intg
		{ $$ = gGC.GetExprWhich<Vector>($1, $3, gGC.GetI2V($5) ); }
		
	| OPR_X { $$ = gGC.GetLiteral( gGC.GetLiteral(1.0), gGC.GetLiteral(0.0), gGC.GetLiteral(0.0) ); }
	| OPR_Y { $$ = gGC.GetLiteral( gGC.GetLiteral(0.0), gGC.GetLiteral(1.0), gGC.GetLiteral(0.0) ); }
	| OPR_Z { $$ = gGC.GetLiteral( gGC.GetLiteral(0.0), gGC.GetLiteral(0.0), gGC.GetLiteral(1.0) ); }
		
	| expr_real	OPR_X { $$ = gGC.GetLiteral($1, gGC.GetLiteral(0.0), gGC.GetLiteral(0.0));  }
	| expr_real	OPR_Y { $$ = gGC.GetLiteral(gGC.GetLiteral(0.0), $1, gGC.GetLiteral(0.0) ); }
	| expr_real	OPR_Z { $$ = gGC.GetLiteral(gGC.GetLiteral(0.0), gGC.GetLiteral(0.0), $1);  }
								
	| expr_intg	OPR_X  { $$ = gGC.GetLiteral(gGC.GetI2R($1), gGC.GetLiteral(0.0), gGC.GetLiteral(0.0)); }
	| expr_intg	OPR_Y  { $$ = gGC.GetLiteral(gGC.GetLiteral(0.0), gGC.GetI2R($1), gGC.GetLiteral(0.0)); }
	| expr_intg	OPR_Z  { $$ = gGC.GetLiteral(gGC.GetLiteral(0.0), gGC.GetLiteral(0.0), gGC.GetI2R($1)); }
														
	| hdr_vctr  arguments ')' 
	{
		CallFunc<Vector>* ptr
				= dynamic_cast<CallFunc<Vector>*>(gFuncCallStack.pop());
				
		if(ptr->ArgCountNotCompatible()) 
			HandleSyntaxError(L"Argument count mismatch.\r\n");
		$$ = ptr; arg_set = false; 
	}
	
	| cast_vctr ')' 
		{ $$=gGC.GetLiteral(gGC.GetLiteral(0.0), gGC.GetLiteral(0.0), gGC.GetLiteral(0.0)); }
	| cast_vctr expr_rnum ',' expr_rnum ',' expr_rnum ')' { $$=gGC.GetLiteral($2, $4, $6); }
		 
	| lhs_vctr '(' ')' { $$ = gGC.GetCallExpression<Vector>($1); }
	| lhs_vctr '(' for_update ')' { $$ = gGC.GetCallExpression<Vector>($1, $3); }
	| '[' lhs_vctr ']' { $$ = gGC.GetAssignExpression<Vector>($2); }
	| '[' lhs_vctr ']' '(' for_update ')' { $$ = gGC.GetAssignExpression<Vector>($2, $5); }
		
	| func_vctr	{$$ = $1; }
	| expr_vctr '+' expr_vctr { $$ = gGC.GetBinOpr<Vector>('+', $1, $3); }
	| expr_vctr '-' expr_vctr { $$ = gGC.GetBinOpr<Vector>('-', $1, $3); }
	| expr_vctr '%' expr_vctr { $$ = gGC.GetBinOpr<Vector>('%', $1, $3); }
	| expr_real '*' expr_vctr { $$ = gGC.GetRVBinOpr('*', $1, $3); }
	| expr_intg '*' expr_vctr { $$ = gGC.GetRVBinOpr('*', gGC.GetI2R($1), $3); }
	| expr_vctr '*' expr_real { $$ = gGC.GetRVBinOpr('*', $1, $3); }
	| expr_vctr '*' expr_intg { $$ = gGC.GetRVBinOpr('*', $1, gGC.GetI2R($3)); }
	| expr_vctr '/' expr_real { $$ = gGC.GetRVBinOpr('/', $1, $3); }
	| expr_vctr '/' expr_intg { $$ = gGC.GetRVBinOpr('/', $1, gGC.GetI2R($3)); }
	
	| expr_vctr '#' expr_vctr { $$ = gGC.GetExprMaxMin<Vector>($1, $3, false); } // minimum
	| expr_vctr '@' expr_vctr { $$ = gGC.GetExprMaxMin<Vector>($1, $3, true);  } // maximum
	
	// unit vector
	| '~' expr_vctr %prec UNARY { $$ = gGC.GetUnaryOpr<Vector>('~', $2); }
		
	| '-' expr_vctr %prec UNARY { $$ = gGC.GetUnaryOpr<Vector>('-', $2); }
	| '+' expr_vctr %prec UNARY { $$ = $2; }
	| '(' expr_vctr ')'	{ $$ = $2; }
	
	| '#' expr_v1d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec1D>($2, '-'); }
	| '#' expr_v2d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec2D>($2, '-'); }
	| '#' expr_v3d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec3D>($2, '-'); }
	| '#' expr_v4d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec4D>($2, '-'); }
	| '#' expr_v5d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec5D>($2, '-'); }
	
	| '@' expr_v1d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec1D>($2, '+'); }
	| '@' expr_v2d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec2D>($2, '+'); }
	| '@' expr_v3d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec3D>($2, '+'); }
	| '@' expr_v4d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec4D>($2, '+'); }
	| '@' expr_v5d %prec UNARY { $$ = gGC.GetMinMaxEle<Vector, VctrVec5D>($2, '+'); }
	;

func_vctr: FN_V_V '(' expr_vctr ')' { $$ = gGC.GetFunSimple($1, $3); }
	| FN_V_RRR '(' expr_rnum ',' expr_rnum ',' expr_rnum ')' { $$ = gGC.GetVFunRRR($1, $3, $5, $7); }
	;

arguments: /* empty */ 
	| expr_boolean { gFuncCallStack.top()->insert($1); } | expr_intg { gFuncCallStack.top()->insert($1); } 
	| expr_real { gFuncCallStack.top()->insert($1); } | expr_cplx { gFuncCallStack.top()->insert($1); } 
	| expr_vctr { gFuncCallStack.top()->insert($1); } | expr_strn { gFuncCallStack.top()->insert($1); } 
	
	| expr_user  { gFuncCallStack.top()->insert($1); gUdtFactoryStack.clear(); }  
	
	| lhs_uptr  { gFuncCallStack.top()->insert($1); gUdtFactoryStack.clear(); }  
			
	| expr_i1d   { gFuncCallStack.top()->insert($1); } | expr_r1d { gFuncCallStack.top()->insert($1); }
	| expr_c1d   { gFuncCallStack.top()->insert($1); } | expr_v1d { gFuncCallStack.top()->insert($1); }
	
	| expr_i2d   { gFuncCallStack.top()->insert($1); } | expr_r2d { gFuncCallStack.top()->insert($1); }
	| expr_c2d   { gFuncCallStack.top()->insert($1); } | expr_v2d { gFuncCallStack.top()->insert($1); }
	
	| expr_i3d   { gFuncCallStack.top()->insert($1); } | expr_r3d { gFuncCallStack.top()->insert($1); }
	| expr_c3d   { gFuncCallStack.top()->insert($1); } | expr_v3d { gFuncCallStack.top()->insert($1); }
	
	| expr_i4d   { gFuncCallStack.top()->insert($1); } | expr_r4d { gFuncCallStack.top()->insert($1); }
	| expr_c4d   { gFuncCallStack.top()->insert($1); } | expr_v4d { gFuncCallStack.top()->insert($1); }
	
	| expr_i5d   { gFuncCallStack.top()->insert($1); } | expr_r5d { gFuncCallStack.top()->insert($1); }
	| expr_c5d   { gFuncCallStack.top()->insert($1); } | expr_v5d { gFuncCallStack.top()->insert($1); }
	
	| PTR_BOOL   { gFuncCallStack.top()->insert($1); } | PTR_INTG { gFuncCallStack.top()->insert($1); }
	| PTR_REAL   { gFuncCallStack.top()->insert($1); } | PTR_CPLX { gFuncCallStack.top()->insert($1); }
	| PTR_VCTR   { gFuncCallStack.top()->insert($1); } | PTR_STRN { gFuncCallStack.top()->insert($1); }
	
	| PTR_AP1I   { gFuncCallStack.top()->insert($1); } | PTR_AP1R   { gFuncCallStack.top()->insert($1); }
	| PTR_AP1C   { gFuncCallStack.top()->insert($1); } | PTR_AP1V   { gFuncCallStack.top()->insert($1); }
    
    | PTR_AP2I   { gFuncCallStack.top()->insert($1); } | PTR_AP2R   { gFuncCallStack.top()->insert($1); }
	| PTR_AP2C   { gFuncCallStack.top()->insert($1); } | PTR_AP2V   { gFuncCallStack.top()->insert($1); }

	| PTR_AP3I   { gFuncCallStack.top()->insert($1); } | PTR_AP3R   { gFuncCallStack.top()->insert($1); }
	| PTR_AP3C   { gFuncCallStack.top()->insert($1); } | PTR_AP3V   { gFuncCallStack.top()->insert($1); }

	| PTR_AP4I   { gFuncCallStack.top()->insert($1); } | PTR_AP4R   { gFuncCallStack.top()->insert($1); }
	| PTR_AP4C   { gFuncCallStack.top()->insert($1); } | PTR_AP4V   { gFuncCallStack.top()->insert($1); }
    
    | PTR_AP5I   { gFuncCallStack.top()->insert($1); } | PTR_AP5R   { gFuncCallStack.top()->insert($1); }
	| PTR_AP5C   { gFuncCallStack.top()->insert($1); } | PTR_AP5V   { gFuncCallStack.top()->insert($1); }
	
	| arguments ',' expr_boolean { gFuncCallStack.top()->insert($3); } 		
	
	| arguments ',' expr_intg  { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_real  { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_cplx  { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_vctr  { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_strn  { gFuncCallStack.top()->insert($3); } 
	
	| arguments ',' expr_user  { gFuncCallStack.top()->insert($3); gUdtFactoryStack.clear(); } 
	| arguments ',' lhs_uptr   { gFuncCallStack.top()->insert($3); gUdtFactoryStack.clear(); } 
		
	| arguments ',' expr_i1d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_r1d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_c1d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_v1d   { gFuncCallStack.top()->insert($3); } 	
	
	| arguments ',' expr_i2d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_r2d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_c2d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_v2d   { gFuncCallStack.top()->insert($3); } 	
	
	| arguments ',' expr_i3d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_r3d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_c3d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_v3d   { gFuncCallStack.top()->insert($3); } 	
	
	| arguments ',' expr_i4d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_r4d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_c4d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_v4d   { gFuncCallStack.top()->insert($3); } 	
	
	| arguments ',' expr_i5d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_r5d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_c5d   { gFuncCallStack.top()->insert($3); } 
	| arguments ',' expr_v5d   { gFuncCallStack.top()->insert($3); } 	
	
	| arguments ',' PTR_BOOL   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_INTG   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_REAL   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_CPLX   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_VCTR   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_STRN   { gFuncCallStack.top()->insert($3); }
	
	| arguments ',' PTR_AP1I   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP1R   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP1C   { gFuncCallStack.top()->insert($3); }
    | arguments ',' PTR_AP1V   { gFuncCallStack.top()->insert($3); }
    
    | arguments ',' PTR_AP2I   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP2R   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP2C   { gFuncCallStack.top()->insert($3); }
    | arguments ',' PTR_AP2V   { gFuncCallStack.top()->insert($3); }

	| arguments ',' PTR_AP3I   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP3R   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP3C   { gFuncCallStack.top()->insert($3); }
    | arguments ',' PTR_AP3V   { gFuncCallStack.top()->insert($3); }

	| arguments ',' PTR_AP4I   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP4R   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP4C   { gFuncCallStack.top()->insert($3); }
    | arguments ',' PTR_AP4V   { gFuncCallStack.top()->insert($3); }
    
    | arguments ',' PTR_AP5I   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP5R   { gFuncCallStack.top()->insert($3); }
	| arguments ',' PTR_AP5C   { gFuncCallStack.top()->insert($3); }
    | arguments ',' PTR_AP5V   { gFuncCallStack.top()->insert($3); }
	
	;
 
 expr_boolean: BOOLN  { $$ = gGC.GetLiteral($1); }
 	
 	| expr_boolean '?' expr_boolean ':' expr_boolean
		{ $$ = gGC.GetExprWhich<bool>($1, $3, $5); }
		
	| TYPE_BOOL '(' ')'	{ $$=gGC.GetLiteral(false); vartype=TypeNull; }
	
	| lhs_bool { $$ = dynamic_cast<ExpBool*>($1); }
		
	| opr_bool { $$ = $1; }
	| '!' expr_boolean		{ $$ = gGC.GetUnaryBoolOpr('!', $2); }
	| '(' expr_boolean ')'	{ $$ = $2; }
	
	| FN_B_S '(' expr_strn ')'  { $$ = gGC.GetBFunS($1, $3); }
		 
	| hdr_bool  arguments ')' 
		{
			CallFunc<bool>* ptr
					= dynamic_cast<CallFunc<bool>*>(gFuncCallStack.pop());
				
			if(ptr->ArgCountNotCompatible()) 
				HandleSyntaxError(L"Argument count mismatch.\r\n");
			$$ = ptr; arg_set = false; 
		}
	;
	
opr_bool: 
	  expr_intg '>' expr_intg	{ $$ = gGC.GetBinBoolOpr<integer>('>', $1, $3); }
	| expr_intg '<' expr_intg	{ $$ = gGC.GetBinBoolOpr<integer>('<', $1, $3); }	
	| expr_intg LE  expr_intg	{ $$ = gGC.GetBinBoolOpr<integer>('(', $1, $3); }	
	| expr_intg GE  expr_intg	{ $$ = gGC.GetBinBoolOpr<integer>(')', $1, $3); }	
	| expr_intg EQ  expr_intg	{ $$ = gGC.GetBinBoolOpr<integer>('$', $1, $3); }	
	| expr_intg NE  expr_intg	{ $$ = gGC.GetBinBoolOpr<integer>('!', $1, $3); }
	
	| expr_real '>' expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('>', $1, $3); }
	| expr_real '<' expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('<', $1, $3); }	
	| expr_real LE  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('(', $1, $3); }	
	| expr_real GE  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>(')', $1, $3); }	
	| expr_real EQ  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('$', $1, $3); }	
	| expr_real NE  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('!', $1, $3); }
	
	| expr_intg '>' expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('>', gGC.GetI2R($1), $3); }
	| expr_intg '<' expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('<', gGC.GetI2R($1), $3); }	
	| expr_intg LE  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('(', gGC.GetI2R($1), $3); }	
	| expr_intg GE  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>(')', gGC.GetI2R($1), $3); }	
	| expr_intg EQ  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('$', gGC.GetI2R($1), $3); }	
	| expr_intg NE  expr_real	{ $$ = gGC.GetBinBoolOpr<realnum>('!', gGC.GetI2R($1), $3); }
	
	| expr_real '>' expr_intg	{ $$ = gGC.GetBinBoolOpr<realnum>('>', $1, gGC.GetI2R($3)); }
	| expr_real '<' expr_intg	{ $$ = gGC.GetBinBoolOpr<realnum>('<', $1, gGC.GetI2R($3)); }	
	| expr_real LE  expr_intg	{ $$ = gGC.GetBinBoolOpr<realnum>('(', $1, gGC.GetI2R($3)); }	
	| expr_real GE  expr_intg	{ $$ = gGC.GetBinBoolOpr<realnum>(')', $1, gGC.GetI2R($3)); }	
	| expr_real EQ  expr_intg	{ $$ = gGC.GetBinBoolOpr<realnum>('$', $1, gGC.GetI2R($3)); }	
	| expr_real NE  expr_intg	{ $$ = gGC.GetBinBoolOpr<realnum>('!', $1, gGC.GetI2R($3)); } 
	
	| expr_cplx '>' expr_cplx	{ $$ = gGC.GetBinBoolOpr<Complex>('>', $1, $3); }
	| expr_cplx '<' expr_cplx	{ $$ = gGC.GetBinBoolOpr<Complex>('<', $1, $3); }	
	| expr_cplx LE  expr_cplx	{ $$ = gGC.GetBinBoolOpr<Complex>('(', $1, $3); }	
	| expr_cplx GE  expr_cplx	{ $$ = gGC.GetBinBoolOpr<Complex>(')', $1, $3); }	
	| expr_cplx EQ  expr_cplx	{ $$ = gGC.GetBinBoolOpr<Complex>('$', $1, $3); }	
	| expr_cplx NE  expr_cplx	{ $$ = gGC.GetBinBoolOpr<Complex>('!', $1, $3); }
	
	| expr_vctr '>' expr_vctr	{ $$ = gGC.GetBinBoolOpr<Vector>('>', $1, $3); }
	| expr_vctr '<' expr_vctr	{ $$ = gGC.GetBinBoolOpr<Vector>('<', $1, $3); }	
	| expr_vctr LE  expr_vctr	{ $$ = gGC.GetBinBoolOpr<Vector>('(', $1, $3); }	
	| expr_vctr GE  expr_vctr	{ $$ = gGC.GetBinBoolOpr<Vector>(')', $1, $3); }	
	| expr_vctr EQ  expr_vctr	{ $$ = gGC.GetBinBoolOpr<Vector>('$', $1, $3); }	
	| expr_vctr NE  expr_vctr	{ $$ = gGC.GetBinBoolOpr<Vector>('!', $1, $3); } 
	
	| expr_boolean OR expr_boolean  { $$ = gGC.GetRelation('|', $1, $3); }
	| expr_boolean AND expr_boolean { $$ = gGC.GetRelation('&', $1, $3); }
	| expr_boolean EQ expr_boolean	{ $$ = gGC.GetBinBoolOpr<bool>('$', $1, $3); } 
	| expr_boolean NE expr_boolean	{ $$ = gGC.GetBinBoolOpr<bool>('!', $1, $3); } 
	;
%%
  
